<?php
session_name('sid');
session_start();
include_once ('../include/db.php');
include_once('../include/auth.php');
require_once('../classes/warehouse.class.php');
require_once('../classes/user.class.php');
$user = new User();
$wh = new Warehouse($user);

$iid = (int)$_POST['iid'];
$mag = (int)$_POST['mag'];
$whId = (int)$_POST['wid'];
$prod = (int)$_POST['prod'];
$equals = (int)$_POST['equals'];
$item = utf8_decode($_POST['item']);
$res = $wh->getUsersForItem($iid, $item, $mag, $prod, $equals);
$it = $wh->getItem($iid, $whId);
$subItems = $wh->getWarhouseItemsByIid($whId, $iid);
$dmgWeapons =	 	[1,2,3,4,5,6,7,8,9,10];
$effectWeapons = 	[11,12,13,14,15,16,17];
$accuracyWeapons = 	[15,16,17];
$armorClothes = 	[18,19,20,21,22];
$absorbClothes = 	[18,19,20];
$handicapClothes = 	[18,19,20];
$blockClothes = 	[21,22];
$heal =                 [28];   // Bandagen

$damaged = $wh->getDemagedItemCount($iid, $whId);
if($damaged['sum'] == 0)
	$damageditem = "Kaputt: 0";
else if($damaged['min'] == $damaged['max'])
	$damageditem = "Kaputt: ".$damaged['sum']." (".$damaged['min']."%)";
else
	$damageditem = "Kaputt: ".$damaged['sum']." (".$damaged['min']." - ".$damaged['max']."%)";

if(in_array($it['itid'], $dmgWeapons))
	$effect = $it['dmgmin']."-".$it['dmgmax']." Schaden";
if(in_array($it['itid'], $effectWeapons))
	$effect = "+".$it['effect']."% Wirkung";
if(in_array($it['itid'], $accuracyWeapons))
	$effect .= ", +".$it['accuracy']."% Treffsicherheit";
if(in_array($it['itid'], $armorClothes))
	$effect = "+".$it['armor']."% R&uuml;stschutz";
if(in_array($it['itid'], $absorbClothes))
	$effect .= ", +".$it['absorb']." Absorb";
if(in_array($it['itid'], $handicapClothes))
	$effect .= ", +".$it['handicap']."% Behinderung";
if(in_array($it['itid'], $blockClothes))
	$effect .= ", +".$it['blockabsorb']."% R&uuml;stschutz bei Block";
if($it['critical'] !== null)
	$effect .= ", +".$it['critical']."% Kritische Treffer";
if(in_array($it['itid'], $heal))
	$effect = $it['dmgmin']."-".$it['dmgmax']." Heilung, ".$it['rel_min']."%-".$it['rel_max']."% Heilung";

echo '
<div class="editoverlib" style="width:300px;">
    <table class="tableOverlib" border="0">
        <tr>
            <th class="right nob1" colspan="4"><span style="cursor:pointer;" onclick="$(\'#itemusers\').hide();">X</span>&nbsp;&nbsp;</th>
        </tr>
    </table>
    <div id="tabs" class="txt2 left">
        <ul>
                <li class="txt4"><a href="#tabs-1">Allgemein</a></li>
                <li class="txt4"><a href="#tabs-2">Produzenten</a></li>
        </ul>
        <div id="tabs-1" class="left txt3">
            <table class="tableOverlib" border="0">
                <tr>
                    <td colspan="4" class="txt3 left nob6"><u>'.$it['item'].'</u> ('.$it['type'].')<br />
                    <span class="hint txt3 nob6">'.$effect.'</span></td>
                </tr>
                <tr>
                    <td class="txt3 left nob">Stufe:</td>
                    <td class="txt3 nob">'.$it['lvl'].'</td>
                    <td class="txt3 left nob">Produzierbar:</td>
                    <td class="txt3 nob">'.($it['producable']?'ja':'nein').'</td>
                </tr>
                <tr>
                    <td class="txt3 left nob6">Marktwert:</td>
                    <td class="txt3 nob6">'.$it['market'].'</td>
                    <td class="txt3 left nob6">Magisch:</td>
                    <td class="txt3 nob6">'.($it['magical']?'ja':'nein').'</td>
                </tr>
                <tr>
                    <td class="txt3 left nob3">Realwert:</td>
                    <td class="txt3 nob3">'.$it['real'].'</td>
                    <td class="txt3 left nob3" colspan="2">'.$damageditem.'</td>
                </tr>
                
            </table>
            <br />
            <table class="tableOverlib" border="0">';
                foreach($subItems as $sub) {
                    $name = $sub['item'];
                    if($sub['stability'] > 0)   $name .= ' ('.$sub['stability'].')';
                    if($sub['increment'] > 0)   $name .= ' +'.$sub['increment'].'';
                    echo '
                    <tr>
                        <td colspan="4" class="right nob6" style="padding:  0 4px">'.$sub['count'].'</td>
                        <td colspan="4" class="left nob6" style="padding: 0 4px">'.$name.'</td>
                    </tr>';
                }
                echo '            
            </table>
        </div>
        <div id="tabs-2" class="left txt3">
            <table class="tableOverlib" border="0">
                <tr>
                    <td colspan="4" class="nob3"><div class="ithright txt3"><strong>Stufe</strong>&nbsp;&nbsp;</div></td>
                </tr>
                <tr>
                    <td colspan="4" class="nob">';
                            $c = count($res);
                            foreach($res as $key=>$value)
                            {					
                                    echo '<span class="txt3"><strong>'.$key.'</strong></span><br />';
                                    $tmpwork = "";
                                    foreach($value as $nicks)
                                    {
                                            $work = ($nicks['nowork']?'Wanderer':'Handwerker');
                                            $active = ($nicks['mainwork']?'(aktiv)':'(nicht aktiv)');
                                            if($work != $tmpwork)
                                            {	echo '<div style="margin:0 auto; clear:both;" class="txt3 left"><u>'.$work.'</u></div>'; $tmpwork = $work; }
                                            echo '<div class="itleft left" style="min-width:150px;"><span class="txt3">&nbsp;&nbsp;&nbsp;'.$nicks['nick'].'</span> <span class="hint">'.$active.'</span></div>
                                                      <div class="itright"><span class="txt3">'.$nicks['value'].'&nbsp;&nbsp;</span></div>';

                                    }			
                            }
                            if($c == 0)
                                    echo '<p class="txt"><i>derzeit keine Charaktere verf&uuml;gbar</i></p>';
                  echo '</td>
                </tr>
            </table>
        </div>
    </div>
    <table class="tableOverlib" border="0">
        <tr>
          <th class="nob">&nbsp;</th>
        </tr>
    </table>
</div>';
	      
    echo '     
    <script type="text/javascript">
        $(document).ready(function()
        {
            $( "#tabs" ).tabs();
        });
    </script>';
?>