<?php
session_name('sid');
session_start();

use Repository\MessageRepository;

include_once('../include/db.php');
include_once('../classes/functions.php');
include_once('../classes/config.class.php');
include_once('../classes/user.class.php');
include_once('../Repository/MessageRepository.php');

$user = new User();
$messageRepo = new MessageRepository();
$load = $_GET['load'] ?? "";

if( $load === 'list' ) {
    $curSite = (int)($_GET['page'] ?? 1);
    $messageRepo->deleteOld($user->getUId());
    $entries = $messageRepo->getCountForUser($user->getUId());
    $pages = $messageRepo->calculatePages($entries);    
    $messages = $messageRepo->getAllForUser($user->getUId(), $curSite);
    
    if( count($messages) > 0 ) {
        echo ' 
        <br />
        <table class="resultT" style="width: 100%;height: 100%;" border="0" id="message-table">
        <tr>
            <th id="chathead" class="txt2" colspan="2">Mitteilungen</th>
        </tr>';

        foreach($messages as $message ) {
            if( !$message['isRead'] ) {
                $message['subject'] = '<strong>'.$message['subject'].'</strong>';
            }
            echo '
            <tr>
                <td class="left txt2 nob pointer" onclick="getMessage('.$message['id'].');">
                    <span class="ui-icon ui-icon-'.($message['isRead'] ? 'mail-open' : 'mail-closed').'"></span>'
                    .$message['subject'].'
                </td>
                <td class="right txt2 nob">'.$message['send']->format('d.m. H:i').'</td>
            </tr>';
        }

        if($pages > 1) {
            echo '
            <tr>
                <td colspan="2" class="nob txt2 italic bold">Seite: ';
            for($i=1;$i<=$pages;$i++)				
            {
                if($curSite != $i) {
                    echo '<a class="txt2" href="#" onclick="loadMessages(\'messages\', '.$i.');">'.$i.'</a>&nbsp;&nbsp;';
                } else{
                    echo ''.$i.'&nbsp;&nbsp;';                    
                }
            }
            echo '</td>
            </tr>';
        }
        
        echo '
        </table>';
    }
} else if( $load === 'single' ) {
    $id = (int)($_GET['id'] ?? 0);
    $message = $messageRepo->get($id);

    // only the user itself is allowed to read own messages
    if(count($message) > 0 && $message['receiver'] == $_SESSION['uid']) {
        echo '
        <table class="message-table" border="0">
        <tr>
            <td class="right">Datum:</td>
            <td class="left">'.$message['send']->format('d.m.Y H:i').' Uhr</td>
        </tr>
        <tr>
            <td class="right">Absender:</td>
            <td class="left">'.$message['senderNick'].'</td>
        </tr>
        <tr>
            <td class="right">Betreff:</td>
            <td class="left">'.$message['subject'].'</td>
        </tr>
        <tr>
            <td class="right">Nachricht:</td>
            <td class="left">'.$message['message'].'</td>
        </tr>
        </table>';
        $messageRepo->setAsRead($message['id']);
    }
} else if( $load === 'new' ) {
    echo $messageRepo->getCountForUser($user->getUId(), true);
}


