<?php

class ActivityDiscover {
    
    /**
     * Retruns a List with all users that were found in the past $days days in wh protocol and the level of the correspondending capability
     * @param int $whId
     * @param int $days
     * @param int $itId
     * @param array $cIds Array of all cids in the given item types id
     * @return type
     */
    public function getWhUserListWithCapLvl($whId, $days, $itId, $cIds) {
        $result = Array();
        
        $inClause = "usercap.cid";
        $inClause .= " IN ("; $i = 0;
        if(count($cIds) > 0)
        {
            foreach($cIds as $wid)	
            {
                $inClause .= $wid;
                if($i != count($cIds)-1) {
                    $inClause .= ', ';
                }                    
                $i++;
            }
            
        } else {
            $inClause .= "-1";
        }
        
        $inClause .= ")";

        // first, we selct all users from wh protocoll from the last few days (given from item_types_values)
        // group the inserted items by itid and sum the amount of these group
        // next, we select all users where auto_cap_active was enabled
        // and selct there capabilities
        // finaly, we connect those two temporarily created tables to retrieve the grouped sum, the capabilities id und the users id
        $query = "  SELECT whactivity.sumicount, usercap.nick, usercap.uid, usercap.cid, usercap.mainwork
                    FROM
                        (SELECT wp.nick, i.itid, SUM(wpe.icount) as sumicount, i.cid  FROM ".DB_PREFIX."warehouse_protocoll wp
                        JOIN ".DB_PREFIX."warehouse_protocoll_entry wpe ON wpe.wpid=wp.wpid
                        JOIN ".DB_PREFIX."items i ON i.iid=wpe.iid and i.itid=".(int)$itId." and i.cid>0
                        WHERE wp.wid=".(int)$whId." and wp.type='Einlagerung'  
                            and wpe.stability IN (0, 100) and wp.date >= DATE(NOW()) - INTERVAL ".(int)$days." DAY
                        GROUP BY wp.nick, i.itid, i.cid) as whactivity
                    RIGHT JOIN    
                        (select c.cid, u.uid, u.nick, uc.mainwork from egtool_guilds g
                        JOIN ".DB_PREFIX."guilds_user gu ON gu.guid=g.guid
                        JOIN ".DB_PREFIX."capabilities c ON c.type=0
                        JOIN ".DB_PREFIX."users_capabilities uc ON uc.uid=gu.uid and uc.cid=c.cid
                        JOIN ".DB_PREFIX."users u ON u.uid=gu.uid
                        WHERE auto_cap_active=1) as usercap ON whactivity.nick=usercap.nick and usercap.cid=whactivity.cid
                    WHERE ".$inClause;
        //echo $query;
        $res =  mysqli_query(Config::getDBConn(), $query);
        if(mysqli_num_rows($res) > 0)
        {
            $i = 0;
            while($row = mysqli_fetch_array($res))
            {
                $result[$i]['sumicount'] = $row['sumicount'];
                $result[$i]['nick'] = $row['nick'];
                $result[$i]['uid'] = $row['uid'];
                $result[$i]['cid'] = $row['cid'];
                $result[$i]['mainwork'] = $row['mainwork'];
                $i++;	
            }
        }
        return $result;  
    }
    
}

