<?php

class Config
{
    private $editnewsids = array();
    private $editHuntUserIds = array();  // user ids which have right to edit/delete all hunt groups
    private static $dbConnection;
    const TOOL_DOWNLOAD_LINK = "https://www.elchlepp.info/egtool/egtool.zip";
    const TOOL_CHANGELOG_LINK = "https://www.elchlepp.info/egtool/changelog.txt";
    const MAX_INCREMENT = 2;

    public static function setDBConn($dbConn)
    {
        self::$dbConnection = $dbConn;
    }

    public static function getDBConn()
    {
        return self::$dbConnection;
    }

    public function getToolVersion()
    {
        $result = "0";
        $query = "SELECT value FROM " . DB_PREFIX . "config WHERE set_key='version'";

        //echo $query;
        $res = mysqli_query(Config::getDBConn(), $query);
        if (mysqli_num_rows($res) == 1) {
            $row = mysqli_fetch_array($res);
            $result = $row['value'];

        }
        return $result;
    }

    public function getEditNewsUser()
    {
        $result = array();
        $query = "SELECT u.nick, u.avatar, u.uid FROM " . DB_PREFIX . "config, " . DB_PREFIX . "users u WHERE set_key='editnews' and value=u.uid";
        //echo $query;
        $qry = mysqli_query(Config::getDBConn(), $query);

        if (mysqli_num_rows($qry) > 0) {
            $i = 0;
            while ($row = mysqli_fetch_array($qry)) {
                $result[$i]['nick'] = $row['nick'];
                $result[$i]['uid'] = $row['uid'];
                $this->editnewsids[] = $row['uid'];
                $i++;
            }
        }
        return $result;
    }

    /**
     * retrieves all user which have right to edit/delete hunt groups
     * @return array
     */
    public function getEditHuntUser()
    {
        $result = array();
        $query = "SELECT u.nick, u.avatar, u.uid FROM " . DB_PREFIX . "config, " . DB_PREFIX . "users u WHERE set_key='edithunt' and value=u.uid";
        //echo $query;
        $qry = mysqli_query(Config::getDBConn(), $query);

        if (mysqli_num_rows($qry) > 0) {
            $i = 0;
            while ($row = mysqli_fetch_array($qry)) {
                $result[$i]['nick'] = $row['nick'];
                $result[$i]['uid'] = $row['uid'];
                $this->editHuntUserIds[] = $row['uid'];
                $i++;
            }
        }
        return $result;
    }

    public function saveEditNewsUser($uId)
    {
        $query = mysqli_query(Config::getDBConn(), "INSERT INTO " . DB_PREFIX . "config VALUES('editnews', " . (int)$uId . ")");
        if ($query) return true;
        else            return false;
    }

    public function delEditNewsUser($uId)
    {
        $query = mysqli_query(Config::getDBConn(), "DELETE FROM " . DB_PREFIX . "config WHERE set_key='editnews' and value='" . (int)$uId . "'");
        if ($query) return true;
        else            return false;
    }

    public function saveEditHuntUser($uId)
    {
        $query = mysqli_query(Config::getDBConn(), "INSERT INTO " . DB_PREFIX . "config VALUES('edithunt', " . (int)$uId . ")");
        if ($query) return true;
        else            return false;
    }

    public function delEditHuntUser($uId)
    {
        $query = mysqli_query(Config::getDBConn(), "DELETE FROM " . DB_PREFIX . "config WHERE set_key='edithunt' and value='" . (int)$uId . "'");
        if ($query) return true;
        else            return false;
    }

    public function getNews()
    {
        $result = array();
        $query = "SELECT description, DATE_FORMAT(date, '%d.%m.%Y %H:%i') as date FROM " . DB_PREFIX . "news WHERE nid=1";

        $qry = mysqli_query(Config::getDBConn(), $query);
        if (mysqli_num_rows($qry) == 1) {
            $row = mysqli_fetch_array($qry);
            $result['text'] = $row['description'];
            $result['date'] = $row['date'];
        }
        return $result;
    }

    public function updateNews($text)
    {
        $result = array();
        $query = "UPDATE  " . DB_PREFIX . "news set description='" . getStringForDb($text) . "', date=NOW() WHERE nid=1";

        if (mysqli_query(Config::getDBConn(), $query))
            return true;
        else
            return false;

    }

    public function updatePJIRCSettings($host, $channel)
    {
        if ($channel == "") $channel = "-";
        if ($host == "") $host = "-";
        $q1 = mysqli_query(Config::getDBConn(), "UPDATE " . DB_PREFIX . "config set value='" . getStringForDb($host, false) . "' WHERE set_key='pjirc_host'");
        $q2 = mysqli_query(Config::getDBConn(), "UPDATE " . DB_PREFIX . "config set value='" . getStringForDb($channel, false) . "' WHERE set_key='pjirc_channel'");
        if ($q1 && $q2)
            return true;
        else
            return false;
    }

    public function getPJIRCSettings()
    {
        $result = array('pjirc_host' => '-', 'pjirc_channel' => '-');
        $query = "SELECT set_key, value FROM " . DB_PREFIX . "config, " . DB_PREFIX . "users u WHERE set_key IN('pjirc_host','pjirc_channel')";
        //echo $query;
        $qry = mysqli_query(Config::getDBConn(), $query);

        if (mysqli_num_rows($qry) > 0) {
            while ($row = mysqli_fetch_array($qry)) {
                $result[$row['set_key']] = $row['value'];
            }
        }
        return $result;
    }

    //Die Einstellungen, wenn ein Nutzer im Protokoll auftaucht und er in die Gilde aufgenommen oder hinausgeworfen wurde
    //removeAction:
    //	0: switch_guild (Nutzer wird in andere Gilde verschoben)
    //	1: remove 		(Nutzer wird aus Tool gel�scht)
    //  2: nothing		(nichts machen)
    //addUser:
    //	0: nein
    //	1: ja
    public function updateProtUserSettings($guId, $addUser, $removeAction)
    {
        if (!in_array($removeAction, array(0, 1, 2))) $removeAction = 0;
        if (!in_array($addUser, array(0, 1))) $addUser = 0;
        if ($guId < 0) $guId = 0;
        $q1 = mysqli_query(Config::getDBConn(), "UPDATE " . DB_PREFIX . "config set value='" . (int)$guId . "' WHERE set_key='prot_add_removeduser_to_guildid'");
        $q2 = mysqli_query(Config::getDBConn(), "UPDATE " . DB_PREFIX . "config set value='" . (int)$addUser . "' WHERE set_key='prot_add_newuser'");
        $q3 = mysqli_query(Config::getDBConn(), "UPDATE " . DB_PREFIX . "config set value='" . (int)$removeAction . "' WHERE set_key='prot_removeduser_action'");
        if ($q1 && $q2 && $q3)
            return true;
        else
            return false;
    }

    //Die Einstellungen, wenn ein Nutzer im Protokoll auftaucht und er in die Gilde aufgenommen oder hinausgeworfen wurde
    public function getProtUserSettings()
    {
        $result = array('prot_add_removeduser_to_guildid' => 0, 'prot_add_newuser' => 0, 'prot_removeduser_action' => 0);
        $query = "SELECT set_key, value FROM " . DB_PREFIX . "config, " . DB_PREFIX . "users u WHERE set_key 
				  IN('prot_add_removeduser_to_guildid','prot_add_newuser', 'prot_removeduser_action')";
        //echo $query;
        $qry = mysqli_query(Config::getDBConn(), $query);

        if (mysqli_num_rows($qry) > 0) {
            while ($row = mysqli_fetch_array($qry)) {
                $result[$row['set_key']] = (int)$row['value'];
            }
        }
        return $result;
    }

    public function updateProtocollDeletePeriod($period)
    {
        if ($channel == "") $channel = "-";
        if ($host == "") $host = "-";
        $q1 = mysqli_query(Config::getDBConn(), "UPDATE " . DB_PREFIX . "config set value='" . (int)$period . "' WHERE set_key='prot_period'");
        if ($q1)
            return true;
        else
            return false;
    }

    public function getProtocollDeletePeriod()
    {
        $result = 0;
        $query = "SELECT set_key, value FROM " . DB_PREFIX . "config WHERE set_key='prot_period'";
        //echo $query;
        $qry = mysqli_query(Config::getDBConn(), $query);

        if (mysqli_num_rows($qry) == 1) {
            $row = mysqli_fetch_array($qry);
            $result = (int)$row['value'];
        }
        return $result;
    }

    public function deleteProtocollPeriod()
    {
        $period = $this->getProtocollDeletePeriod();
        if ($period > 0) {
            //alles l�schen, was �lter als $period Monate ist
            $where = "period_diff(DATE_FORMAT(NOW(), '%Y%m'), DATE_FORMAT(date, '%Y%m'))>" . $period;
            $q1 = mysqli_query(Config::getDBConn(), "DELETE FROM " . DB_PREFIX . "warehouse_protocoll_entry WHERE wpid 
								IN (SELECT wpid from " . DB_PREFIX . "warehouse_protocoll where " . $where . ")");
            $q2 = mysqli_query(Config::getDBConn(), "DELETE FROM " . DB_PREFIX . "warehouse_protocoll WHERE " . $where);
            $q3 = mysqli_query(Config::getDBConn(), "DELETE FROM " . DB_PREFIX . "kasse WHERE " . $where);
            if ($q1 && $q2 && $q3)
                return true;
            else
                return false;

        }
        return true;
    }

    public function getLastActivityDiscoverDate()
    {
        $result = null;
        $query = "SELECT value FROM " . DB_PREFIX . "config WHERE set_key='cron_last_activity_discover'";

        //echo $query;
        $res = mysqli_query(Config::getDBConn(), $query);
        if (mysqli_num_rows($res) == 1) {
            $row = mysqli_fetch_array($res);
            $result = new DateTime($row['value']);

        }
        return $result;
    }

    public function updateLastActivityDiscoverDate($date)
    {
        if (!($date instanceof DateTime)) {
            return false;
        }
        $dateStr = $date->format("Y-m-d H:i");
        $q1 = mysqli_query(Config::getDBConn(), "UPDATE " . DB_PREFIX . "config set value='" . $dateStr . "' WHERE set_key='cron_last_activity_discover'");
        if ($q1) {
            return true;
        } else {
            return false;
        }
    }

    public function getLatestVersion($force = false)
    {
        //aktuellste Version ermitteln und nur einmal pro session (auer force ist true
        if (!isset($_SESSION['latest_version']) || $force) {
            $installedVerion = $this->getToolVersion();
            try {
                $version = $this->getUrlContent("https://www.elchlepp.info/egtool/version.txt?v=" . urlencode($installedVerion));
                if ($version !== false) {
                    $_SESSION['latest_version'] = makeEntityString($version);
                } else {
                    $_SESSION['latest_version'] = $installedVerion;
                }
            } catch (Exception $e) {
                // on error set the used version as latest version
                $_SESSION['latest_version'] = $installedVerion;
            }
        }
        return $_SESSION['latest_version'];
    }

    /**
     * @throws Exception
     * @return string|bool
     */
    private function getUrlContent(string $url)
    {
        if (function_exists('curl_version'))
        {
            $curl = curl_init();
            curl_setopt($curl, CURLOPT_URL, $url);
            curl_setopt($curl, CURLOPT_RETURNTRANSFER, 1);
            $content = curl_exec($curl);
            curl_close($curl);
        }
        else if (file_get_contents(__FILE__) && ini_get('allow_url_fopen'))
        {
            $content = file_get_contents($url);
        }
        else
        {
            throw new Exception('Weder cUrl noch allow_url_fopen ist aktiviert!');
        }
        return $content;
    }


    public function getEditNewsIds()
    {
        return $this->editnewsids;
    }

    public function getEditHuntUserIds()
    {
        return $this->editHuntUserIds;
    }


}