<?php
require_once 'Security.php';

function redirectTo($redirect)
{
    $hostname = $_SERVER['HTTP_HOST'];
    $path = dirname($_SERVER['PHP_SELF']);
    $prot = (Security::isSSL() ? 'https' : 'http');
    header('Location: '.$prot.'://'.$hostname.$path.'/index.php'.$redirect);
    exit;
}

function addToListPayment($list, $newItem, $ignore, &$ignored)
 {
    //Aufbau: 0: ganze Zeile, 1: Datum, 2:Uhrzeit, 3: Name, 4: Einzahlung|Entnahme, 5: Betrag
    if(array_key_exists(5, $newItem))
	{
		//wenn die einzelnen Arrays auch befllt sind
		if(count($newItem[1]) > 0 && count($newItem[2]) > 0 && count($newItem[3]) > 0 && count($newItem[4]) > 0)
		
		$date = $newItem[1][0];
		$time = $newItem[2][0];
		$name = $newItem[3][0];
		$action = $newItem[4][0];
		$amount = $newItem[5][0];
		
		//wenn Name ignoriert werden soll
		if(in_array($name, $ignore)) 
		{
			if(!in_array($name, $ignored)) $ignored[] = $name;
			return $list;
		}
		
		//wenn kein Index, mit dem Namen existiert
		if(!array_key_exists($name, $list))
			$list[$name] = Array();
		//wenn kein Index, mit dem Datum existiert
		if(!array_key_exists($date, $list[$name]))
		{	
			$list[$name][$date] = Array(); 
			$list[$name][$date]['deposit'] = 0; 
			$list[$name][$date]['withdrawal'] = 0; 
			$d = explode('.', $date);
			$t = explode(':', $time);
			$datetime = sprintf('%s-%s-%s %s:%s:00', $d[2], $d[1], $d[0], $t[0], $t[1]);
			$list[$name][$date]['lastaction'] = $datetime; 
			$list[$name][$date]['lastamount'] = $amount; 
		}
		
		if($action == 'Einzahlung' && is_numeric($amount))
		  $list[$name][$date]['deposit'] += $amount;
		else if($action == 'Entnahme' && is_numeric($amount))
		  $list[$name][$date]['withdrawal'] += $amount;
		if(!array_key_exists($time, $list[$name][$date]))
		  $list[$name][$date][$time][$action] = $amount;
	}
	return $list;
}

function getStringForDb($string, $withentities = true)
{
	if($withentities)
            $string = htmlentities($string, ENT_COMPAT | ENT_HTML401, 'ISO-8859-1');
        $string = mysqli_real_escape_string(Config::getDBConn(), $string);
	return $string;	
}

function makeEntityString($string)
{
	return htmlentities($string, ENT_COMPAT | ENT_HTML401, 'ISO-8859-1');
}

function makeEntityDecodeString($string)
{
	return html_entity_decode($string, ENT_COMPAT | ENT_HTML401, 'ISO-8859-1');
}

function createRepeatedString($input, $count=0)
{
	$result = "";
	for($i = 0; $i <= $count; $i++)
		$result .= $input;
	return $result;
}

function getMonthList($months)
{
  $list = array();
  if(is_array($months));
  {
    foreach($months as $month)
	{
	    $c = count($list);
		switch($month)
		{
			case 1: $list[$c][0] = "Januar"; $list[$c][1] = 1; break;
			case 2: $list[$c][0] = "Februar"; $list[$c][1] = 2; break;
			case 3: $list[$c][0] = "M&auml;rz"; $list[$c][1] = 3; break;
			case 4: $list[$c][0] = "April"; $list[$c][1] = 4; break;
			case 5: $list[$c][0] = "Mai"; $list[$c][1] = 5; break;
			case 6: $list[$c][0] = "Juni"; $list[$c][1] = 6; break;
			case 7: $list[$c][0] = "Juli"; $list[$c][1] = 7; break;
			case 8: $list[$c][0] = "August"; $list[$c][1] = 8; break;
			case 9: $list[$c][0] = "September"; $list[$c][1] = 9; break;
			case 10: $list[$c][0] = "Oktober"; $list[$c][1] = 10; break;
			case 11: $list[$c][0] = "November"; $list[$c][1] = 11; break;
			case 12: $list[$c][0] = "Dezember"; $list[$c][1] = 12; break;
		}
	}
  }
  return $list;
}

function getMonth($month)
{
	switch($month)
	{
		case 1: return "Januar"; break;
		case 2: return "Februar"; break;
		case 3: return "M&auml;rz"; break;
		case 4: return "April"; break;
		case 5: return "Mai"; break;
		case 6: return "Juni"; break;
		case 7: return "Juli"; break;
		case 8: return "August"; break;
		case 9: return "September"; break;
		case 10: return "Oktober"; break;
		case 11: return "November"; break;
		case 12: return "Dezember"; break;
	}
}

function decodeAbsatz($string) 
{  
    $string = str_replace("[nlabsnl]", "\n", $string);
    $string = str_replace("[nlgansnl]", "\"", $string);
    $string = str_replace("[nlgans1nl]", "'", $string);
    
    return $string;  
}

function generateToken($len=8)
{
	$res = "";
	for($i = 0; $i < 8; $i++)
		$res .= chr(rand(97,122));	//nur kleinbuchstaben
	return $res;
}

function bbCodeConverter($str)
{
    $str = preg_replace("/\[b\](.*)\[\/b\]/Usi", "<strong>$1</strong>", $str);
    $str = preg_replace("/\[i\](.*)\[\/i\]/Usi", "<i>$1</i>", $str);
    $str = preg_replace("/\[u\](.*)\[\/u\]/Usi", "<u>$1</u>", $str);
    $str = preg_replace("/\[c\](.*)\[\/c\]/Usi", "<div style=\"text-align:center\">$1</div>", $str);
    
    return $str;
}

// http://php.net/manual/en/function.uniqid.php#94959
function gen_uuidv4() {
    return sprintf( '%04x%04x-%04x-%04x-%04x-%04x%04x%04x',
        // 32 bits for "time_low"
        mt_rand( 0, 0xffff ), mt_rand( 0, 0xffff ),

        // 16 bits for "time_mid"
        mt_rand( 0, 0xffff ),

        // 16 bits for "time_hi_and_version",
        // four most significant bits holds version number 4
        mt_rand( 0, 0x0fff ) | 0x4000,

        // 16 bits, 8 bits for "clk_seq_hi_res",
        // 8 bits for "clk_seq_low",
        // two most significant bits holds zero and one for variant DCE1.1
        mt_rand( 0, 0x3fff ) | 0x8000,

        // 48 bits for "node"
        mt_rand( 0, 0xffff ), mt_rand( 0, 0xffff ), mt_rand( 0, 0xffff )
    );
}
?>