<?php
class Group
{
	private $user;
	
	public function __construct($user) { $this->user = $user; }

	public function getGroups()
	{
		$result = array();
		$query = "SELECT g.gid, g.name, g.description, ua.site, ua.sid 
					FROM ".DB_PREFIX."groups g LEFT JOIN  
						(SELECT gr.gid, s.site, s.sid FROM ".DB_PREFIX."group_rights gr 
						LEFT JOIN ".DB_PREFIX."sites s ON gr.sid=s.sid ORDER BY s.sort) ua 
					ON g.gid=ua.gid";
		$res =  mysqli_query(Config::getDBConn(), $query);
		if(mysqli_num_rows($res) > 0)
		{
			$i = -1;
			$tmpgid = 0;
			while($row = mysqli_fetch_array($res))
			{
				if($row['gid'] != $tmpgid)
				{
					$i++;
					$result[$i]['id'] = $row['gid'];
					$result[$i]['name'] = $row['name'];
					$result[$i]['desc'] = $row['description'];
					$result[$i]['sites'] = $row['site'];
					$result[$i]['sid'] = $row['sid'];
				}
				else
					$result[$i]['sites'] .= '<br />'.$row['site'];
				
				$tmpgid = $row['gid'];				
			}
		}
		return $result;
	}
	
	
	public function getUserByGroup($gid)
	{
		$result = array();
		$query = "SELECT gu.gid, u.uid, u.nick FROM ".DB_PREFIX."users u, ".DB_PREFIX."groups_user gu 
				  WHERE gu.uid=u.uid and gu.gid=".(int)$gid." ORDER BY u.nick";
		$res =  mysqli_query(Config::getDBConn(), $query);
		if(mysqli_num_rows($res) > 0)
		{
			$i = 0;
			while($row = mysqli_fetch_array($res))
			{
				
				$result[$i]['uid'] = $row['uid'];
				$result[$i]['gid'] = $row['gid'];
				$result[$i]['nick'] = $row['nick'];
				$i++;
			}
								
		}
		return $result;
	}
	
	public function getGuildsByGroup($gid)
	{
		$result = array();
		$query = "SELECT gg.gid, g.guid, g.name FROM ".DB_PREFIX."guilds g, ".DB_PREFIX."groups_guild gg 
				  WHERE gg.guid=g.guid and gg.gid=".(int)$gid." ORDER BY g.name";
		$res =  mysqli_query(Config::getDBConn(), $query);
		if(mysqli_num_rows($res) > 0)
		{
			$i = 0;
			while($row = mysqli_fetch_array($res))
			{
				
				$result[$i]['guid'] = $row['guid'];
				$result[$i]['gid'] = $row['gid'];
				$result[$i]['name'] = $row['name'];
				$i++;
			}
								
		}
		return $result;
	}
	
	public function getGuildRightsByGroup($gid)
	{
		$result = array();
		$query = "SELECT gg.gid, g.guid, g.name, gg.canread, gg.canwrite
				  FROM ".DB_PREFIX."guilds g, ".DB_PREFIX."group_rights_guild gg 
				  WHERE gg.guid=g.guid and gg.gid=".(int)$gid." ORDER BY g.name";
		$res =  mysqli_query(Config::getDBConn(), $query);
		if(mysqli_num_rows($res) > 0)
		{
			$i = 0;
			while($row = mysqli_fetch_array($res))
			{
				
				$result[$i]['guid'] = $row['guid'];
				$result[$i]['gid'] = $row['gid'];
				$result[$i]['name'] = $row['name'];
				$result[$i]['canread'] = $row['canread'];
				$result[$i]['canwrite'] = $row['canwrite'];
				$i++;
			}
								
		}
		return $result;
	}
	
	private function getSubPages($gid, $parent, &$pagearray, $lvl = 0)
	{
		//alle untergeordneten Seiten eine Parenseite holen
		$query = "SELECT gr.gid, s.sid, s.site
				  FROM ".DB_PREFIX."sites s, ".DB_PREFIX."group_rights gr 
				  WHERE gr.sid=s.sid and gr.gid=".(int)$gid." and s.parent=".(int)$parent." ORDER BY s.sort";

		$res =  mysqli_query(Config::getDBConn(), $query);
		if(mysqli_num_rows($res) > 0)
		{			//jeweils 2 leerzeichen pro sublvl hinzufgen
			$i = 0; $whitespace = createRepeatedString("&nbsp;", $lvl+(2*$lvl));
			while($row = mysqli_fetch_array($res))
			{
				$newArr = Array(
									'site'	=> $whitespace.$row['site'],
									'id'	=> $row['sid'],
									'gid' 	=> $row['gid'],
									'lvl'	=> $lvl
								);
				$pagearray[] = $newArr;
				$this->getSubPages($gid, $row['sid'], $pagearray, $lvl+1);			//rekursiven aufruf starten und alle unterseiten holen
			}
		}
	}
	
	public function getSitesForGroup($gid)
	{
		$result = Array();
		$this->getSubPages($gid, 0, $result);
		return $result;
	}
	
	public function getWarehousesByGroup($gid)
	{
		$result = array();
		$query = "SELECT wgr.gid, w.wid, w.name, wgr.canread, wgr.canwrite FROM ".DB_PREFIX."warehouse_group_rights wgr, ".DB_PREFIX."warehouse w 
				  WHERE wgr.wid=w.wid and wgr.gid=".(int)$gid." ORDER BY w.name";
		
		$res =  mysqli_query(Config::getDBConn(), $query);
		if(mysqli_num_rows($res) > 0)
		{
			$i = 0;
			while($row = mysqli_fetch_array($res))
			{
				
				$result[$i]['wid'] = $row['wid'];
				$result[$i]['gid'] = $row['gid'];
				$result[$i]['name'] = $row['name'];
				$result[$i]['canread'] = $row['canread'];
				$result[$i]['canwrite'] = $row['canwrite'];
				$i++;
			}
								
		}
		return $result;
	}
	
	public function addGroup($name)
	{
		if( mysqli_query(Config::getDBConn(), "INSERT INTO ".DB_PREFIX."groups(name) VALUES ('".getStringForDb($name)."')"))
			return true;
		else 	
			return false;
	}
	
	public function loadGroup($gid)
	{
		$result = array();
		$query = "SELECT gid, name FROM ".DB_PREFIX."groups WHERE gid=".(int)$gid;
		
		$res =  mysqli_query(Config::getDBConn(), $query);
		if(mysqli_num_rows($res) == 1)
		{
			$row = mysqli_fetch_array($res);
			$result['id'] = $row['gid'];
			$result['name'] = $row['name'];
		}
		return $result;
	}
	
	public function updateGroup($gid, $name)
	{
		if( mysqli_query(Config::getDBConn(), "UPDATE ".DB_PREFIX."groups SET name='".getStringForDb($name)."' WHERE gid=".(int)$gid))
			return true;
		else 	
			return false;
	}
	
	public function deleteGroup($gid)
	{
		$q1 =  mysqli_query(Config::getDBConn(), "DELETE FROM ".DB_PREFIX."groups WHERE gid=".(int)$gid);
		$q2 =  mysqli_query(Config::getDBConn(), "DELETE FROM ".DB_PREFIX."groups_user WHERE gid=".(int)$gid);
		$q3 =  mysqli_query(Config::getDBConn(), "DELETE FROM ".DB_PREFIX."group_rights WHERE gid=".(int)$gid);
		$q4 =  mysqli_query(Config::getDBConn(), "DELETE FROM ".DB_PREFIX."warehouse_group_rights WHERE gid=".(int)$gid);
		if($q1 && $q2 && $q3 && $q4)
			return true;
		else 	
			return false;
	}
	
	public function getSitesNotInGroup($gid)
	{
		$result = array();
		$this->getSubPagesNotInGroup($gid, 0, $result);		//und die rekursion beginnt ...
		return $result;
	}
	
	
	private function getSubPagesNotInGroup($gid, $parent, &$pagearray, $lvl = 0)
	{
		//alle untergeordneten Seiten eine Parentseite holen
		$query = "SELECT s1.sid, s1.site
				  FROM ".DB_PREFIX."sites s1
				  WHERE parent=".(int)$parent." ORDER BY sort";

		$res =  mysqli_query(Config::getDBConn(), $query);
		//wenn es keine gibt, nichts machen
		if(mysqli_num_rows($res) > 0)
		{	
			$whitespace = createRepeatedString("&nbsp;", $lvl+(2*$lvl));
			while($row = mysqli_fetch_array($res))
			{
				
				//prfen ob seite gesetzt wurden
				$query2 = "SELECT sid, site FROM ".DB_PREFIX."sites 
						   WHERE sid=".$row['sid']." and sid NOT IN(SELECT sid FROM ".DB_PREFIX."group_rights WHERE gid=".(int)$gid.")";
				
				$res2 =  mysqli_query(Config::getDBConn(), $query2);
				
				//Seite zum Array hinzufgen
				$newArr = Array(
									'site'	=> $whitespace.$row['site'],
									'id'	=> $row['sid'],
									'lvl'	=> $lvl
								);
				$pagearray[] = $newArr;
					
				//wenn seite noch nicht gesetzt, Unterseiten holen
				if(mysqli_num_rows($res2) > 0)
				{
					$this->getSubPagesNotInGroup($gid, $row['sid'], $pagearray, $lvl+1);
				}
				else
				{
					//auch erst einmal hinzufgen, wenn keine Untersiten vorhanden, wieder aus array entfernen
					$precount = count($pagearray);		//index merken
					$this->getSubPagesNotInGroup($gid, $row['sid'], $pagearray, $lvl+1);
					//wenn keine Unterseiten hinzugefgt wurden, wieder aus array antfernen
					if(count($pagearray) == $precount)
						array_splice($pagearray, $precount-1, 1);
					
				}
			}
		}
	}
	
	private function getParentPages($sid, &$pagearray)
	{
		//die bergeordnete Seite holen
		$query = "SELECT s.sid, s.site
				  FROM ".DB_PREFIX."sites s
				  WHERE s.sid=(SELECT parent FROM ".DB_PREFIX."sites where sid=".(int)$sid.")";

		$res =  mysqli_query(Config::getDBConn(), $query);
		if(mysqli_num_rows($res) > 0)
		{			
			while($row = mysqli_fetch_array($res))
			{
				$newArr = Array(
									'site'	=> $row['site'],
									'id'	=> $row['sid']
								);
				$pagearray[] = $newArr;
				$this->getParentPages($row['sid'], $pagearray);			//rekursiven aufruf starten und alle unterseiten holen
			}
		}
	}
	
	public function addRightToGroup($gid, $sid)
	{
		$parents = Array();
		$this->getParentPages($sid, $parents);
		
		//die eigentliche Seite hinzufgen
		$q1 =  mysqli_query(Config::getDBConn(), "INSERT INTO ".DB_PREFIX."group_rights(gid, sid) VALUES (".(int)$gid.", ".(int)$sid.")");
		//die Elternseiten hinzufgen
		foreach($parents as $row)
			 mysqli_query(Config::getDBConn(), "INSERT INTO ".DB_PREFIX."group_rights(gid, sid) VALUES (".(int)$gid.", ".(int)$row['id'].")");
		
		if($q1)
			return true;
		else 	
			return false;
	}
	
	public function getUserNotInGroup($gid)
	{
		$result = array();
		$query = "SELECT uid, nick FROM ".DB_PREFIX."users WHERE uid NOT IN(SELECT uid FROM ".DB_PREFIX."groups_user WHERE gid=".(int)$gid.")";
		$res =  mysqli_query(Config::getDBConn(), $query);
		if(mysqli_num_rows($res) > 0)
		{
			$i = 0;
			while($row = mysqli_fetch_array($res))
			{
				$result[$i]['uid'] = $row['uid'];
				$result[$i]['nick'] = $row['nick'];
				$i++;
			}
								
		}
		return $result;
	}
	
	public function getGuildsNotInGroup($gid)
	{
		$result = array();
		$query = $query = "SELECT gu.guid, gu.name 
						   FROM ".DB_PREFIX."guilds gu 
						   WHERE guid NOT IN(SELECT guid FROM ".DB_PREFIX."groups_guild WHERE gid=".(int)$gid.") 
						   ORDER BY gu.name";
		$res =  mysqli_query(Config::getDBConn(), $query);
		if(mysqli_num_rows($res) > 0)
		{
			$i = 0;
			while($row = mysqli_fetch_array($res))
			{
				$result[$i]['id'] = $row['guid'];
				$result[$i]['name'] = $row['name'];
				$i++;
			}
								
		}
		return $result;
	}
	
	public function getGuildsNotInGroupRight($gid)
	{
		$result = array();
		$query = $query = "SELECT gu.guid, gu.name 
						   FROM ".DB_PREFIX."guilds gu 
						   WHERE guid NOT IN(SELECT guid FROM ".DB_PREFIX."group_rights_guild WHERE gid=".(int)$gid.") 
						   ORDER BY gu.name";
		$res =  mysqli_query(Config::getDBConn(), $query);
		if(mysqli_num_rows($res) > 0)
		{
			$i = 0;
			while($row = mysqli_fetch_array($res))
			{
				$result[$i]['id'] = $row['guid'];
				$result[$i]['name'] = $row['name'];
				$i++;
			}
								
		}
		return $result;
	}
	
	public function getWhNotInGroup($gid)
	{
		$result = array();
		$query = "SELECT wid, name FROM ".DB_PREFIX."warehouse WHERE wid NOT IN(SELECT wid FROM ".DB_PREFIX."warehouse_group_rights WHERE gid=".(int)$gid.")";
		$res =  mysqli_query(Config::getDBConn(), $query);
		if(mysqli_num_rows($res) > 0)
		{
			$i = 0;
			while($row = mysqli_fetch_array($res))
			{
				$result[$i]['wid'] = $row['wid'];
				$result[$i]['name'] = $row['name'];
				$i++;
			}
								
		}
		return $result;
	}
	
	public function addUserToGroup($gid, $uid)
	{
		if( mysqli_query(Config::getDBConn(), "INSERT INTO ".DB_PREFIX."groups_user(gid, uid) VALUES (".(int)$gid.", ".(int)$uid.")"))
			return true;
		else 	
			return false;
	}
	
	public function addGuildToGroup($gid, $guid)
	{
		if( mysqli_query(Config::getDBConn(), "INSERT INTO ".DB_PREFIX."groups_guild(gid, guid) VALUES (".(int)$gid.", ".(int)$guid.")"))
			return true;
		else 	
			return false;
	}
	
	public function addGuildRightToGroup($gid, $guid, $read, $write)
	{
		if( mysqli_query(Config::getDBConn(), "INSERT INTO ".DB_PREFIX."group_rights_guild(gid, guid, canread, canwrite) VALUES (".(int)$gid.", ".(int)$guid.", ".(int)$read.", ".(int)$write.")"))
			return true;
		else 	
			return false;
	}
	
	public function addWhToGroup($gid, $wid, $r, $w)
	{
		if( mysqli_query(Config::getDBConn(), "INSERT INTO ".DB_PREFIX."warehouse_group_rights(wid, gid, canread, canwrite) 
			VALUES (".(int)$wid.", ".(int)$gid.", ".(int)$r.", ".(int)$w.")"))
			return true;
		else 	
			return false;
	}
	
	public function deleteUserByGroup($gid, $uid)
	{
		if( mysqli_query(Config::getDBConn(), "DELETE FROM ".DB_PREFIX."groups_user WHERE gid=".(int)$gid." and uid=".(int)$uid))
			return true;
		else 	
			return false;
	}
	
	public function deleteGuildByGroup($gid, $guid)
	{
		if( mysqli_query(Config::getDBConn(), "DELETE FROM ".DB_PREFIX."groups_guild WHERE gid=".(int)$gid." and guid=".(int)$guid))
			return true;
		else 	
			return false;
	}
	
	public function deleteGuildRightByGroup($gid, $guid)
	{
		if( mysqli_query(Config::getDBConn(), "DELETE FROM ".DB_PREFIX."group_rights_guild WHERE gid=".(int)$gid." and guid=".(int)$guid))
			return true;
		else 	
			return false;
	}
	
	public function deleteRightByGroup($gid, $sid)
	{
		//lsche aktuelle Seite unt evtl. Unterseiten
		$query = "DELETE FROM ".DB_PREFIX."group_rights 
				  WHERE gid=".(int)$gid." and sid IN (
				  	SELECT sid from ".DB_PREFIX."sites 
				  	WHERE sid=".(int)$sid." or parent=".(int)$sid.")";
		if( mysqli_query(Config::getDBConn(), $query))
			return true;
		else 	
			return false;
	}
	
	public function deleteWhForGroup($gid, $wid)
	{
		if( mysqli_query(Config::getDBConn(), "DELETE FROM ".DB_PREFIX."warehouse_group_rights WHERE gid=".(int)$gid." and wid=".(int)$wid))
			return true;
		else 	
			return false;
	}
}
?>