<?php
class Guild
{
	private $user;
	
	public function __construct($user) { $this->user = $user; }

	public function getGuilds()
	{
		$result = array();
		$query = "SELECT gu.guid, gu.name, gu.color, gu.short 
					FROM ".DB_PREFIX."guilds gu";
		
		$res =  mysqli_query(Config::getDBConn(), $query);
		$i = 0;
		if(mysqli_num_rows($res) > 0)
		{
			while($row = mysqli_fetch_array($res))
			{
				$result[$i]['id'] = $row['guid'];
				$result[$i]['name'] = $row['name'];
				$result[$i]['color'] = $row['color'];
				$result[$i]['short'] = $row['short'];
				$i++;			
			}
		}
		return $result;
	}
	
	public function getGuildById($guId)
	{
		$result = array();
		$query = "SELECT gu.guid, gu.name, gu.color, gu.short, gu.auto_cap_active, gu.world 
					FROM ".DB_PREFIX."guilds gu WHERE guid=".(int)$guId;
		
		$res =  mysqli_query(Config::getDBConn(), $query);
		if(mysqli_num_rows($res) > 0)
		{
			while($row = mysqli_fetch_array($res))
			{
				$result['id'] = $row['guid'];
				$result['name'] = $row['name'];
				$result['color'] = $row['color'];
				$result['short'] = $row['short'];
                                $result['auto_cap_active'] = $row['auto_cap_active'];
                                $result['world'] = $row['world'];
			}
		}
		return $result;
	}
	
	public function getGuildByShort($short)
	{
		$result = array();
		$query = "SELECT gu.guid, gu.name, gu.color, gu.short 
					FROM ".DB_PREFIX."guilds gu WHERE gu.short='".getStringForDb($short)."'";
	
		$res =  mysqli_query(Config::getDBConn(), $query);
		if(mysqli_num_rows($res) > 0)
		{
			while($row = mysqli_fetch_array($res))
			{
				$result['id'] = $row['guid'];
				$result['name'] = $row['name'];
				$result['color'] = $row['color'];
				$result['short'] = $row['short'];		
			}
		}
		return $result;
	}
	
	public function getGuildsByReadRight()
	{
		$result = array();
		$query = "SELECT DISTINCT g.guid, g.name, g.color 
					FROM ".DB_PREFIX."guilds g
					JOIN ".DB_PREFIX."group_rights_guild grg ON grg.guid=g.guid
					LEFT JOIN ".DB_PREFIX."groups_user gu ON grg.gid=gu.gid
				 	LEFT JOIN ".DB_PREFIX."groups_guild gg ON grg.gid=gg.gid
				  	LEFT JOIN ".DB_PREFIX."guilds_user ggu ON ggu.guid=gg.guid
					WHERE ((gu.uid=".$this->user->getUId().") or (ggu.uid=".$this->user->getUId().")) and grg.canread=1
					ORDER BY g.guid";
		
		$res =  mysqli_query(Config::getDBConn(), $query);
		$i = 0;
		if(mysqli_num_rows($res) > 0)
		{
			while($row = mysqli_fetch_array($res))
			{
				$result[$i]['id'] = $row['guid'];
				$result[$i]['name'] = $row['name'];
				$result[$i]['color'] = $row['color'];
				$i++;			
			}
		}
		return $result;
	}
	
	public function getGuildsByWriteRight()
	{
		$result = array();
		$query = "SELECT DISTINCT g.guid, g.name, g.color 
					FROM ".DB_PREFIX."guilds g
					JOIN ".DB_PREFIX."group_rights_guild grg ON grg.guid=g.guid
					LEFT JOIN ".DB_PREFIX."groups_user gu ON grg.gid=gu.gid
				 	LEFT JOIN ".DB_PREFIX."groups_guild gg ON grg.gid=gg.gid
				  	LEFT JOIN ".DB_PREFIX."guilds_user ggu ON ggu.guid=gg.guid
					WHERE ((gu.uid=".$this->user->getUId().") or (ggu.uid=".$this->user->getUId().")) and grg.canwrite=1
					ORDER BY g.guid";
		
		$res =  mysqli_query(Config::getDBConn(), $query);
		$i = 0;
		if(mysqli_num_rows($res) > 0)
		{
			while($row = mysqli_fetch_array($res))
			{
				$result[$i]['id'] = $row['guid'];
				$result[$i]['name'] = $row['name'];
				$result[$i]['color'] = $row['color'];
				$i++;			
			}
		}
		return $result;
	}
	
	public function canAccess($guilds, $postguild)
	{
		if(is_array($guilds))
		{
			foreach($guilds as $guild)
			{
				if($guild['id'] == $postguild)
					return true;
			}
		}
		return false;
	}
	
	public function getGuildsUserByAccess($guilds)
	{
		/*****************Gilden******************/
		$ing = " and gu.guid IN("; $i = 0;
		foreach($guilds as $gid)	
		{
			$ing .= $gid['id'];
			if($i != count($guilds)-1)
					$ing .= ', ';
				$i++;
		}
		if(count($guilds) == 0)	$ing .= "0";
		$ing .= ")";
		
		$result = array();
		$query = "SELECT u.uid, u.nick FROM ".DB_PREFIX."users u, ".DB_PREFIX."guilds_user gu WHERE u.uid=gu.uid".$ing."
				  ORDER BY u.nick";
		$res =  mysqli_query(Config::getDBConn(), $query);
		if(mysqli_num_rows($res) > 0)
		{
			$i = 0;
			while($row = mysqli_fetch_array($res))
			{
				$result[$i]['id'] = $row['uid'];	
				$result[$i]['nick'] = $row['nick'];		
				$i++;		
			}
		}
		return $result;
	}
	
	public function getUsersForGuild($gid)
	{
		$result = array();
		$query = "SELECT u.uid, u.nick FROM ".DB_PREFIX."users u, ".DB_PREFIX."guilds_user gu WHERE gu.guid=".(int)$gid." and u.uid=gu.uid
				  ORDER BY u.nick";
		$res =  mysqli_query(Config::getDBConn(), $query);
		if(mysqli_num_rows($res) > 0)
		{
			$i = 0;
			while($row = mysqli_fetch_array($res))
			{
				$result[$i]['id'] = $row['uid'];
				$result[$i]['nick'] = $row['nick'];
				$i++;
			}
		}
		return $result;
	}
	
	public function getUserByGroup($gid)
	{
		$result = array();
		$query = "SELECT gu.gid, u.uid, u.nick FROM ".DB_PREFIX."users u, ".DB_PREFIX."groups_user gu 
				  WHERE gu.uid=u.uid and gu.gid=".(int)$gid." ORDER BY u.nick";
		$res =  mysqli_query(Config::getDBConn(), $query);
		if(mysqli_num_rows($res) > 0)
		{
			$i = 0;
			while($row = mysqli_fetch_array($res))
			{
				
				$result[$i]['uid'] = $row['uid'];
				$result[$i]['gid'] = $row['gid'];
				$result[$i]['nick'] = $row['nick'];
				$i++;
			}
								
		}
		return $result;
	}
	
	public function getRightsByGroup($gid)
	{
		$result = array();
		$query = "SELECT gr.gid, s.sid, s.site FROM ".DB_PREFIX."sites s, ".DB_PREFIX."group_rights gr 
				  WHERE gr.sid=s.sid and gr.gid=".(int)$gid." ORDER BY s.site";

		$res =  mysqli_query(Config::getDBConn(), $query);
		if(mysqli_num_rows($res) > 0)
		{
			$i = 0;
			while($row = mysqli_fetch_array($res))
			{
				
				$result[$i]['sid'] = $row['sid'];
				$result[$i]['gid'] = $row['gid'];
				$result[$i]['site'] = $row['site'];
				$i++;
			}
								
		}
		return $result;
	}
	
	
	
	public function getWarehousesByGroup($gid)
	{
		$result = array();
		$query = "SELECT wgr.gid, w.wid, w.name FROM ".DB_PREFIX."warehouse_group_rights wgr, ".DB_PREFIX."warehouse w 
				  WHERE wgr.wid=w.wid and wgr.gid=".(int)$gid." ORDER BY w.name";
		$res =  mysqli_query(Config::getDBConn(), $query);
		if(mysqli_num_rows($res) > 0)
		{
			$i = 0;
			while($row = mysqli_fetch_array($res))
			{
				
				$result[$i]['wid'] = $row['wid'];
				$result[$i]['gid'] = $row['gid'];
				$result[$i]['name'] = $row['name'];
				$i++;
			}
								
		}
		return $result;
	}
	
	public function addGuild($name, $color, $short, $autoCap, $world)
	{
		if( mysqli_query(Config::getDBConn(), "INSERT INTO ".DB_PREFIX."guilds(name, color, short, auto_cap_active, world) 
					    VALUES ('".getStringForDb($name)."', '".getStringForDb($color)."', '".getStringForDb($short)."', ".(int)$autoCap.", "
                                            .(int)$world.")"))
			return true;
		else 	
			return false;
	}
	
	public function loadGuild($gid)
	{
		$result = array();
		$query = "SELECT guid, name, color, short, auto_cap_active, world FROM ".DB_PREFIX."guilds WHERE guid=".(int)$gid;
		
		$res =  mysqli_query(Config::getDBConn(), $query);
		if(mysqli_num_rows($res) == 1)
		{
			$row = mysqli_fetch_array($res);
			$result['id'] = $row['guid'];
			$result['name'] = $row['name'];
			$result['color'] = $row['color'];
			$result['short'] = $row['short'];
                        $result['auto_cap_active'] = $row['auto_cap_active'];
                        $result['world'] = $row['world'];
		}
		return $result;
	}
	
	public function updateGuild($gid, $name, $color, $short, $autoCap, $world)
	{
		if( mysqli_query(Config::getDBConn(), "UPDATE ".DB_PREFIX."guilds 
					    SET name='".getStringForDb($name)."', color='".getStringForDb($color)."', short='".getStringForDb($short)."',
                                                auto_cap_active=".(int)$autoCap.", world=".(int)$world."
					    WHERE guid=".(int)$gid))
			return true;
		else 	
			return false;
	}
	
	public function deleteGuild($gid)
	{
		$q1 =  mysqli_query(Config::getDBConn(), "DELETE FROM ".DB_PREFIX."guilds WHERE guid=".(int)$gid);
		$q2 =  mysqli_query(Config::getDBConn(), "DELETE FROM ".DB_PREFIX."guilds_user WHERE guid=".(int)$gid);
		if($q1 && $q2)
			return true;
		else 	
			return false;
	}
	
	public function getUserNotInGuild($gid)
	{
		$result = array();
		$query = "SELECT uid, nick FROM ".DB_PREFIX."users WHERE uid NOT IN(SELECT uid FROM ".DB_PREFIX."guilds_user)
				  ORDER BY nick";
		$res =  mysqli_query(Config::getDBConn(), $query);
		if(mysqli_num_rows($res) > 0)
		{
			$i = 0;
			while($row = mysqli_fetch_array($res))
			{
				$result[$i]['uid'] = $row['uid'];
				$result[$i]['nick'] = $row['nick'];
				$i++;
			}
								
		}
		return $result;
	}
	
	
	public function addUserToGuild($gid, $uid)
	{
		if( mysqli_query(Config::getDBConn(), "INSERT INTO ".DB_PREFIX."guilds_user(guid, uid) VALUES (".(int)$gid.", ".(int)$uid.")"))
			return true;
		else 	
			return false;
	}
	
	public function deleteUserFromGuilds($uid)
	{
		if( mysqli_query(Config::getDBConn(), "DELETE FROM ".DB_PREFIX."guilds_user WHERE uid=".(int)$uid))
			return true;
		else 	
			return false;
	}
}
?>