<?php
class Hunt
{
    private $perPage = 20;
    private $userFilterQuery;
    private $fightcaps = Array(19,20,21,22,23,24,25,28,29,31,30);
    private $armorcaps = Array(26,27);
    private $slskcaps = Array(32,33);
    private $top_groups = Array();
    private $top_groups_names = Array();

    public function __construct()
    {
        $this->loadIniTopGroups();
    }

    public function getUsersByFilter($arr, $curSite, $hid)
    {
        //print_r($arr);
        $query = $this->getQueryOfUsersForFilter($arr, $hid);
        $query .= " LIMIT ".$this->getStartPos($curSite).", ".$this->perPage;

        $result = array();

        //echo $query;
        $query = @ mysqli_query(Config::getDBConn(), $query);
        $result[0] = $this->getNumberOfUsersForFilter($hid);
        $i = 1;
        while($row = @mysqli_fetch_array($query))
        {
            $result[$i]['id'] = $row['uid'];
            $result[$i]['nick'] = $row['nick'];
            $result[$i]['folk'] = $row[5];
            $result[$i]['titel'] = $row['titel'];
            $result[$i]['mail'] = $row['mail'];
            $result[$i]['lvl'] = $row['lvl'];
            $result[$i]['gilde'] = $row['name'];
            $result[$i]['color'] = $row['color'];
            $i++;
        }
        return $result;
    }

    public function calculatePages($number)
    {
        $page = 1;
        $page = $number / $this->perPage;	//anzahl der beitr�ge durch eintr�ge pro seite -- ergebnis z.b. 1.4
        $page = ceil($page);					//Aufrunden der Komma Zahl

        return $page;
    }

    private function getStartPos($currentPage=1)
    {
        return ($currentPage -1) * $this->perPage;
    }

    private function getNumberOfUsersForFilter($hid)
    {
        $query = $this->userFilterQuery;
        $query =  mysqli_query(Config::getDBConn(), $query);
        return mysqli_num_rows($query);
    }

    private function getQueryOfUsersForFilter($arr, $hid)
    {//print_r($arr);
        $guids = array();	$nks = false;	$healer = false;	$inpublic = false;
        $folks = array();	$dmg = false;	$active = false;	$topgroups = array();
        $works = array();	$area = false;	$notin = false;
        $lvlfrom = 1; $lvlto = 99; $capfrom = 0; $capto = 99;
        foreach($arr as $key=>$value)
        {
            //Gilde
            if(strlen(strstr($key, 'guild')) > 0)
            {
                $guid = substr($key, 5);
                //$cond .= " and gu.guid=".(int)$guid;
                $guids[count($guids)] = (int)$guid;
            }
            //Volk
            if(strlen(strstr($key, 'folk')) > 0)
            {
                $fid = substr($key, 4);
                $folks[count($folks)] = (int)$fid;
            }
            //Hauptgruppen
            if(strlen(strstr($key, 'htgid')) > 0)
            {
                $htgid = substr($key, 5);
                $topgroups[count($topgroups)] = (int)$htgid;
            }
            //Wanderer
            if(strlen(strstr($key, 'walker')) > 0)
            {
                //$cond .= " and u.nowork=1";
                $works[count($works)] = 1;
            }
            //Handwerker
            if(strlen(strstr($key, 'worker')) > 0)
            {
                //$cond .= " and u.nowork=0";
                $works[count($works)] = 0;
            }
            //Charakterstufe ab
            if(strlen(strstr($key, 'lvlfrom')) > 0)
            {
                $lvlfrom = (int)$value;
            }
            //Charakterstufetufe bis
            if(strlen(strstr($key, 'lvlto')) > 0)
            {
                $lvlto = (int)$value;
            }

            //Fertigkeitsstufe ab
            if(strlen(strstr($key, 'capfrom')) > 0)
            {
                $capfrom = (int)$value;
            }
            //Charakterstufetufe bis
            if(strlen(strstr($key, 'capto')) > 0)
            {
                $capto = (int)$value;
            }

            //NK
            if(strlen(strstr($key, 'nk')) > 0)
            {
                $nk = true;
            }

            //Damage-Dealer
            if(strlen(strstr($key, 'dmg')) > 0)
            {
                $dmg = true;
            }

            //Fl�che
            if(strlen(strstr($key, 'area')) > 0)
            {
                $area = true;
            }

            //Heiler
            if(strlen(strstr($key, 'healer')) > 0)
            {
                $healer = true;
            }

            //aktive Kampffertigkeiten
            if(strlen(strstr($key, 'active')) > 0)
            {
                $active = true;
            }

            //nur Chars die nicht in Gruppe sind
            if(strlen(strstr($key, 'notin')) > 0)
            {
                $notin = true;
            }

            //chars anzeigen, die in �ffentlichen Gruppen sind
            if(strlen(strstr($key, 'inpublic')) > 0)
            {
                $inpublic = true;
            }
        }

        /*****************Gilden******************/
        $ing = " and gu.guid IN("; $i = 0;
        foreach($guids as $gid)
        {
            $ing .= $gid;
            if($i != count($guids)-1)
                $ing .= ', ';
            $i++;
        }
        if(count($guids) == 0)	$ing .= "0";
        $ing .= ")";
        /*****************************************/
        /**************Hauptgruppen***************/
        $intg = " and u.uid NOT IN(SELECT hgu.uid FROM ".DB_PREFIX."hunt_group hg, ".DB_PREFIX."hunt_group_users hgu
								  WHERE hg.hid=hgu.hid and hg.htgid NOT IN("; $i = 0;
        foreach($topgroups as $gid)
        {
            $intg .= $gid;
            if($i != count($topgroups)-1)
                $intg .= ', ';
            $i++;
        }
        if(count($topgroups) == 0)	$intg .= "0";
        $intg .= "))";
        /*****************************************/
        /*****************V�lker******************/
        $inf = " and u.fid IN("; $i = 0;
        foreach($folks as $val)
        {
            $inf .= $val;
            if($i != count($folks)-1)
                $inf .= ', ';
            $i++;
        }
        if(count($folks) == 0)	$inf .= "-1";
        $inf .= ")";
        /*****************************************/
        /*****************Aktiv*******************/
        $inw = " and u.nowork IN("; $i = 0;
        foreach($works as $val)
        {
            $inw .= $val;
            if($i != count($works)-1)
                $inw .= ', ';
            $i++;
        }
        if(count($works) == 0)	$inw .= "9";
        $inw .= ")";
        /*****************************************/
        /***********Charakterstufe****************/
        $inlvl = " and u.lvl BETWEEN ".$lvlfrom." and ".$lvlto;
        /*****************************************/
        /***********Fertigkeitsstufe**************/
        $incap = " and uc.value BETWEEN ".$capfrom." and ".$capto;
        /*****************************************/
        /***********Kampffertigkeiten*************/
        if($nk || $dmg || $area || $healer)
        {
            $ind = " and uc.cid IN("; $tmp = "";
            if($nk)		$tmp .= ",19,20,21,22,23,";
            if($dmg)	$tmp .= ",24,25,28,";
            if($area)	$tmp .= ",29,31,";
            if($healer)	$tmp .= ",30,";

            $tmp = str_replace(",,", ",", $tmp);
            ($tmp[0]==","?$tmp = substr($tmp, 1):'');
            ($tmp[strlen($tmp)-1]==","?$tmp = substr($tmp, 0,strlen($tmp)-1):"");

            $ind .= $tmp;
            $ind .= ")";

        }
        else
            $ind = " and uc.cid IN(0)";
        if($active) 	$ind .= " and uc.mainwork=1";
        else			$ind .= " and uc.mainwork IN(0,1)";
        /*****************************************/
        $hid = (int)$hid;
        //wenn gruppe existiert, nur die Nutzer Laden, die noch nicht in der Gruppe sind
        if($hid > 0 && $notin)
        {
            $notin= " and u.uid NOT IN(SELECT hgu.uid FROM ".DB_PREFIX."hunt_group_users hgu WHERE hgu.hid=".$hid.")";
        }
        else
            $notin = "";

        //if(!$inpublic)
        //	$nopublic = " and u.uid NOT IN(SELECT hgu.uid FROM hunt_group hg, hunt_group_users hgu WHERE hg.hid=hgu.hid and hg.public=1)";

        $cond = $ind.$ing.$inf.$inw.$inlvl.$incap.$notin.$intg;
        //echo $cond;
        $query = "SELECT DISTINCT u.uid, u.nick, u.titel, u.mail, u.lvl, f.name, g.name, g.color
				  FROM ".DB_PREFIX."users u
				  JOIN ".DB_PREFIX."guilds_user gu
				  JOIN ".DB_PREFIX."capabilities c
				  JOIN ".DB_PREFIX."users_capabilities uc
				  JOIN ".DB_PREFIX."guilds g
				  JOIN ".DB_PREFIX."folk f ON f.fid=u.fid
				  WHERE u.uid=gu.uid and c.type=1 and uc.cid=c.cid and uc.uid=u.uid and g.guid=gu.guid".$cond." 
				  ORDER BY nick";
        $this->userFilterQuery = $query;
        return $query;
    }

    public function getUsersForHunt($hid)
    {
        //print_r($arr);
        $query = "SELECT u.uid, u.nick, u.titel, u.mail, u.lvl, u.fid, f.name as folk, hgu.leader, hgu.rand_enemy,
						 hgu.weak_enemy, hgu.strong_enemy, hgu.close_combat, hgu.close_far_combat 
				  FROM ".DB_PREFIX."hunt_group_users hgu
				  JOIN ".DB_PREFIX."users u ON u.uid=hgu.uid
				  JOIN ".DB_PREFIX."folk f ON f.fid=u.fid
				  WHERE hgu.hid=".(int)$hid." 
				  ORDER BY hgu.sort";

        $result = array();

        //echo $query;
        $query = @ mysqli_query(Config::getDBConn(), $query);
        $i = 0;
        while($row = @mysqli_fetch_array($query))
        {
            $result[$i]['id'] = $row['uid'];
            $result[$i]['nick'] = $row['nick'];
            $result[$i]['titel'] = $row['titel'];
            $result[$i]['mail'] = $row['mail'];
            $result[$i]['lvl'] = $row['lvl'];
            $result[$i]['folk'] = $row['folk'];
            $result[$i]['fid'] = $row['fid'];
            $result[$i]['leader'] = $row['leader'];
            $result[$i]['rand_enemy'] = $row['rand_enemy'];
            $result[$i]['weak_enemy'] = $row['weak_enemy'];
            $result[$i]['strong_enemy'] = $row['strong_enemy'];
            $result[$i]['close_combat'] = $row['close_combat'];
            $result[$i]['close_far_combat'] = $row['close_far_combat'];
            $result[$i]['attributes'] = $this->getUserAttributs($row['uid']);
            $result[$i]['capabilities'] = $this->getUserCapabilities($row['uid']);
            $i++;
        }
        return $result;
    }

    public function loadUserForHunt($uid)
    {
        //print_r($arr);
        $query = "SELECT u.uid, u.nick, u.titel, u.mail, u.lvl, u.nowork, u.fid, f.name as folk, g.name as guild,
				  u.description, u.bot, u.trustlvl, u.enemy, u.combat, u.combat_position, u.ontime,
                                  class.name as class
				  FROM ".DB_PREFIX."users u
				  JOIN ".DB_PREFIX."folk f ON f.fid=u.fid
				  LEFT JOIN ".DB_PREFIX."guilds_user gu ON gu.uid=u.uid
				  LEFT JOIN ".DB_PREFIX."guilds g ON g.guid=gu.guid
                                  LEFT JOIN " . DB_PREFIX . "classes_class AS class ON u.classes_class_id=class.id 
				  WHERE u.uid=".(int)$uid;

        $result = array();

        //echo $query;
        $query = @ mysqli_query(Config::getDBConn(), $query);
        if(mysqli_num_rows($query) == 1)
        {
            $row = @mysqli_fetch_array($query);

            $result['id'] = $row['uid'];
            $result['nick'] = $row['nick'];
            $result['titel'] = $row['titel'];
            $result['mail'] = $row['mail'];
            $result['lvl'] = $row['lvl'];
            $result['nowork'] = $row['nowork'];
            $result['folk'] = $row['folk'];
            $result['fid'] = $row['fid'];
            $result['guild'] = $row['guild'];
            $result['desc'] = $row['description'];
            $result['bot'] = $row['bot'];
            $result['trustlvl'] = $row['trustlvl'];
            $result['enemy'] = $row['enemy'];
            $result['combat'] = $row['combat'];
            $result['cposition'] = $row['combat_position'];
            $result['ontime'] = $row['ontime'];
            $result['class'] = $row['class'];
            $result['attributes'] = $this->getUserAttributs($row['uid']);
            $result['capabilities'] = $this->sortCaps($this->getUserCapabilities($row['uid']));
        }
        return $result;
    }

    public function loadUserForHunt2($uid, $hid)
    {
        //print_r($arr);
        $query = "SELECT u.uid, u.nick, u.titel, u.mail, u.lvl, u.nowork, u.fid,
				  u.description, u.bot, u.trustlvl, u.enemy, u.combat, u.combat_position, u.ontime, class.name as class, 
                                  hgu.inventar, hgu.spells, hgu.attributes, hgu.combat as hcombat, enchantment, hgu.enemy as henemy, 
                                  hgu.cposition as hcposition
				  FROM ".DB_PREFIX."users u
				  JOIN ".DB_PREFIX."hunt_group_users hgu ON hgu.uid=u.uid
                                  LEFT JOIN " . DB_PREFIX . "classes_class AS class ON u.classes_class_id=class.id
				  WHERE u.uid=".(int)$uid." and hgu.hid=".(int)$hid;

        $result = array();

        //echo $query;
        $query = @ mysqli_query(Config::getDBConn(), $query);
        if(mysqli_num_rows($query) == 1)
        {
            $row = @mysqli_fetch_array($query);

            $result['id'] = $row['uid'];
            $result['nick'] = $row['nick'];
            $result['titel'] = $row['titel'];
            $result['mail'] = $row['mail'];
            $result['lvl'] = $row['lvl'];
            $result['nowork'] = $row['nowork'];
            $result['fid'] = $row['fid'];
            $result['desc'] = $row['description'];
            $result['bot'] = $row['bot'];
            $result['trustlvl'] = $row['trustlvl'];
            $result['enemy'] = $row['enemy'];
            $result['combat'] = $row['combat'];
            $result['combat_position'] = $row['combat_position'];
            $result['ontime'] = $row['ontime'];
            $result['class'] = $row['class'];
            $result['custominventar'] = $row['inventar'];
            $result['customspells'] = $row['spells'];
            $result['customattributes'] = $row['attributes'];
            $result['customenchantment'] = $row['enchantment'];
            $result['hcombat'] = $row['hcombat'];
            $result['henemy'] = $row['henemy'];
            $result['hcposition'] = $row['hcposition'];
            //$result['attributes'] = $this->getUserAttributs($row['uid']);
            $result['capabilities'] = $this->sortCaps($this->getUserCapabilities($row['uid']));
        }
        return $result;
    }

    public function getUserAttributs($uid)
    {
        //print_r($arr);
        $query = "SELECT a.aid, a.name, ua.lvl
				  FROM ".DB_PREFIX."attributes a
				  LEFT JOIN ".DB_PREFIX."user_attributes ua ON a.aid=ua.aid and ua.uid=".(int)$uid." 
				  ORDER by a.aid";

        $result = array();

        //echo $query;
        $query = @ mysqli_query(Config::getDBConn(), $query);
        $i = 0;
        while($row = @mysqli_fetch_array($query))
        {
            $result[$i]['id'] = $row['aid'];
            $result[$i]['name'] = $row['name'];
            $result[$i]['lvl'] = (int)$row['lvl'];
            $i++;
        }
        return $result;
    }

    public function getUserCapabilities($uid)
    {
        $result = Array();
        //Kampffertigkeiten laden
        $query = "SELECT c.cid, c.capability, uc.value, uc.mainwork
				  FROM ".DB_PREFIX."capabilities c 
				  JOIN ".DB_PREFIX."users_capabilities uc on uc.cid=c.cid and uc.uid=".$uid." 
				  WHERE c.type=1 and c.cid<>34
				  ORDER BY uc.mainwork DESC, uc.value DESC";

        //echo $query;
        $res =  mysqli_query(Config::getDBConn(), $query);
        if(mysqli_num_rows($res) > 0)
        {
            $i = 0;
            while($row = mysqli_fetch_array($res))
            {
                $result[$i]['id'] = $row['cid'];
                $result[$i]['name'] = $row['capability'];
                $result[$i]['lvl'] = (int)$row['value'];
                $result[$i]['active'] = (int)$row['mainwork'];
                $i++;
            }

        }
        return $result;
    }

    public function sortCaps($caps)
    {
        $fightArray = Array(); $armorArray = Array(); $slskArray = Array(); $otherArray = Array();
        for($i=0;$i<count($caps);$i++)
        {
            if(in_array($caps[$i]['id'], $this->fightcaps) && $caps[$i]['active'])
                array_push($fightArray, $caps[$i]);
            else if(in_array($caps[$i]['id'], $this->armorcaps) && $caps[$i]['active'])
                array_push($armorArray, $caps[$i]);
            else if(in_array($caps[$i]['id'], $this->slskcaps))
                array_push($slskArray, $caps[$i]);
            else
                array_push($otherArray, $caps[$i]);
        }
        //if(count($fightArray)>0)	array_push($fightArray, Array("id"=>"","name"=>"","lvl"=>"","active"=>""));
        //if(count($armorArray)>0)	array_push($armorArray, Array("id"=>"","name"=>"","lvl"=>"","active"=>""));
        //arrays zusammenf�gen
        $res = array_merge($fightArray, $armorArray);
        $res = array_merge($res, $slskArray);
        $res = array_merge($res, $otherArray);

        return $res;
    }

    public function saveHuntGroup($arr, $owner)
    {
        $hid = (int)$arr['hid'];
        $htgid = (int)$arr['htgid'];
        //Gruppe erstellen
        if($hid == 0)
            $hid = $this->createHuntGroup($arr['name'],$arr['description'],
                ($arr['public']=="true"?1:0), $owner, $arr['spacer'], $htgid);
        else
            $this->updateHuntGroup($hid, $arr['name'], $arr['description'],
                ($arr['public']=="true"?1:0), $owner, $arr['spacer'], $htgid);
        //wenn Gruppe erfolgreich erstellt wurde
        if($hid > 0)
        {
            //erst mal alle Nutzer aus Gruppe entfernen und sie anschlie�end einzeln einf�gen
            if($this->deleteUsersByHuntGroup($hid) && $this->deleteEditUsersByHuntGroup($hid))
            {
                //Gruppenmitglieder durchgehen
                foreach($arr as $key1=>$users)
                {
                    if(is_array($users))
                    {
                        if($key1 != "editusers")
                        {
                            $uid = 0; $leader = 0; $enemy = 1; $ontime = "";
                            $comb = 1; $cPosition = 1; $sort = 0;
                            $inv = 0; $spells = 0; $attr = 0; $ench = 0;
                            //die einzelnen Eigenschaften des Gruppenmitglieds durchgehen
                            foreach($users as $key=>$value)
                            {
                                //User Id
                                if(strlen(strstr($key, 'uid')) > 0)
                                {
                                    $uid = (int)$value;
                                }
                                //Leiter
                                if(strlen(strstr($key, 'leader')) > 0)
                                {
                                    $leader = 1;
                                }
                                //NK oder FK
                                if(strlen(strstr($key, 'fknk')) > 0)
                                {
                                    $comb = (int)$value;
                                }
                                //Gegnerwahl
                                if(strlen(strstr($key, 'enemy')) > 0)
                                {
                                    $enemy = (int)$value;
                                }
                                //Position
                                if(strlen(strstr($key, 'cposition')) > 0)
                                {
                                    $cPosition = (int)$value;
                                }
                                //sortierung
                                if(strlen(strstr($key, 'sort')) > 0)
                                {
                                    $sort = (int)$value;
                                }
                                //Onlinezeit
                                if(strlen(strstr($key, 'ontime')) > 0)
                                {
                                    $ontime = $value;
                                }
                                //Ausr�stung
                                if(strlen(strstr($key, 'inv')) > 0)
                                {
                                    $inv = (int)$value;
                                }
                                //Spr�che
                                if(strlen(strstr($key, 'spells')) > 0)
                                {
                                    $spells = (int)$value;
                                }
                                //Attribute
                                if(strlen(strstr($key, 'attr')) > 0)
                                {
                                    $attr = (int)$value;
                                }
                                //Verzauberung
                                if(strlen(strstr($key, 'ench')) > 0)
                                {
                                    $ench = (int)$value;
                                }
                            }
                            $this->addUserToHuntGroup($hid, $uid, $leader, $enemy, $comb, $cPosition,
                                $sort, $ontime, $inv, $spells, $attr, $ench);
                        }
                        else if($key1 == "editusers")
                        {
                            //die einzelnen Eigenschaften des Gruppenmitglieds durchgehen
                            foreach($users as $key2=>$value2)
                            {
                                $this->addEditUserToHuntGroup($hid, $value2);
                            }
                        }
                    }
                }
            }
        }

        return $hid;
    }

    private function createHuntGroup($name, $desc, $public, $owner, $spacer, $htgid)
    {
        $desc = utf8_decode($desc);
        $name = utf8_decode($name);
        $hid = 0;
        $query = "INSERT INTO ".DB_PREFIX."hunt_group (name, description, public, owner, changed, spacer, htgid) VALUES
				  (
					'".getStringForDb($name)."', '".getStringForDb($desc)."',
				    ".(int)$public.", ".(int)$owner.", NOW(), ".(int)$spacer.",
				    ".(int)$htgid."
				  )";
        //echo $query;
        if( mysqli_query(Config::getDBConn(), $query))
            $hid = mysqli_insert_id(Config::getDBConn());
        return $hid;
    }

    private function updateHuntGroup($hid, $name, $desc, $public, $owner, $spacer, $htgid)
    {
        $desc = utf8_decode($desc);
        $name = utf8_decode($name);
        $result = false;
        $query = "UPDATE ".DB_PREFIX."hunt_group SET name='".getStringForDb($name)."', description='".getStringForDb($desc)."',
				  public=".(int)$public.", changed=NOW(), spacer=".(int)$spacer.", htgid=".(int)$htgid."
				  WHERE hid=".(int)$hid;
        if( mysqli_query(Config::getDBConn(), $query))
            $result = true;
        return $result;
    }

    public function updateHuntEditUser($hid, $uid, $cell, $val)
    {
        $result = false;
        $query = "UPDATE ".DB_PREFIX."hunt_group_users SET ".getStringForDb($cell)."=".(int)$val."
				  WHERE hid=".(int)$hid." and uid=".(int)$uid;
        if( mysqli_query(Config::getDBConn(), $query))
            $result = true;
        return $result;
    }

    private function addUserToHuntGroup($hid, $uid, $leader, $enemy, $comb, $cPosition, $sort, $ontime, $inv, $spells, $attr, $ench)
    {
        $result = false;
        $query = "INSERT INTO ".DB_PREFIX."hunt_group_users (hid, uid, leader, enemy, combat, cposition, sort,
                                                                    ontime, inventar, spells, attributes, enchantment) VALUES 
				  (
					".(int)$hid.", ".(int)$uid.", ".(int)$leader.", ".(int)$enemy.", ".(int)$comb.", ".(int)$cPosition.", ".(int)$sort.", 
				        '".getStringForDb($ontime)."', ".(int)$inv.", ".(int)$spells.", ".(int)$attr.", ".(int)$ench."
				  )";
        //echo $query;
        if( mysqli_query(Config::getDBConn(), $query))
            $result = true;
        return $result;
    }

    private function addEditUserToHuntGroup($hid, $uid)
    {
        $result = false;
        $query = "INSERT INTO ".DB_PREFIX."hunt_group_edit_users (hid, uid) VALUES
				  (
					".(int)$hid.", ".(int)$uid."
				  )";
        //echo $query;
        if( mysqli_query(Config::getDBConn(), $query))
            $result = true;
        return $result;
    }

    private function deleteUsersByHuntGroup($hid)
    {
        if( mysqli_query(Config::getDBConn(), "DELETE FROM ".DB_PREFIX."hunt_group_users WHERE hid=".(int)$hid))
            return true;
        else
            return false;
    }

    private function deleteEditUsersByHuntGroup($hid)
    {
        if( mysqli_query(Config::getDBConn(), "DELETE FROM ".DB_PREFIX."hunt_group_edit_users WHERE hid=".(int)$hid))
            return true;
        else
            return false;
    }

    public function deleteHuntGroup($hid)
    {
        if($hid > 0)
        {
            $q1 =  mysqli_query(Config::getDBConn(), "DELETE FROM ".DB_PREFIX."hunt_group WHERE hid=".(int)$hid);
            $q2 =  mysqli_query(Config::getDBConn(), "DELETE FROM ".DB_PREFIX."hunt_group_users WHERE hid=".(int)$hid);
            $q3 =  mysqli_query(Config::getDBConn(), "DELETE FROM ".DB_PREFIX."hunt_group_edit_users WHERE hid=".(int)$hid);
            $q4 =  mysqli_query(Config::getDBConn(), "DELETE FROM ".DB_PREFIX."user_attributes WHERE hid=".(int)$hid);
            $q5 =  mysqli_query(Config::getDBConn(), "DELETE FROM ".DB_PREFIX."users_inventar WHERE hid=".(int)$hid);
            $q6 =  mysqli_query(Config::getDBConn(), "DELETE FROM ".DB_PREFIX."users_spell WHERE hid=".(int)$hid);

            if($q1 && $q2 && $q3 && $q4 && $q5 && $q6)
                return true;
            else
                return false;
        }
        else
            return false;
    }

    public function loadGroups($user, $mode=0)
    {
        $result = Array();
        //�ffentliche Gruppen
        if($mode == 0)
            $query = "SELECT hg.hid, hg.name, hg.description, hg.owner, u1.nick as ownernick, htg.htgid,
				  DATE_FORMAT(hg.changed, '%d.%m.%Y %H:%i') as changed, hg.spacer, htg.public, htg.name as topname
				  FROM ".DB_PREFIX."hunt_group hg
				  JOIN ".DB_PREFIX."users u1 ON hg.owner=u1.uid
				  JOIN ".DB_PREFIX."hunt_top_groups htg ON htg.htgid=hg.htgid
				  WHERE htg.public=1
				  ORDER BY htg.name, hg.name";
        else if($mode == 1)	//eigene Gruppen
            $query = "SELECT hg.hid, hg.name, hg.description, hg.owner, u1.nick as ownernick, hg.public,
				  DATE_FORMAT(hg.changed, '%d.%m.%Y %H:%i') as changed, hg.spacer
				  FROM ".DB_PREFIX."hunt_group hg
				  JOIN ".DB_PREFIX."users u1 ON hg.owner=u1.uid
				  WHERE hg.public=0 and hg.owner=".$user->getUId()." 
				  ORDER BY hg.name";
        else if($mode == 2)	//andere, wo als bearbeiter oder gruppenmitglied drin oder selbst owner aber nicht public
            $query = "SELECT DISTINCT hg.hid, hg.name, hg.description, hg.owner, u1.nick as ownernick, htg.public, htg.name as topname, htg.htgid,
				  DATE_FORMAT(hg.changed, '%d.%m.%Y %H:%i') as changed, hgu.uid as groupuser, hgeu.uid as edituser, hg.spacer
				  FROM ".DB_PREFIX."hunt_group hg
				  JOIN ".DB_PREFIX."users u1 ON hg.owner=u1.uid
				  JOIN ".DB_PREFIX."hunt_top_groups htg ON htg.htgid=hg.htgid
				  LEFT JOIN ".DB_PREFIX."hunt_group_users hgu ON hg.hid=hgu.hid and hgu.uid=".$user->getUId()."
				  LEFT JOIN ".DB_PREFIX."hunt_group_edit_users hgeu ON hgeu.hid=hg.hid and hgeu.uid=".$user->getUId()."
				  WHERE htg.public=0
				  ORDER BY htg.name, hg.name";

        //echo $query;
        $res =  mysqli_query(Config::getDBConn(), $query);
        if(mysqli_num_rows($res) > 0)
        {
            $i = 0;
            while($row = mysqli_fetch_array($res))
            {
                if(($mode == 2 && ($row['groupuser'] != "" || $row['edituser'] != "" || $row['owner'] == $user->getUId())) || $mode != 2)
                {
                    $result[$i]['id'] = $row['hid'];
                    $result[$i]['name'] = decodeAbsatz($row['name']);
                    $result[$i]['desc'] = $row['description'];
                    $result[$i]['ownerid'] = $row['owner'];
                    $result[$i]['ownernick'] = $row['ownernick'];
                    $result[$i]['public'] = $row['public'];
                    $result[$i]['changed'] = $row['changed'];
                    $result[$i]['spacer'] = $row['spacer'];
                    $result[$i]['htgid'] = $row['htgid'];
                    $result[$i]['topname'] = $row['topname'];
                    $i++;
                }
            }

        }
        return $result;
    }

    public function canEdit($hid, $user)
    {
        //wo als owner oder edituser eingetragen
        $query = "SELECT hg.hid, hg.owner, hgeu.uid
				  FROM ".DB_PREFIX."hunt_group hg
				  LEFT JOIN ".DB_PREFIX."hunt_group_edit_users hgeu ON hgeu.hid=hg.hid
				  WHERE hg.hid=".(int)$hid." and (hg.owner=".$user->getUId()." or hgeu.uid=".$user->getUId().")";
		

        //echo $query;
        $res =  mysqli_query(Config::getDBConn(), $query);
        if(mysqli_num_rows($res) > 0)
            return true;
        else
            return false;
    }

    public function canView($hid, $user)
    {
        //wo als owner oder edituser eingetragen
        $query = "SELECT hg.hid, hg.owner, hgu.uid, hgeu.uid
				  FROM ".DB_PREFIX."hunt_group hg
				  JOIN ".DB_PREFIX."hunt_top_groups htg ON htg.htgid=hg.htgid
				  LEFT JOIN ".DB_PREFIX."hunt_group_users hgu ON hgu.hid=hg.hid
				  LEFT JOIN ".DB_PREFIX."hunt_group_edit_users hgeu ON hgeu.hid=hg.hid
				  WHERE hg.hid=".(int)$hid." and 
				  (hg.owner=".$user->getUId()." or hgeu.uid=".$user->getUId()." or htg.public=1 or hgu.uid=".$user->getUId().")";

        //echo $query;
        $res =  mysqli_query(Config::getDBConn(), $query);
        if(mysqli_num_rows($res) > 0)
            return true;
        else
            return false;
    }

    public function loadGroupById($hid, $user, $mode="view")
    {
        $result = Array();
        if(($mode == "view" && $this->canView($hid, $user)) || ($mode == "edit" && $this->canEdit($hid, $user)))
        {
            $query = "SELECT hg.hid, hg.name, hg.description, hg.owner, u1.nick as ownernick, hg.public,
					  DATE_FORMAT(hg.changed, '%d.%m.%Y %H:%i') as changed,
					  hgu.uid as groupuser, hgu.leader, hgu.enemy, hgu.combat, hgu.cposition, hgu.sort, u2.uid as edituid, 
                                          u2.nick as editnick, hgu.ontime, hg.spacer, hgu.inventar, hgu.spells, hgu.attributes, hgu.enchantment, hg.htgid
					  FROM ".DB_PREFIX."hunt_group hg
					  JOIN ".DB_PREFIX."users u1 ON hg.owner=u1.uid
					  LEFT JOIN ".DB_PREFIX."hunt_group_users hgu ON hgu.hid=hg.hid
					  LEFT JOIN ".DB_PREFIX."hunt_group_edit_users hgeu ON hgeu.hid=hg.hid
					  LEFT JOIN ".DB_PREFIX."users u2 ON u2.uid=hgeu.uid
					  WHERE hg.hid=".(int)$hid."
					  ORDER BY hgu.sort";

            //echo $query;
            $res =  mysqli_query(Config::getDBConn(), $query);
            if(mysqli_num_rows($res) > 0)
            {
                $i = 0; $p = 0; $tmpEditId = Array(); $tmpGroupId = Array();
                while($row = mysqli_fetch_array($res))
                {
                    $result['id'] = $row['hid'];
                    $result['name'] = decodeAbsatz($row['name']);
                    $result['desc'] = decodeAbsatz($row['description']);
                    $result['ownerid'] = $row['owner'];
                    $result['public'] = $row['public'];
                    $result['changed'] = $row['changed'];
                    $result['spacer'] = $row['spacer'];
                    $result['htgid'] = $row['htgid'];

                    //wenn jemand existiert, der bearbeiten darf
                    if($row['edituid'] != "" && $row['edituid'] != NULL && !in_array($row['edituid'],$tmpEditId))
                    {
                        $result['edit'][$p]['id'] = $row['edituid'];
                        $result['edit'][$p]['nick'] = $row['editnick'];
                        array_push($tmpEditId,$row['edituid']);
                        $p++;
                    }

                    //wenn ein Gruppenmitglied existiert
                    if($row['groupuser'] != "" && $row['groupuser'] != NULL && !in_array($row['groupuser'],$tmpGroupId))
                    {
                        $result['group'][$i]['id'] = $row['groupuser'];
                        $result['group'][$i]['leader'] = $row['leader'];
                        $result['group'][$i]['enemy'] = $row['enemy'];
                        $result['group'][$i]['combat'] = $row['combat'];
                        $result['group'][$i]['cposition'] = $row['cposition'];
                        $result['group'][$i]['sort'] = $row['sort'];
                        $result['group'][$i]['ontime'] = decodeAbsatz($row['ontime']);
                        $result['group'][$i]['custominventar'] = $row['inventar'];
                        $result['group'][$i]['customspells'] = $row['spells'];
                        $result['group'][$i]['customattributes'] = $row['attributes'];
                        $result['group'][$i]['customenchantment'] = $row['enchantment'];
                        array_push($tmpGroupId, $row['groupuser']);
                        $i++;
                    }
                }
            }
        }
        return $result;
    }

    public function getSlSk($caps)
    {
        $len = count($caps);
        $sl = 0; $sk = 0;
        for($i=0;$i<$len;$i++)
        {
            //wenn aktiv und eine Kapffertigkeit
            if((int)$caps[$i]['id'] == 32)
                $sk = (int)$caps[$i]['lvl'];
            if((int)$caps[$i]['id'] == 33)
                $sl = (int)$caps[$i]['lvl'];
        }
        $arr = Array();
        $arr['sl'] = $sl;
        $arr['sk'] = $sk;
        return $arr;
    }

    public function getActiveCap($caps)
    {
        $len = count($caps);

        for($i=0;$i<$len;$i++)
        {
            //wenn aktiv und eine Kapffertigkeit
            if(in_array((int)$caps[$i]['id'], $this->fightcaps) && (int)$caps[$i]['active'] == 1)
                return $caps[$i]['name']." (".$caps[$i]['lvl'].")";
        }
        return "";
    }

    public function getUsersWeaponCap($curUser, $hid, $items)
    {
        $huser2 = $this->loadUserForHunt2($curUser->getUId(), $hid);

        //wenn spezifische waffen angelegt wurden
        //pr�fen auf fk einstellung, dann fk waffe nehmen
        //sonst auf nk waffe pr�fen
        //sonst aktiver skill der h�chsten stufe nehmen
        if($huser2['custominventar'])
            $curItems = $curUser->getUsersInventar($hid);
        else
            $curItems = $curUser->getUsersInventar();
        $fkitem = $curUser->getItemForType($curItems, 8);
        $nkitem = $curUser->getItemForType($curItems, 6);
        $item = array(); $fc = array();
        // nk + fk
        if($huser2['hcombat'] == 1 && $fkitem != 0)
        {
            $item = $items->getItem($fkitem['iid']);
            $fc = $items->getFightCapForUser($item['cid_fight'] ?? 0, $curUser->getUId());
            $activecap = ($fc['capability'] ?? "")." (".($fc['lvl'] ?? "").")";
        }
        else if($huser2['hcombat'] == 2 && $nkitem != 0)    // nk
        {
            $item = $items->getItem($nkitem['iid']);
            $fc = $items->getFightCapForUser($item['cid_fight'], $curUser->getUId());
            $activecap = $fc['capability']." (".$fc['lvl'].")";
        }
        else
            $activecap = $this->getActiveCap($huser2['capabilities']);

        return array($activecap, $item, $fc);
    }

    public function getOrderedListForFightAction($list)
    {
        $result = array(); $names = Array(); $speeds = array();
        $totsteps = 0; $maxsteps = 0;
        foreach($list as $name=>$val)
        {
            array_push($names, $name);
            array_push($speeds, $val['speed']);
            $totsteps += $val['speed'];
            if($val['speed'] > $maxsteps) $maxsteps = $val['speed'];
        }

        $a = 0;
        //8=> alle 2 sek, 6=>alle 4 sek, 4=> alle 6 sek
        //alle speed durchgehen
        foreach($speeds as $speed)
        {
            //$step entspricht der Zeitnagabe aller wieviel sekunden der char pro Runde ein Aktion macht
            if($speed == 2)			$step = 12;
            else if($speed == 3)	$step = 8;
            else if($speed == 4)	$step = 6;
            else if($speed == 6)	$step = 4;
            else if($speed == 8)	$step = 3;
            $ind = 0;
            //alle steps f�r person mit zeitangabe (index) schreiben
            for($i=0;$i<$speed;$i++)
            {
                //$result[$ind][$names[$a]] = $list[$names[$a]];
                $result[$ind][$names[$a]]['step'] = $step;			//alle wie viel sekunden
                $result[$ind][$names[$a]]['speed'] = $speed;		//wie viel schritte/aktionen pro runde
                $result[$ind][$names[$a]]['partner'] = $list[$names[$a]]['partner'];
                $ind += $step;
            }
            $a++;
        }

        return $result;
    }

    public function combineOrderedArrays($arr1, $arr2)
    {
        //alle Eintr�ge aus arr2 in arr1 einf�gen
        foreach($arr2 as $k1=>$v1)
        {
            foreach($v1 as $k2=>$v2)
                $arr1[$k1][$k2] = $v2;
        }
        return $arr1;
    }

    //Liefert mit der Wahrscheinlichkeit von $chance % eine 1 zur�ck
    function isValidRandom($chance)
    {
        $g=mt_rand(0,100);
        if ($g<100)
        {
            if ($g==0) $h=mt_rand(1,999);
            else $h=mt_rand(0,999);
        }
        $zahl=$g+$h*0.001;
        if ($zahl<=$chance) return 1;
        else return 0;
    }

    public function getEnemy($hunter, $enemyGroup)
    {
        $names = Array();
        $rand = "";

        if(is_array($enemyGroup))
        {
            foreach($enemyGroup as $nick=>$vals)
            {
                if($hunter['enemy'] == 1)		//random Gegner
                {
                    $rand .= "1:";
                }
                else if($hunter['enemy'] == 2)	//schache Gegner
                {
                    if($vals['combat'] == 'fk')
                        $rand .= "'4:";
                    else
                        $rand .= "1:";
                }
                else if($hunter['enemy'] == 3)	//starke Gegner
                {
                    if($vals['combat'] == 'nk')
                        $rand .= "'4:";
                    else
                        $rand .= "1:";
                }
                array_push($names, $nick);
            }
        }
        //letzten Doppelpunkt abschneiden
        if(strlen($rand) > 0)
            $rand = substr($rand, 0, strlen($rand)-1);
        //echo $rand;

        //print_r();
        //$rand = "2:1:2";
        return $this->getRandomElement($names, $rand);
    }

    public function getRandomElement( $array, $propDistr=null )
    {
        $retVal = null;
        if( !is_array($array) ) {
            return false;
        }
        $keys = array_keys($array);

        if( !is_string($propDistr) ) {
            $retVal = array_rand($array);
        } else {
            $propDistr = explode(':', $propDistr);
            if( count($array) !== count($propDistr) ) {
                return false;
            }
            $rand = rand() / getrandmax();
            $propSum = array_sum($propDistr);
            $sum = 0;
            foreach( $propDistr as $key => $value ) {
                if( $value > 0 ) {
                    $sum += $value/$propSum;
                    if( $rand < $sum ) {
                        $retVal = $array[$keys[$key]];
                        break;
                    }
                }
            }
        }
        return $retVal;
    }

    public function doAttack($index, $huntername, &$hunterarr, &$gr1, &$gr2)
    {
        if(array_key_exists($huntername, $gr1))
        {
            $hunter = $gr1[$huntername];
            $gr = 1;
            $partner = $gr2[$hunterarr[$index][$huntername]['partner']];
        }
        else
        {
            $hunter = $gr2[$huntername];
            $gr = 2;
            $partner = $gr1[$hunterarr[$index][$huntername]['partner']];
        }

        if($hunter['combat'] == 'nk')
        {
            //wenn beide Gegner auf dem gleichen feld stehen
            if(($hunter['pos'] == 0 && $partner['pos'] == 0) ||
                ($hunter['pos'] < 0 && $partner['pos'] > 0 && abs($hunter['pos']) == $partner['pos']) ||
                ($hunter['pos'] > 0 && $partner['pos'] < 0 && $hunter['pos'] == abs($partner['pos'])))
            {
                //f�r den Gegner aktuelle person als Gegner setzen
                $this->setEnemy($hunterarr, $hunterarr[$index][$huntername]['partner'], $huntername, $index);
                return $huntername.' greift '.$hunterarr[$index][$huntername]['partner'];
            }
            else
            {
                //einen Schritt zum Gegner laufen
                if($gr == 1)
                    $gr1[$huntername]['pos'] = $gr1[$huntername]['pos'] - 1;
                else
                    $gr2[$huntername]['pos'] = $gr2[$huntername]['pos'] - 1;

                return $huntername.' n&auml;hert sich '.$hunterarr[$index][$huntername]['partner'];
            }
        }
        return 0;
        //print_r($hunter);
    }

    public function setEnemy(&$list, $hunter, $enemy, $index)
    {
        foreach($list as $key=>$val)
        {
            if($key >= $index)
            {
                $list[$key][$hunter]['partner'] = $enemy;
            }
        }
    }

    public function loadIniTopGroups()
    {
        unset($this->top_groups);
        unset($this->top_groups_names);
        $this->top_groups = array();
        $this->top_groups_names = array();

        //alle nutzer holen, die beim Protokoll nicht in die summe der transaktionen eingehen sollen (lagerverwalter z.bsp.)
        $query = "SELECT htgid, name, public FROM ".DB_PREFIX."hunt_top_groups";
        //echo $query;
        $qry =  mysqli_query(Config::getDBConn(), $query);

        if(mysqli_num_rows($qry) > 0)
        {
            $i = 0;
            while($row = mysqli_fetch_array($qry))
            {
                $this->top_groups[$i]['name'] = $row['name'];
                $this->top_groups[$i]['id'] = $row['htgid'];
                $this->top_groups[$i]['public'] = (int)$row['public'];
                $this->top_groups_names[] = $row['name'];
                $i++;
            }
        }
    }

    public function getTopGroup($htgid)
    {
        $result = array();
        foreach($this->top_groups as $group)
        {
            if($group['id'] == (int)$htgid)
                return $group;
        }
    }

    public function saveTopGroup($name, $public)
    {
        $query =  mysqli_query(Config::getDBConn(), "INSERT INTO ".DB_PREFIX."hunt_top_groups (name, public) VALUES('".getStringForDb($name)."', ".(int)$public.")");
        if($query)		return true;
        else			return false;
    }

    public function editTopGroup($htgid, $name, $public)
    {
        $query =  mysqli_query(Config::getDBConn(), "UPDATE ".DB_PREFIX."hunt_top_groups SET name='".getStringForDb($name)."', public=".(int)$public." WHERE htgid=".(int)$htgid);
        if($query)		return true;
        else			return false;
    }

    public function delTopGroup($htgid)
    {
        //pr�fen, ob der top gruppe noch Jagdgruppen zugeordnet sind
        $q1 =  mysqli_query(Config::getDBConn(), "SELECT hid FROM ".DB_PREFIX."hunt_group WHERE htgid=".(int)$htgid);

        if($q1 && (mysqli_num_rows($q1) == 0))
        {
            $query =  mysqli_query(Config::getDBConn(), "DELETE FROM ".DB_PREFIX."hunt_top_groups WHERE htgid=".(int)$htgid);
            if($query)		return true;
            else			return false;
        }
        else
            return false;
    }

    public function getTopGroups()		{ return $this->top_groups; }
    public function getTopGrouspsNames(){ return $this->top_groups_names; }

    public function getTimeString($seconds)
    {
        $min = floor($seconds/60);
        $sec = $seconds - floor($seconds/60)*60;
        return str_pad($min,2,'0',STR_PAD_LEFT).':'.str_pad($sec,2,'0',STR_PAD_LEFT);
    }

    public function getPerPage()
    {
        return $this->perPage;
    }

    public function getCharsWithoutHuntGroup($showLevelFrom, $showLevelTo) {
        $qry = "
                        SELECT u.uid, u.nick, u.lvl, folk.name
                        FROM " . DB_PREFIX . "users AS u
                        LEFT JOIN " . DB_PREFIX . "hunt_group AS hg ON(u.uid=hg.owner)
                        LEFT JOIN " . DB_PREFIX . "hunt_group_users AS hgu ON(u.uid=hgu.uid)
                        LEFT JOIN " . DB_PREFIX . "folk AS folk ON u.fid=folk.fid
                        WHERE u.lvl BETWEEN $showLevelFrom AND $showLevelTo
                        AND u.bot <> 1
                        AND hg.owner is NULL
                        AND hgu.uid is NULL
                        ORDER BY u.lvl, u.nick
                    ";

        $res =  mysqli_query(Config::getDBConn(), $qry);

        $characters = array();

        while($row = mysqli_fetch_array($res)) {
            $characters[$row['uid']]['nick'] = $row['nick'];
            $characters[$row['uid']]['lvl'] = $row['lvl'];
            $characters[$row['uid']]['name'] = $row['name'];
        }

        return $characters;
    }

    public function getMaxCharLevel() {
        $qry = "
            SELECT lvl
            FROM " . DB_PREFIX . "users
            ORDER BY lvl DESC
            LIMIT 1
        ";

        $res =  mysqli_query(Config::getDBConn(), $qry);

        $character = mysqli_fetch_assoc($res);

        return $character['lvl'];
    }
}