<?php

class HeroInfo {
    public function getHeroData($hero_id) {
        $hero_id = mysqli_real_escape_string(Config::getDBConn(), $hero_id);

        $qry = "
            SELECT users_gender.id, users_gender.name, user.nick, user.avatar, user.titel, user.lvl, user.description, folk.fid, folk.name, guilds_user.guid, guilds.name, guilds.short, guilds.color, user.lastaction, class.name as class
            FROM " . DB_PREFIX . "users AS user
            LEFT JOIN " . DB_PREFIX . "folk AS folk ON user.fid=folk.fid
            LEFT JOIN " . DB_PREFIX . "guilds_user AS guilds_user ON guilds_user.uid='" . (int)$hero_id . "'
            LEFT JOIN " . DB_PREFIX . "guilds AS guilds ON guilds_user.guid=guilds.guid
            LEFT JOIN " . DB_PREFIX . "users_gender AS users_gender ON user.gender_id=users_gender.id
            LEFT JOIN " . DB_PREFIX . "classes_class AS class ON user.classes_class_id=class.id
            WHERE user.uid='" . (int)$hero_id . "'
        ";
        $res =  mysqli_query(Config::getDBConn(), $qry);

        if(mysqli_num_rows($res) == 1) {
            $hero = array();

            while($row = mysqli_fetch_array($res)) {
                $hero['gender_id'] = $row[0];
                $hero['gender_name'] = $row[1];
                $hero['nick'] = $row[2];
                $hero['avatar'] = $row[3];
                $hero['titel'] = $row[4];
                $hero['lvl'] = $row[5];
                $hero['description'] = $row[6];
                $hero['fid'] = $row[7];
                $hero['folk'] = $row[8];
                $hero['guid'] = $row[9];
                $hero['guild'] = $row[10];
                $hero['guild_short'] = $row[11];
                $hero['guild_color'] = $row[12];
                $hero['lastAction'] = $row[13];
                $hero['class'] = $row[14];
            }

            return $hero;
        }
        else {
            return false;
        }
    }

    public function getHeroEQ($hero_id) {
        $hero_id = mysqli_real_escape_string(Config::getDBConn(), $hero_id);

        $qry = "
            SELECT item.item, item.magical, enchantments.name AS enchantment
            FROM " . DB_PREFIX . "users_inventar AS user_inventar
            LEFT JOIN " . DB_PREFIX . "items AS item ON user_inventar.iid=item.iid
            LEFT JOIN " . DB_PREFIX . "users_enchantment AS user_enchantment ON user_enchantment.type=user_inventar.type AND user_enchantment.hid=0 AND user_enchantment.uid='" . (int)$hero_id . "'
            LEFT JOIN " . DB_PREFIX . "enchantments AS enchantments ON enchantments.eid=user_enchantment.eid
            WHERE user_inventar.uid=" . (int)$hero_id ."
            AND user_inventar.iid != 0
            AND user_inventar.hid=0
            ORDER BY user_inventar.sort
        ";

        $res =  mysqli_query(Config::getDBConn(), $qry);

        if(mysqli_num_rows($res) > 0) {
            $hero_eq = array();

            while($row = mysqli_fetch_array($res)) {
                $hero_eq[] = array(
                    'item' => $row['item'],
                    'magical' => $row['magical'],
                    'enchantment' => $row['enchantment']
                );
            }

            return $hero_eq;
        }
        else {
            return false;
        }
    }

    public function getCrafts($hero_id) {
        $hero_id = mysqli_real_escape_string(Config::getDBConn(), $hero_id);
        $crafts = array();

        $qry = "
            SELECT c.cid, uc.value, c.capability, uc.mainwork
            FROM " . DB_PREFIX . "users_capabilities AS uc
            LEFT JOIN " . DB_PREFIX . "capabilities AS c ON uc.cid=c.cid AND c.type='0'
            WHERE uid='" . (int)$hero_id . "'
            AND c.capability IS NOT NULL
            ORDER BY c.cid
        ";

        $res =  mysqli_query(Config::getDBConn(), $qry);

        if(mysqli_num_rows($res) > 0) {
            while ($row = mysqli_fetch_assoc($res)) {
                $crafts[$row['cid']]['capability'] = $row['capability'];
                $crafts[$row['cid']]['lvl'] = $row['value'];
                $crafts[$row['cid']]['active'] = $row['mainwork'];
            }

            return $crafts;
        }
        else {
            return false;
        }
    }

    public function getCraftItems($cid, $lvl) {
        $lvl_equals_cap_lvl_0 = $lvl + 1;

        $items = array();

        $qry = "
            SELECT i.iid, i.itid, it.type, it.cid_fight, i.item, i.lvl, i.weight, i.dmgmin, i.dmgmax, i.effect, i.armor, i.absorb, i.handicap, i.speed, i.accuracy
            FROM " . DB_PREFIX . "items AS i
            LEFT JOIN " . DB_PREFIX . "item_types AS it ON i.itid=it.itid
            WHERE (
                (
                    it.prod_equals_cap_lvl = 1
                    AND i.lvl BETWEEN 0 AND '" . (int)$lvl . "'
                )
                OR (
                    it.prod_equals_cap_lvl = 0
                    AND i.lvl BETWEEN 0 AND '" . $lvl_equals_cap_lvl_0 . "'
                )
            )
            AND i.producable='1'
            AND i.magical='0'
            AND i.cid='" . (int)$cid . "'
            ORDER BY i.lvl
        ";

        $res =  mysqli_query(Config::getDBConn(), $qry);

        if(mysqli_num_rows($res) > 0) {
            while($row = mysqli_fetch_assoc($res)) {

                // Layout zur Ausgabe bestimmen
                if($row['itid'] >= 1 && $row['itid'] <= 10) {
                    $display_layout = 'weapon';
                }
                elseif($row['itid'] >= 11 && $row['itid'] <= 14) {
                    $display_layout = 'magic_staff';
                }
                elseif($row['itid'] >= 15 && $row['itid'] <= 17) {
                    $display_layout = 'ammunition';
                }
                elseif($row['itid'] >= 18 && $row['itid'] <= 20) {
                    $display_layout = 'armor';
                }
                elseif($row['itid'] >= 21 && $row['itid'] <= 22) {
                    $display_layout = 'shield';
                }
                else {
                    $display_layout = 'resource';
                }

                // Gegenstandstyp festlegen
                if(preg_match(' [2H]', $row['type'])) {
                    $type = explode(' [2H]', $row['type']);
                    $type = $type[0];
                }
                else {
                    $type = $row['type'];
                }

                $items[] = array(
                    'iid' => $row['iid'],
                    'type' =>  $type,
                    'cid_fight' => $row['cid_fight'],
                    'item' => $row['item'],
                    'lvl' => $row['lvl'],
                    'weight' => number_format($row['weight'], 3, '.', ''),
                    'damage' => $row['dmgmin'] . '-' . $row['dmgmax'],
                    'effect' => $row['effect'],
                    'armor' => number_format($row['armor'], 1, '.', ''),
                    'absorb' => number_format($row['absorb'], 1, '.', ''),
                    'handicap' => number_format($row['handicap'], 1, '.', ''),
                    'speed' => $row['speed'],
                    'average_damage' => (($row['dmgmin'] + $row['dmgmax']) / 2) * $row['speed'],
                    'accuracy' => $row['accuracy'],
                    'display_layout' => $display_layout
                );
            }

            return $items;
        }
        else {
            return false;
        }

    }

    public function getMagicalItems($uid, $cid) {
        $uid = mysqli_real_escape_string(Config::getDBConn(), $uid);
        $cid = mysqli_real_escape_string(Config::getDBConn(), $cid);
        $items = array();

        $qry = "
            SELECT i.iid, i.itid, it.type, it.cid_fight, it.cid_fight, i.item, i.lvl, i.weight, i.dmgmin, i.dmgmax, i.effect, i.armor, i.absorb, i.handicap, i.speed, i.accuracy
            FROM " . DB_PREFIX . "user_plans AS up
            LEFT JOIN " . DB_PREFIX . "items AS i ON up.realiid=i.iid AND i.cid='" . (int)$cid . "'
            LEFT JOIN " . DB_PREFIX . "item_types AS it ON i.itid=it.itid
            WHERE up.uid='" . (int)$uid . "'
            AND i.item IS NOT NULL
            ORDER BY i.lvl
        ";

        $res =  mysqli_query(Config::getDBConn(), $qry);

        if(mysqli_num_rows($res) > 0) {
            while($row = mysqli_fetch_assoc($res)) {
                // Layout zur Ausgabe bestimmen
                if($row['itid'] >= 1 && $row['itid'] <= 10) {
                    $display_layout = 'weapon';
                }
                elseif($row['itid'] >= 11 && $row['itid'] <= 14) {
                    $display_layout = 'magic_staff';
                }
                elseif($row['itid'] >= 15 && $row['itid'] <= 17) {
                    $display_layout = 'ammunition';
                }
                elseif($row['itid'] >= 18 && $row['itid'] <= 20) {
                    $display_layout = 'armor';
                }
                elseif($row['itid'] >= 21 && $row['itid'] <= 22) {
                    $display_layout = 'shield';
                }
                else {
                    $display_layout = 'resource';
                }

                // Gegenstandstyp festlegen
                if(preg_match(' [2H]', $row['type'])) {
                    $type = explode(' [2H]', $row['type']);
                    $type = $type[0];
                }
                else {
                    $type = $row['type'];
                }

                $items[] = array(
                    'iid' => $row['iid'],
                    'type' =>  $type,
                    'cid_fight' => $row['cid_fight'],
                    'item' => $row['item'],
                    'lvl' => $row['lvl'],
                    'weight' => number_format($row['weight'], 3, '.', ''),
                    'damage' => $row['dmgmin'] . '-' . $row['dmgmax'],
                    'effect' => $row['effect'],
                    'armor' => number_format($row['armor'], 1, '.', ''),
                    'absorb' => number_format($row['absorb'], 1, '.', ''),
                    'handicap' => number_format($row['handicap'], 1, '.', ''),
                    'speed' => $row['speed'],
                    'average_damage' => (($row['dmgmin'] + $row['dmgmax']) / 2) * $row['speed'],
                    'accuracy' => $row['accuracy'],
                    'display_layout' => $display_layout
                );
            }

            return $items;
        }
        else {
            return false;
        }

    }

    public function getLearnedPlans($uid) {
        $uid = mysqli_real_escape_string(Config::getDBConn(), $uid);
        $plans = array();

        $qry = "
            SELECT i.iid, i.cid, i.item, i.lvl
            FROM " . DB_PREFIX . "user_plans AS up
            LEFT JOIN " . DB_PREFIX . "items AS i ON up.iid=i.iid
            WHERE up.uid='" . (int)$uid . "'
            AND i.item IS NOT NULL
            ORDER BY i.cid, i.lvl
        ";

        $res =  mysqli_query(Config::getDBConn(), $qry);

        if(mysqli_num_rows($res) > 0) {
            while($row = mysqli_fetch_assoc($res)) {
                $plans[$row['cid']][] = array(
                    'iid' => $row['iid'],
                    'item' => $row['item'],
                    'lvl' => $row['lvl']
                );
            }

            return $plans;
        }
        else {
            return false;
        }
    }

    public function getBattleInfo($hero_id) {
        $hero_id = mysqli_real_escape_string(Config::getDBConn(), $hero_id);

        $qry = "
            SELECT DISTINCT item.itid, user.combat
            FROM " . DB_PREFIX . "users_inventar AS user_inventar
            LEFT JOIN " . DB_PREFIX . "items AS item ON user_inventar.iid=item.iid
            LEFT JOIN " . DB_PREFIX . "users AS user ON user.uid='" . (int)$hero_id . "'
            WHERE user_inventar.uid=" . (int)$hero_id ."
            AND user_inventar.iid != 0
            AND user_inventar.hid=0
            ORDER BY item.itid
        ";

        $res =  mysqli_query(Config::getDBConn(), $qry);

        if(mysqli_num_rows($res) > 0) {

            $itids = array();

            while ($row = mysqli_fetch_assoc($res)) {
                $itids['combat'] = $row['combat'];
                $itids[] = (int)$row['itid'];
            }


            /*
             * Ermittlung des Kampfverhaltens
             */

            if (
                (
                    $itids['combat'] == 1 &&
                    (
                        // Bogen
                        in_array(9, $itids) &&
                        // Munition - Boegen
                        in_array(15, $itids)
                    )
                ) ||
                (
                    $itids['combat'] == 1 &&
                    (
                        // Munition - Magiestaebe + *
                        in_array(17, $itids) &&
                        (
                            // Feuerstab
                            in_array(11, $itids) ||
                            // Wasserstab
                            in_array(12, $itids) ||
                            // Luftstab
                            in_array(14, $itids)
                        )
                    )
                ) ||
                (
                    $itids['combat'] == 1 &&
                    (
                        // Armbrust
                        in_array(10, $itids) &&
                        // Munition - Armbrueste
                        in_array(16, $itids)
                    )
                )
            ) {
                $returnBattleType = array(
                    'Kampfverhalten' => 'Fernk&auml;mpfer',
                    'Rolle' => 'Damage-Dealer'
                );
            }
            elseif (
                $itids['combat'] == 1 &&
                (
                    // Erdstab
                    in_array(13, $itids) &&
                    // Munition - Magiestaebe
                    in_array(17, $itids)
                )
            ) {
                $returnBattleType = array(
                    'Kampfverhalten' => 'Fernk&auml;mpfer',
                    'Rolle' => 'Heiler'
                );
            }
            elseif (
                // Schwere Ruestung
                in_array(20, $itids) &&
                // Schweres Schild
                in_array(22, $itids)
            ) {
                $returnBattleType = array(
                    'Kampfverhalten' => 'Nahk&auml;mpfer',
                    'Rolle' => 'Tank'
                );
            }
            else {
                $returnBattleType = array(
                    'Kampfverhalten' => 'Nahk&auml;mpfer',
                    'Rolle' => 'Damage-Dealer'
                );
            }

            return $returnBattleType;
        }
        else {
            return false;
        }
    }

    public function getViewerCapabilities($viewer_uid) {
        $capabilities = array();

        $qry = "
            SELECT cid, value
            FROM " . DB_PREFIX . "users_capabilities
            WHERE uid='" . (int)$viewer_uid . "'
            ORDER BY cid
        ";

        $res =  mysqli_query(Config::getDBConn(), $qry);

        if(mysqli_num_rows($res) > 0) {
            while ($row = mysqli_fetch_assoc($res)) {
                $capabilities[$row['cid']] = $row['value'];
            }

            return $capabilities;
        }
        else {
            return false;
        }
    }
}