<?php
class Item
{
	private $fightcaps = 		Array(19,20,21,22,23,24,25,28,29,31,30);
	private $armorcaps = 		Array(26,27);
	private $dmgWeapons =	 	Array(1,2,3,4,5,6,7,8,9,10);
	private $effectWeapons = 	Array(11,12,13,14,15,16,17);
	private $accuracyWeapons = 	Array(15,16,17);
	private $armorClothes = 	Array(18,19,20,21,22);
	private $absorbClothes = 	Array(18,19,20);
	private $handicapClothes = 	Array(18,19,20);
	private $blockClothes = 	Array(21,22);
	private $armorBasis	= 		Array(18=>0, 19=>10, 20=>20, 21=>4, 22=>6);	//itid=>R�stschutz
	private $itidWeapons = 		Array(1,2,3,4,5,6,7,8,9,10,11,12,13,14);
	private $itidSpellWeapons = Array(11,12,13,14);
        private $itidNoActivityDiscover = Array(24, 25, 26, 27);
	private $itidDmgAttr = 		Array(
										4=>array('aid'=>1,'name'=>'St&auml;rke','factor'=>1),
									 	5=>array('aid'=>1,'name'=>'St&auml;rke','factor'=>1),
									 	6=>array('aid'=>1,'name'=>'St&auml;rke','factor'=>1),
									 	7=>array('aid'=>1,'name'=>'St&auml;rke','factor'=>1),
									 	8=>array('aid'=>1,'name'=>'St&auml;rke','factor'=>1),
									 	1=>array('aid'=>2,'name'=>'Geschicklichkeit','factor'=>0.8),
									 	2=>array('aid'=>2,'name'=>'Geschicklichkeit','factor'=>0.8),
									 	3=>array('aid'=>2,'name'=>'Geschicklichkeit','factor'=>0.8),
									 	9=>array('aid'=>2,'name'=>'Geschicklichkeit','factor'=>0.8),
									 	10=>array('aid'=>2,'name'=>'Geschicklichkeit','factor'=>0.8),
									 	11=>array('aid'=>4,'name'=>'Intelligenz','factor'=>1),
									 	12=>array('aid'=>4,'name'=>'Intelligenz','factor'=>1),
									 	13=>array('aid'=>4,'name'=>'Intelligenz','factor'=>1),
									 	14=>array('aid'=>4,'name'=>'Intelligenz','factor'=>1)
									); //welche itid durch welche attribute beim schaden beeinflusst werden
	private $attrEtId = 			Array(
										'St&auml;rke'=>7,
									 	'Geschicklichkeit'=>8,
									 	'Konstitution'=>9,
									 	'Intelligenz'=>10,
										'Absorb'=>2,
									 	'Schildblock'=>3,
									 	'Ausweichen'=>4,
									 	'Treffsicherheit'=>5,
									 	'kritische Treffer'=>6,
									 	'Lebenspunkte'=>11
									); //welches Attribut, durch welche etid beeinflusst wird
	
	public function __construct(){}
	
	public function getItemTypes($whId)
	{
		$result = Array();
		$query = "SELECT it.itid, it.type, itv.minval, itv.maxval, itv.active_amount, itv.inactive_days "
                        . "FROM ".DB_PREFIX."item_types it 
                            JOIN ".DB_PREFIX."item_types_values itv on it.itid=itv.itid and itv.wid=".(int)$whId." 
                        ORDER BY it.sort";
		$qry =  mysqli_query(Config::getDBConn(), $query);
		
		$i = 0;
		while($row = mysqli_fetch_array($qry))
		{
			$result[$i]['id'] = $row['itid'];
			$result[$i]['name'] = $row['type'];
			$result[$i]['min'] = number_format($row['minval'],0,'','.');
                        $result[$i]['max'] = number_format($row['maxval'],0,'','.');
			$result[$i]['active_amount'] = number_format($row['active_amount'],0,'','.');
                        $result[$i]['inactive_days'] = $row['inactive_days'];
			$i++;
		}
		return $result;
	}
	
	public function getItemsByType($tid, $whId)
	{
		$result = Array();
		$query = "SELECT i.iid, i.item, iv.minval, iv.maxval, i.marketvalue, i.realvalue, i.magical 
				  FROM ".DB_PREFIX."items i, ".DB_PREFIX."item_values iv WHERE itid=".(int)($tid)." and i.iid=iv.iid and iv.wid=".(int)$whId."
				  ORDER BY i.magical, i.lvl, i.sort";
		$qry =  mysqli_query(Config::getDBConn(), $query);
		
		$i = 0;
		while($row = mysqli_fetch_array($qry))
		{
			$result[$i]['id'] = $row['iid'];
			$result[$i]['name'] = $row['item'];
			$result[$i]['min'] = ($row['minval']!=NULL?number_format($row['minval'],0,'','.'):'');
			$result[$i]['max'] = ($row['maxval']!=NULL?number_format($row['maxval'],0,'','.'):'');
			$result[$i]['market'] = number_format($row['marketvalue'],0,'','.');
			$result[$i]['real'] = number_format($row['realvalue'],0,'','.');
			$result[$i]['magical'] = $row['magical'];
			$i++;
		}
		return $result;
	}
	
	//muss so aussehen [min1],[max1],[it1] usw, f�er alle Types
	public function updateItemsType($postArray, $whId)
	{
		$result = false;
		
		if(is_array($postArray))
		{
			$pos = 0; $min = 0; $max = 0; $active = 0; $days = 0; $itid = 0;
			//Eintr�ge durchgehen und Werte zwischenspeichern, immer 3er-Paare
			foreach($postArray as $key => $value)
			{
				$value = str_replace(".", "", $value);
				if(strlen(strstr($key, 'min')) > 0)
				{	$min = (int)$value; $pos++; }
				if(strlen(strstr($key, 'max')) > 0)
				{	$max = (int)$value; $pos++; }
                                if(strlen(strstr($key, 'active')) > 0)
				{	$active = (int)$value; $pos++; }
                                if(strlen(strstr($key, 'days')) > 0)
				{	$days = (int)$value; $pos++; }
				if(strlen(strstr($key, 'it')) > 0)
				{	$itid = (int)$value; $pos++; }

				//wenn min, max und id gesammelt wurden
				if(($pos == 5 || $pos == 3) && $itid != 0)
				{
					//echo $min.' '.$max.' '.$itid.'<br />';
					$query = "UPDATE ".DB_PREFIX."item_types_values set minval=".$min.", maxval=".$max.", active_amount=".$active.",
                                                        inactive_days=".$days."
                                                    WHERE itid=".$itid." and wid=".(int)$whId;
					if( mysqli_query(Config::getDBConn(), $query))
					  $result = true;
					else 
						$result = false;
					$pos = 0; $min = 0; $max = 0; $active = 0; $days = 0; $itid = 0;
				}
				
			}
		}
		
		return $result;
	}
	
	//muss so aussehen [min1],[max1],[market1],[real1],[it1] usw, f�r alle Items
	public function updateItems($postArray, $whId)
	{
		//print_r($postArray);
		$result = false;
		
		if(is_array($postArray))
		{
			$pos = 0; $min = 0; $max = 0; $market = 0; $real = 0; $iid = 0;
			//Eintr�ge durchgehen und Werte zwischenspeichern, immer 3er-Paare
			foreach($postArray as $key => $value)
			{
				$value = str_replace(".", "", $value);
				if(strlen(strstr($key, 'min')) > 0)
				{	$min = ($value == ''?'NULL':(int)$value); $pos++; }
				if(strlen(strstr($key, 'max')) > 0)
				{	$max = ($value == ''?'NULL':(int)$value); $pos++; }
				if(strlen(strstr($key, 'market')) > 0)
				{	$market = (int)$value; $pos++; }
				if(strlen(strstr($key, 'real')) > 0)
				{	$real = (int)$value; $pos++; }
				if(strlen(strstr($key, 'it')) > 0)
				{	$iid = (int)$value; $pos++; }

				//wenn min, max und id gesammelt wurden
				if($pos == 5 && $iid != 0)
				{
					//echo $min.' '.$max.' '.$market.' '.$real.' '.$iid.'<br />';
					$query1 = "UPDATE ".DB_PREFIX."items set marketvalue=".$market.", realvalue=".$real." WHERE iid=".$iid;
					$query2 = "UPDATE ".DB_PREFIX."item_values set minval=".$min.", maxval=".$max." 
							   WHERE iid=".$iid." and wid=".(int)$whId;
					if( mysqli_query(Config::getDBConn(), $query1) &&  mysqli_query(Config::getDBConn(), $query2))
					  $result = true;
					else 
						$result = false;
					$pos = 0; $min = 0; $max = 0; $market = 0; $real = 0; $iid = 0;
				}
				
			}
		}
		
		return $result;
	}
	/*
	 * Type:
	 * 1->Kopf, 2->Torso, 3->H�nde, 4->Beine, 5->F��e, 6->NK 7->NK, 8->FK, 9->Munition 10->Bandagen
	 */
	public function getItemsForInventary($type, $uid)
	{
		$result = array();

		switch($type)
		{
			case 1: $where = " i.itid IN(18, 19, 20) and i.sort=1 and uc.cid IN(26,27)"; break;
			case 2: $where = " i.itid IN(18, 19, 20) and i.sort=2 and uc.cid IN(26,27)"; break;
			case 3: $where = " i.itid IN(18, 19, 20) and i.sort=3 and uc.cid IN(26,27)"; break;
			case 4: $where = " i.itid IN(18, 19, 20) and i.sort=4 and uc.cid IN(26,27)"; break;
			case 5: $where = " i.itid IN(18, 19, 20) and i.sort=5 and uc.cid IN(26,27)"; break;
			case 6: $where = " i.itid IN(1, 2, 3, 4, 5, 6, 7, 8) and uc.cid IN(19,20, 21, 22, 23)"; break;
			case 7: $where = " i.itid IN(1, 3, 4, 6, 21, 22) and uc.cid IN(19,20, 21, 22, 26,27)"; break;
			case 8: $where = " i.itid IN(9, 10, 11, 12, 13, 14) and uc.cid IN(24,25,28,29,30,31)"; break;
			case 9: $where = " i.itid IN(15, 16, 17)"; break;
                        case 10: $where = " i.itid IN(28) and uc.cid IN(35)"; break;
		}
		
		if($type != 9)
		$query = "SELECT i.lvl, i.itid, i.iid, it.type, i.item, i.cid, i.magical, i.producable, i.dmgmin, i.dmgmax, i.effect, i.armor, i.absorb, i.handicap, i.speed, i.accuracy, i.blockabsorb 
				  FROM ".DB_PREFIX."items i, ".DB_PREFIX."users_capabilities uc, ".DB_PREFIX."item_types it
				  WHERE".$where." and it.itid=i.itid and it.cid_fight=uc.cid and uc.uid=".(int)$uid." and uc.value>=i.lvl
				  ORDER BY i.itid, i.lvl DESC, i.magical";
		else 
			$query = "SELECT i.lvl, i.itid, i.iid, it.type, i.item, i.cid, i.magical, i.producable, i.dmgmin, i.dmgmax, i.effect, i.armor, i.absorb, i.handicap, i.speed, i.accuracy, i.blockabsorb 
				  FROM ".DB_PREFIX."items i, ".DB_PREFIX."item_types it
				  WHERE".$where." and it.itid=i.itid
				  ORDER BY i.itid, i.lvl DESC, i.magical";
		//echo $query;
		$res =  mysqli_query(Config::getDBConn(), $query);
		$i = 0;
		if(mysqli_num_rows($res) > 0)
		{
			while($row = mysqli_fetch_array($res))
			{
				$result[$i]['iid'] = $row['iid'];
				$result[$i]['itid'] = $row['itid'];
				$result[$i]['lvl'] = $row['lvl'];
				$result[$i]['type'] = $row['type'];
				$result[$i]['item'] = $row['item'];
				$result[$i]['cid'] = $row['cid'];
				$result[$i]['magical'] = $row['magical'];
				$result[$i]['producable'] = $row['producable'];
				$result[$i]['dmgmin'] = $row['dmgmin'];
				$result[$i]['dmgmax'] = $row['dmgmax'];
				$result[$i]['effect'] = $row['effect'];
				$result[$i]['armor'] = $row['armor'];
				$result[$i]['absorb'] = $row['absorb'];
				$result[$i]['handicap'] = $row['handicap'];
				$result[$i]['speed'] = $row['speed'];
				$result[$i]['accuracy'] = $row['accuracy'];
				$result[$i]['blockabsorb'] = $row['blockabsorb'];
				$i++;
			}
		}
		return $result;
	}
	
	 /*
	 * Spell:
	 * 1->1.Zauber, 2->2.Zauber, 3->3.Zauber
	 * Spell-Type:
	 * 1=Sofortschaden, 2=Rundenschaden, 3=Sofortheilung, 4=Rundenheilung
	 */
	public function getSpells($spell, $user, $fkitem)
	{
		$result = array();
		//wenn fk waffe angelegt
		if((int)$fkitem != 0)
		{
			switch($spell)
			{
				case 1: $where = " s.type IN(1, 2, 3, 4)"; break;
				case 2: $where = " s.type IN(1, 3)"; break;
				case 3: $where = " s.type IN(1)"; break;
			}
			
			$query = "SELECT spid, name, lvl, dmgmin, dmgmax, s.type, s.itid, reach, speed, it.type as typename, uc.cid
					  FROM ".DB_PREFIX."users_capabilities uc, ".DB_PREFIX."spells s, ".DB_PREFIX."item_types it
					  WHERE".$where." and s.itid=".(int)$fkitem." and it.cid_fight=uc.cid and s.itid=it.itid and 
					  		uc.uid=".$user->getUId()." and uc.value>=s.lvl
					  ORDER BY s.lvl DESC";
			//echo $query;
			$res =  mysqli_query(Config::getDBConn(), $query);
			$i = 0;
			if(mysqli_num_rows($res) > 0)
			{
				while($row = mysqli_fetch_array($res))
				{
					$result[$i]['spid'] = $row['spid'];
					$result[$i]['itid'] = $row['itid'];
					$result[$i]['lvl'] = $row['lvl'];
					$result[$i]['type'] = $row['type'];
					$result[$i]['name'] = $row['name'];
					$result[$i]['typename'] = $row['typename'];
					$result[$i]['cid'] = $row['cid'];
					$result[$i]['dmgmin'] = $row['dmgmin'];
					$result[$i]['dmgmax'] = $row['dmgmax'];
					$result[$i]['reach'] = $row['reach'];
					$result[$i]['speed'] = $row['speed'];
					$i++;
				}
			}
		}
		return $result;
	}
	
	/*
	 * Verzauberung:
	 * 1->Traglast, 2->Absorbs, 3->Schildblocks, 4->Ausweichens, 5->Treffsicherheit, 6->kritischen
	 * 7->St�rke, 8->Geschicklichkeit, 9->Konstitution, 10->Intelligenz, 11->Lebenspunkte
	 */
	public function getEnchantments()
	{
		$result = array();

		$query = "SELECT e.eid, e.name, et.name as typename, e.description, e.effect, e.etid
				  FROM ".DB_PREFIX."enchantments e, ".DB_PREFIX."enchantment_types et
				  WHERE e.etid=et.etid
				  ORDER BY e.etid, e.effect";
		//echo $query;
		$res =  mysqli_query(Config::getDBConn(), $query);
		$i = 0;
		if(mysqli_num_rows($res) > 0)
		{
			while($row = mysqli_fetch_array($res))
			{
				$result[$i]['eid'] = $row['eid'];
				$result[$i]['type'] = $row['etid'];
				$result[$i]['name'] = $row['name'];
				$result[$i]['typename'] = $row['typename'];
				$result[$i]['description'] = $row['description'];
				$result[$i]['effect'] = $row['effect'];
				$i++;
			}
		}
		return $result;
	}
	
	public function getItem($iid)
	{
		$result = array();


		$query = "SELECT i.lvl, i.itid, i.iid, it.type, i.item, i.cid, i.magical, i.producable, 
				  i.dmgmin, i.dmgmax, i.effect, i.armor, i.absorb, i.handicap, i.speed, i.accuracy, 
				  i.blockabsorb, it.cid_fight, i.marketvalue, i.realvalue, it.cid_fight, i.rel_min, i.rel_max
				  FROM ".DB_PREFIX."items i, ".DB_PREFIX."item_types it
				  WHERE i.itid=it.itid and i.iid=".(int)$iid;
		//echo $query;
		$res =  mysqli_query(Config::getDBConn(), $query);
		$i = 0;
		if(mysqli_num_rows($res) > 0)
		{
			while($row = mysqli_fetch_array($res))
			{
				$result['iid'] = $row['iid'];
				$result['itid'] = $row['itid'];
				$result['lvl'] = $row['lvl'];
				$result['type'] = $row['type'];
				$result['item'] = $row['item'];
				$result['cid'] = $row['cid'];
				$result['cid_fight'] = $row['cid_fight'];
				$result['magical'] = $row['magical'];
				$result['producable'] = $row['producable'];
				$result['dmgmin'] = $row['dmgmin'];
				$result['dmgmax'] = $row['dmgmax'];
				$result['effect'] = $row['effect'];
				$result['armor'] = $row['armor'];
				$result['absorb'] = $row['absorb'];
				$result['handicap'] = $row['handicap'];
				$result['speed'] = $row['speed'];
				$result['accuracy'] = $row['accuracy'];
				$result['blockabsorb'] = $row['blockabsorb'];
				$result['realvalue'] = $row['realvalue'];
				$result['marketvalue'] = $row['marketvalue'];
				$result['price'] = ($row['realvalue'] != 0 ? $row['realvalue'] : $row['marketvalue']);
                                $result['cid_fight'] = $row['cid_fight'];
                                $result['rel_min'] = $row['rel_min'];
                                $result['rel_max'] = $row['rel_max'];  // in %
				$i++;
			}
		}
		return $result;
	}
	
	public function getSpell($spid)
	{
		$result = array();


		$query = "SELECT spid, name, lvl, dmgmin, dmgmax, s.type, s.itid, reach, speed
				  FROM ".DB_PREFIX."spells s
				  WHERE s.spid=".(int)$spid;
		//echo $query;
		$res =  mysqli_query(Config::getDBConn(), $query);
		$i = 0;
		if(mysqli_num_rows($res) > 0)
		{
			while($row = mysqli_fetch_array($res))
			{
				$result['spid'] = $row['spid'];
				$result['itid'] = $row['itid'];
				$result['lvl'] = $row['lvl'];
				$result['type'] = $row['type'];
				$result['name'] = $row['name'];
				$result['dmgmin'] = $row['dmgmin'];
				$result['dmgmax'] = $row['dmgmax'];
				$result['reach'] = $row['reach'];
				$result['speed'] = $row['speed'];
				$i++;
			}
		}
		return $result;
	}
	
	public function getFightCapForUser($cid, $uid)
	{
		$result = array();


		$query = "SELECT c.cid, uc.value, c.capability
				  FROM ".DB_PREFIX."capabilities c
				  JOIN ".DB_PREFIX."users_capabilities uc ON uc.cid=c.cid 
				  WHERE uc.uid=".(int)$uid." and c.cid=".(int)$cid;
		//echo $query;
		$res =  mysqli_query(Config::getDBConn(), $query);
		$i = 0;
		if(mysqli_num_rows($res) > 0)
		{
			while($row = mysqli_fetch_array($res))
			{
				$result['cid'] = $row['cid'];
				$result['lvl'] = $row['value'];
				$result['capability'] = $row['capability'];
				$i++;
			}
		}
		return $result;
	}
	
	public function getValidMunforWeapon($iid_weapon, $iid_mun)
	{
		//ids der mun
		$mun_magic = 	Array(211,212,213,214,215,0);
		$mun_bow = 		Array(201,202,203,204,205,0);
		$mun_balistic = Array(206,207,208,209,210,0);
		
		//itids f�r fk waffen
		$magic_weapon = Array(11,12,13,14);
		$bow_weapon = 	Array(9);
		$balis_weapon = Array(10);

		$itid_weapon = $this->getItem($iid_weapon);
		$itid_weapon = $itid_weapon['itid'] ?? 0;
		
		//wenn magier und keine korrekte mun
		if(in_array($itid_weapon, $magic_weapon) && !in_array($iid_mun, $mun_magic))
			return 211;
		else if(in_array($itid_weapon, $bow_weapon) && !in_array($iid_mun, $mun_bow))
			return 201;
		else if(in_array($itid_weapon, $balis_weapon) && !in_array($iid_mun, $mun_balistic))
			return 206;
			
		return 0;
	}
	
	public function getValidSpells($s1, $s2, $s3)
	{
		$s1 = (int)$s1; $s2 = (int)$s2; $s3 = (int)$s3;
		$spell1 = $this->getSpell($s1);
		$spell2 = $this->getSpell($s2);
		$spell3 = $this->getSpell($s3);
		
		//keine freien Zauber mitten drin
		/******************************************/
		if($s1 == 0)
		{ $s1 = $s2; $s2 = $s3; $spell1 = $spell2; $spell2 = $spell3; $s3 = 0; }
		if($s2 == 0)
		{$s2 = $s3; $spell2 = $spell3; $s3 = 0; }
		
		/******************************************/
		
		//wenn im 2. und 3. der gleiche typ steht
		if($spell2['type'] == 1 && $spell3['type'] == 1)
		{ $s3 = 0; }
		
		//wenn im 1. und 2. der gleiche typ steht
		if($spell1['type'] == 3 && $spell2['type'] == 3)
		{ $s2 = $s3; $s3 = 0; $spell2 = $spell3; }
		
		//wenn im ersten sofortschaden steht, m�ssen die anderen leer sein
		if($spell1['type'] == 1)
		{ $s2 = 0; $s3 = 0; }
		
		//wenn zauber 1 kein rundenschaden und zauber 2 angelegt wurde
		if($s2 != 0 && ($spell1['type'] != 2 && $spell1['type'] != 4))
		{
			//wenn zauber 1 und zwei gleicher ty sind, nimm den zweiten
			if($spell1['type'] == 1 && $spell2['type'] == 1)
			{	$s1 = $s2; $s2 = $s3; $spell1 = $spell2; $spell2 = $spell3; $s3 = 0; }
		}
		
		return Array($s1,$s2,$s3);
	}
	
	public function getItemAttributesText($it)
	{
		$dmgWeapons =	 	Array(1,2,3,4,5,6,7,8,9,10);
		$effectWeapons = 	Array(11,12,13,14,15,16,17);
		$accuracyWeapons = 	Array(15,16,17);
		$armorClothes = 	Array(18,19,20,21,22);
		$absorbClothes = 	Array(18,19,20);
		$handicapClothes = 	Array(18,19,20);
		$blockClothes = 	Array(21,22);
		
		$effect = "";
		if(in_array($it['itid'], $dmgWeapons))
			$effect = $it['dmgmin']."-".$it['dmgmax']." Schaden";
		if(in_array($it['itid'], $effectWeapons))
			$effect = "+".$it['effect']."% Wirkung";
		if(in_array($it['itid'], $accuracyWeapons))
			$effect .= ", +".$it['accuracy']."% Treffsicherheit";
		if(in_array($it['itid'], $armorClothes))
			$effect = "+".$it['armor']."% R&uuml;stschutz";
		if(in_array($it['itid'], $absorbClothes))
			$effect .= ", +".$it['absorb']."% Absorb";
		if(in_array($it['itid'], $handicapClothes))
			$effect .= ", +".$it['handicap']."% Behinderung";
		if(in_array($it['itid'], $blockClothes))
			$effect .= ", +".$it['blockabsorb']."% Absorb bei Block";
		
		return $effect;
	}
	
	public function getSpellTypeName($type)
	{
		switch($type)
		{
			case 1: return "Sofortschaden"; break;
			case 2: return "Rundenschaden"; break;
			case 3: return "Sofortheilung"; break;
			case 4: return "Rundenheilung"; break;
			default: return "";
		}
	}
	
	public function getComponentsForBuilding($building)
	{
		$result = Array();
		$query = "SELECT b.bid, b.name, bc.iid, bc.icount, i.item
				  FROM ".DB_PREFIX."buildings b 
				  JOIN ".DB_PREFIX."buildings_components bc 
				  	ON bc.bid=b.bid and b.name='".getStringForDb($building)."'
				  JOIN ".DB_PREFIX."items i
				  	ON i.iid=bc.iid";
		$qry =  mysqli_query(Config::getDBConn(), $query);
		//echo $query;
		$i = 0;
		while($row = mysqli_fetch_array($qry))
		{
			$result['id'] = $row['bid'];
			$result['name'] = $row['name'];
			$result['components'][$i]['iid'] = $row['iid'];
			$result['components'][$i]['name'] = $row['item'];
			$result['components'][$i]['icount'] = $row['icount'];
			$i++;
		}
		return $result;
	}
        
        /**
         * Returns a list with als cids (capability ids) which were found in the given item types
         * @param type $itId
         * @return array
         */
        public function getCapabilitiesIdInItemTypes($itId)
	{
		$result = Array();
		$query = "SELECT DISTINCT cid from ".DB_PREFIX."items where itid=".(int)$itId;
		$qry =  mysqli_query(Config::getDBConn(), $query);
		
		while($row = mysqli_fetch_array($qry))
		{
			$result[] = $row['cid'];
		}
		return $result;
	}
	
	public function getDmgWeapons()		{ return $this->dmgWeapons; }
	public function getEffectWeapons()	{ return $this->effectWeapons; }
	public function getAccuracyWeapons(){ return $this->accuracyWeapons; }
	public function getArmorClothes()	{ return $this->armorClothes; }
	public function getAbsorbClothes()	{ return $this->absorbClothes; }
	public function getHandicapClothes(){ return $this->handicapClothes; }
	public function getBlockClothes()	{ return $this->blockClothes; }
	public function getArmorBasis()		{ return $this->armorBasis; }
	public function getItidDmgAttr()	{ return $this->itidDmgAttr; }
	public function getItidWeapons()	{ return $this->itidWeapons; }
	public function getItidSpellWeapons(){ return $this->itidSpellWeapons; }
	public function getAttrEtId()		{ return $this->attrEtId; }
        public function getItIdNoActivityDiscover() { return $this->itidNoActivityDiscover;}
}

?>