<?php 
class Payment
{
	private $no_donation_show = Array();
	private $no_donation_show_nicks = Array();
	
	public function __construct()
	{
		$this->loadIniNoDonationShow();
	}
	
	public function getOverview($month=0, $year=0, $sort="", $dir="", $withusers=false, $guids=array(), $daymin=1, $daymax=31, $nick="")
	{
		$result = Array();
		if($sort != "" && $dir != "")
			$order = ' ORDER BY '.getStringForDb($sort).' '.($dir=='down'?'ASC':'DESC');
		else
			$order = ' ORDER BY gesamt DESC';
		if($year > 0)
			$cond =  ($withusers?" and":" WHERE")." YEAR(date)=".(int)$year;
		if($month > 0)
		{
			$cond .= " and MONTH(date)=".(int)$month;
			$where = " and (DAY(k.date) BETWEEN ".(int)$daymin." and ".(int)$daymax.")";
		}
		
		
		/*****************Gilden******************/
		if(count($guids) > 0)
		{
			$where .= " and k.guid";
			$ind = " IN("; $i = 0;
			
			foreach($guids as $gid)	
			{
				$ind .= $gid;
				if($i != count($guids)-1)
						$ind .= ', ';
					$i++;
			}
			if(count($guids) == 0)	$ind .= "0";
			$ind .= ")";
			$where .= $ind;
			$where2 = " and gu.guid";
			$where2 .= $ind;
		}
		$nick1 = "";
		if($nick != "")
		{
			$nick1 = " and (k.name LIKE '".getStringForDb($nick)."' or u.nick LIKE '".getStringForDb($nick)."')";
		}
		if($withusers)
			$query = "SELECT u.uid, u.nick, SUM(deposit)as deposit, SUM(withdrawal) as withdrawal, COALESCE(SUM(gesamt),0) as gesamt, g.name, g.color, g.guid
				  	  FROM ".DB_PREFIX."users u
				  	  LEFT JOIN ".DB_PREFIX."guilds_user gu ON gu.uid=u.uid".$where2."
				  	  LEFT JOIN ".DB_PREFIX."guilds g ON g.guid=gu.guid
				  	  LEFT JOIN ".DB_PREFIX."kasse k on u.nick=k.name".$cond."".$where." 
				  	  WHERE bot=0".$nick1." 
				  	  GROUP BY u.nick, u.uid".$order;
		else
			$query = "SELECT k.name as nick, SUM(deposit)as deposit, SUM(withdrawal) as withdrawal, SUM(gesamt) as gesamt
				  	  FROM ".DB_PREFIX."kasse k".$cond."
				  	  GROUP BY k.name".$order;

		//echo $query;
		$res =  mysqli_query(Config::getDBConn(), $query);
		if(mysqli_num_rows($res) > 0)
		{
			$i = 0;
			while($row = mysqli_fetch_array($res))
			{				
				if(count($guids) > 0)
				{
					//wenn die person aktuell nicht mehr zur gilde geh�rt und fr�her auch keine ein- bzw. entnhamen get�tigt hat
					if($row['deposit'] == "" && $row['withdrawal'] == "" && $row['guid'] == "")
						continue;
				}
                $result[$i]['uid'] = $row['uid'];
                $result[$i]['nick'] = $row['nick'];
				$result[$i]['deposit'] = $row['deposit'];
				$result[$i]['withdrawal'] = $row['withdrawal'];
				$result[$i]['gilde'] = $row['name'];
				$result[$i]['color'] = $row['color'];
				$i++;
			}
			
		}
		return $result;		
	}
	
	public function getPaymentMonthly($year, $guIds=Array())
	{
		/*****************Gild Ids******************/
		$inf = " and guid IN("; $i = 0;
		foreach($guIds as $val)	
		{
			$inf .= $val;
			if($i != count($guIds)-1)
					$inf .= ', ';
				$i++;
		}
		if(count($guIds) == 0)	$inf .= "0";
		$inf .= ")";
		/*****************************************/
		$result = Array();
		$result[0] = Array(); $result[1] = Array(); $result[2] = Array();
		$query = "SELECT SUM(deposit)as deposit, SUM(withdrawal) as withdrawal, MONTH(date) as month 
			  	  FROM ".DB_PREFIX."kasse
			  	  WHERE YEAR(date)=".(int)$year.".$inf
			  	  GROUP BY MONTH(date)";

//		echo $query;
		$res =  mysqli_query(Config::getDBConn(), $query);
		if(mysqli_num_rows($res) > 0)
		{
                    $i = 0;
                    while($row = mysqli_fetch_array($res))
                    {				
                        $result[0][] = (int)$row['deposit'];
                        $result[1][] = (int)$row['withdrawal'];
                        $result[2][] = $row['month'];
                        $i++;
                    }
			
		}
		
		return $result;
	}
	
	public function getPaymentWeekly($yearf, $monthf, $yeart, $montht, $guId)
	{
		$result = Array();
		$result[0] = Array(); $result[1] = Array(); $result[2] = Array();
		$from = $yearf.'-'.$monthf.'-1';
		
		//anzahl tage im Monat ermitteln
		$tmpstmp = mktime(0,0,0,$montht,1,$yeart);
		
		$to = $yeart.'-'.$montht.'-'.date("t", $tmpstmp);
		
		$query = "SELECT SUM(deposit)as deposit, SUM(withdrawal) as withdrawal, WEEKOFYEAR(date) as wd 
			  	  FROM ".DB_PREFIX."kasse
			  	  WHERE DATEDIFF(date, '".$from."')>=0 and DATEDIFF(date, '".$to."')<=0 and guid=".(int)$guId."  
			  	  GROUP BY YEAR(date), WEEKOFYEAR(date)
			  	  order by year(date)";

		//echo $query;
		$res =  mysqli_query(Config::getDBConn(), $query);
		if(mysqli_num_rows($res) > 0)
		{
                    while($row = mysqli_fetch_array($res))
                    {				
                        $result[0][] = (int)$row['deposit'];
                        $result[1][] = (int)$row['withdrawal'];
                        $result[2][] = $row['wd'];
                    }
			
		}
		
		return $result;
	}
	
	public function getPaymentDayly($yearf, $monthf, $yeart, $montht, $guId)
	{
		$result = Array();
		$result[0] = Array(); $result[1] = Array(); $result[2] = Array();
		$query = "SELECT SUM(deposit)as deposit, SUM(withdrawal) as withdrawal, DAY(date) as wd 
			  	  FROM ".DB_PREFIX."kasse
			  	  WHERE YEAR(date)>=".(int)$yearf." and MONTH(date)>=".(int)$monthf." and YEAR(date)<=".(int)$yeart." and 
			  	  MONTH(date)<=".(int)$montht." and guid=".(int)$guId."  
			  	  GROUP BY YEAR(date), MONTH(date), DAY(date)";

		//echo $query;
		$res =  mysqli_query(Config::getDBConn(), $query);
		if(mysqli_num_rows($res) > 0)
		{
                    while($row = mysqli_fetch_array($res))
                    {
                        $result[0][] = (int)$row['deposit'];
                        $result[1][] = (int)$row['withdrawal'];
                        $result[2][] = $row['wd'];
                    }
			
		}
		
		return $result;
	}
	
	public function getYoungestProtEntry($guIds = Array())
	{
		/*****************Gild Ids******************/
		$inf = " guid IN("; $i = 0;
		foreach($guIds as $val)	
		{
			$inf .= $val;
			if($i != count($guIds)-1)
					$inf .= ', ';
				$i++;
		}
		if(count($guIds) == 0)	$inf .= "0";
		$inf .= ")";
		$result = array();
		$query = "SELECT DISTINCT name, DATE_FORMAT(lastaction, '%d.%m.%Y %H:%i') as date 
				  FROM ".DB_PREFIX."kasse 
				  WHERE lastaction=(SELECT MAX(k.lastaction) FROM ".DB_PREFIX."kasse k
				  	WHERE".$inf.") 
				  and".$inf;		
		
		//echo $query;
		$res =  mysqli_query(Config::getDBConn(), $query);
		if(mysqli_num_rows($res))
		{
			$res = mysqli_fetch_array($res);
			$result['name'] = $res['name'];
			$result['date'] = $res['date'];
		}
		return $result;		
	}
	
	public function getYoungestCityEntry($whId)
	{
		$result = array();
		$query = "SELECT DATE_FORMAT(MAX(date), '%d.%m.%Y %H:%i') as date 
				  FROM ".DB_PREFIX."city_transfer ct
				  WHERE ct.wid=".(int)$whId;	
		
		//echo $query;
		$res =  mysqli_query(Config::getDBConn(), $query);
		if(mysqli_num_rows($res))
		{
			$res = mysqli_fetch_array($res);
			$result['date'] = $res['date'];
		}
		return $result;		
	}
	
	public function loadIniNoDonationShow()
	{
		unset($this->no_donation_show);
		unset($this->no_donation_show_nicks);
		$this->no_donation_show = array();
		$this->no_donation_show_nicks = array();
		
		//alle nutzer holen, die beim Protokoll nicht in die summe der transaktionen eingehen sollen (lagerverwalter z.bsp.)
		$query = "SELECT u.nick, u.uid FROM ".DB_PREFIX."config, ".DB_PREFIX."users u WHERE set_key='nodonationshow' and value=u.uid";
		//echo $query;
		$qry =  mysqli_query(Config::getDBConn(), $query);
		
		if(mysqli_num_rows($qry) > 0)
		{
			$i = 0;
			while($row = mysqli_fetch_array($qry))
			{
				$this->no_donation_show[$i]['nick'] = $row['nick'];
				$this->no_donation_show[$i]['uid'] = $row['uid'];
				$this->no_donation_show_nicks[] = $row['nick'];
				$i++;
			}
		}
	}
	
	public function saveNoDonationShowUser($uId)
	{
		$query =  mysqli_query(Config::getDBConn(), "INSERT INTO ".DB_PREFIX."config VALUES('nodonationshow', ".(int)$uId.")");
		if($query)		return true;
		else			return false;
	}
	
	public function delNoDonationShowUser($uId)
	{
		$query =  mysqli_query(Config::getDBConn(), "DELETE FROM ".DB_PREFIX."config WHERE set_key='nodonationshow' and value='".(int)$uId."'");
		if($query)		return true;
		else			return false;
	}
	
	public function getYears()
	{
		$result = Array();
		
		$query = "SELECT DISTINCT YEAR(date) FROM ".DB_PREFIX."kasse ORDER BY YEAR(date) DESC";
		$qry_y =  mysqli_query(Config::getDBConn(), $query);	
	

		while($row = mysqli_fetch_row($qry_y))
		{
			$result[] = $row[0];
		}
		
		return $result;
	}
	
	public function getYearsForCity()
	{
		$result = Array();
		
		$query = "SELECT DISTINCT YEAR(date) FROM ".DB_PREFIX."city_transfer ORDER BY YEAR(date) DESC";
		$qry_y =  mysqli_query(Config::getDBConn(), $query);	
	

		while($row = mysqli_fetch_row($qry_y))
		{
			$result[] = $row[0];
		}
		
		return $result;
	}
	
	public function getMonths()
	{
		$result = Array();
		
		$query = "SELECT DISTINCT MONTH(date) FROM ".DB_PREFIX."kasse ORDER BY MONTH(date) ASC";
		$qry_m =  mysqli_query(Config::getDBConn(), $query);	
	

		while($row = mysqli_fetch_row($qry_m))
		{
			$result[] = $row[0];
		}
		
		return $result;
	}
	
	public function getMonthsForCity()
	{
		$result = Array();
		
		$query = "SELECT DISTINCT MONTH(date) FROM ".DB_PREFIX."city_transfer ORDER BY MONTH(date) ASC";
		$qry_m =  mysqli_query(Config::getDBConn(), $query);	
	

		while($row = mysqli_fetch_row($qry_m))
		{
			$result[] = $row[0];
		}
		
		return $result;
	}
	
	public function getNoDonationShowUsers()		{ return $this->no_donation_show; }
	public function getNoDonationShowNicks()		{ return $this->no_donation_show_nicks; }
	
	public function saveCityTransfer($list, $whId, $wh, $noquestion = false)
	{
		// alle Gildenlager laden
		$whs = $wh->getWHsByType(WHType::GILDENLAGER);	
		//$isGuildWh = false;
		foreach($whs as $row)
		{
			if($whId == $row['wid'])
			{
				//$isGuildWh = true;
				return Array(); // Bei Gildenlager nichts machen und alle Goldtransfers ignorieren
			}
		}
		
		$guildObj = new Guild(null);
		
		//namen durchgehen
		 foreach($list as $k1=>$entries)
		 {
			$name = $entries['name'];
		    $date = $entries['date'];
			$guild = $entries['guild'];
		    $type =  getStringForDb($entries['type']);
			if($entries['transfercity'] > 0)
				$amountIn = $entries['transfercity'];
			else
				$amountIn = 0;
			if($entries['transfercity'] < 0)
				$amountOut = $entries['transfercity'];
			else
				$amountOut = 0;
		    $dt = explode(' ', $date);
		    $d = explode('.', $dt[0]);
		    $t = explode(':', $dt[1]);
			$guId = 0;
		    
			$nd = sprintf('%s-%s-%s %s:%s:00', $d[2], $d[1], $d[0], $t[0], $t[1]);
			
			// Umbuchungen durch einen Charakter
			// Gildenid ermitteln
			if($guild == '')
			{
				$user = new User();
				// nur registrierte Nutzer bedenken
				if(!$user->loadUserByNick($name))
				{
					$list[$k1]['status'] = '<span class="err">kein Nutzer</span>';
					continue;
				}
				$guild = $user->getGuildShort();
				$list[$k1]['guild'] = $guild;
				$guId = $user->getGuId();
			}
			else	// Steuern durch das System, Gildenid ermitteln
			{
				$gu = $guildObj->getGuildByShort($guild);
				if(count($gu) == 0)
				{
					$list[$k1]['status'] = '<span class="err">keine Gilde</span>';
					continue;
				}
				
				$guId = $gu['id'];
			}
			
			//pr�fen, ob Eintrag vorhanden
			if(!$noquestion)
			{
				//pr�fen, ob Eintrag existiert
				$query = "SELECT ctid 
							FROM ".DB_PREFIX."city_transfer ct
							WHERE ct.wid=".(int)$whId." and ct.nick='".getStringForDb($name)."' and ct.date='".$nd."' and ct.type='".$type."' 
								and ct.guid=".$guId." and ct.amount_in=".$amountIn." and ct.amount_out=".$amountOut;
				
				$res =  mysqli_query(Config::getDBConn(), $query);
				$exist = false;
				if(mysqli_num_rows($res) == 0)
					$exist = false;
				else
					$exist = true;
			}
			
			if(!$exist || $noquestion) //Eintrag existiert noch nicht
			{
				$query = "INSERT INTO ".DB_PREFIX."city_transfer(date, nick, type, amount_in, amount_out, guid, wid) VALUES
						('".$nd."', '".getStringForDb($name)."', '".$type."', ".(int)$amountIn.", ".(int)$amountOut.", ".(int)$guId.", ".(int)$whId.")";
				if( mysqli_query(Config::getDBConn(), $query))
				{
					$list[$k1]['status'] = 'OK';
				}
			}
			else
			{
				$list[$k1]['status'] = 'ignoriert';
				$_SESSION['tmptransferlist'][$k1] = $list[$k1];
			}
		 }
		 
		 return $list;
	}
	
	public function getCityTransferOverview($whId, $type, $month=0, $year=0, $sort="", $dir="", $daymin=1, $daymax=31)
	{
		$result = Array();
		if($sort != "" && $dir != "")
			$order = ' ORDER BY '.getStringForDb($sort).' '.($dir=='down'?'ASC':'DESC');
		else
			$order = ' ORDER BY gesamt DESC';
		$cond = "";
		if($type == 1)	$cond .= " and type='Umbuchung'";
		if($type == 2)	$cond .= " and type='Steuer'";
		if($year > 0) $cond .= " and YEAR(date)=".(int)$year;
		if($month > 0)
			$cond .=  " and MONTH(date)=".(int)$month." and (DAY(date) BETWEEN ".(int)$daymin." and ".(int)$daymax.")";		

		$query = "SELECT g.name, SUM(amount_in) as amountin, SUM(amount_out) as amountout, (SUM(amount_in)+SUM(amount_out)) as gesamt 
				  FROM ".DB_PREFIX."city_transfer ct
				  JOIN ".DB_PREFIX."guilds g ON g.guid=ct.guid
				  WHERE ct.wid=".(int)$whId.$cond."
				  GROUP BY ct.guid".$order;		

		//echo $query;
		$res =  mysqli_query(Config::getDBConn(), $query);
		if(mysqli_num_rows($res) > 0)
		{
			$i = 0;
			while($row = mysqli_fetch_array($res))
			{				
				$result[$i]['name'] = $row['name'];
				$result[$i]['amountin'] = $row['amountin'];
				$result[$i]['amountout'] = $row['amountout'];
				$result[$i]['gesamt'] = $row['gesamt'];
				$i++;
			}
			
		}
		return $result;		
	}
        
        public function saveMarketTransfer($list, $whId, $wh, $noquestion = false)
	{
//            if(!$wh->hasRightForWh($whId)) {
//                return array();
//            }

            //namen durchgehen
             foreach($list as $k1=>$entries)
             {
                $name = $entries['name'];
                $date = $entries['date'];
                $type =  getStringForDb($entries['type']);
                $amountIn = 0;
                $amountOut = 0;

                if($type == getStringForDb("Gebhr")) {
                    $amountOut = (int)$entries['amount'];
                }
                    
                $dt = explode(' ', $date);
                $d = explode('.', $dt[0]);
                $t = explode(':', $dt[1]);

                $nd = sprintf('%s-%s-%s %s:%s:00', $d[2], $d[1], $d[0], $t[0], $t[1]);

                // Umbuchungen durch einen Charakter
                // Gildenid ermitteln
//                $user = new User();
//                // nur registrierte Nutzer bedenken
//                if(!$user->loadUserByNick($name))
//                {
//                        $list[$k1]['status'] = '<span class="err">kein Nutzer</span>';
//                        continue;
//                }
//                
//                $guild = $user->getGuildShort();
//                $list[$k1]['guild'] = $guild;
//                $guId = $user->getGuId();


                //prfen, ob Eintrag vorhanden
                if(!$noquestion)
                {
                    //prfen, ob Eintrag existiert
                    $query = "SELECT mtid FROM ".DB_PREFIX."market_transfer mt
                                WHERE mt.wid=".(int)$whId." and mt.nick='".getStringForDb($name)."' and mt.date='".$nd."' and mt.type='".$type."' 
                                        and mt.amount_in=".$amountIn." and mt.amount_out=".$amountOut;

                    $res =  mysqli_query(Config::getDBConn(), $query);
                    $exist = false;
                    if(mysqli_num_rows($res) == 0)
                        $exist = false;
                    else
                        $exist = true;
                }

                if(!$exist || $noquestion) //Eintrag existiert noch nicht
                {
                    $query = "INSERT INTO ".DB_PREFIX."market_transfer(date, nick, type, amount_in, amount_out, wid) VALUES
                                    ('".$nd."', '".getStringForDb($name)."', '".$type."', ".(int)$amountIn.", ".(int)$amountOut.", ".(int)$whId.")";
                    if( mysqli_query(Config::getDBConn(), $query))
                    {
                        $list[$k1]['status'] = 'OK';
                    }
                }
                else
                {
                    $list[$k1]['status'] = 'ignoriert';
                    $_SESSION['tmpmarkettransferlist'][$k1] = $list[$k1];
                }
             }

             return $list;
	}
}
?>