<?php
class Poll
{
	private $user;
	public function __construct($user)
	{
		$this->user = $user;
	}
	
	public function createPoll($question, $answers, $guilds, $groups, $maxvotes, $owner, $validuntil="")
	{
		$query = "INSERT INTO ".DB_PREFIX."poll_question (question, active, max_votes, owner, date) 
				  VALUES ('".getStringForDb($question)."', 1, ".(int)$maxvotes.", ".(int)$owner.", NOW())";
		
		if( mysqli_query(Config::getDBConn(), $query))
		{
			$id = mysqli_insert_id(Config::getDBConn());
			$this->addAnswers($answers, $id);
			$this->addGuilds($guilds, $id);
			$this->addGroups($groups, $id);
			return true;
		}
		else
			return false;
	}
	
	public function updatePoll($pqid, $active, $question, $answers, $guilds, $groups, $maxvotes, $validuntil="")
	{
		$active = ($active?1:0);
		$query = "UPDATE ".DB_PREFIX."poll_question set question='".getStringForDb($question)."', active=".(int)$active.", 
				  max_votes=".(int)$maxvotes." WHERE pqid=".(int)$pqid;				 
		
		if( mysqli_query(Config::getDBConn(), $query))
		{
			$this->updateAnswers($answers);
			$this->addGuilds($guilds, $pqid);
			$this->addGroups($groups, $pqid);
			return true;
		}
		else
			return false;
	}
	
	private function updateAnswers($answers)
	{
		if(is_array($answers))
		foreach($answers as $key=>$value)
		{
			$query = "UPDATE ".DB_PREFIX."poll_answer set answer='".getStringForDb($value)."' 
					  WHERE paid=".(int)$key;
			 mysqli_query(Config::getDBConn(), $query);
		}
	}
	
	private function addAnswers($answers, $pqid)
	{
		if(is_array($answers))
		foreach($answers as $row)
		{
			$query = "INSERT INTO ".DB_PREFIX."poll_answer (answer, pqid) VALUES ('".getStringForDb($row)."', ".(int)$pqid.")";
			 mysqli_query(Config::getDBConn(), $query);
		}
	}
	
	private function addGuilds($guilds, $pqid)
	{
		//fr das bearbeiten erst alle gilden lschen und dann hinzufgen
		$q1 = "DELETE FROM ".DB_PREFIX."poll_guild WHERE pqid=".(int)$pqid;
		if( mysqli_query(Config::getDBConn(), $q1) && is_array($guilds))
		{
			foreach($guilds as $key=>$value)
			{
				$query = "INSERT INTO ".DB_PREFIX."poll_guild (pqid, guid) VALUES (".(int)$pqid.", ".(int)$key.")";
				 mysqli_query(Config::getDBConn(), $query);
			}
			
		}		
	}
	
	private function addGroups($groups, $pqid)
	{
		//fr das bearbeiten erst alle gruppen lschen und dann hinzufgen
		$q1 = "DELETE FROM ".DB_PREFIX."poll_group WHERE pqid=".(int)$pqid;
		if( mysqli_query(Config::getDBConn(), $q1) && is_array($groups))
		{
			foreach($groups as $key=>$value)
			{
				$query = "INSERT INTO ".DB_PREFIX."poll_group (pqid, gid) VALUES (".(int)$pqid.", ".(int)$key.")";
				 mysqli_query(Config::getDBConn(), $query);
			}
			
		}		
	}
	
	public function addVotes($answers, $pqid)
	{
		if(is_array($answers))
		{
			//fr das bearbeiten erst alle gilden lschen und dann hinzufgen
			$q1 = "UPDATE ".DB_PREFIX."poll_question set unique_users=unique_users+1 WHERE pqid=".(int)$pqid;

			if( mysqli_query(Config::getDBConn(), $q1))
			{
				foreach($answers as $value)
				{
					$query = "INSERT INTO ".DB_PREFIX."poll_user (paid, uid, date) VALUES (".(int)$value.", ".$this->user->getUId().", NOW())";
					if(! mysqli_query(Config::getDBConn(), $query))
						return false;
				}
			}
			else
				return false;
			return true;
		}
		return false;
	}
	
	//bei 0 werden alle geladen
	public function getPollsByRight($pqid = 0)
	{
		$result = array();
		if($pqid == 0)	$where = "";
		else			$where = " WHERE pq.pqid=".(int)$pqid;
		$query = "SELECT DISTINCT pq.pqid, pq.question, pq.active, pq. valid_until, pq.unique_users, pq.max_votes, pq.date as tmpdate, DATE_FORMAT(pq.date, '%d.%m.%Y %H:%i') as date
				  FROM ".DB_PREFIX."poll_question pq
				  JOIN ".DB_PREFIX."poll_guild pg ON pg.pqid=pq.pqid
				  JOIN ".DB_PREFIX."guilds_user gu ON pg.guid=gu.guid and (gu.uid=".$this->user->getUId()." or pq.owner=".$this->user->getUId().")
				  ".$where."
				  ORDER BY pq.date DESC";
		$res =  mysqli_query(Config::getDBConn(), $query);
		if(mysqli_num_rows($res) > 0)
		{
			$i = 0;
			while($row = mysqli_fetch_array($res))
			{				
				$result[$i]['pqid'] = $row['pqid'];
				$result[$i]['question'] = $row['question'];
				$result[$i]['active'] = ($row['active']==1?true:false);
				$result[$i]['valid_until'] = $row['valid_until'];
				$result[$i]['unique_users'] = $row['unique_users'];
				$result[$i]['max_votes'] = $row['max_votes'];
				$result[$i]['date'] = $row['date'];
				$result[$i]['results'] = $this->getResults($row['pqid']);
				$result[$i]['answers'] = $this->getAnswers($row['pqid']);
				$result[$i]['groups'] = $this->getGroups($row['pqid']);
				$result[$i]['guilds'] = $this->getGuilds($row['pqid']);
				$i++;
			}								
		}
		return $result;
	}
	
	public function canEdit($pqid)
	{
		$query = "SELECT DISTINCT pq.pqid
				  FROM ".DB_PREFIX."poll_question pq
				  LEFT JOIN ".DB_PREFIX."poll_group pg ON pg.pqid=pq.pqid
				  LEFT JOIN ".DB_PREFIX."groups_user gu ON pg.gid=gu.gid
				  LEFT JOIN ".DB_PREFIX."groups_guild gg ON pg.gid=gg.gid
				  LEFT JOIN ".DB_PREFIX."guilds_user ggu ON ggu.guid=gg.guid
				  WHERE pq.pqid=".(int)$pqid." and ((gu.uid=".$this->user->getUId().") or (ggu.uid=".$this->user->getUId().") or pq.owner=".$this->user->getUId().")";
		
		$res =  mysqli_query(Config::getDBConn(), $query);
		if(mysqli_num_rows($res) > 0)
			return true;
		else 
		return false;
	}
	
	private function getResults($pqid)
	{
		$result = array();
		//hole votes je Antwort und Gesamtanuahl an Stimmen
		$query = "SELECT a.paid, a.answer,  (SELECT COUNT(*) as votes FROM ".DB_PREFIX."poll_user pu WHERE pu.paid=a.paid) as votes,
				  (SELECT COUNT(*) as totalvotes FROM ".DB_PREFIX."poll_user pu WHERE pu.paid IN
				  	(SELECT pa.paid FROM ".DB_PREFIX."poll_answer pa WHERE pa.pqid=".(int)$pqid.")) as totalvotes
				  FROM ".DB_PREFIX."poll_answer a 
				  WHERE a.pqid=".(int)$pqid."
				  ORDER BY votes DESC, a.paid ASC";
		
		$res =  mysqli_query(Config::getDBConn(), $query);
		if(mysqli_num_rows($res) > 0)
		{
			$i = 0;
			while($row = mysqli_fetch_array($res))
			{				
				$result[$i]['paid'] = $row['paid'];
				$result[$i]['answer'] = $row['answer'];
				$result[$i]['votes'] = $row['votes'];
				$result[$i]['totalvotes'] = $row['totalvotes'];
				$i++;
			}								
		}
		return $result;
	}
	
	private function getAnswers($pqid)
	{
		$result = array();
		//hole votes je Antwort und Gesamtanzahl an Stimmen
		$query = "SELECT a.paid, a.answer, a.pqid
				  FROM ".DB_PREFIX."poll_answer a 
				  WHERE a.pqid=".(int)$pqid."
				  ORDER BY a.paid ASC";
		
		$res =  mysqli_query(Config::getDBConn(), $query);
		if(mysqli_num_rows($res) > 0)
		{
			$i = 0;
			while($row = mysqli_fetch_array($res))
			{				
				$result[$i]['paid'] = $row['paid'];
				$result[$i]['answer'] = $row['answer'];
				$result[$i]['pqid'] = $row['pqid'];
				$i++;
			}								
		}
		return $result;
	}
	
	private function getGroups($pqid)
	{
		$result = array();
		//hole votes je Antwort und Gesamtanuahl an Stimmen
		$query = "SELECT g.gid
				  FROM ".DB_PREFIX."poll_group g 
				  WHERE g.pqid=".(int)$pqid;
		
		$res =  mysqli_query(Config::getDBConn(), $query);
		if(mysqli_num_rows($res) > 0)
		{
			while($row = mysqli_fetch_array($res))
			{				
				$result[] = $row['gid'];
			}								
		}
		return $result;
	}
	
	private function getGuilds($pqid)
	{
		$result = array();
		//hole votes je Antwort und Gesamtanuahl an Stimmen
		$query = "SELECT g.guid
				  FROM ".DB_PREFIX."poll_guild g 
				  WHERE g.pqid=".(int)$pqid;
		
		$res =  mysqli_query(Config::getDBConn(), $query);
		if(mysqli_num_rows($res) > 0)
		{
			while($row = mysqli_fetch_array($res))
			{				
				$result[] = $row['guid'];
			}								
		}
		return $result;
	}
	
	public function getUserVoteCount($pqid)
	{
		$result = array();
		$query = "SELECT COUNT(*) as votes 
				  FROM ".DB_PREFIX."poll_answer a
				  JOIN ".DB_PREFIX."poll_user pu ON a.pqid=".(int)$pqid." and pu.paid=a.paid and pu.uid=".$this->user->getUId();
		
		$res =  mysqli_query(Config::getDBConn(), $query);
		if(mysqli_num_rows($res) == 1)
		{
			$row = mysqli_fetch_array($res);
			return	(int)$row['votes'];		
		}
		return 0;
	}
	
	public function deletePoll($pqid)
	{
		$q1 =  mysqli_query(Config::getDBConn(), "DELETE FROM ".DB_PREFIX."poll_user WHERE paid IN (SELECT paid FROM ".DB_PREFIX."poll_answer WHERE pqid=".(int)$pqid.")");
		$q2 =  mysqli_query(Config::getDBConn(), "DELETE FROM ".DB_PREFIX."poll_answer WHERE pqid=".(int)$pqid);
		$q3 =  mysqli_query(Config::getDBConn(), "DELETE FROM ".DB_PREFIX."poll_guild WHERE pqid=".(int)$pqid);
		$q4 =  mysqli_query(Config::getDBConn(), "DELETE FROM ".DB_PREFIX."poll_group WHERE pqid=".(int)$pqid);
		$q5 =  mysqli_query(Config::getDBConn(), "DELETE FROM ".DB_PREFIX."poll_question WHERE pqid=".(int)$pqid);
		
		if($q1 && $q2 && $q3 && $q4 && $q5)
			return true;
		else
			return false;
	}
}