<?php
class User
{
private $uId = 0;
private $gender;
private $nick;
private $titel;
private $mail;
private $lastaction;
private $nowork;
private $lvl;
private $folk;
private $class;
private $fid;
private $bot;
private $desc;
private $guId;
private $enemy;
private $combat;
private $position;
private $bandagesCount;
private $bandagesHeal;
private $bandagesPrio;
private $trustlvl;
private $ontime;
private $guildname;
private $guildshort;
private $lastlogin;
private $apikey;
	
	public function __construct()
	{
		if(isset($_SESSION['uid']))
		{
			$this->loadUser($_SESSION['uid']);
			$this->setLastAction();
		}	
	}
	
	public function loadUser($uid)
	{
		$result = false;
		$query = "SELECT u.uid, u.gender_id, nick, u.avatar, pwd, titel, mail, DATE_FORMAT(lastaction, '%d.%m.%Y %H:%i') as lastaction, nowork,
				  lvl, u.fid, f.name, u.description, u.bot, gu.guid, u.combat, u.enemy, u.ontime, u.trustlvl, g.name as guildname, g.short, 
                                  u.combat_position, u.bandages_count, u.bandages_heal, u.bandages_prio, u.apikey, u.classes_class_id 
				  FROM ".DB_PREFIX."users u 
				  LEFT JOIN ".DB_PREFIX."folk f ON f.fid=u.fid 
				  LEFT JOIN ".DB_PREFIX."guilds_user gu ON gu.uid=u.uid
				  LEFT JOIN ".DB_PREFIX."guilds g ON g.guid=gu.guid
				  WHERE u.uid=".(int)$uid;
		//echo $query;
		$query =  mysqli_query(Config::getDBConn(), $query);
		if(mysqli_num_rows($query))
		{
			$row = @mysqli_fetch_array($query);
			$result = true;
			if($uid == $_SESSION['uid'])
			{
				$_SESSION['nick'] = $row['nick'];
				$_SESSION['titel'] = $row['titel'];
				$_SESSION['mail'] = $row['mail'];
			}
			$this->uId = $row['uid'];
                        $this->gender = $row['gender_id'];
			$this->nick = $row['nick'];
                        $this->avatar = $row['avatar'];
			$this->titel = $row['titel'];
			$this->mail = $row['mail'];
			$this->lastaction = $row['lastaction'];
			$this->nowork = $row['nowork'];
			$this->lvl = $row['lvl'];
			$this->folk = $row['name'];
                        $this->class = (int)$row['classes_class_id'];
			$this->fid = $row['fid'];
			$this->bot = $row['bot'];
			$this->desc = $row['description'];
			$this->guId = $row['guid'];
			$this->enemy = $row['enemy'];
			$this->combat = $row['combat'];
                        $this->position = $row['combat_position'];
                        $this->bandagesCount = $row['bandages_count'];
                        $this->bandagesHeal = $row['bandages_heal'];
                        $this->bandagesPrio = $row['bandages_prio'];
			$this->trustlvl = $row['trustlvl'];
			$this->ontime = $row['ontime'];
			$this->guildname = $row['guildname'];
			$this->guildshort = $row['short'];
			$this->lastlogin = $row['lastaction'];
                        $this->apikey = $row['apikey'];
		}
		return $result;		
	}
	
	public function loadUserByNick($nick)
	{
		$result = false;
		$query = "SELECT u.uid, nick, pwd, titel, mail, DATE_FORMAT(lastaction, '%d.%m.%Y %H:%i') as lastaction, nowork,
				  lvl, u.fid, f.name, u.description, u.bot, gu.guid, u.combat, u.enemy, u.ontime, u.trustlvl, g.name as guildname, g.short, 
                                  u.combat_position, u.apikey, u.classes_class_id 
				  FROM ".DB_PREFIX."users u 
				  LEFT JOIN ".DB_PREFIX."folk f ON f.fid=u.fid 
				  LEFT JOIN ".DB_PREFIX."guilds_user gu ON gu.uid=u.uid
				  LEFT JOIN ".DB_PREFIX."guilds g ON g.guid=gu.guid
				  WHERE u.nick='".getStringForDb($nick)."'";
		//echo $query;
		$query = @ mysqli_query(Config::getDBConn(), $query);
		if(mysqli_num_rows($query) == 1)
		{
			$row = @mysqli_fetch_array($query);
			$result = true;
			
			$this->uId = $row['uid'];
			$this->nick = $row['nick'];
			$this->titel = $row['titel'];
			$this->mail = $row['mail'];
			$this->lastaction = $row['lastaction'];
			$this->nowork = $row['nowork'];
			$this->lvl = $row['lvl'];
			$this->folk = $row['name'];
                        $this->class = $row['classes_class_id'];
			$this->fid = $row['fid'];
			$this->bot = $row['bot'];
			$this->desc = $row['description'];
			$this->guId = $row['guid'];
			$this->enemy = $row['enemy'];
			$this->combat = $row['combat'];
                        $this->position = $row['combat_position'];
			$this->trustlvl = $row['trustlvl'];
			$this->ontime = $row['ontime'];
			$this->guildname = $row['guildname'];
			$this->guildshort = $row['short'];
			$this->lastlogin = $row['lastaction'];
                        $this->apikey = $row['apikey'];
		}
		return $result;		
	}
        
        public function loadUserByAPIKey($apiKey)
	{
		$result = false;
		$query = "SELECT u.uid FROM ".DB_PREFIX."users u WHERE u.apikey='".getStringForDb($apiKey)."'";
		//echo $query;
		$query = @ mysqli_query(Config::getDBConn(), $query);
		if(mysqli_num_rows($query) == 1)
		{
                    $row = @mysqli_fetch_array($query);
                    return $this->loadUser($row['uid']);
                }
                else
                {
                    return null;
                }
        }
	
	public function getUpdateTimes()
	{
		$result = array();
		$query = "SELECT DATE_FORMAT(lastaction, '%d.%m.%Y %H:%i') as lastaction,
				  DATE_FORMAT(MAX(uc.updated), '%d.%m.%Y %H:%i') as caps, 
				  DATE_FORMAT(MAX(ui.updated), '%d.%m.%Y %H:%i') as inv, 
				  DATE_FORMAT(MAX(us.updated), '%d.%m.%Y %H:%i') as spells 
				  FROM ".DB_PREFIX."users u 
				  LEFT JOIN ".DB_PREFIX."users_capabilities uc ON uc.uid=u.uid
				  LEFT JOIN ".DB_PREFIX."users_inventar ui ON ui.uid=u.uid and ui.hid=0
				  LEFT JOIN ".DB_PREFIX."users_spell us ON us.uid=u.uid and us.hid=0
				  WHERE u.uid=".$this->uId."
				  GROUP BY u.uid";
		//echo $query;
		$query = @ mysqli_query(Config::getDBConn(), $query);
		if(mysqli_num_rows($query))
		{
			$row = @mysqli_fetch_array($query);
			$result['lastaction'] = $row['lastaction'];
			$result['caps'] = $row['caps'];
			$result['inv'] = $row['inv'];
			$result['spells'] = $row['spells'];
		}
		return $result;		
	}
	
	public function getId()
	{
		return $this->uId;
	}	
	
	public function nickAvailable($nick)
	{
		$result = false;
		$nick = strtolower(getStringForDb($nick));
		$query = "SELECT uid FROM ".DB_PREFIX."users WHERE lower(nick)='".$nick."'";
		$qry =  mysqli_query(Config::getDBConn(), $query);
		if($qry && mysqli_num_rows($qry) == 0)
		  $result = true;
		  
		return $result;
	}
	
	public function addUser($gender_id, $nick, $avatar, $pw, $mail, $titel, $lvl, $fid, $desc, $bot, $nowork, $class)
	{
		$result = false;
                $security = new Security();
		$query = "INSERT INTO ".DB_PREFIX."users(gender_id, nick, avatar, pwd, mail, titel, lvl, fid, description, bot, nowork, classes_class_id, trustlvl, enemy, combat, combat_position)
					VALUES ('" . getStringForDb($gender_id) . "', '".getStringForDb($nick)."', '" . getStringForDb($avatar) . "', '".$security->hashPssword($pw)."', '".getStringForDb($mail)."',
							'".getStringForDb($titel)."', ".(int)$lvl.", ".(int)$fid.", '".getStringForDb($desc)."',
							".(int)$bot.", ".(int)$nowork.", ".(int)$class.",0,1,1,1)";

		if( mysqli_query(Config::getDBConn(), $query)) {
                    $id = mysqli_insert_id(Config::getDBConn());
                    $uuid = gen_uuidv4();
                    $this->updateAPIKey($id, $uuid);
                    return $id;
                }
		   
		return 0;
	}
	
	public function updateUser($nick, $gender_id, $pw, $mail, $titel, $nowork, $lvl, $fid, $desc, $avatar, $bot=0, $ontime, $class, $adminMode=0)
	{
		$result = false;
		$nowork = ($nowork != ""?1:0);
                
		if($adminMode)
		{
                    $query = "UPDATE ".DB_PREFIX."users set gender_id='" . (int)$gender_id . "', nick='".getStringForDb($nick)."', avatar='" . getStringForDb($avatar) . "', mail='".getStringForDb($mail)."', bot=".(int)$bot.",
                                    titel='".getStringForDb($titel)."', nowork=".$nowork.", lvl=".(int)$lvl.", fid=".(int)$fid.",
                                    description='".getStringForDb($desc)."', ontime='".getStringForDb($ontime)."', classes_class_id=".(int)$class."
                              WHERE uid=".$this->uId;
		}	
		else
		{
                    $query = "UPDATE ".DB_PREFIX."users set gender_id='" . (int)$gender_id . "', avatar='" . getStringForDb($avatar) . "', mail='".getStringForDb($mail)."', "
                        . "nowork=".$nowork.", lvl=".(int)$lvl.", fid=".(int)$fid.", description='".getStringForDb($desc)."', ontime='".getStringForDb($ontime)."', classes_class_id=".(int)$class." "
                        . "WHERE uid=".$this->uId;
		}	
		//echo $query;
		if( mysqli_query(Config::getDBConn(), $query))
		{
                    $result = true;
                    $this->loadUser($this->uId);
		} 
                
                if(!empty($pw)) {
                    $security = new Security();
                    $security->updatePassword($this->uId, $pw);
                }
		return $result;
	}
        
        public function updateUsersLvl($uId, $lvl)
	{
		$result = false;
		$query = "UPDATE ".DB_PREFIX."users set lvl=".(int)$lvl." WHERE uid=".(int)$uId;
			
		//echo $query;
		if(@ mysqli_query(Config::getDBConn(), $query))
			$result = true;
			
		return $result;
	}
        
        public function updateAPIKey($uid, $apiKey)
	{
		$result = false;
		$query = "UPDATE ".DB_PREFIX."users set apikey='".  getStringForDb($apiKey)."' WHERE uid=".(int)$uid;
			
		//echo $query;
		if(@ mysqli_query(Config::getDBConn(), $query))
			$result = true;
			
		return $result;
	}
	
	public function updateTrustLvl($uid, $lvl)
	{
		$result = false;
		$query = "UPDATE ".DB_PREFIX."users set trustlvl=".(int)$lvl." WHERE uid=".(int)$uid;
			
		//echo $query;
		if( mysqli_query(Config::getDBConn(), $query))
			$result = true;
			
		return $result;
	}
	
	public function updateBehavior($enemy, $combat, $position, $banCount, $banHeal, $banPrio, $s1, $s2, $s3)
	{
		$result = false;
		$q1 =  mysqli_query(Config::getDBConn(), "UPDATE ".DB_PREFIX."users set enemy=".(int)$enemy.", combat=".(int)$combat.", "
                        . "combat_position=".(int)$position.", bandages_count=".(int)$banCount.", bandages_heal=".(int)$banHeal.", bandages_prio=".(int)$banPrio." "
                        . "WHERE uid=".$this->uId);
		$q2 = $this->updateUsersSpell($this->uId, $s1, $s2, $s3);
		
		if($q1 && $q2)
			return true;
		else
			return false;	
	}
	
	public function updateUsersSpell($uid, $s1, $s2, $s3, $hid=0)
	{
		$result = false;
		 mysqli_query(Config::getDBConn(), "DELETE FROM ".DB_PREFIX."users_spell WHERE uid=".(int)$uid." and hid=".(int)$hid);
		$q1 =  mysqli_query(Config::getDBConn(), "INSERT INTO ".DB_PREFIX."users_spell (uid,spid,updated,type,hid) VALUES (".(int)$uid.",".(int)$s1.",NOW(),1,".(int)$hid.")");
		$q2 =  mysqli_query(Config::getDBConn(), "INSERT INTO ".DB_PREFIX."users_spell (uid,spid,updated,type,hid) VALUES (".(int)$uid.",".(int)$s2.",NOW(),2,".(int)$hid.")");
		$q3 =  mysqli_query(Config::getDBConn(), "INSERT INTO ".DB_PREFIX."users_spell (uid,spid,updated,type,hid) VALUES (".(int)$uid.",".(int)$s3.",NOW(),3,".(int)$hid.")");
		
		if($q1 && $q2 && $q3)
			return true;
		else
			return false;	
	}
	
	public function isValidMail($mail)
	{
		if(!filter_var($mail, FILTER_VALIDATE_EMAIL))
			return false;
		else 
			return true;
	}
	
	public function getUserList()
	{
		$result = array();
		$query = "SELECT uid, nick, titel, mail FROM ".DB_PREFIX."users ORDER BY nick";
		$query = @ mysqli_query(Config::getDBConn(), $query);
		$i = 0;
		while($row = @mysqli_fetch_array($query))
		{
			$result[$i]['id'] = $row['uid'];
			$result[$i]['nick'] = $row['nick'];
			$result[$i]['titel'] = $row['titel'];
			$result[$i]['mail'] = $row['mail'];
			$i++;
		}
		return $result;		
	}
	
	public function getUserListByWriteRight()
	{
		$result = array();
		$query = "SELECT DISTINCT u.uid, u.nick, titel, mail, g.name, g.color
				  FROM ".DB_PREFIX."users u
				  JOIN ".DB_PREFIX."guilds_user ggu ON ggu.uid=u.uid
				  JOIN ".DB_PREFIX."guilds g ON g.guid=ggu.guid
				  JOIN ".DB_PREFIX."group_rights_guild grg ON grg.guid=g.guid and grg.canwrite=1 
				  LEFT JOIN ".DB_PREFIX."groups_user gu ON gu.gid=grg.gid
				  LEFT JOIN ".DB_PREFIX."groups_guild gg ON gg.gid=grg.gid
				  LEFT JOIN ".DB_PREFIX."guilds_user ggu2 ON ggu2.guid=gg.guid
				  WHERE gu.uid=".$this->getUId()." or ggu2.uid=".$this->getUId()." 
				  ORDER BY u.nick";
		$query = @ mysqli_query(Config::getDBConn(), $query);
		$i = 0;
		while($row = @mysqli_fetch_array($query))
		{
			$result[$i]['id'] = $row['uid'];
			$result[$i]['nick'] = $row['nick'];
			$result[$i]['titel'] = $row['titel'];
			$result[$i]['mail'] = $row['mail'];
			$result[$i]['gilde'] = $row['name'];
			$result[$i]['color'] = $row['color'];
			$i++;
		}
		return $result;		
	}
	
	public function canEdit($uid)
	{
		$result = false;
		//Warehouse laut Nutzerrecht holen
		$query = "SELECT DISTINCT u.uid
				  FROM ".DB_PREFIX."users u
				  JOIN ".DB_PREFIX."guilds_user ggu ON u.uid=".(int)$uid." and ggu.uid=u.uid
				  JOIN ".DB_PREFIX."guilds g ON g.guid=ggu.guid
				  JOIN ".DB_PREFIX."group_rights_guild grg ON grg.guid=g.guid and grg.canwrite=1 
				  LEFT JOIN ".DB_PREFIX."groups_user gu ON gu.gid=grg.gid
				  LEFT JOIN ".DB_PREFIX."groups_guild gg ON gg.gid=grg.gid
				  LEFT JOIN ".DB_PREFIX."guilds_user ggu2 ON ggu2.guid=gg.guid
				  WHERE gu.uid=".$this->getUId()." or ggu2.uid=".$this->getUId();
		//echo $query;
		$qry =  mysqli_query(Config::getDBConn(), $query);
		
		if(mysqli_num_rows($qry) > 0)
			$result = true;
		
		return $result;
	}
	
	private function setLastAction()
	{
		if($this->uId > 0)
			@ mysqli_query(Config::getDBConn(), "UPDATE ".DB_PREFIX."users SET lastaction=NOW() WHERE uid=".(int)$this->uId);
		
	}
	
	public function deleteUserById()
	{
		$q1 =  mysqli_query(Config::getDBConn(), "DELETE FROM ".DB_PREFIX."users WHERE uid=".(int)$this->uId);
		$q2 =  mysqli_query(Config::getDBConn(), "DELETE FROM ".DB_PREFIX."groups_user WHERE uid=".(int)$this->uId);
		$q3 =  mysqli_query(Config::getDBConn(), "DELETE FROM ".DB_PREFIX."guilds_user WHERE uid=".(int)$this->uId);
		$q4 =  mysqli_query(Config::getDBConn(), "DELETE FROM ".DB_PREFIX."users_capabilities WHERE uid=".(int)$this->uId);
		$q5 =  mysqli_query(Config::getDBConn(), "DELETE FROM ".DB_PREFIX."user_plans WHERE uid=".(int)$this->uId);
		$q6 =  mysqli_query(Config::getDBConn(), "DELETE FROM ".DB_PREFIX."users_inventar WHERE uid=".(int)$this->uId);
		$q7 =  mysqli_query(Config::getDBConn(), "DELETE FROM ".DB_PREFIX."hunt_group_edit_users WHERE uid=".(int)$this->uId);
		$q8 =  mysqli_query(Config::getDBConn(), "DELETE FROM ".DB_PREFIX."hunt_group_users WHERE uid=".(int)$this->uId);
		$q9 =  mysqli_query(Config::getDBConn(), "DELETE FROM ".DB_PREFIX."users_enchantment WHERE uid=".(int)$this->uId);
		$q10 =  mysqli_query(Config::getDBConn(), "DELETE FROM ".DB_PREFIX."users_spell WHERE uid=".(int)$this->uId);
		$q11 =  mysqli_query(Config::getDBConn(), "DELETE FROM ".DB_PREFIX."user_attributes WHERE uid=".(int)$this->uId);
		//$q12 =  mysqli_query(Config::getDBConn(), "DELETE FROM ".DB_PREFIX."kasse WHERE name='".$this->nick."'");
		$q12 =  mysqli_query(Config::getDBConn(), "DELETE FROM ".DB_PREFIX."warehouse_protocoll_entry WHERE wpid 
							IN (SELECT wpid from ".DB_PREFIX."warehouse_protocoll where nick='".$this->nick."')");
		$q13 =  mysqli_query(Config::getDBConn(), "DELETE FROM ".DB_PREFIX."warehouse_protocoll WHERE nick='".$this->nick."'");
		
		if($q1 && $q2 && $q3 && $q4 && $q5 && $q6 && $q7 && $q8 && $q9 && $q10 && $q11 && $q12 && $q13)
			return true;
		else
			return false;
	}
	
	public function getUsersCapabilities($type=0)
	{
		$result = Array();
		$query = "SELECT c.cid, c.capability, uc.value, uc.mainwork, uc.effect, c.name_alias  
				  FROM ".DB_PREFIX."capabilities c LEFT JOIN ".DB_PREFIX."users_capabilities uc on uc.cid=c.cid and uc.uid=".$this->uId." 
				  WHERE c.type=".(int)$type;

		//echo $query;
		$res =  mysqli_query(Config::getDBConn(), $query);
		if(mysqli_num_rows($res) > 0)
		{
			while($row = mysqli_fetch_array($res))
			{
				$result[$row['capability']]['id'] = $row['cid'];
				$result[$row['capability']]['value'] = $row['value'];
                $result[$row['capability']]['alias'] = $row['name_alias'];
				$result[$row['capability']]['mainwork'] = $row['mainwork'];
                $result[$row['capability']]['effect'] = $row['effect'];
			}
			
		}
		return $result;		
	}
	
	public function getUsersAttributes($hid=0)
	{
		$result = Array();
		$query = "SELECT a.aid, a.name, ua.lvl
				  FROM ".DB_PREFIX."attributes a LEFT JOIN ".DB_PREFIX."user_attributes ua on ua.aid=a.aid and 
				  ua.uid=".$this->uId." and hid=".(int)$hid;

		//echo $query;
                $folk = new Folk();
		$res =  mysqli_query(Config::getDBConn(), $query);
		if(mysqli_num_rows($res) > 0)
		{	
                    while($row = mysqli_fetch_array($res))
                    {
                        $minlvl = $folk->getMinAttributLvl($this->getFolkId(), $row['aid'], $this->getClassesClassId());
                        if($minlvl > $row['lvl'])
                            $row['lvl'] = $minlvl;
                        $result[$row['name']]['id'] = $row['aid'];
                        $result[$row['name']]['lvl'] = $row['lvl'];
                    }			
		}
		return $result;		
	}
	
	public function getUsersInventar($hid=0)
	{
		$result = Array();
		$query = "SELECT ui.uid, ui.iid, DATE_FORMAT(ui.updated, '%d.%m.%Y %H:%i') as updated, ui.type, i.item, i.lvl, i.itid, ui.increment
				  FROM ".DB_PREFIX."users_inventar ui
				  LEFT JOIN ".DB_PREFIX."items i ON i.iid=ui.iid
				  WHERE uid=".$this->uId." and hid=".(int)$hid."
				  ORDER BY i.sort, ui.sort";

		//echo $query;
		$res =  mysqli_query(Config::getDBConn(), $query);
		if(mysqli_num_rows($res) > 0)
		{
			$i = 0;
			while($row = mysqli_fetch_array($res))
			{
				$result[$i]['uid'] = $row['uid'];
				$result[$i]['iid'] = $row['iid'];
				$result[$i]['updated'] = $row['updated'];
				$result[$i]['type'] = $row['type'];
				$result[$i]['item'] = $row['item'];
				$result[$i]['itid'] = $row['itid'];
				$result[$i]['lvl'] = $row['lvl'];
                                $result[$i]['increment'] = $row['increment'];
				$i++;
			}
			
		}
		return $result;		
	}
	
	public function getUsersEnchantments($hid=0)
	{
		$result = Array();
		$query = "SELECT ue.uid, ue.eid, e.name, ue.type, et.name as typename, e.description, e.effect, e.etid, DATE_FORMAT(ue.updated, '%d.%m.%Y %H:%i') as updated
				  FROM ".DB_PREFIX."users_enchantment ue
				  LEFT JOIN ".DB_PREFIX."enchantments e ON ue.eid=e.eid
				  LEFT JOIN ".DB_PREFIX."enchantment_types et ON e.etid=et.etid
				  WHERE uid=".$this->uId." and hid=".(int)$hid."
				  ORDER BY e.etid";

		//echo $query;
		$res =  mysqli_query(Config::getDBConn(), $query);
		if(mysqli_num_rows($res) > 0)
		{
                    $i = 0;
			while($row = mysqli_fetch_array($res))
			{
				$result[$i]['uid'] = $row['uid'];
				$result[$i]['eid'] = $row['eid'];
				$result[$i]['name'] = $row['name'];
				$result[$i]['updated'] = $row['updated'];
				$result[$i]['type'] = $row['type'];
				$result[$i]['typename'] = $row['typename'];
				$result[$i]['description'] = $row['description'];
				$result[$i]['etid'] = $row['etid'];
				$result[$i]['effect'] = $row['effect'];
				$i++;
			}
			
		}
		return $result;		
	}
	
	public function getUsersSpell($hid=0)
	{
		$result = Array();
		$query = "SELECT us.spid, us.uid, DATE_FORMAT(us.updated, '%d.%m.%Y %H:%i') as updated, us.type, s.name, s.lvl, s.itid, dmgmin, dmgmax, s.type as type2, s.itid, reach, speed
				  FROM ".DB_PREFIX."users_spell us
				  LEFT JOIN ".DB_PREFIX."spells s ON s.spid=us.spid
				  WHERE us.uid=".$this->uId." and hid=".(int)$hid."
				  ORDER BY us.type";

		//echo $query;
		$res =  mysqli_query(Config::getDBConn(), $query);
		if(mysqli_num_rows($res) > 0)
		{
			$i = 0;
			while($row = mysqli_fetch_array($res))
			{
				$result[$i]['uid'] = $row['uid'];
				$result[$i]['spid'] = $row['spid'];
				$result[$i]['updated'] = $row['updated'];
				$result[$i]['type'] = $row['type'];
				$result[$i]['type2'] = $row['type2'];
				$result[$i]['name'] = $row['name'];
				$result[$i]['itid'] = $row['itid'];
				$result[$i]['lvl'] = $row['lvl'];
				$result[$i]['dmgmin'] = $row['dmgmin'];
				$result[$i]['dmgmax'] = $row['dmgmax'];
				$result[$i]['speed'] = $row['speed'];
				$result[$i]['reach'] = $row['reach'];
				$i++;
			}
			
		}
		return $result;		
	}
	
	public function getItemIdForType($arr, $type)
	{
		if(is_array($arr))
		{
			foreach($arr as $single)
			{
				if($single['type'] == $type)
					return $single['iid'];
			}
		}
		return 0;
	}
	
	public function getItemForType($arr, $type)
	{
		if(is_array($arr))
		{
			foreach($arr as $single)
			{
				if($single['type'] == $type)
					return $single;
			}
		}
		return 0;
	}
	
	public function updateUsersAttributes($uid, $a1, $a2, $a3, $a4, $hid=0)
	{
		$result = false;
		 mysqli_query(Config::getDBConn(), "DELETE FROM ".DB_PREFIX."user_attributes WHERE uid=".(int)$uid." and hid=".(int)$hid);
		$q1 =  mysqli_query(Config::getDBConn(), "INSERT INTO ".DB_PREFIX."user_attributes (uid,aid,lvl,hid) VALUES (".(int)$uid.",1,".(int)$a1.",".(int)$hid.")");
		$q2 =  mysqli_query(Config::getDBConn(), "INSERT INTO ".DB_PREFIX."user_attributes (uid,aid,lvl,hid) VALUES (".(int)$uid.",2,".(int)$a2.",".(int)$hid.")");
		$q3 =  mysqli_query(Config::getDBConn(), "INSERT INTO ".DB_PREFIX."user_attributes (uid,aid,lvl,hid) VALUES (".(int)$uid.",3,".(int)$a3.",".(int)$hid.")");
		$q4 =  mysqli_query(Config::getDBConn(), "INSERT INTO ".DB_PREFIX."user_attributes (uid,aid,lvl,hid) VALUES (".(int)$uid.",4,".(int)$a4.",".(int)$hid.")");
		
		if($q1 && $q2 && $q3 && $q4)
			return true;
		else
			return false;	
	}
	
	//type ist position am K?rper, 1->Kopf, 2->Torso, usw.
	public function updateInventar($uid, $t1, $t2, $t3, $t4, $t5, $t6, $t7, $t8, $t9, $t10, $increment, $hid=0)
	{
		 mysqli_query(Config::getDBConn(), "DELETE FROM ".DB_PREFIX."users_inventar WHERE uid=".(int)$uid." and hid=".(int)$hid);
		
		$q1 =  mysqli_query(Config::getDBConn(), "INSERT INTO ".DB_PREFIX."users_inventar (uid,iid,updated,type,sort,hid,increment) VALUES (".(int)$uid.",".(int)$t1.",NOW(),1,5,".(int)$hid.",".(int)$increment[0].")");
		$q2 =  mysqli_query(Config::getDBConn(), "INSERT INTO ".DB_PREFIX."users_inventar (uid,iid,updated,type,sort,hid,increment) VALUES (".(int)$uid.",".(int)$t2.",NOW(),2,6,".(int)$hid.",".(int)$increment[1].")");
		$q3 =  mysqli_query(Config::getDBConn(), "INSERT INTO ".DB_PREFIX."users_inventar (uid,iid,updated,type,sort,hid,increment) VALUES (".(int)$uid.",".(int)$t3.",NOW(),3,7,".(int)$hid.",".(int)$increment[2].")");
		$q4 =  mysqli_query(Config::getDBConn(), "INSERT INTO ".DB_PREFIX."users_inventar (uid,iid,updated,type,sort,hid,increment) VALUES (".(int)$uid.",".(int)$t4.",NOW(),4,8,".(int)$hid.",".(int)$increment[3].")");
		$q5 =  mysqli_query(Config::getDBConn(), "INSERT INTO ".DB_PREFIX."users_inventar (uid,iid,updated,type,sort,hid,increment) VALUES (".(int)$uid.",".(int)$t5.",NOW(),5,9,".(int)$hid.",".(int)$increment[4].")");
		$q6 =  mysqli_query(Config::getDBConn(), "INSERT INTO ".DB_PREFIX."users_inventar (uid,iid,updated,type,sort,hid,increment) VALUES (".(int)$uid.",".(int)$t6.",NOW(),6,1,".(int)$hid.",".(int)$increment[5].")");
		$q7 =  mysqli_query(Config::getDBConn(), "INSERT INTO ".DB_PREFIX."users_inventar (uid,iid,updated,type,sort,hid,increment) VALUES (".(int)$uid.",".(int)$t7.",NOW(),7,2,".(int)$hid.",".(int)$increment[6].")");
		$q8 =  mysqli_query(Config::getDBConn(), "INSERT INTO ".DB_PREFIX."users_inventar (uid,iid,updated,type,sort,hid,increment) VALUES (".(int)$uid.",".(int)$t8.",NOW(),8,3,".(int)$hid.",".(int)$increment[7].")");
		$q9 =  mysqli_query(Config::getDBConn(), "INSERT INTO ".DB_PREFIX."users_inventar (uid,iid,updated,type,sort,hid,increment) VALUES (".(int)$uid.",".(int)$t9.",NOW(),9,4,".(int)$hid.",".(int)$increment[8].")");
                $q10 =  mysqli_query(Config::getDBConn(), "INSERT INTO ".DB_PREFIX."users_inventar (uid,iid,updated,type,sort,hid,increment) VALUES (".(int)$uid.",".(int)$t10.",NOW(),10,1,".(int)$hid.",".(int)$increment[9].")");
		
		if($q1 && $q2 && $q3 && $q4 && $q5 && $q6 && $q7 && $q8 && $q9 && $q10)
			return true;
		else
			return false;
	}
	
	//type ist position am K�rper, 1->Kopf, 2->Torso, usw.
	public function updateEnchantments($uid, $t1, $t2, $t3, $t4, $t5, $t6, $t7, $t8, $hid=0)
	{
		 mysqli_query(Config::getDBConn(), "DELETE FROM ".DB_PREFIX."users_enchantment WHERE uid=".(int)$uid." and hid=".(int)$hid);
		
		$q1 =  mysqli_query(Config::getDBConn(), "INSERT INTO ".DB_PREFIX."users_enchantment (uid,eid,updated,type,hid) VALUES (".(int)$uid.",".(int)$t1.",NOW(),1,".(int)$hid.")");
		$q2 =  mysqli_query(Config::getDBConn(), "INSERT INTO ".DB_PREFIX."users_enchantment (uid,eid,updated,type,hid) VALUES (".(int)$uid.",".(int)$t2.",NOW(),2,".(int)$hid.")");
		$q3 =  mysqli_query(Config::getDBConn(), "INSERT INTO ".DB_PREFIX."users_enchantment (uid,eid,updated,type,hid) VALUES (".(int)$uid.",".(int)$t3.",NOW(),3,".(int)$hid.")");
		$q4 =  mysqli_query(Config::getDBConn(), "INSERT INTO ".DB_PREFIX."users_enchantment (uid,eid,updated,type,hid) VALUES (".(int)$uid.",".(int)$t4.",NOW(),4,".(int)$hid.")");
		$q5 =  mysqli_query(Config::getDBConn(), "INSERT INTO ".DB_PREFIX."users_enchantment (uid,eid,updated,type,hid) VALUES (".(int)$uid.",".(int)$t5.",NOW(),5,".(int)$hid.")");
		$q6 =  mysqli_query(Config::getDBConn(), "INSERT INTO ".DB_PREFIX."users_enchantment (uid,eid,updated,type,hid) VALUES (".(int)$uid.",".(int)$t6.",NOW(),6,".(int)$hid.")");
		$q7 =  mysqli_query(Config::getDBConn(), "INSERT INTO ".DB_PREFIX."users_enchantment (uid,eid,updated,type,hid) VALUES (".(int)$uid.",".(int)$t7.",NOW(),7,".(int)$hid.")");
		$q8 =  mysqli_query(Config::getDBConn(), "INSERT INTO ".DB_PREFIX."users_enchantment (uid,eid,updated,type,hid) VALUES (".(int)$uid.",".(int)$t8.",NOW(),8,".(int)$hid.")");
		
		if($q1 && $q2 && $q3 && $q4 && $q5 && $q6 && $q7 && $q8)
			return true;
		else
			return false;
	}
	//muss so aussehen [mw],[lvl],[cid] usw, f�r alle Items
	public function updateCap($postArray)
	{
		//print_r($postArray);
		$result = false;
		
		if(is_array($postArray))
		{
			$pos = 0; $lvl = 0; $cid = 0; $mainwork = 0; $effect = 1.00;
			//Eintr?ge durchgehen und Werte zwischenspeichern, immer 3er-Paare
			foreach($postArray as $key => $value)
			{
				if(strlen(strstr($key, 'mw')) > 0)
				{	$mainwork = 1; }
                                if(strlen(strstr($key, 'eff')) > 0)
				{	$effect = floatval($value); }
				if(strlen(strstr($key, 'lvl')) > 0)
				{	$lvl = (int)$value; $pos++; }
				if(strlen(strstr($key, 'c')) > 0)
				{	$cid = (int)$value; $pos++; }

				//wenn mainwork, lvl und id gesammelt wurden
				if($pos == 2 && $cid != 0)
				{
						
					//prfen, ob ein Eintrag schon vorhanden ist
					$query = "SELECT cid FROM ".DB_PREFIX."users_capabilities WHERE cid=".$cid." and uid=".$this->uId;
					$res =  mysqli_query(Config::getDBConn(), $query);
					//wenn vorhanden-> update
					if(mysqli_num_rows($res) == 1)
					{
						$query = "UPDATE ".DB_PREFIX."users_capabilities set value=".$lvl.", mainwork=".$mainwork.", effect=".$effect.", 
										 updated=NOW() 
								   WHERE cid=".$cid." and uid=".$this->uId;
						if( mysqli_query(Config::getDBConn(), $query))
						  $result = true;
						else 
						{	$result = false; break; }
					}
					else //ansonsten hinzufgen
					{
						//nur einfgen, wenn fhigkeit auch genutzt wird
						if($lvl > 0 || $mainwork)
						{
							$query = "INSERT INTO ".DB_PREFIX."users_capabilities (uid,cid,value, effect, mainwork, updated) 
									  VALUES(".$this->uId.", ".$cid.", ".$lvl.", ".$effect.", ".$mainwork.", NOW())";

							if( mysqli_query(Config::getDBConn(), $query))
							  $result = true;
							else 
							{	$result = false; break; }
						}
						else
							$result = true;
					}

					$pos = 0; $lvl = 0; $cid = 0; $mainwork = 0; $effect = 1.00;
				}				
			}
		}
		
		return $result;
	}
        
        /**
         * Update the status (active/inactive) of users capabiliy
         * @param int $uid
         * @param int $cid
         * @param boolean $active
         * @return boolean
         */
        public function updateCapActivity($uid, $cid, $active) {
            $query = "  UPDATE ".DB_PREFIX."users_capabilities set mainwork=".(int)$active.", updated=NOW()
                        WHERE cid=".(int)$cid." and uid=".(int)$uid;
            if( mysqli_query(Config::getDBConn(), $query)) {
                return true;
            }
            return false;
        }
	
	public function updatePlans($postArray)
	{
		//print_r($postArray);
		$result = false;
		
		if(is_array($postArray))
		{
			//alle Eintr�ge des Nutzers zun�chst l�schen
			 mysqli_query(Config::getDBConn(), "DELETE FROM ".DB_PREFIX."user_plans WHERE uid=".$this->uId);
			$pos = 0; $cid = 0; $iid = 0; $name = "";
			//Eintr�ge durchgehen und Werte zwischenspeichern, immer 3er-Paare
			foreach($postArray as $key => $value)
			{
				if(strlen(strstr($key, 'cid')) > 0)
				{	$cid = (int)$value; $pos = 0; }
				if(strlen(strstr($key, 'iid')) > 0)
				{	$iid = (int)$value; $pos++; }
				if(strlen(strstr($key, 'name')) > 0 && $iid != 0)
				{	$name = getStringForDb($value); $pos++; }

				//sobald das erste item hier ankommt
				if($pos == 2 && $cid != 0 && $iid != 0 && $name != "")
				{
					$item = substr($name,0,strpos($name, ' (Plan'));

					//id des produzierbaren schwertes holen
					$query1 = "SELECT iid FROM ".DB_PREFIX."items WHERE item='".$item."'";

					$res1 =  mysqli_query(Config::getDBConn(), $query1);
					//bei 2H Waffen
					if(mysqli_num_rows($res1) == 0)
					{
						$item .= ' [2H]';
						$query2 = "SELECT iid FROM ".DB_PREFIX."items WHERE item='".$item."'";

						$res1 =  mysqli_query(Config::getDBConn(), $query2);
					}
					if(mysqli_num_rows($res1) == 1)
					{
						$iidres = mysqli_fetch_array($res1);
						$realiid = $iidres['iid'];
						$query = "INSERT INTO ".DB_PREFIX."user_plans (uid,iid,realiid) 
								  VALUES(".$this->uId.", ".$iid.", ".$realiid.")";
		
						if( mysqli_query(Config::getDBConn(), $query))
						  $result = true;
						else 
						{	$result = false; break; }
					}
					else 
					{	$result = false; break; }
					$iid = 0; $pos = 0; $name = "";
				}
				else 
					$result = true;
				
			}
                        // update date of capabilities
                        $query = "UPDATE ".DB_PREFIX."users_capabilities SET updated=NOW() WHERE uid=".$this->uId;
                        if(! mysqli_query(Config::getDBConn(), $query)) {
                            $result = false;
                        }
		}
		
		return $result;
	}
	
	public function getPlansForUser()
	{
		$result = Array();
		$query = "SELECT uc.uid, i.iid, i.item, i.lvl, c.capability, c.cid, up.iid as upiid
				  FROM ".DB_PREFIX."users_capabilities uc 
				  INNER JOIN ".DB_PREFIX."capabilities c on uc.cid=c.cid and uc.uid=".$this->uId." and uc.value>0
				  INNER JOIN ".DB_PREFIX."items i on i.cid=c.cid and uc.value>=i.lvl
				  and i.itid=(SELECT itid FROM ".DB_PREFIX."item_types WHERE type='Baupl&auml;ne')
				  LEFT JOIN ".DB_PREFIX."user_plans up on uc.uid=up.uid and up.iid=i.iid
				  ORDER BY c.cid, i.lvl, i.sort";

		//echo $query;
		$res =  mysqli_query(Config::getDBConn(), $query);
		if(mysqli_num_rows($res) > 0)
		{
			while($row = mysqli_fetch_array($res))
			{
				$result[$row['capability']]['cid'] = $row['cid'];
				$result[$row['capability']][$row['item']]['iid'] = $row['iid'];
				$result[$row['capability']][$row['item']]['lvl'] = $row['lvl'];
				$result[$row['capability']][$row['item']]['active'] = ($row['upiid']!=Null?1:0);
			}
			
		}
		return $result;		
	}
	
	public function getOnlineList($guids= Array(), $sort="", $dir="")
	{
		$result = Array();
		$in = "";
		/*****************Gilden******************/
		if(count($guids) > 0)
		{
			$in = "WHERE g.guid IN  ("; $i = 0;			
			foreach($guids as $gid)	
			{
				$in .= (int)$gid;
				if($i != count($guids)-1)
						$in .= ', ';
					$i++;
			}
			$in .= ")";
		}
		/*****************************************/
			
		if($sort == "updated")	$sort = "MAX(uc.updated)";
		if($sort != "" && $dir != "")
			$order = ' ORDER BY '.getStringForDb($sort).' '.($dir=='down'?'ASC':'DESC');
		else
			$order = ' ORDER BY nick';
		
		//der letzten 5 Minuten
		$query = "SELECT u.uid, nick, lastaction, DATE_FORMAT(lastaction, '%d.%m.%Y %H:%i') as action,
				  DATE_FORMAT(MAX(updated), '%d.%m.%Y %H:%i') as updated, MAX(updated) as updated2, g.name, g.color, trustlvl
				  FROM ".DB_PREFIX."users u 
				  LEFT JOIN ".DB_PREFIX."users_capabilities uc ON u.uid=uc.uid
				  LEFT JOIN ".DB_PREFIX."guilds_user gu ON gu.uid=u.uid
				  LEFT JOIN ".DB_PREFIX."guilds g ON g.guid=gu.guid
				  ".$in."
				  GROUP BY u.uid, g.name, g.color".$order;

		//echo $query;
		$res =  mysqli_query(Config::getDBConn(), $query);
		if(mysqli_num_rows($res) > 0)
		{
			$i = 0;
			while($row = mysqli_fetch_array($res))
			{
				$date = strtotime($row['lastaction']);
				
				$result[$i]['uid'] = $row['uid'];
				$result[$i]['nick'] = $row['nick'];
				$result[$i]['action'] = $row['action'];
				$result[$i]['action2'] = $date;
				$result[$i]['updated'] = $row['updated'];
				$result[$i]['updated2'] = strtotime($row['updated2']);
				$result[$i]['online'] = ($date>=(time()-(60*5))?1:0);
				$result[$i]['gilde'] = $row['name'];
				$result[$i]['color'] = $row['color'];
				$result[$i]['trustlvl'] = $row['trustlvl'];
				$i++;
			}
			
		}
		return $result;		
	}

	public function getCapabilities($guids, $type=0)
	{
		$result = array();
		
		/*****************Gilden******************/
			$in = " ("; $i = 0;			
			foreach($guids as $gid)	
			{
				$in .= (int)$gid;
				if($i != count($guids)-1)
						$in .= ', ';
					$i++;
			}
			if(count($guids) == 0)	$in .= "0";
			$in .= ")";
		/*****************************************/
		//alle nutzer die die Ware herstellen k�nnen
		//type = 0 => Handwerk
		//type = 1 => Fertigkeiten
		$query = "SELECT c.capability, u.uid, u.nick, uc.value, u.nowork, uc.mainwork, g.short
			  FROM ".DB_PREFIX."guilds g
			  JOIN ".DB_PREFIX."guilds_user gu ON g.guid IN ".$in." and gu.guid=g.guid
			  JOIN ".DB_PREFIX."users u ON gu.uid=u.uid
			  JOIN ".DB_PREFIX."users_capabilities uc ON uc.uid=u.uid and uc.value>0
			  RIGHT JOIN ".DB_PREFIX."capabilities c ON c.cid=uc.cid
			  WHERE c.type=".(int)$type."
			  ORDER BY c.cid, u.nowork, uc.mainwork DESC, uc.value DESC";
			
		//echo $query;
		$res =  mysqli_query(Config::getDBConn(), $query);
		if(mysqli_num_rows($res) > 0)
		{
			$i = 0;
			while($row = mysqli_fetch_array($res))
			{
				$nick = $row['nick'];
				if(!array_key_exists($row['capability'], $result))
					$result[$row['capability']] = Array();
				if($nick != "")
				{
                    $result[$row['capability']][$i]['uid']= $row['uid'];
                    $result[$row['capability']][$i]['nick']= $nick;
					$result[$row['capability']][$i]['guild']= $row['short'];
					$result[$row['capability']][$i]['value'] = $row['value'];
					//if($type == 0)
						$result[$row['capability']][$i]['nowork'] = $row['nowork'];
					$result[$row['capability']][$i]['mainwork'] = $row['mainwork'];
					$i++;
				}
				
			}			
		}
		return $result;		
	}
	
	public function getPlans($guids)
	{
		$result = array();
		
		/*****************Gilden******************/
			$in = " ("; $i = 0;			
			foreach($guids as $gid)	
			{
				$in .= (int)$gid;
				if($i != count($guids)-1)
						$in .= ', ';
					$i++;
			}
			if(count($guids) == 0)	$in .= "0";
			$in .= ")";
		/*****************************************/
		
		//alle nutzer die die Ware herstellen k�nnen
		//Handwerk				
		$query = "SELECT i.item, u.nick, uc.value, u.nowork, uc.mainwork, g.short, u.uid 
				  FROM ".DB_PREFIX."guilds g
				  JOIN ".DB_PREFIX."guilds_user gu ON g.guid IN ".$in." and gu.guid=g.guid
				  JOIN ".DB_PREFIX."users u ON gu.uid=u.uid				  
				  JOIN ".DB_PREFIX."user_plans up ON u.uid=up.uid
				  JOIN ".DB_PREFIX."users_capabilities uc ON uc.uid=u.uid and uc.value>0 
				  RIGHT JOIN ".DB_PREFIX."items i ON  i.iid=up.iid
				  	and uc.value>=i.lvl and i.cid=uc.cid
				  WHERE i.itid=(SELECT itid FROM ".DB_PREFIX."item_types WHERE type='Baupl&auml;ne')
				  ORDER BY i.cid, i.lvl, i.sort, u.nowork, uc.mainwork DESC, uc.value DESC";
		
		//echo $query;
		$res =  mysqli_query(Config::getDBConn(), $query);
		if(mysqli_num_rows($res) > 0)
		{
			$i = 0;
			while($row = mysqli_fetch_array($res))
			{
				$nick = $row['nick'];
				if(!array_key_exists($row['item'], $result))
					$result[$row['item']] = Array();
				if($nick != "")
				{
					$result[$row['item']][$i]['nick']= $nick;
					$result[$row['item']][$i]['guild']= $row['short'];
					$result[$row['item']][$i]['value'] = $row['value'];
					//if($type == 0)
					$result[$row['item']][$i]['nowork'] = $row['nowork'];
					$result[$row['item']][$i]['mainwork'] = $row['mainwork'];
                                        $result[$row['item']][$i]['uid']= $row['uid'];
					$i++;
				}
				
			}			
		}
		return $result;		
	}
	
	public function getMaxAttrPoints()
	{
		return ($this->getLvl()-1)*5+50;
	}
	
	public function getUsersFreeAttrPoints($attr)
	{
		if(is_array($attr))
		{
			$sum = 0;
			foreach($attr as $val)
				$sum += $val['lvl'];
				
			return $this->getMaxAttrPoints()-$sum;
		}
		else
			return 0;
	}
	
	private function getAttrMultiplicator($attr, $enchantment, $items, $inventar)
	{
		$multi = 0;
		$attrEtIds = $items->getAttrEtId();	//die Attribute und welche Verzauberung diese erh�hen
		$etid = $attrEtIds[$attr];
		//alle verzauberungen durchgehen
		foreach($enchantment as $single)
		{
			//wenn gegenstand f�r die berechnung ben�tigt wird
			if($single['eid'] > 0 && $single['etid'] == $etid)
			{
				$invItem = $this->getItemForType($inventar,$single['type']);
				//wenn an aktueller Position auch etwas anliegt
				if($invItem['iid'] > 0)
					$multi += $single['effect'];
			}
		}
		return $multi;
	}
	
	public function getLP($attr, $enchantment, $inventar, $items)
	{
		$const = $attr['Konstitution']['lvl'];
		$const += $this->getAttrMultiplicator('Konstitution', $enchantment, $items, $inventar);

		$faktor = ($const*0.2)/10;
		$basislp = 120 + $this->getLvl() * 20;
		
		$lp = $basislp+($basislp*$faktor);
		
		$lp += $basislp * ($this->getAttrMultiplicator('Lebenspunkte', $enchantment, $items, $inventar)/100);
		//also Basislp berechnen, davon + konst, dann verzauberung von basislp, und alles addieren
		return floor($lp);
	}
	
	public function getArmor($inventar, $items)
	{
		$armoritids = $items->getArmorClothes();
		$armor = 0;
		foreach($inventar as $single)
		{
			//wenn gegenstand f�r die berechnung ben�tigt wird
			if($single['iid'] > 0 && in_array($single['itid'], $armoritids))
			{
				$item = $items->getItem($single['iid']);
				$armor += $item['armor'];
			}
		}
		return $armor;
	}
	
	public function getAbsorb($attr, $inventar, $items, $enchantment, $usersCaps, $user)
	{
		$absorbitids = $items->getAbsorbClothes();
		$const = $attr['Konstitution']['lvl'];
		$const += $this->getAttrMultiplicator('Konstitution', $enchantment, $items, $inventar);
		$faktor = ($const*0.1)/10;
		$absorb = 0;
		foreach($inventar as $single)
		{
			//wenn gegenstand fr die berechnung bentigt wird
			if($single['iid'] > 0 && in_array($single['itid'], $absorbitids))
			{
				$item = $items->getItem($single['iid']);
                                // get effect bonus for folk
                                $effectBonus = $user->getCapabilityForCId($item['cid_fight'], $usersCaps);                                
                                if(count($effectBonus) > 0) {
                                    $eBonus = $effectBonus['effect'];
                                } else {
                                    $eBonus = 1.0;  // no bonus, use base value
                                }
                                // first, bonus from +X and than effect bonus for folk
				$absorb += ($item['absorb'] + ($single['increment'] * 0.1)) * $eBonus;
			}
		}
		//$absorb +=$this->getAttrMultiplicator('Absorb', $enchantment, $items, $inventar);
		$res = $absorb+($absorb*$faktor);
		$res +=$this->getAttrMultiplicator('Absorb', $enchantment, $items, $inventar);
		return round($res,1);
	}
	
	public function getAvoid($attributes, $handicap, $items, $inventar, $enchantment)
	{
		//$handicapitids = $items->getHandicapClothes();
		$attr = $attributes['Geschicklichkeit']['lvl'];
		$attr += $this->getAttrMultiplicator('Geschicklichkeit', $enchantment, $items, $inventar);
		$faktor = ($attr*0.2);
		$avoid = 4 + $faktor;
		$avoid += $this->getAttrMultiplicator('Ausweichen', $enchantment, $items, $inventar);
		$avoid = $avoid<0?0:($avoid>25?25:$avoid);
		
		$handicapfaktor = $avoid * ($handicap/100);
		$res = round($avoid-$handicapfaktor,2);
		
		return ($res<0?0:($res>25?25:$res));
	}
	
	public function getHandicap($attributes, $inventar, $items, $enchantment)
	{
            $handicapitids = $items->getHandicapClothes();
            $spellWeaponsItid = $items->getItidSpellWeapons();
            $attr = $attributes['St&auml;rke']['lvl'];
            $attr2 = $attributes['Geschicklichkeit']['lvl'];
            $attr += $this->getAttrMultiplicator('St&auml;rke', $enchantment, $items, $inventar);
            $attr2 += $this->getAttrMultiplicator('Geschicklichkeit', $enchantment, $items, $inventar);
            $faktor = ($attr*0.4);
            $handicap = 0;
            // Ein Punkt Geschick senkt die Behinderung von Lederr�stungen um 0,3 Punkte;  
            // bzw. um 0,2 Punkte, wenn ein Magiestab ausger�stet ist
            $extraBonus = false; $extraBaseFactor = 0.3;
            foreach($inventar as $single)
            {
                //wenn gegenstand f�r die berechnung ben�tigt wird
                if($single['iid'] > 0 && in_array($single['itid'], $handicapitids))
                {
                    $item = $items->getItem($single['iid']);
                    // extra Bonus bei Lederr�stungen
                    if($single['itid'] == 19) {
                        $extraBonus = true;
                    }
                    $handicap += $item['handicap'];                             
                } else if(in_array($single['itid'], $spellWeaponsItid)) {
                    // 0.2 bei Magiest�ben
                    $extraBaseFactor = 0.2;
                }
            }
            // extra Bonus bei Lederr�stungen
            if($extraBonus) {
                $faktor += $attr2 * $extraBaseFactor;
            }
            $res = $handicap-$faktor;

            return ($res<0?0:floor($res));
	}
	
	public function getDmgForWeapon($attributes, $item, $items, $inventar, $enchantment, $userItem, $usersCaps, $user)
	{
		$itidDmgAttr = $items->getItidDmgAttr();
		$attrname = $itidDmgAttr[$item['itid']]['name'];
		$fac =  $itidDmgAttr[$item['itid']]['factor'];
		$attr = $attributes[$attrname]['lvl'];
		$attr += $this->getAttrMultiplicator($attrname, $enchantment, $items, $inventar);
		$nk2 = $this->getItemForType($inventar, 7);	//zweite waffe holen
                //add base damage depending on increment
                $increment = $userItem['increment'];
                $speed = $item['speed'];
                
                // get effect bonus for folk
                $effectBonus = $user->getCapabilityForCId($item['cid_fight'], $usersCaps);
                if(count($effectBonus) > 0) {
                    $eBonus = $effectBonus['effect'];
                } else {
                    $eBonus = 1.0;  // no bonus, use base value
                }
                // first, bonus from +X and than effect bonus for folk
                $item['dmgmin'] = ($item['dmgmin'] + floor((($increment*4)/$speed))) * $eBonus;
                $item['dmgmax'] = ($item['dmgmax'] + floor((($increment*4)/$speed))) * $eBonus;

		//wenn zwei einhandwaffen angelegt wurden, schaden um 10% reduzieren
		if($nk2['iid'] > 0 && in_array($nk2['itid'], $items->getItidWeapons()))
		{	
			$item['dmgmin'] = $item['dmgmin']-($item['dmgmin']*0.1); 
			$item['dmgmax'] = $item['dmgmax']-($item['dmgmax']*0.1); 
		}	
		
		$faktor = ($attr*$fac);
		$dmgmin = floor(($faktor*$item['dmgmin']/100)+$item['dmgmin']);
		$dmgmax = floor(($faktor*$item['dmgmax']/100)+$item['dmgmax']);

		return array($dmgmin, $dmgmax);
	}
	
	public function getDmgForSpell($attributes, $spell, $items, $inventar, $handicap, $enchantment, $usersCaps, $user)
	{
		$item = $this->getItemForType($inventar, 8);	//fk
		$mun = $this->getItemForType($inventar, 9);	//mun
		$fkitem = 0;  $munitem = 0;
		if($item['iid'] > 0)
			$fkitem = $items->getItem($item['iid']);
		if($mun['iid'] > 0)
			$munitem = $items->getItem($mun['iid']);
		$itidDmgAttr = $items->getItidDmgAttr();
		$attrname = $itidDmgAttr[$item['itid']]['name']; //Das Attribut, welches den Schaden bestimmt
		$fac =  $itidDmgAttr[$item['itid']]['factor'];	 //um welchen Faktor
		$attr = $attributes[$attrname]['lvl'];			 //Stufe
		$attr += $this->getAttrMultiplicator($attrname, $enchantment, $items, $inventar);
		
		$faktor = ($attr*$fac);
                
		//Grundwert und Atrribut
		$dmgmin = ($faktor*$spell['dmgmin']/100)+$spell['dmgmin'];
		$dmgmax = ($faktor*$spell['dmgmax']/100)+$spell['dmgmax'];
		
		if($fkitem['iid'] > 0)
		{
                        // get effect bonus for folk
                        $effectBonus = $user->getCapabilityForCId($fkitem['cid_fight'], $usersCaps);
                        if(count($effectBonus) > 0) {
                            $eBonus = $effectBonus['effect'];
                        } else {
                            $eBonus = 1.0;  // no bonus, use base value
                        }
                        //neuer Grundwert und Waffe
                        $effect = $fkitem['effect'] + (2 * $item['increment']);    // +2% Wirkung auf Waffe f?r +X
			$dmgmin = (($dmgmin*$effect/100)+$dmgmin)*$eBonus;
			$dmgmax = (($dmgmax*$effect/100)+$dmgmax)*$eBonus;
		}
		if($munitem['iid'] > 0)
		{
			//neuer Grundwert und Munition
                        $effect = $munitem['effect'] + (1 * $mun['increment']);    // +1% Wirkung auf muni f?r +X
			$dmgmin = ($dmgmin*$effect/100)+$dmgmin;
			$dmgmax = ($dmgmax*$effect/100)+$dmgmax;
		}
		
		$dmgmin = $dmgmin - ($dmgmin * ($handicap/100));
		$dmgmax = $dmgmax - ($dmgmax * ($handicap/100));
		
		return array(floor($dmgmin), floor($dmgmax));
	}
	
	public function getDmgForFk($attributes, $item, $items, $inventar, $handicap, $enchantment, $userItem, $usersCaps, $user)
	{
                $mun = $this->getItemForType($inventar, 9);		//mun
		$munitem = 0;

		if($mun['iid'] > 0)
			$munitem = $items->getItem($mun['iid']);
		
		$itidDmgAttr = $items->getItidDmgAttr();
		$attrname = $itidDmgAttr[$item['itid']]['name']; //Das Attribut, welches den Schaden bestimmt
		$fac =  $itidDmgAttr[$item['itid']]['factor'];	 //um welchen Faktor
		$attr = $attributes[$attrname]['lvl'];			 //Stufe
		$attr += $this->getAttrMultiplicator($attrname, $enchantment, $items, $inventar);
		
                //add base damage depending on increment
                $increment = $userItem['increment'];
                $speed = $item['speed'];

                // get effect bonus for folk
                $effectBonus = $user->getCapabilityForCId($item['cid_fight'], $usersCaps);
                if(count($effectBonus) > 0) {
                    $eBonus = $effectBonus['effect'];
                } else {
                    $eBonus = 1.0;  // no bonus, use base value
                }
                // first, bonus from +X and than effect bonus for folk
                $item['dmgmin'] = ($item['dmgmin'] + floor((($increment*4)/$speed))) * $eBonus;
                $item['dmgmax'] = ($item['dmgmax'] + floor((($increment*4)/$speed))) * $eBonus;
                
		$faktor = ($attr*$fac);
                
		//Grundwert und Atrribut
		$dmgmin = ($faktor*$item['dmgmin']/100)+$item['dmgmin'];
		$dmgmax = ($faktor*$item['dmgmax']/100)+$item['dmgmax'];
		
		if($munitem['iid'] > 0)
		{
			//neuer Grundwert und Munition
                        $effect = $munitem['effect'] + (1 * $mun['increment']);    // +1% Wirkung auf muni fr +X
			$dmgmin = ($dmgmin*$effect/100)+$dmgmin;
			$dmgmax = ($dmgmax*$effect/100)+$dmgmax;
		}
		
		$dmgmin = $dmgmin - ($dmgmin * ($handicap/100));
		$dmgmax = $dmgmax - ($dmgmax * ($handicap/100));
		
		return array(floor($dmgmin), floor($dmgmax));
	}
        
        public function getBaseHealForBandages($attributes, $items, $inventar, $enchantment, $usersCaps, $user)
	{
            $result = [];
            $inventarItem = $this->getItemForType($inventar, 10);	//Bandagen

            $bandages = [];
            if($inventarItem['iid'] > 0) {
                $bandages = $items->getItem($inventarItem['iid']);
            }

            if(count($bandages) > 0)
            {
                $minAbsBase = $bandages['dmgmin'] + (1 * $inventarItem['increment']);    // +1% Wirkung auf muni f?r +X;
                $maxAbsBase = $bandages['dmgmax'] + (1 * $inventarItem['increment']);    // +1% Wirkung auf muni f?r +X;;
                // get effect bonus and level for user capability
                $capability = $user->getCapabilityForCId($bandages['cid_fight'], $usersCaps);
                if(count($capability) > 0) {
                    $eBonus = $capability['effect'];
                    $capLvl = $capability['value'];
                } else {
                    $eBonus = 1.0;  // no bonus, use base value
                    $capLvl = 0;
                }
                //neuer Grundwert
                $minAbs = ($minAbsBase * (1 + 0.05 * $capLvl)) * $eBonus; // effect bonus only on LP
                $maxAbs = ($maxAbsBase * (1 + 0.05 * $capLvl)) * $eBonus; // effect bonus only on LP
                $minRel = $bandages['rel_min'] * (1 + 0.05 * $capLvl);
                $maxRel = $bandages['rel_max'] * (1 + 0.05 * $capLvl);
                
                $result = [
                    'minAbs' => round($minAbs),
                    'maxAbs' => round($maxAbs),
                    'minRel' => $minRel,
                    'maxRel' => $maxRel,
                    'item'   => $bandages
                ];
            }

            return $result;
	}
	
	public function getCritical($attributes, $handicap, $items, $inventar, $enchantment, $mode='nk')
	{
            $munitem = 0;
            //fk, mun bonus einberechnen
            if($mode == 'fk')
            {
                    $mun = $this->getItemForType($inventar, 9);		//mun	
                    $iid = $mun['iid'] ?? 0;
                    if($iid > 0)
                        $munitem = $items->getItem($mun['iid']);
            }
            $iid = $munitem['iid'] ?? 0;
            $attr = $attributes['Intelligenz']['lvl'];
            $attr += $this->getAttrMultiplicator('Intelligenz', $enchantment, $items, $inventar);
            $faktor = ($attr*0.2);
            $crit = 4 + $faktor;
            $crit += $this->getAttrMultiplicator('kritische Treffer', $enchantment, $items, $inventar);
            $crit = ($crit<0?0:($crit>25?25:$crit));
            
            if($iid > 0)
            {
                    //neuer Grundwert und Munition
                    $crit += $munitem['accuracy'];
            }
            //zum schluss handicap abziehen
            $handicapfaktor = $crit * ($handicap/100);
            $res = round($crit-$handicapfaktor,2);

            return ($res<0?0:($res>25?25:$res));
	}
	
	public function getAccuracy($attributes, $inventar, $items, $mode, $enchantment)
	{
            $nk2 = $this->getItemForType($inventar, 7);	//zweite waffe holen
            $iid = $nk2['iid'] ?? 0;
            //wenn zwei einhandwaffen angelegt wurden
            if($iid > 0 && in_array($nk2['itid'], $items->getItidWeapons()) && $mode == 'nk')
                    $accu = 70;
            else 
                    $accu = 75;

            $attr = $attributes['Geschicklichkeit']['lvl'];
            $attr += $this->getAttrMultiplicator('Geschicklichkeit', $enchantment, $items, $inventar);
            $faktor = ($attr*0.2);
            $accu += $faktor;
            $accu += $this->getAttrMultiplicator('Treffsicherheit', $enchantment, $items, $inventar);

            $res = round($accu,2);

            return ($res<0?0:($res>95?95:$res));
	}
	
	public function getBlock($attributes, $inventar, $items, $enchantment)
	{
		$blockClothes = $items->getBlockClothes();
		$attr = $attributes['St&auml;rke']['lvl'];
                $attr2 = $attributes['Geschicklichkeit']['lvl'];
		$attr += $this->getAttrMultiplicator('St&auml;rke', $enchantment, $items, $inventar);
                $attr2 += $this->getAttrMultiplicator('Geschicklichkeit', $enchantment, $items, $inventar);
                
		$factor1 = 0; $factor2 = 0;
		$blockabsorb = 0;
		foreach($inventar as $single)
		{
                    //wenn gegenstand f�r die berechnung ben�tigt wird
                    if($single['iid'] > 0 && in_array($single['itid'], $blockClothes))
                    {
                        if($single['itid'] == 21) { // leichte schilde
                            $factor1 = 0.15;    // strke
                            $factor2 = 0.2;     // geschicklichkeit
                        } else if($single['itid'] == 22) {  // schw. Schilde
                            $factor1 = 0.2;
                            $factor2 = 0.15;
                        }
                        $item = $items->getItem($single['iid']);
                        // add bonus for +X
                        $blockabsorb += $item['blockabsorb'] + $single['increment'];
                    }
		}

		$block = 4 + ($attr * $factor1) + ($attr2 * $factor2);
		$block += $this->getAttrMultiplicator('Schildblock', $enchantment, $items, $inventar);
		$res = $block;
		
		return array(($res<0?0:($res>25?25:$res)), $blockabsorb);
	}
	
	public function getSpeed($item, $items, $inventar, $mode)
	{
		$nk2 = $this->getItemForType($inventar, 7);	//zweite waffe holen
		//wenn zwei einhandwaffen angelegt wurden, schaden um 10% reduzieren
		if($nk2['iid'] > 0 && in_array($nk2['itid'], $items->getItidWeapons()) && $mode == 'nk')
		{	
			return $item['speed'] - 1;
		}
		else
			return $item['speed'];
	}

    private function getAliasCapability($cap, $capabilities) {
        foreach($capabilities as $capability) {
            if($capability['alias'] == $cap) {
                return $capability;
            }
        }
        return null;
    }

    public function parseCapabilitiesInput($post) {
        $matches = Array();
        // look for pattern
        // name lernfaktor stufe fortschritt wirkung
        preg_match_all("/([a-z\(\) \-&]+).{1}([0-9]\.[0-9][0-9]?).{1}([0-9]+).{1}([0-9]+)%(.{1}([0-9]\.[0-9]{1,2}))?/i", $post, $matches);

        $res = Array();
        $uc1 = $this->getUsersCapabilities(1);  // load list to compare with
        $uc2 = $this->getUsersCapabilities(0);
        $ucs = array_merge($uc1, $uc2);
        
        foreach($matches[1] as $key=>$match) {
            $cap = getStringForDb($match);
            $tmpUc = $this->getAliasCapability($cap, $ucs);
            // check if capability name or alias exists
            if(null === $tmpUc && array_key_exists($cap, $ucs)) {
                $tmpUc = $ucs[$cap];
            }

            if(null !== $tmpUc) {
                // now build the same array as the $_POST array from manual input will look like, therefore we can use the same updateCap method
                $cid = $tmpUc['id'];
                if($tmpUc['mainwork'] == 1) {
                    $res['mw'.$cid] = 'on';
                }
                // add effect
                if(array_key_exists(6, $matches) && strlen($matches[6][$key]) > 0) {
                    $res['eff'.$cid] = $matches[6][$key];
                }
                $res['lvl'.$cid] = $matches[3][$key];
                $res['c'.$cid] = $cid;
                
            }
            //echo 'Name: '.$match.' Faktor: '.$matches[2][$key].' Stufe: '.$matches[3][$key].' Fortschritt: '.$matches[4][$key].'<br>';
        }
        
        $this->parseCharLevel($post, $this->uId, $this->lvl);
        return $res;
    }
    
    /**
     * Looks for the character level in the input 
     * @param string $input
     * @param int $uId
     * @param int $oldLvl
     * @return boolean
     */
    public function parseCharLevel($input, $uId, $oldLvl) {
        $matches = Array();
        preg_match_all("/([a-z?????? -]+).{1,2}(Mensch|Halbelf|Elf|Zwerg|Gnom).{1,2}Level ([0-9]+).*[0-9]+ Gold/is", $input, $matches);

        if(count($matches[1]) == 1 && count($matches[2]) == 1 && count($matches[3]) == 1) {
            $nick = trim($matches[1][0]);
            $folk = $matches[2][0];
            $lvl = (int)$matches[3][0];
            // update user's lvl
            if($oldLvl != $lvl && $this->updateUsersLvl($uId, $lvl)) {
                echo 'Dein Charakterlevel wurde von Stufe '.$oldLvl.' auf '.$lvl.' ge&auml;ndert. ';
                return true;
            }
        }
        return false;
    }

    public function getGenders() {
        $genders = array();

        $qry = "
            SELECT id, name
            FROM " . DB_PREFIX . "users_gender
            ORDER BY id
        ";

        $res =  mysqli_query(Config::getDBConn(), $qry);

        while($row = mysqli_fetch_array($res)) {
            $genders[$row[0]] = $row[1];
        }

        return $genders;
    }
    
    public function getCapabilityForCId($cId, $capArray) {
        if(is_array($capArray)) {
            foreach($capArray as $row) {
                if($row['id'] == $cId) {
                    return $row;
                }
            }
        }
       return array();
    }
	
	public function getUId() { return $this->uId; }
        public function getGender() { return $this->gender; }
	public function getNick() { return $this->nick; }
	public function getTitel() { return $this->titel; }
	public function getMail() { return $this->mail; }
	public function getLastAction() { return $this->lastaction; }
	public function getNoWork() { return $this->nowork; }
	public function getLvl() { return $this->lvl; }
	public function getFolkName() { return $this->folk; }
	public function getFolkId() { return $this->fid; }
        public function getClassesClassId() { return $this->class; }
	public function isBot() { return $this->bot; }
	public function getDesc() { return $this->desc; }
        public function getAvatar() { return $this->avatar; }
        public function getGuId() { return $this->guId; }
	public function getEnemy() { return $this->enemy; }
	public function getCombat() { return $this->combat; }
        public function getPosition() { return $this->position; }
        public function getBandagesCount() { return $this->bandagesCount; }
        public function getBandagesHeal() { return $this->bandagesHeal; }
        public function getBandagesPrio() { return $this->bandagesPrio; }
	public function getTrustLvl() { return $this->trustlvl; }
	public function getOnTime() { return $this->ontime; }
	public function getGuildName() { return $this->guildname; }
	public function getGuildShort() { return $this->guildshort; }
	public function getLastLogin() { return $this->lastlogin; }
        public function getAPIKey() { return $this->apikey; }
        public function getNoAutoCapDiscoverCids() { return Array(5, 18); } // Konstruktion, Wachdienst
}
