<?php
class Warehouse
{
	private $user;
	private $itemTypes = array();
	private $armorcaps = Array(11,12,16);
	private $no_wh_transact = Array();
	private $no_wh_transact_nicks = Array();
	
	public function __construct($user)
	{ 
		$this->user=$user;
		$this->loadIniNoWhTransactUsers();
	}
	
	public function getWHs()
	{
		$result = Array();
		
		//Warehouse laut Nutzerrecht holen
		$query = "SELECT DISTINCT w.wid, w.name as whname, DATE_FORMAT(inidate, '%d.%m.%Y %H:%i') as inidate, g.guid, g.name as gname, g.short, 
                                    w.parent, w.world, w.type
				  FROM ".DB_PREFIX."warehouse w
				  LEFT JOIN ".DB_PREFIX."guilds g ON g.guid=w.ownerguild
				  ORDER BY wid";

		$qry =  mysqli_query(Config::getDBConn(), $query);
		
		$i = 0;
		while($row = mysqli_fetch_array($qry))
		{
			$result[$i]['wid'] = $row['wid'];
			$result[$i]['name'] = $row['whname'];
			$result[$i]['ini'] = $row['inidate'];
			$result[$i]['guid'] = $row['guid'];
			$result[$i]['gname'] = $row['gname'];
			$result[$i]['short'] = $row['short'];
			$result[$i]['parent'] = $row['parent'];
                        $result[$i]['world'] = $row['world'];
                        $result[$i]['type'] = $row['type'];
			$i++;
		}
		
		return $result;
	}
	
	public function getWHByType($guId, $parent)
	{
		$result = Array();
		
		//Warehouse laut Nutzerrecht holen
		$query = "SELECT DISTINCT w.wid, w.name as whname, DATE_FORMAT(inidate, '%d.%m.%Y %H:%i') as inidate, g.guid, g.name as gname, g.short, w.parent
				  FROM ".DB_PREFIX."warehouse w
				  LEFT JOIN ".DB_PREFIX."guilds g ON g.guid=w.ownerguild
				  WHERE w.ownerguild=".$guId." and w.parent=".$parent."
				  ORDER BY w.wid";

		$qry =  mysqli_query(Config::getDBConn(), $query);
		
		if(mysqli_num_rows($qry) > 0)
		{
			$row = mysqli_fetch_array($qry);
			$result['wid'] = $row['wid'];
			$result['whname'] = $row['whname'];
			$result['ini'] = $row['inidate'];
			$result['guid'] = $row['guid'];
			$result['gname'] = $row['gname'];
			$result['short'] = $row['short'];
			$result['parent'] = $row['parent'];
		}
		
		return $result;
	}
	
	public function getWHsByType($type)
	{
		$result = Array();
		$str = 'w.type='.$type;
		//Warehouse laut Nutzerrecht holen
		$query = "SELECT DISTINCT w.wid, w.name as whname, DATE_FORMAT(inidate, '%d.%m.%Y %H:%i') as inidate, g.guid, g.name as gname, g.short, w.parent
				  FROM ".DB_PREFIX."warehouse w
				  LEFT JOIN ".DB_PREFIX."guilds g ON g.guid=w.ownerguild
				  WHERE ".$str."
				  ORDER BY w.wid";

		$qry =  mysqli_query(Config::getDBConn(), $query);
		
		$i = 0;
		while($row = mysqli_fetch_array($qry))
		{
			$result[$i]['wid'] = $row['wid'];
			$result[$i]['whname'] = $row['whname'];
			$result[$i]['ini'] = $row['inidate'];
			$result[$i]['guid'] = $row['guid'];
			$result[$i]['gname'] = $row['gname'];
			$result[$i]['short'] = $row['short'];
			$result[$i]['parent'] = $row['parent'];
			$i++;
		}
		
		return $result;
	}
	
	// pr�ft alle Gildenlager einer stadt und schaut, dass jede gilde pro stadt nur ein lager hat
	public function canAddWh($guild, $parent, $type, $whId = 0)
	{
            if($type == WHType::MARKTSTAND) return true; //ignore check for markets
            $whs = $this->getWHsByType(WHType::GILDENLAGER);
            foreach($whs as $row)
            {
                    if($parent == $row['parent'] && $guild == $row['guid'] && $row['wid'] != $whId)
                            return false;
            }
            return true;
	}
	
	
	public function getWH($whId)
	{
		$result = Array();
		
		//Warehouse laut Nutzerrecht holen
		$query = "SELECT DISTINCT w.wid, w.name as whname, DATE_FORMAT(inidate, '%d.%m.%Y %H:%i') as inidate_de, inidate, g.guid, g.name as gname, g.short, 
                                    w.parent, w.world, w.type
				  FROM ".DB_PREFIX."warehouse w
				  LEFT JOIN ".DB_PREFIX."guilds g ON g.guid=w.ownerguild
				  WHERE wid=".(int)$whId;
		//echo $query;
		$qry =  mysqli_query(Config::getDBConn(), $query);
		
		if(mysqli_num_rows($qry) > 0)
		{
			$row = mysqli_fetch_array($qry);
			$result['wid'] = $row['wid'];
			$result['name'] = $row['whname'];
			$result['ini'] = $row['inidate_de'];	//deutsches Format
			$result['ini_en'] = $row['inidate'];	//englisches Format
			$result['guid'] = $row['guid'];
			$result['gname'] = $row['gname'];
			$result['short'] = $row['short'];
			$result['parent'] = $row['parent'];
                        $result['world'] = $row['world'];
                        $result['type'] = $row['type'];
		}
		
		return $result;
	}
	
	private function getWhIdForBaumeister($guild, $parentWhId)
	{
		/*foreach($guilds as $g)
		{
			if($item == $g['item'])
			{
				if(array_key_exists('guild', $g))
				{
					$guild = $g['guild'];
					break;
				}
				else
					return $parentWhId;	// keine Gilde angegeben, es handelt sich um entnahme aus stadtlager
			}
		}
		
		if($guild === '')
			return 0;*/
		
		if(array_key_exists($guild, $this->guilds))
		{
			return $this->guilds[$guild]['whid'];
		}
		else
		{
			$g = new Guild(null);
			$garr = $g->getGuildByShort($guild);

			if(count($garr) > 0)
			{
				$guId = $garr['id'];
				$this->guilds[$guild]['guid'] = $guId;
				$wharr = $this->getWHByType($guId, $parentWhId);

				if(count($wharr) > 0)
				{
					$this->guilds[$guild]['whid'] = $wharr['wid'];
					return $wharr['wid'];
				}
				else
				{
					return 0;
				}
			}
			else
			{
				return 0;
			}
		}
	}
	
	public function saveProtocoll($list, $whid, $noquestion = 0) {
        //print_r($list);

        $summary = new Summary();    //Statistik
        // alle Gildenlager laden
        $whs = $this->getWHsByType(WHType::GILDENLAGER);
        $isGuildWh = false;
        foreach ($whs as $row) {
            if ($whid == $row['wid'])
                $isGuildWh = true;
        }

        //namen durchgehen
        foreach ($list as $k1 => $entries) {
            // we need to ignore empty entries which where created during parsing (stupid market protocol)
            if(count($entries['items']) == 0) {
                continue;
            }
            $tmpWhId = $whid;
            $name = getStringForDb($entries['name']);
            $date = $entries['date'];
            $guild = getStringForDb($entries['guild']);
            $action = getStringForDb($entries['action']);
            $dt = explode(' ', $date);
            $d = explode('.', $dt[0]);
            $t = explode(':', $dt[1]);
            $tsek = (array_key_exists(2, $t) ? $t[2] : '00');   // angabe der sekunden

            $nd = sprintf('%s-%s-%s %s:%s:%s', $d[2], $d[1], $d[0], $t[0], $t[1], $tsek);

            if ($isGuildWh && $guild == '') {
                $list[$k1]['status'] = 'Stadtware ignoriert';
                continue; // Wenn Gildenlager, ignoriere alle anderen Eintr�ge au�er denen f�r die Gilde	
            }

            // Baumeister nur bei Stadtlagern beachten
            if ($isGuildWh && $name == 'Baumeister') {
                $list[$k1]['status'] = 'Baumeister ignoriert';
                continue;
            }

            // Wenn Stadtlager, und Gildeneintrag wird erkannt, �ndere f�r diese Eintr�ge die whid
            if (!$isGuildWh && $guild != '') {
                if (array_key_exists($guild, $this->guilds)) {
                    $guId = $this->guilds[$guild]['guid'];
                    $tmpWhId = $this->guilds[$guild]['whid'];
                } else {
                    $g = new Guild(null);
                    $garr = $g->getGuildByShort($guild);

                    if (count($garr) > 0) {
                        $guId = $garr['id'];
                        $this->guilds[$guild]['guid'] = $guId;
                        $wharr = $this->getWHByType($guId, $tmpWhId); // load guild wh

                        if (count($wharr) > 0) {
                            $tmpWhId = $wharr['wid'];
                            $this->guilds[$guild]['whid'] = $tmpWhId;
                        } else {
                            $list[$k1]['status'] = '<span class="err">kein Lager</span>';
                            continue; // nichts machen
                        }
                    } else {
                        $list[$k1]['status'] = '<span class="err">keine Gilde</span>';
                        continue; // nichts machen
                    }
                }
            } else
                $tmpWhId = $whid;

            $q =  mysqli_query(Config::getDBConn(), "SELECT inidate FROM " . DB_PREFIX . "warehouse WHERE wid=" . (int) $tmpWhId);
            $q = mysqli_fetch_array($q);
            $inidate = strtotime($q['inidate']); //timestamp
            //wenn Eintrag auch eingef�gt werden soll, wenn er schon existiert
            if (!$noquestion) {
                //pr�fen, ob Eintrag existiert
                $query = "SELECT wp.wpid, wp.nick, wp.date, wp.type, i.item, wpe.stability, wpe.icount, wpe.increment 
							FROM " . DB_PREFIX . "warehouse_protocoll wp, " . DB_PREFIX . "warehouse_protocoll_entry wpe, " . DB_PREFIX . "items i  
							WHERE wpe.wpid=wp.wpid and wpe.iid=i.iid and wp.wid=" . (int) $tmpWhId . "
							and wp.nick='" . $name . "' and wp.date='" . $nd . "' and wp.type='" . $action . "' and wp.guild='" . $guild . "' ORDER BY wpe.wpid, i.item";

                $res =  mysqli_query(Config::getDBConn(), $query);
                $exist = 0;
                if (mysqli_num_rows($res) != 0) 
                {
                    if ($name == 'Baumeister') {
                        $loop = $entries['item_guild'];
                        $list[$k1]['items'] = $entries['item_guild'];
                    } else {
                        $loop = $entries['items'];
                    }

                    //jetzt pr�fe jede Ware
                    $tmpwpid = 0;
                    $matches = 0;
                    $cdb = 0;
                    $c = count($list[$k1]['items']); //Anzahl der Waren

                    while ($row = mysqli_fetch_array($res)) 
                    {
                        //wenn genausoviele �bereinstimmungen wie eintr�ge in lokaler Liste da sind
                        if ($c == $matches && $row['wpid'] != $tmpwpid && $c == $cdb) 
                        {
                            $exist = 1;
                            break;
                        } 
                        else
                            $exist = 0;

                        if ($row['wpid'] != $tmpwpid) 
                        {
                            $matches = 0;
                            $cdb = 0;
                            $tmpwpid = $row['wpid'];
                        }
                        $cdb++;


                        foreach ($loop as $item => $val) {
                            $amount = (int) $val['amount'];
                            $stability = (int) $val['stability'];
                            $tmpInc = (int) $val['increment'];
                            $it = makeEntityString($val['item']);
                            if ($row['item'] == $it && $row['icount'] == $amount && $row['stability'] == $stability
                                    && $row['increment'] == $tmpInc) {
                                $matches++;
                                break;
                            }
                        }
                        //echo $c.' '.$matches.' '.$row['item'].' '.$cdb.'<br>';
                        if ($c == $matches && $c == $cdb)
                            $exist = 1;
                    }
                }
            }

            if (!$exist || $noquestion) { //Eintrag existiert noch nicht

                $query = "INSERT INTO " . DB_PREFIX . "warehouse_protocoll(nick, date, type, wid, guild) VALUES('" . $name . "', 
						  '" . $nd . "', '" . $action . "', " . (int) $tmpWhId . ", '" . $guild . "')";
                if ( mysqli_query(Config::getDBConn(), $query)) 
                {
                    $list[$k1]['status'] = 'OK';
                    $wpid = mysqli_insert_id(Config::getDBConn());
                    $curTs = strtotime($nd); //timestamp des Protokolleintrages
                    $lenIniDate = strlen($inidate);
                    $inUser = 0;
                    $outUser = 0;
                    $inManager = 0;
                    $outManager = 0;   //Summe der Ein- bzw. Entnahmen

                    if ($name == 'Baumeister') {
                        $loop = $entries['item_guild'];
                        $list[$k1]['items'] = $entries['item_guild'];
                    } else {
                        $loop = $entries['items'];
                    }
                    foreach ($loop as $item => $val) 
                    {
                        $amount = (int) $val['amount'];
                        $stability = (int) $val['stability'];
                        $increment = (int) $val['increment'];
                        $sellPrice = (int) $val['sellPrice'];
                        $it = makeEntityString($val['item']);

                        //warehouse_items aktualiseren, wenn wh inidate in der Vergangenheit liegt
                        if ($lenIniDate == 0 || $curTs > $inidate) 
                        {
                            // Beim Baumeister wird die Gilde pro Item gespeichert!
                            if ($name == 'Baumeister') 
                            {
                                // wenn aus gildenlager entnommen
                                if (array_key_exists('guild', $val)) {
                                    $updateWhId = $this->getWhIdForBaumeister($val['guild'], $tmpWhId);
                                } else {
                                    $updateWhId = $tmpWhId;
                                }

                                // zum status die Gilde hinzuf�gen, wenn id ungleich der stadlager id ist
                                if ($updateWhId > 0 && $updateWhId != $tmpWhId) {
                                    $list[$k1]['items'][$item]['status'] = '<br />[' . $val['guild'] . '] ';
                                }
                            } else
                                $updateWhId = $tmpWhId;

                            // nur machen, wenn g�ltige whid
                            if ($updateWhId > 0) {
                                $status = $this->updateWarehouseFromProt($it, $updateWhId, $amount, $stability, $guild, $increment, $action);
                                $list[$k1]['items'][$item]['status'] .= $status . '/ ';
                                //Lager kann auch leer sein und durch den ersten Protokolleintrag initialisiert werden
                                if ($lenIniDate == 0)
                                    @ mysqli_query(Config::getDBConn(), "UPDATE " . DB_PREFIX . "warehouse SET inidate=NOW() WHERE wid=" . (int) $tmpWhId);
                            }
                        }

                        //pr�fen, ob das Item existiert
                        $itemq =  mysqli_query(Config::getDBConn(), "SELECT iid FROM " . DB_PREFIX . "items WHERE item='" . $it . "'");
                        if ($itemq && mysqli_num_rows($itemq) == 1) {
                            $res = mysqli_fetch_array($itemq);
                            $iid = $res['iid'];
                            //echo $amount['amount'].' '.$item.'<br />';
                            $query = "INSERT INTO " . DB_PREFIX . "warehouse_protocoll_entry(wpid, iid, icount, stability, increment, sellprice) VALUES
					(" . $wpid . ", " . (int) $iid . ",	" . $amount . ", " . $stability . ", " . $increment . ", " . $sellPrice . ")";
                            //echo $query.'<br>';
                            if ( mysqli_query(Config::getDBConn(), $query)) {
                                $list[$k1]['items'][$item]['status'] .= "OK";

                                /*** Die Summen f�r die Statistik extra speichern ****/
                                $itemObj = new Item();
                                $sumItem = $itemObj->getItem($iid);
                                $toAdd = 0;
                                //Gesamtbetrag berechnen
                                if ($stability == 0)
                                    $toAdd = $amount * $sumItem['price'];
                                else
                                    $toAdd = ($amount * $sumItem['price']) * ($stability / 100);

                                if ($action == 'Einlagerung' && !in_array($name, $this->getNoWhTransactNicks())) //normale Nutzer
                                    $inUser += $toAdd;
                                else if (!in_array($name, $this->getNoWhTransactNicks()))
                                    $outUser += $toAdd;
                                else if ($action == 'Einlagerung')            //Verwalter
                                    $inManager += $toAdd;
                                else
                                    $outManager += $toAdd;
                                /***************************************************** */
                            } else
                                $list[$k1]['items'][$item]['status'] .= '<span class="err">Fehler</span>';
                        } else
                            $list[$k1]['items'][$item]['status'] .= 'no Item';
                    }

                    //Summen f�r die Statistik speichern, f�r jeden Tag, der im Protokoll auftaucht
                    $nd2 = sprintf('%s-%s-%s', $d[2], $d[1], $d[0]);

                    $summary->addSumForWh($nd2, $inUser, $outUser, $inManager, $outManager, $tmpWhId);
                }
            }
            else {
                $list[$k1]['status'] = 'ignoriert';
                $_SESSION['tmplist'][$k1] = $list[$k1];
            }
        }
        return $list;
    }

    //newItem: [1][0]:Anzahl, [2][0]:Item,[3][0]:Haltbarkeit
	public function addToWhInitList($list, $newItem, $whId)
	{
		if($this->hasRightForWh($whId))
		{//print_r($newItem);echo '<br>';
			$status = 'Fehler';
			
			$stability = 0;
            $increment = 0;
			$amount = (int)$newItem[1][0] ?? 1;	//Anzahl
            if($amount == 0) $amount = 1;
			$itemName = trim($newItem[2][0]);			//Item
			$item = $itemName;                  // itemName nur zum Zwischenspeichern des originalem Namen
			//Verzauberungen abschneiden
			//if(strlen(strstr($item,'(Plan)')) == 0 && strlen(strstr($item,'[2H]')) == 0 && strpos($item,' ') > 0)
			//	$item = substr($item,0,strpos($item,' '));
			//Verzauberungen abschneiden
			if(strlen(strstr($item,' der ')) > 0 || strlen(strstr($item,' des ')) > 0)
            {
                $pos = strpos($item, ' der ') ?: strpos($item, ' des ');
                $item = substr($item,0, $pos);
            }
			//var_dump($newItem[3]);				
			//Haltbarkeit, nur machen wenn nicht munition
			if(array_key_exists(5, $newItem) && array_key_exists(3, $newItem) && strpos($newItem[3][0], '+') === false)
			{
				$stability = (int)$newItem[3][0];
                $increment = (int)$newItem[5][0];
			}
            // +X Waren bei Waren ohne Haltbarkeit
			if(array_key_exists(4, $newItem))
			{
				$increment = (int)$newItem[4][0];
			}
			
			//in db einf�gen/updaten
			$squery = "SELECT iid FROM ".DB_PREFIX."items WHERE item='".getStringForDb($item)."'";
			$res =  mysqli_query(Config::getDBConn(), $squery);
			
			//wenn es eine entsprechende Ware gibt
			if(mysqli_num_rows($res) == 1)
			{
                $res = mysqli_fetch_array($res);
                $iid = $res['iid'];

                $squery = "SELECT wiid FROM ".DB_PREFIX."warehouse_items WHERE wid=".(int)$whId." and iid=".(int)$iid." 
                                        and stability=".(int)$stability." and increment=".(int)$increment;
                $res =  mysqli_query(Config::getDBConn(), $squery);
                //wenn item mit der Haltbarkeit schon im ausgew�hlten Lager ist, addiere hinzu
                if(mysqli_num_rows($res) == 1)
                {
                        $res = mysqli_fetch_array($res);
                        $wiid = $res['wiid'];
                        $query = "UPDATE ".DB_PREFIX."warehouse_items SET icount=icount+".$amount." WHERE wiid=".(int)$wiid;
                        if( mysqli_query(Config::getDBConn(), $query))
                                $status = 'OK';
                }
                else 	//ansonsten f�ge Item zu Lager hinzu
                {
                        $query = "INSERT INTO ".DB_PREFIX."warehouse_items(iid, icount, stability, wid, increment)
                                        VALUES (".(int)$iid.", ".(int)$amount.", ".(int)$stability.", ".(int)$whId.", ".(int)$increment.")";
                        if( mysqli_query(Config::getDBConn(), $query))
                                $status = 'OK';
                }
			}
			$idx = $item.' ('.$stability.')'.$increment;
            if(!array_key_exists($idx, $list)) {
                $list[$idx] = [];
                $list[$idx]['amount'] = 0;
            }
            $list[$idx]['amount'] += $amount;
            $list[$idx]['status'] = $status;
            $list[$idx]['increment'] = $increment;

            if($stability > 0)
			{                            
                $list[$idx]['name'] = makeEntityString($item).' ('.$stability.')';
			}
			else
			{                            
                $list[$idx]['name'] = makeEntityString($item);
			}
			
			@ mysqli_query(Config::getDBConn(), "UPDATE ".DB_PREFIX."warehouse SET inidate=NOW() WHERE wid=".(int)$whId);
		}
		return $list;
	}	
	
	private $guilds = Array();
	
	private function updateWarehouseFromProt($item, $whId, $amount, $stability, $guild, $increment, $type='Einlagerung')
	{	
		$type = ($type=='Einlagerung'?'+':'-');
		$status = '<span class="err">update Fehler</span>';
		$squery = "SELECT iid FROM ".DB_PREFIX."items WHERE item='".$item."'";

		$res =  mysqli_query(Config::getDBConn(), $squery);

		//wenn es eine entsprechende Ware gibt
		if(mysqli_num_rows($res) == 1)
		{
			$res = mysqli_fetch_array($res);
			$iid = $res['iid'];

			$squery = "SELECT wiid, icount FROM ".DB_PREFIX."warehouse_items WHERE wid=".(int)$whId." and iid=".(int)$iid." 
						and stability=".(int)$stability." and increment=".(int)$increment;
			$res =  mysqli_query(Config::getDBConn(), $squery);
			
			//wenn item mit der Haltbarkeit schon im ausgew�hlten Lager ist, addiere hinzu
			if(mysqli_num_rows($res) == 1)
			{
				$res = mysqli_fetch_array($res);
				$wiid = $res['wiid'];
				$icount = $res['icount'];
				$number = ($type=='+' ? $icount+$amount : $icount-$amount);
				//$number = ($number >= 0 ? $number : 0); //0
				$query = "UPDATE ".DB_PREFIX."warehouse_items SET icount=".$number." WHERE wiid=".(int)$wiid;
				if( mysqli_query(Config::getDBConn(), $query))
					$status = 'update OK';
			}
			else 	//ansonsten f�ge Item zu Lager hinzu
			{
				if($type == '+')
				{
					$query = "INSERT INTO ".DB_PREFIX."warehouse_items(iid, icount, stability, wid, increment)
						VALUES (".(int)$iid.", ".(int)$amount.", ".(int)$stability.", ".(int)$whId.", ".(int)$increment.")";
					if( mysqli_query(Config::getDBConn(), $query))
						$status = 'insert OK';
				}				
			}
		}
		return $status;
	}
	
	public function truncateWh($whId, $deleteProtocoll = false)
	{
		$result = false;
		if($this->hasRightForWh($whId))
		{
			$query = "DELETE FROM ".DB_PREFIX."warehouse_items WHERE wid=".(int)$whId;
                        if($deleteProtocoll)
                        {
                            $query2 = "DELETE FROM ".DB_PREFIX."warehouse_protocoll_entry where wpid IN (SELECT wpid FROM ".DB_PREFIX."warehouse_protocoll WHERE wid=".(int)$whId.")";
                            $query3 = "DELETE FROM ".DB_PREFIX."warehouse_protocoll WHERE wid=".(int)$whId;
                            @ mysqli_query(Config::getDBConn(), $query2);
                            @ mysqli_query(Config::getDBConn(), $query3);
                        }
			
			if( mysqli_query(Config::getDBConn(), $query))
				$result = true;
			@ mysqli_query(Config::getDBConn(), "UPDATE ".DB_PREFIX."warehouse SET inidate=NULL WHERE wid=".(int)$whId);
			$this->iniWh($whId);
		}
		return $result;
	}
	
	public function iniWh($whId)
	{
		//alle items holen, die noch nicht enthalten sind
		$query = "SELECT i.iid FROM ".DB_PREFIX."items i 
		            JOIN ".DB_PREFIX."warehouse w on w.wid=".(int)$whId."
		            JOIN ".DB_PREFIX."items_world iw on iw.iid=i.iid and iw.world=w.world
		            WHERE i.iid NOT IN(
					(SELECT iid FROM ".DB_PREFIX."warehouse_items WHERE wid=".(int)$whId." and stability IN(100,0)))";
		if($res =  mysqli_query(Config::getDBConn(), $query))
		{
			while($row = mysqli_fetch_array($res))
			{
				//Items hinzuf�gen und auf 0 setzen
				$q = "INSERT INTO ".DB_PREFIX."warehouse_items(wid, iid, icount, stability) VALUES(".(int)$whId.", 
					  ".(int)$row['iid'].", 0, 0)";
				 mysqli_query(Config::getDBConn(), $q);
			}
			
			//alle die eine Haltbarkeit haben auf 100 setzen
			$q2 = "UPDATE ".DB_PREFIX."warehouse_items set stability=100 WHERE iid 
					IN(SELECT i.iid FROM ".DB_PREFIX."items i, ".DB_PREFIX."item_types it WHERE it.itid=i.itid and it.itid 
					NOT IN(15,16,17,23,24,25,26,27,28,29,30)) and stability=0 and wid=".(int)$whId;
			 mysqli_query(Config::getDBConn(), $q2);
		}
	}
	
	private function hasRightForWh($whId)
	{
		$result = false;
		//Warehouse laut Nutzerrecht holen
		$query = "SELECT w.wid FROM ".DB_PREFIX."warehouse w
				  JOIN ".DB_PREFIX."warehouse_group_rights wgr ON w.wid=".(int)$whId." and w.wid=wgr.wid
				  LEFT JOIN ".DB_PREFIX."groups_user gu ON wgr.gid=gu.gid
				  LEFT JOIN ".DB_PREFIX."groups_guild gg ON wgr.gid=gg.gid
				  LEFT JOIN ".DB_PREFIX."guilds_user ggu ON ggu.guid=gg.guid
				  WHERE (gu.uid=".$this->user->getUId().") or (ggu.uid=".$this->user->getUId().")";
		//echo $query;
		$qry =  mysqli_query(Config::getDBConn(), $query);
		
		if(mysqli_num_rows($qry) > 0)
			$result = true;
		
		return $result;
	}
	
	public function getWarhouseItemTypes($whId)
	{
		$result = array();
		if($this->hasRightForWh($whId))
		{			
			//Alle Warentypen mit der Anzahl der im Lager befindlichen Waren, je Warengruppe			
			$query = "SELECT it.type, it.itid, SUM(wi.icount) as icount, itv.minval, itv.maxval from ".DB_PREFIX."warehouse_items wi  
						RIGHT JOIN ".DB_PREFIX."items i ON wi.iid=i.iid and wi.wid=".(int)$whId." and wi.stability IN(100,0) 
						and wi.icount>0
						RIGHT JOIN  ".DB_PREFIX."item_types it on it.itid=i.itid
						INNER JOIN ".DB_PREFIX."item_types_values itv on it.itid=itv.itid and itv.wid=".(int)$whId." 
						INNER JOIN ".DB_PREFIX."item_types_world itw on itw.itid=it.itid
						INNER JOIN ".DB_PREFIX."warehouse w on w.world=itw.world and w.wid=".(int)$whId."
					  GROUP BY it.itid, it.type 
					  ORDER BY it.sort";
			//echo $query;
			$res =  mysqli_query(Config::getDBConn(), $query);
			if(mysqli_num_rows($res) > 0)
			{
				$i = 0;
				while($row = mysqli_fetch_array($res))
				{
					$result[$i]['id'] = $row['itid'];
					$result[$i]['type'] = $row['type'];
					$result[$i]['count'] = number_format(($row['icount']==NULL?0:$row['icount']),0,'','.');
					$result[$i]['minvalue'] = number_format($row['minval'],0,'','.');
					$result[$i]['maxvalue'] = number_format($row['maxval'],0,'','.');
					$i++;
				}
			}
		}
		return $result;
	}
	
	public function getWarhouseItemsByType($whId, $itid)
	{
		$result = array();
		if($this->hasRightForWh($whId))
		{
			//Alle Warentypen mit der Anzahl der im Lager befindlichen Waren, je Warengruppe			
			$query = "SELECT wi.wiid, i.itid, i.iid, i.item, iv.minval, iv.maxval, SUM(wi.icount) as icount, i.magical, i.producable, it.prod_equals_cap_lvl, i.cid 
					  FROM ".DB_PREFIX."items i, ".DB_PREFIX."warehouse_items wi, ".DB_PREFIX."item_values iv, ".DB_PREFIX."item_types it, ".DB_PREFIX."items_world iw, ".DB_PREFIX."warehouse w
					  WHERE i.itid=it.itid and wi.wid=".(int)$whId." and wi.iid=i.iid and i.itid=".(int)$itid." 
					  and (w.wid=".(int)$whId." and iw.iid=i.iid and iw.world=w.world) 
					  and wi.stability IN(100,0) and i.iid=iv.iid and iv.wid=".(int)$whId."
                                          GROUP BY i.iid, wi.wiid
					  ORDER BY i.magical, i.subsort, i.lvl, i.sort";
			//echo $query;
			$res =  mysqli_query(Config::getDBConn(), $query);
			if(mysqli_num_rows($res) > 0)
			{
				$i = 0;
				while($row = mysqli_fetch_array($res))
				{
					$it = $this->getItemTypeById($itid, $whId);
					$result[$i]['id'] = $row['iid'];
					$result[$i]['wiid'] = $row['wiid'];
					$result[$i]['item'] = $row['item'];
					$result[$i]['magical'] = $row['magical'];
					$result[$i]['producable'] = $row['producable'];
					$result[$i]['count'] = $row['icount']==NULL?0:$row['icount'];
					$result[$i]['fcount'] = number_format(($row['icount']==NULL?0:$row['icount']),0,'','.');
					//die werte der Einzelware wiegt h�her als die Werte der Gruppe
					if($row['minval'] != NULL)
						$min = $row['minval'];
					else 
						$min = $it['minvalue'];
					if($row['maxval'] != NULL)
						$max = $row['maxval'];
					else 
						$max = $it['maxvalue'];
					$result[$i]['fminvalue'] = number_format($min,0,'','.');
					$result[$i]['fmaxvalue'] = number_format($max,0,'','.');
					$result[$i]['minvalue'] = $min;
					$result[$i]['maxvalue'] = $max;
					$result[$i]['cid'] = $row['cid'];
					$result[$i]['equals'] = $row['prod_equals_cap_lvl'];
					$i++;
				}
			}
		}
		return $result;
	}
        
        public function getWarhouseItemsByIid($whId, $iid)
	{
		$result = array();
		if($this->hasRightForWh($whId))
		{
			//Alle Warentypen mit der Anzahl der im Lager befindlichen Waren, je Warengruppe			
			$query = "SELECT wi.wiid, i.itid, i.iid, i.item, wi.icount, i.magical, i.producable, wi.stability, wi.increment
					  FROM ".DB_PREFIX."items i, ".DB_PREFIX."warehouse_items wi
					  WHERE wi.wid=".(int)$whId." and wi.iid=i.iid and i.iid=".(int)$iid." and wi.icount > 0					  
					  ORDER BY wi.increment, wi.stability DESC";
			//echo $query;
			$res =  mysqli_query(Config::getDBConn(), $query);
			if(mysqli_num_rows($res) > 0)
			{
				$i = 0;
				while($row = mysqli_fetch_array($res))
				{
					$result[$i]['id'] = $row['iid'];
					$result[$i]['wiid'] = $row['wiid'];
					$result[$i]['item'] = $row['item'];
					$result[$i]['magical'] = $row['magical'];
					$result[$i]['producable'] = $row['producable'];
					$result[$i]['count'] = $row['icount']==NULL?0:$row['icount'];
                    $result[$i]['stability'] = $row['stability'];
                    $result[$i]['increment'] = $row['increment'];
					$result[$i]['fcount'] = number_format($result[$i]['count'],0,'','.');
					$i++;
				}
			}
		}
		return $result;
	}
	
	private function getItemTypeById($itid, $whId)
	{
		$result = array();
		if(array_key_exists($itid, $this->itemTypes))
			return $this->itemTypes[$itid];
		//Alle Warentypen mit der Anzahl der im Lager befindlichen Waren, je Warengruppe			
		$query = "SELECT it.itid, itv.minval, itv.maxval 
				  FROM ".DB_PREFIX."item_types it, ".DB_PREFIX."item_types_values itv WHERE it.itid=".(int)$itid." 
				  and it.itid=itv.itid and itv.wid=".(int)$whId;

		$res =  mysqli_query(Config::getDBConn(), $query);
		if(mysqli_num_rows($res) == 1)
		{
			$row = mysqli_fetch_array($res);
			$this->itemTypes[$row['itid']]['minvalue'] = $row['minval'];
			$this->itemTypes[$row['itid']]['maxvalue'] = $row['maxval'];
		}
		
		return $this->itemTypes[$itid];
	}
	
	public function getWarhouseItemByIidFirst($whId, $iid)
	{
		$result = array();
		//Waren aus Lager holen	
		$query = "SELECT wi.wiid, wi.iid, wi.icount, wi.stability, wi.wid
				  FROM ".DB_PREFIX."warehouse_items wi
				  WHERE wi.wid=".(int)$whId." and wi.iid=".(int)$iid." 
				  LIMIT 1";

		$res =  mysqli_query(Config::getDBConn(), $query);
		
		while($row = mysqli_fetch_array($res))
		{
			$result['wiid'] = $row['wiid'];
			$result['iid'] = $row['iid'];
			$result['icount'] = $row['icount'];
			$result['stability'] = $row['stability'];
			$result['wid'] = $row['wid'];
		}			
		return $result;
	}
	
	public function updateWarehouseItemsICount($wiid, $icount)
	{
		$query = "UPDATE ".DB_PREFIX."warehouse_items SET icount=".(int)$icount." WHERE wiid=".(int)$wiid;
		//echo $query;
		if( mysqli_query(Config::getDBConn(), $query))
			return true;
		else
			return false;
	}
	
	public function getJungestProtEntry($whid = 0)
	{
		$result = array();
		if($whid != 0)
			$query = "SELECT DISTINCT nick, DATE_FORMAT(date, '%d.%m.%Y %H:%i') as date, type 
					  FROM ".DB_PREFIX."warehouse_protocoll WHERE date=(SELECT MAX(k.date) FROM ".DB_PREFIX."warehouse_protocoll k 
					  	WHERE k.wid=".(int)$whid.") 
					  and wid=".(int)$whid;
		else //j�ngster eintrag �ber alle Lager
			$query = "SELECT DISTINCT nick, DATE_FORMAT(date, '%d.%m.%Y %H:%i') as date, type 
					  FROM ".DB_PREFIX."warehouse_protocoll WHERE date=(SELECT MAX(k.date) FROM ".DB_PREFIX."warehouse_protocoll k)";
			
		$res =  mysqli_query(Config::getDBConn(), $query);
		if(mysqli_num_rows($res))
		{
			$res = mysqli_fetch_array($res);
			$result['nick'] = $res['nick'];
			$result['date'] = $res['date'];
			$result['action'] = $res['type'];
		}
		return $result;		
	}
	
	public function getDemagedItemCount($iid, $whid)
	{
		$result = array();
		$query = "SELECT SUM(icount) as sumcount, minstability, maxstability 
				  FROM egtool_warehouse_items, 
					(SELECT MIN(stability) as minstability FROM egtool_warehouse_items 
						WHERE  wid=".(int)$whid." and iid=".(int)$iid." and stability BETWEEN 1 and 99 and icount > 0 group by wid) ua1, 
					(SELECT MAX(stability) as maxstability FROM egtool_warehouse_items 
						WHERE  wid=".(int)$whid." and iid=".(int)$iid." and stability BETWEEN 1 and 99 and icount > 0 group by wid) ua2
				  WHERE  wid=".(int)$whid." and iid=".(int)$iid." and stability BETWEEN 1 and 99 and icount > 0
				  group by wid, minstability, maxstability";
		
		
		$res =  mysqli_query(Config::getDBConn(), $query);
		if(mysqli_num_rows($res))
		{
			$res = mysqli_fetch_array($res);

			if($res['sumcount'] != NULL)
			{
				$result['sum'] = (int)$res['sumcount'];
				$result['min'] = (int)$res['minstability'];
				$result['max'] = (int)$res['maxstability'];
			}
			else
				$result['sum'] = 0;
			
		}
		return $result;		
	}
		
	public function getProtocollListTotal($year, $month, $sort, $dir, $user, $single = 0, $daymin=1, $daymax=31, $whIds = array())
	{
		
		$result = array();
		//$query = "select wp.wpid, wp.nick, wp.date, wp.type, SUM(wpe.icount) as isum, wpe.stability, i.item, i.magical
		//			from warehouse_protocoll wp, warehouse_protocoll_entry wpe, items i
		//			where wpe.wpid=wp.wpid and wpe.iid=i.iid
		//			group by wp.nick, wpe.iid ORDER BY wp.nick, wp.type";
		
		$dirarr = array('up', 'down');
		$sortarr = array('nick', 'deposit', 'withdrawal');

		/*****************Lager******************/
		if(count($whIds) > 0)
		{
			$ind = "wp.wid";
			$ind .= " IN("; $i = 0;
			
			foreach($whIds as $wid)	
			{
				$ind .= $wid;
				if($i != count($whIds)-1)
						$ind .= ', ';
					$i++;
			}
			$ind .= ") and";
		}
		else
			$ind = "";

		//sortierung
  		if(in_array($sort, $sortarr) && in_array($dir, $dirarr))
    		$order = ' ORDER BY wp.'.getStringForDb($sort).' '.($dir=='down'?'ASC':'DESC').', wp.type, it.itid, i.magical, i.lvl, i.sort';
  		else
    		$order = ' ORDER BY wp.nick, wp.type, it.itid, i.magical, i.lvl, i.sort';
		$cond = "";
                if($year > 0) $cond .= " and YEAR(wp.date)=".(int)$year;
		if($month > 0)
			$cond .=  " and MONTH(wp.date)=".(int)$month." and (DAY(wp.date) BETWEEN ".(int)$daymin." and ".(int)$daymax.")";	

    		if($user != "") $user = " and wp.nick='".getStringForDb($user)."'";
			else			$user = "";
    		$query = "SELECT wp.nick, wpe.iid, i.item, SUM(wpe.icount) as isum, wpe.stability, wp.type, 
    				  i.magical, i.marketvalue, i.realvalue, wpe.increment
				      FROM ".DB_PREFIX."warehouse_protocoll wp, ".DB_PREFIX."warehouse_protocoll_entry wpe, ".DB_PREFIX."items i, ".DB_PREFIX."item_types it 
				      where ".$ind." wp.wpid=wpe.wpid and i.iid=wpe.iid and i.itid=it.itid".$cond.$user."
				      group by wp.nick, wpe.iid, wpe.increment, wpe.stability, i.item, wp.type, i.magical".$order;
    	


		//echo $query;
		$res =  mysqli_query(Config::getDBConn(), $query);
		if(mysqli_num_rows($res) > 0)
		{
                    while($row = mysqli_fetch_array($res))
                    {
                        $type = $row['type'];
                        $nick = $row['nick']; $tmptype = "";
                        if(!isset($result[$nick])) {
                            $result[$nick] = [];
                        }
                        if(!isset($result[$nick][$type])) {
                            $result[$nick][$type]['sum'] = 0;
                        }
                        $item = ($row['stability']==0?$row['item']:$row['item'].' ('.$row['stability'].')'); 
                        if($row['increment'] > 0) $item .= ' +'.$row['increment'];
                        if($row['realvalue'] != 0)
                                $factor = $row['realvalue'];
                        else 
                                $factor = $row['marketvalue'];
                        if($row['stability'] == 0)
                                $total = $row['isum']*$factor;
                        else
                                $total = ($row['isum']*$factor)*($row['stability']/100);
                         
                        $amount = number_format($row['isum'],0,'','.');
                        $result[$nick][$type]['sum'] += $total;
                        //$result[$nick][$type][$row['item']]
                        if($single)
                        {
                            $result[$nick][$type][$item][0] = $amount;
                            $result[$nick][$type][$item][1] = $row['magical'];
                            $result[$nick][$type][$item][2] = $total;
                            $result[$nick][$type][$item][3] = $factor;
                        }
                    }			
		}
		return $result;		
	}
	
	public function getProtocollListAmounts($whIds, $yearf, $monthf=0, $yeart=0, $montht=0)
	{
		$result = array();
		
		/*****************Gild Ids******************/
		$inf = " and wp.wid IN("; $i = 0;
		foreach($whIds as $val)	
		{
			$inf .= $val;
			if($i != count($whIds)-1)
					$inf .= ', ';
				$i++;
		}
		if(count($whIds) == 0)	$inf .= "0";
		$inf .= ")";
		/*****************************************/
		
		$from = $yearf.'-'.$monthf.'-1';
		
		//anzahl tage im Monat ermitteln
		$tmpstmp = mktime(0,0,0,$montht,1,$yeart);
		
		$to = $yeart.'-'.$montht.'-'.date("t", $tmpstmp);
		
		if($monthf == 0)	//yearly
			$query = "SELECT wp.nick, SUM(wpe.icount) as isum, wpe.stability, i.marketvalue, i.realvalue, wp.type, MONTH(wp.date) as month
					  FROM ".DB_PREFIX."warehouse_protocoll wp, ".DB_PREFIX."warehouse_protocoll_entry wpe, ".DB_PREFIX."items i, ".DB_PREFIX."item_types it 
					  where i.iid=wpe.iid and wp.wpid=wpe.wpid and i.itid=it.itid and YEAR(wp.date)=".(int)$yearf." 
					  group by YEAR(wp.date), MONTH(wp.date), wp.nick, wpe.iid, wpe.stability, wp.type";
		else if($monthf > 0 && $yeart > 0 && $montht > 0)	//weekly
			$query = "SELECT wp.nick, SUM(wpe.icount) as isum, wpe.stability, i.marketvalue, i.realvalue, wp.type, WEEKOFYEAR(wp.date) as month
				  	  FROM ".DB_PREFIX."warehouse_protocoll wp, ".DB_PREFIX."warehouse_protocoll_entry wpe, ".DB_PREFIX."items i, ".DB_PREFIX."item_types it 
				  	  where i.iid=wpe.iid and wp.wpid=wpe.wpid and i.itid=it.itid and DATEDIFF(wp.date, '".$from."')>=0 and DATEDIFF(wp.date, '".$to."')<=0 ".$inf." 
			  	  	  group by YEAR(wp.date), WEEKOFYEAR(wp.date), wp.nick, wpe.iid, wpe.stability, wp.type
			  	  	  order by year(wp.date)";
		else if($yeart == 0 && $montht == 0)	//dayly
			$query = "SELECT wp.nick, SUM(wpe.icount) as isum, wpe.stability, i.marketvalue, i.realvalue, wp.type, DAY(wp.date) as month
				  	  FROM ".DB_PREFIX."warehouse_protocoll wp, ".DB_PREFIX."warehouse_protocoll_entry wpe, ".DB_PREFIX."items i, ".DB_PREFIX."item_types it 
				  	  where i.iid=wpe.iid and wp.wpid=wpe.wpid and i.itid=it.itid and YEAR(wp.date)>=".(int)$yearf." ".$inf." and 
				  	  MONTH(wp.date)>=".(int)$monthf." and YEAR(wp.date)<=".(int)$yearf." and MONTH(wp.date)<=".(int)$monthf." 
			  	  	  group by YEAR(wp.date), MONTH(wp.date), DAY(wp.date), wp.nick, wpe.iid, wpe.stability, wp.type";

		//echo $query;
		$res =  mysqli_query(Config::getDBConn(), $query);
		if(mysqli_num_rows($res) > 0)
		{
			$no_transact_in = Array(); $no_transact_out = Array();
			while($row = mysqli_fetch_array($res))
			{
				if($row['realvalue'] != 0)
					$factor = $row['realvalue'];
				else 
					$factor = $row['marketvalue'];
				if($row['stability'] == 0)
					$total = $row['isum']*$factor;
				else
					$total = ($row['isum']*$factor)*($row['stability']/100);
				
				if(!in_array($row['nick'], $this->no_wh_transact_nicks))
				{
					$result[$row['type']][$row['month']] += $total;
				}
				else 
				{
					//alle die nicht betrachtet werden sollen, bei denen jedoch die differenz im Anschluss dazu rechnen
					if($row['type'] == 'Einlagerung')
						$no_transact_in[$row['nick']][$row['month']] += $total;
					else
						$no_transact_out[$row['nick']][$row['month']] += $total;
				}
			}
			
			//Differenz der nicht betrachteten hinzurechnen je monat
			foreach($no_transact_out as $nick=>$val)
			{
				foreach($val as $month=>$amount)
				{
					if($no_transact_in[$nick][$month] > $amount)
						$result['Einlagerung'][$month] += $no_transact_in[$nick][$month] - $amount;
					else if($amount > $no_transact_in[$nick][$month])
						$result['Entnahme'][$month] += $amount - $no_transact_in[$nick][$month];
				}
			}
		}
		return $result;		
	}
	
	public function getMinList($whId)
	{
		$result = array();
		if($this->hasRightForWh($whId))
		{
			//Alle waren je Lager			
			$query = "SELECT it.type, it.itid, i.iid, i.item, iv.minval as ivmin, iv.maxval as ivmax, 
					  itv.minval as itvmin, itv.maxval as itvmax, SUM(wi.icount) as icount, i.magical, i.producable, it.prod_equals_cap_lvl, i.weight 
					  FROM ".DB_PREFIX."items i, ".DB_PREFIX."warehouse_items wi, ".DB_PREFIX."item_values iv, ".DB_PREFIX."item_types_values itv, ".DB_PREFIX."item_types it 
					  WHERE wi.wid=".(int)$whId." and wi.iid=i.iid and i.itid=it.itid and it.itid=itv.itid
					  and itv.wid=".(int)$whId." and wi.stability IN(100,0) and i.iid=iv.iid 
					  and iv.wid=".(int)$whId."
                                          GROUP BY i.iid
					  ORDER BY it.sort,i.magical, i.lvl, i.sort";
			//echo $query;
			$res =  mysqli_query(Config::getDBConn(), $query);
			if(mysqli_num_rows($res) > 0)
			{
				$i = 0;
				while($row = mysqli_fetch_array($res))
				{
					//die werte der Einzelware wiegt h�her als die Werte der Gruppe
					if($row['ivmin'] != NULL)
						$min = $row['ivmin'];
					else 
						$min = $row['itvmin'];
					if($row['ivmax'] != NULL)
						$max = $row['ivmax'];
					else 
						$max = $row['itvmax'];
					if($row['icount'] < $min)
					{
					if($tmptype != $row['type']) { $tmptype = $row['type']; $i = 0; }
						$result[$row['type']][$i]['id'] = $row['iid'];
						$result[$row['type']][$i]['itid'] = $row['itid'];
						$result[$row['type']][$i]['item'] = $row['item'];
						$result[$row['type']][$i]['magical'] = $row['magical'];
						$result[$row['type']][$i]['producable'] = $row['producable'];
						$result[$row['type']][$i]['count'] = $row['icount']==NULL?0:$row['icount'];
						$result[$row['type']][$i]['fcount'] = number_format(($row['icount']==NULL?0:$row['icount']),0,'','.');
						
						$result[$row['type']][$i]['fminvalue'] = number_format($min,0,'','.');
						$result[$row['type']][$i]['fmaxvalue'] = number_format($max,0,'','.');
						$result[$row['type']][$i]['minvalue'] = $min;
						$result[$row['type']][$i]['maxvalue'] = $max;
						$result[$row['type']][$i]['equals'] = $row['prod_equals_cap_lvl'];
						$result[$row['type']][$i]['diff'] = number_format($min-$row['icount'],0,'','.');
					$i++;
					}
					else if(!array_key_exists($row['type'],$result))
						$result[$row['type']] = Array();
				}
			}
		}
		return $result;
	}
	
	public function getMaxList($whId)
	{
		$result = array();
		if($this->hasRightForWh($whId))
		{
			//Alle waren je Lager			
			$query = "SELECT it.type, it.itid, i.iid, i.item, iv.minval as ivmin, iv.maxval as ivmax, i.realvalue, i.marketvalue,  
					  itv.minval as itvmin, itv.maxval as itvmax, SUM(wi.icount) as icount, i.magical, i.producable, it.prod_equals_cap_lvl, i.weight 
					  FROM ".DB_PREFIX."items i, ".DB_PREFIX."warehouse_items wi, ".DB_PREFIX."item_values iv, ".DB_PREFIX."item_types_values itv, ".DB_PREFIX."item_types it 
					  WHERE wi.wid=".(int)$whId." and wi.iid=i.iid and i.itid=it.itid and it.itid=itv.itid
					  and itv.wid=".(int)$whId." and wi.stability IN(100,0) and i.iid=iv.iid 
					  and iv.wid=".(int)$whId."
                                          GROUP BY i.iid
					  ORDER BY it.sort,i.magical, i.lvl, i.sort";
			//echo $query;
			$res =  mysqli_query(Config::getDBConn(), $query);
			if(mysqli_num_rows($res) > 0)
			{
				$i = 0; $tmptype = "";
				while($row = mysqli_fetch_array($res))
				{
					//die werte der Einzelware wiegt h�her als die Werte der Gruppe
					if($row['ivmin'] != NULL)
						$min = $row['ivmin'];
					else 
						$min = $row['itvmin'];
					if($row['ivmax'] != NULL)
						$max = $row['ivmax'];
					else 
						$max = $row['itvmax'];
					if($row['icount'] > $max)
					{	
						if($tmptype != $row['type']) { $tmptype = $row['type']; $i = 0; }
						$result[$row['type']][$i]['id'] = $row['iid'];
						$result[$row['type']][$i]['itid'] = $row['itid'];
						$result[$row['type']][$i]['item'] = $row['item'];
						$result[$row['type']][$i]['magical'] = $row['magical'];
						$result[$row['type']][$i]['producable'] = $row['producable'];
						$result[$row['type']][$i]['count'] = $row['icount']==NULL?0:$row['icount'];
						$result[$row['type']][$i]['fcount'] = number_format(($row['icount']==NULL?0:$row['icount']),0,'','.');
						
						$result[$row['type']][$i]['fminvalue'] = number_format($min,0,'','.');
						$result[$row['type']][$i]['fmaxvalue'] = number_format($max,0,'','.');
						$result[$row['type']][$i]['minvalue'] = $min;
						$result[$row['type']][$i]['maxvalue'] = $max;
						$result[$row['type']][$i]['equals'] = $row['prod_equals_cap_lvl'];
						$result[$row['type']][$i]['diff'] = number_format($row['icount']-$max,0,'','.');
						
						$i++;
					}
					else if(!array_key_exists($row['type'],$result))
						$result[$row['type']] = Array();
				}
			}
		}
		
		return $result;
	}
        
        /**
         * Returns a list of used items where stability is between $from and $to
         * @param type $whId
         * @param type $from
         * @param type $to
         * @return array
         */
        public function getScrapList($whId, $from = 1, $to = 99)
	{
		$result = array();
                // check for valid input
                if($from < 1) $from = 1;
                if($to > 99) $to = 99;
                if($from > $to) {
                    // change values of variables with xor
                    $from ^= $to;
                    $to ^= $from;
                    $from ^= $to;
                }
                
		if($this->hasRightForWh($whId))
		{
			//Alle waren je Lager			
			$query = "SELECT it.type, it.itid, i.iid, i.item, i.realvalue, i.marketvalue, SUM(wi.icount) as icount, i.magical, i.producable, it.prod_equals_cap_lvl, i.weight 
                                FROM ".DB_PREFIX."warehouse_items wi
                                JOIN ".DB_PREFIX."items i ON i.iid=wi.iid and wi.wid=".(int)$whId." and wi.stability BETWEEN ".$from." AND ".$to." 
                                RIGHT JOIN ".DB_PREFIX."item_types it ON it.itid=i.itid 
                                GROUP BY it.itid, i.iid  
                                ORDER BY it.sort, i.magical, i.lvl, i.sort ";
			//echo $query;
			$res =  mysqli_query(Config::getDBConn(), $query);
			if(mysqli_num_rows($res) > 0)
			{
				$i = 0; $tmptype = "";
				while($row = mysqli_fetch_array($res))
				{	
                                    if($row['icount'] > 0)
                                    {
                                        if($tmptype != $row['type']) { $tmptype = $row['type']; $i = 0; }
                                        $result[$row['type']][$i]['id'] = $row['iid'];
                                        $result[$row['type']][$i]['itid'] = $row['itid'];
                                        $result[$row['type']][$i]['item'] = $row['item'];
                                        $result[$row['type']][$i]['magical'] = $row['magical'];
                                        $result[$row['type']][$i]['producable'] = $row['producable'];
                                        $result[$row['type']][$i]['count'] = $row['icount']==NULL?0:$row['icount'];
                                        $result[$row['type']][$i]['fcount'] = number_format(($row['icount']==NULL?0:$row['icount']),0,'','.');
                                        $result[$row['type']][$i]['equals'] = $row['prod_equals_cap_lvl'];
                                        $i++;
                                    }
                                    else if(!array_key_exists($row['type'],$result))
                                            $result[$row['type']] = Array();
				}
			}
		}
		
		return $result;
	}
	
	public function addWh($name, $guild, $parent, $world, $type)
	{
		$result = false;

		$query = "INSERT INTO ".DB_PREFIX."warehouse(name, ownerguild, parent, inidate, world, type) "
                        . "VALUES('".getStringForDb($name)."', ".(int)$guild.", ".(int)$parent.", NOW(), ".(int)$world.", ".(int)$type.")";
		// Lager leer initialisieren
		if( mysqli_query(Config::getDBConn(), $query))
		{
			$whId = mysqli_insert_id(Config::getDBConn());
			$this->iniWh($whId);
			$query1 = "INSERT INTO ".DB_PREFIX."item_values(iid, wid) 
			                SELECT iid, ".$whId." as wid 
			                    FROM ".DB_PREFIX."items_world 
			                    WHERE world=".(int)$world;
			$query2 = "INSERT INTO ".DB_PREFIX."item_types_values(itid, wid, minval, maxval) 
			                SELECT itid, ".$whId." as wid, 0 as minval, 0 as maxval 
			                FROM ".DB_PREFIX."item_types_world 
			                WHERE world=".(int)$world;
			if( mysqli_query(Config::getDBConn(), $query1) &&  mysqli_query(Config::getDBConn(), $query2))
				$result = true;
		}
		return $result;
	}
	
	public function renameWh($name, $whId, $guId, $parent, $world, $type)
	{
		$result = false;
		$query = "UPDATE ".DB_PREFIX."warehouse set name='".getStringForDb($name)."', ownerguild=".(int)$guId.", "
                        . "parent=".(int)$parent.", world=".(int)$world.", type=".(int)$type." where wid=".(int)$whId;

		if( mysqli_query(Config::getDBConn(), $query))
			$result = true;
		return $result;
	}
	
	public function delWh($whId)
	{
		$result = false;
		$query1 = "DELETE FROM ".DB_PREFIX."warehouse WHERE wid=".(int)$whId;
		$query2 = "DELETE FROM ".DB_PREFIX."item_values WHERE wid=".(int)$whId;
		$query3 = "DELETE FROM ".DB_PREFIX."item_types_values WHERE wid=".(int)$whId;
		if( mysqli_query(Config::getDBConn(), $query1) &&  mysqli_query(Config::getDBConn(), $query2) &&  mysqli_query(Config::getDBConn(), $query3))
			$result = true;
		return $result;
	}
	
	public function getUsersForItem($iid, $item, $magical = 0, $producable = 0, $equals = 0)
	{//echo $item;
		$result = array();
		//$prod = ($producable?'-1':'');
		$prod = ($equals?'':'-1');
		//alle nutzer die die Ware herstellen k�nnen
		//lvl -1
		if($magical && $producable)					//magisch und produzierbar
		$query = "SELECT g.short, u.nick, i.item, c.capability, uc.value, u.nowork, uc.mainwork
				  FROM ".DB_PREFIX."capabilities c, ".DB_PREFIX."users u, ".DB_PREFIX."items i, ".DB_PREFIX."users_capabilities uc, ".DB_PREFIX."user_plans up,
				  ".DB_PREFIX."guilds_user gu, ".DB_PREFIX."guilds g 
				  WHERE uc.cid=c.cid and i.cid=uc.cid and uc.uid=u.uid and uc.value>0 
				  	and i.iid=".(int)$iid." and uc.value>=(i.lvl-1) and up.uid=u.uid and up.realiid=i.iid and u.uid=gu.uid and gu.guid=g.guid
				  ORDER BY u.nowork, uc.mainwork DESC, uc.value";
		else if(strlen(strstr($item,'(Plan)'))>0)	//Pl�ne
		$query = "SELECT g.short, u.nick, i.item, c.capability, uc.value, u.nowork, uc.mainwork  
				  FROM ".DB_PREFIX."capabilities c, ".DB_PREFIX."users u, ".DB_PREFIX."items i, ".DB_PREFIX."users_capabilities uc, ".DB_PREFIX."user_plans up,
				  ".DB_PREFIX."guilds_user gu, ".DB_PREFIX."guilds g  
				  WHERE uc.cid=c.cid and i.cid=uc.cid and uc.uid=u.uid
				  	and i.iid=".(int)$iid." and up.iid=".(int)$iid." and up.uid=u.uid and u.uid=gu.uid and gu.guid=g.guid
				  ORDER BY u.nowork, uc.mainwork DESC, uc.value";
		else										//normale waren
		$query = "SELECT g.short, u.nick, i.item, c.capability, uc.value, u.nowork, uc.mainwork  
				  FROM ".DB_PREFIX."capabilities c, ".DB_PREFIX."users u, ".DB_PREFIX."items i, ".DB_PREFIX."users_capabilities uc,
				  ".DB_PREFIX."guilds_user gu, ".DB_PREFIX."guilds g
				  WHERE uc.cid=c.cid and i.cid=uc.cid and uc.uid=u.uid and uc.value>0 and i.iid=".(int)$iid."
				  		and uc.value>=(i.lvl".$prod.") and u.uid=gu.uid and gu.guid=g.guid
				  ORDER BY u.nowork, uc.mainwork DESC, uc.value";
		
		//echo $query;
		$res =  mysqli_query(Config::getDBConn(), $query);
		if(mysqli_num_rows($res) > 0)
		{
			$i = 0;
			while($row = mysqli_fetch_array($res))
			{
				$nick = $row['nick']." [".$row['short']."]";
				$result[$row['capability']][$i]['nick']= $nick;
				$result[$row['capability']][$i]['value'] = $row['value'];
				$result[$row['capability']][$i]['nowork'] = $row['nowork'];
				$result[$row['capability']][$i]['mainwork'] = $row['mainwork'];
				$i++;
			}			
		}
		return $result;		
	}
	
	public function getWhPrice($whId)
	{
		 mysqli_query(Config::getDBConn(), "CALL getWarehousePrice(".(int)$whId.",@total, @weight)");
		$res =  mysqli_query(Config::getDBConn(), "SELECT @total as total, @weight as weight");
		$res = mysqli_fetch_array($res);
		$ret = array();
		$ret[0] = number_format($res['total'],0,'','.');
		$ret[1] = number_format($res['weight'],0,'','.');
		return $ret;
	}
	
	public function getWhTypePrice($whId, $tId)
	{
		 mysqli_query(Config::getDBConn(), "CALL getWarehouseTypePrice(".(int)$whId.", ".(int)$tId.", @total, @weight)");
		$res =  mysqli_query(Config::getDBConn(), "SELECT @total as total, @weight as weight");
		$res = mysqli_fetch_array($res);
		$ret = array();
		$ret[0] = number_format($res['total'],0,'','.');
		$ret[1] = number_format($res['weight'],2,',','.');
		$ret[2] = $res['total'];
		$ret[3] = $res['weight'];
		return $ret;
	}
	
	public function getMinMax($whId)
	{
		 mysqli_query(Config::getDBConn(), "CALL getMinMax(".(int)$whId.", @total1, @weight1, @total2, @weight2)");
		$res =  mysqli_query(Config::getDBConn(), "SELECT @total1 as total1, @weight1 as weight1, @total2 as total2, @weight2 as weight2");
		$res = mysqli_fetch_array($res);
		$ret = array();
		$ret[0] = number_format($res['total1'],0,'','.');
		$ret[1] = number_format($res['weight1'],2,',','.');
		$ret[2] = number_format($res['total2'],0,'','.');
		$ret[3] = number_format($res['weight2'],2,',','.');
		return $ret;
	}
	
	public function getMinMaxType($whId, $tid)
	{
		 mysqli_query(Config::getDBConn(), "CALL getMinMaxType(".(int)$whId.", ".(int)$tid.",@total1, @weight1, @total2, @weight2)");
		$res =  mysqli_query(Config::getDBConn(), "SELECT @total1 as total1, @weight1 as weight1, @total2 as total2, @weight2 as weight2");
		$res = mysqli_fetch_array($res);
		$ret = array();
		$ret[0] = number_format($res['total1'],0,'','.');
		$ret[1] = number_format($res['weight1'],2,',','.');
		$ret[2] = number_format($res['total2'],0,'','.');
		$ret[3] = number_format($res['weight2'],2,',','.');
		
		$ret[4] = $res['total1'];
		$ret[5] = $res['weight1'];
		$ret[6] = $res['total2'];
		$ret[7] = $res['weight2'];
		return $ret;
	}
	
	public function getItem($iid, $whId)
	{
		$result = array();
		//Alle waren je Lager			
		$query = "SELECT i.lvl, it.type, it.itid, i.iid, i.item, iv.minval as ivmin, iv.maxval as ivmax, i.marketvalue, i.realvalue,
				  itv.minval as itvmin, itv.maxval as itvmax,wi.icount, i.magical, i.producable, it.prod_equals_cap_lvl,
				  i.dmgmin, i.dmgmax, i.effect, i.armor, i.absorb, i.handicap, i.speed, i.accuracy, i.blockabsorb, i.critical, 
                                  i.rel_min, i.rel_max                                  
				  FROM ".DB_PREFIX."items i, ".DB_PREFIX."warehouse_items wi, ".DB_PREFIX."item_values iv, ".DB_PREFIX."item_types_values itv, ".DB_PREFIX."item_types it 
				  WHERE i.iid=".(int)$iid." and i.itid=it.itid and wi.wid=".(int)$whId." and wi.iid=i.iid  and it.itid=itv.itid
				  and itv.wid=".(int)$whId." and i.iid=iv.iid and iv.wid=".(int)$whId;
		//echo $query;
		$res =  mysqli_query(Config::getDBConn(), $query);
		if(mysqli_num_rows($res) > 0)
		{
			$i = 0;
			$row = mysqli_fetch_array($res);
			//die werte der Einzelware wiegt h�her als die Werte der Gruppe
			if($row['ivmin'] != NULL)
				$min = $row['ivmin'];
			else 
				$min = $row['itvmin'];
			if($row['ivmax'] != NULL)
				$max = $row['ivmax'];
			else 
				$max = $row['itvmax'];

			$result['id'] = $row['iid'];
			$result['itid'] = $row['itid'];
			$result['lvl'] = $row['lvl'];
			$result['item'] = $row['item'];
			$result['market'] = number_format($row['marketvalue'],0,'','.');
			$result['real'] = number_format($row['realvalue'],0,'','.');
			$result['type'] = $row['type'];
			$result['magical'] = $row['magical'];
			$result['producable'] = $row['producable'];
			$result['count'] = $row['icount']==NULL?0:$row['icount'];
			$result['fcount'] = number_format(($row['icount']==NULL?0:$row['icount']),0,'','.');
			$result['dmgmin'] = $row['dmgmin'];
			$result['dmgmax'] = $row['dmgmax'];
			$result['effect'] = $row['effect'];
			$result['armor'] = $row['armor'];
			$result['absorb'] = $row['absorb'];
			$result['handicap'] = $row['handicap'];
			$result['speed'] = $row['speed'];
			$result['accuracy'] = $row['accuracy'];
			$result['blockabsorb'] = $row['blockabsorb'];
                        $result['critical'] = $row['critical'];
                        $result['rel_min'] = $row['rel_min'];
                        $result['rel_max'] = $row['rel_max'];  // in %
			
			$result['fminvalue'] = number_format($min,0,'','.');
			$result['fmaxvalue'] = number_format($max,0,'','.');
			$result['minvalue'] = $min;
			$result['maxvalue'] = $max;
			$result['equals'] = $row['prod_equals_cap_lvl'];
			$result['diff'] = number_format($min-$row['icount'],0,'','.');			
		}
		return $result;
	}
	
	public function sortPlans($plans)
	{
		$weaponsArray = Array(); $armorArray = Array(); 
		$res = array();
		for($i=0;$i<count($plans);$i++)
		{
			if(in_array($plans[$i]['cid'], $this->armorcaps))
				array_push($armorArray, $plans[$i]);
			else
				array_push($weaponsArray, $plans[$i]);
		}
		//if(count($fightArray)>0)	array_push($fightArray, Array("id"=>"","name"=>"","lvl"=>"","active"=>""));
		//if(count($armorArray)>0)	array_push($armorArray, Array("id"=>"","name"=>"","lvl"=>"","active"=>""));
		//arrays zusammenf�gen
		$res = array_merge($weaponsArray, $armorArray);
		
		
		return $res;
	}
	
	public function loadIniNoWhTransactUsers()
	{
		unset($this->no_wh_transact);
		unset($this->no_wh_transact_nicks);
		$this->no_wh_transact = array();
		$this->no_wh_transact_nicks = array();
		
		//alle nutzer holen, die beim Protokoll nicht in die summe der transaktionen eingehen sollen (lagerverwalter z.bsp.)
		$query = "SELECT u.nick, u.uid FROM ".DB_PREFIX."config, ".DB_PREFIX."users u WHERE set_key='nowhtransact' and value=u.uid";
		//echo $query;
		$qry =  mysqli_query(Config::getDBConn(), $query);
		
		if(mysqli_num_rows($qry) > 0)
		{
			$i = 0;
			while($row = mysqli_fetch_array($qry))
			{
				$this->no_wh_transact[$i]['nick'] = $row['nick'];
				$this->no_wh_transact[$i]['uid'] = $row['uid'];
				$this->no_wh_transact_nicks[] = $row['nick'];
				$i++;
			}
		}
	}
	
	public function saveNoWhTransactUser($uId)
	{
		$query =  mysqli_query(Config::getDBConn(), "INSERT INTO ".DB_PREFIX."config VALUES('nowhtransact', ".(int)$uId.")");
		if($query)		return true;
		else			return false;
	}
	
	public function delNoWhTransactUser($uId)
	{
		$query =  mysqli_query(Config::getDBConn(), "DELETE FROM ".DB_PREFIX."config WHERE set_key='nowhtransact' and value='".(int)$uId."'");
		if($query)		return true;
		else			return false;
	}
	
	public function getChronic($iid, $whid, $period = 0)
	{
		$result = array('Entnahme'=>Array(), 'Einlagerung'=>Array());
		//Die Chronic welcher Nutzer die Ware eingelagert/ausgelagert hat	
		if($period > 0)//Die letzten $period Tage
			$query = "SELECT nick, SUM(icount) as sumicount, type 
					  FROM egtool_warehouse_protocoll wp 
					  JOIN egtool_warehouse_protocoll_entry wpe ON wp.wid=".(int)$whid." and wpe.iid=".(int)$iid." and wpe.wpid=wp.wpid
					  WHERE DATEDIFF(NOW(), date)<=".(int)$period."
					  GROUP BY nick, type
					  ORDER BY type DESC, sumicount DESC";
		else	//Gesamt
			$query = "SELECT nick, SUM(icount) as sumicount, type 
					  FROM egtool_warehouse_protocoll wp 
					  JOIN egtool_warehouse_protocoll_entry wpe ON wp.wid=".(int)$whid." and wpe.iid=".(int)$iid." and wpe.wpid=wp.wpid
					  GROUP BY nick, type
					  ORDER BY type DESC, sumicount DESC";
		//echo $query;
		$res =  mysqli_query(Config::getDBConn(), $query);
                $totalIn = 0;
                $totalOut = 0;
		if(mysqli_num_rows($res) > 0)
		{
			$i = 0; $nowh = array('Entnahme'=>Array(), 'Einlagerung'=>Array());
			$tmptype = "";
			while($row = mysqli_fetch_array($res))
			{
				//bei typwechsel, zur�cksetzen
				if($tmptype != $row['type']) { $tmptype = $row['type']; $i = 0; }
				$isNoWhTransactUser = in_array($row['nick'], $this->getNoWhTransactNicks());
                                if(!$isNoWhTransactUser) {
                                    if($tmptype == 'Einlagerung') {
                                        $totalIn += $row['sumicount'];
                                    } else if($tmptype == 'Entnahme') {
                                        $totalOut += $row['sumicount'];
                                    }
                                }
				//je Typ nur 8 Personen anzeigen
				if($i >= 8)	continue;
				if($isNoWhTransactUser)
				{	
					$nowh[$row['type']][$row['nick']] = $row['sumicount'];
					continue;
				}
				$result[$row['type']][$i]['nick'] = $row['nick'];
				$result[$row['type']][$i]['sum'] = number_format($row['sumicount'],0,'','.');
				$i++;
			}
			//jetzt die nowh personen durchgehen
			if(isset($nowh['Entnahme']))
			foreach($nowh['Entnahme'] as $name=>$value)
			{
				//differenz ermitteln
				if(isset($nowh['Einlagerung']) && array_key_exists($name, $nowh['Einlagerung']))
				{
					$sum = 0; $t;
					//wenn Entnahme gr��er Einlagerung ist
					if($value > $nowh['Einlagerung'][$name])
					{
						$t = 'Entnahme';
						$sum = $value - $nowh['Einlagerung'][$name];
					}
					else if($value < $nowh['Einlagerung'][$name])
					{
						$t = 'Einlagerung';
						$sum = $nowh['Einlagerung'][$name] - $value;
					}
					else	//wo die differenz 0 ergibt
						continue;
				}
				else //wenn es nur entnahmen gibt
				{
					$t = 'Entnahme';
					$sum = $value;
				}
				
				$newinp = Array('nick'=>$name, 'sum'=>number_format($sum,0,'','.'));
                                
                                // f�ge summer zur gesamtsumme hinzu
                                if($t == 'Einlagerung') {
                                    $totalIn += $sum;
                                } else if($t == 'Entnahme') {
                                    $totalOut += $sum;
                                }
                                    
				$k = 0; $ins = false;
				//f�ge person an die passende Stelle im array
				foreach($result[$t] as $row)
				{
					if((int)str_replace(".", "", $row['sum']) <= $sum)
					{
						array_splice($result[$t], $k, 0, Array($newinp));
						$ins = true;
						break;
					}
					$k++;
				}
				//Wenn noch nicht eingef�gt, dann ans Ende des Array einf�gen
				if(!$ins)
					array_splice($result[$t], $k, 0, Array($newinp));			
			}
			//jetzt noch alle die, die nur Eingelagert haben
			if(isset($nowh['Einlagerung']))
			foreach($nowh['Einlagerung'] as $name=>$value)
			{
				//wenn Name nicht im anderen Array ist
				if(!array_key_exists($name, $nowh['Entnahme']))
				{
					$newinp = Array('nick'=>$name, 'sum'=>number_format($value,0,'','.'));
					$k = 0;	$t = 'Einlagerung'; $ins = false;
					//f�ge person an die passende Stelle
					foreach($result[$t] as $row)
					{
						if((int)str_replace(".", "", $row['sum']) <= $value)
						{
							array_splice($result[$t], $k, 0, Array($newinp));
							$ins = true;
							break;
						}
						$k++;
					}
					//Wenn noch nicht eingef�gt, dann ans Ende des Array einf�gen
					if(!$ins)
					array_splice($result[$t], $k, 0, Array($newinp));	
                                        
                                        // f�ge summer zur gesamtsumme hinzu
                                        if($t == 'Einlagerung') {
                                            $totalIn += $value;
                                        } else if($t == 'Entnahme') {
                                            $totalOut += $value;
                                        }
				}								
			}
		}
                $result['totalIn'] = number_format($totalIn,0,'','.');
                $result['totalOut'] = number_format($totalOut,0,'','.');
		return $result;
	}
	
	public function getWHsByReadRight()
	{
		$result = Array();
		
		//Warehouse laut Nutzerrecht holen
		$query = "SELECT DISTINCT w.wid, w.name, DATE_FORMAT(inidate, '%d.%m.%Y %H:%i') as inidate, g.guid, g.name as gname, g.short, 
                                    w.parent, w.world, w.type
				  FROM ".DB_PREFIX."warehouse w
				  LEFT JOIN ".DB_PREFIX."guilds g ON g.guid=w.ownerguild
				  JOIN ".DB_PREFIX."warehouse_group_rights wgr ON w.wid=wgr.wid
				  LEFT JOIN ".DB_PREFIX."groups_user gu ON wgr.gid=gu.gid
				  LEFT JOIN ".DB_PREFIX."groups_guild gg ON wgr.gid=gg.gid
				  LEFT JOIN ".DB_PREFIX."guilds_user ggu ON ggu.guid=gg.guid
				  WHERE ((gu.uid=".$this->user->getUId().") or (ggu.uid=".$this->user->getUId().")) and wgr.canread=1
				  ORDER BY w.wid ASC";
		//echo $query;
		$qry =  mysqli_query(Config::getDBConn(), $query);
		
		$i = 0;
		while($row = mysqli_fetch_array($qry))
		{
			$result[$i]['wid'] = $row['wid'];
			$result[$i]['name'] = $row['name'];
			$result[$i]['ini'] = $row['inidate'];
			$result[$i]['guid'] = $row['guid'];
			$result[$i]['gname'] = $row['gname'];
			$result[$i]['short'] = $row['short'];
			$result[$i]['parent'] = $row['parent'];
                        $result[$i]['world'] = $row['world'];
                        $result[$i]['type'] = $row['type'];
			$i++;
		}
		
		return $result;
	}
	
	public function getWHsByWriteRight()
	{
		$result = Array();
		
		//Warehouse laut Nutzerrecht holen
		$query = "SELECT DISTINCT w.wid, w.name, DATE_FORMAT(inidate, '%d.%m.%Y %H:%i') as inidate, g.guid, g.name as gname, g.short, 
                                    w.parent, w.world, w.type
				  FROM ".DB_PREFIX."warehouse w
				  LEFT JOIN ".DB_PREFIX."guilds g ON g.guid=w.ownerguild
				  JOIN ".DB_PREFIX."warehouse_group_rights wgr ON w.wid=wgr.wid
				  LEFT JOIN ".DB_PREFIX."groups_user gu ON wgr.gid=gu.gid
				  LEFT JOIN ".DB_PREFIX."groups_guild gg ON wgr.gid=gg.gid
				  LEFT JOIN ".DB_PREFIX."guilds_user ggu ON ggu.guid=gg.guid
				  WHERE ((gu.uid=".$this->user->getUId().") or (ggu.uid=".$this->user->getUId().")) and wgr.canwrite=1
				  ORDER BY w.wid ASC";
		//echo $query;
		$qry =  mysqli_query(Config::getDBConn(), $query);
		
		$i = 0;
		while($row = mysqli_fetch_array($qry))
		{
			$result[$i]['wid'] = $row['wid'];
			$result[$i]['name'] = $row['name'];
			$result[$i]['ini'] = $row['inidate'];
			$result[$i]['guid'] = $row['guid'];
			$result[$i]['gname'] = $row['gname'];
			$result[$i]['short'] = $row['short'];
			$result[$i]['parent'] = $row['parent'];
                        $result[$i]['world'] = $row['world'];
                        $result[$i]['type'] = $row['type'];
			$i++;
		}
		
		return $result;
	}
	
	public function canAccess($whs, $postwh)
	{
		if(is_array($whs))
		{
			foreach($whs as $wh)
			{
				if($wh['wid'] == $postwh)
					return true;
			}
		}
		return false;
	}
	
	public function getYears()
	{
		$result = Array();
		
		$query = "SELECT DISTINCT YEAR(date) FROM ".DB_PREFIX."warehouse_protocoll ORDER BY YEAR(date) DESC";
		$qry_y =  mysqli_query(Config::getDBConn(), $query);	
	

		while($row = mysqli_fetch_row($qry_y))
		{
			$result[] = $row[0];
		}
		
		return $result;
	}
	
	public function updateWarehouseItem($wiid, $amount, $whId)
	{
		$squery = "SELECT wiid, icount FROM ".DB_PREFIX."warehouse_items WHERE wiid=".(int)$wiid." and wid=".(int)$whId;
		$res =  mysqli_query(Config::getDBConn(), $squery);

		//wenn item existiert
		if(mysqli_num_rows($res) == 1)
		{
			$res = mysqli_fetch_array($res);
			$wiid = $res['wiid'];
			$icount = $res['icount'];
			$number = $icount+$amount;
			$number = ($number >= 0 ? $number : 0); //0
			$query = "UPDATE ".DB_PREFIX."warehouse_items SET icount=".$number." WHERE wiid=".(int)$wiid;
			if( mysqli_query(Config::getDBConn(), $query))
				return $number;
			else 	
				return -1;
		}
		return -1;
	}
	public function getMonths()
	{
		$result = Array();
		
		$query = "SELECT DISTINCT MONTH(date) FROM ".DB_PREFIX."warehouse_protocoll ORDER BY MONTH(date) ASC";
		$qry_m =  mysqli_query(Config::getDBConn(), $query);	
	

		while($row = mysqli_fetch_row($qry_m))
		{
			$result[] = $row[0];
		}
		
		return $result;
	}
	
	// Liefert den Wert des Schrotts f�r ein Lager
	public function getScrapAmount($whId, $from = 1, $to = 99)
	{
            // check for valid input
                if($from < 1) $from = 1;
                if($to > 99) $to = 99;
                if($from > $to) {
                    // switch values of variables with xor
                    $from ^= $to;
                    $to ^= $from;
                    $from ^= $to;
                }
		$squery = "SELECT SUM(wi.icount*i.marketvalue*(wi.stability/100)*0.5) as val 
				   FROM egtool_warehouse_items wi, egtool_items i 
				   WHERE wi.wid=".(int)$whId." and wi.icount>0 and wi.stability BETWEEN ".$from." and ".$to." and i.iid=wi.iid";
		$res =  mysqli_query(Config::getDBConn(), $squery);

		//wenn ein Wert zur�ck kommt
		if(mysqli_num_rows($res) == 1)
		{
			$res = mysqli_fetch_array($res);
			return number_format((int)$res['val'],0,'','.');
		}
		return 0;
	}
	
	public function getNoWhTransactUsers()		{ return $this->no_wh_transact; }
	public function getNoWhTransactNicks()		{ return $this->no_wh_transact_nicks; }
}
