<?php

interface Graphfunctions 
{
	public function execute($parser, $token);
}

/*****************************/
/****** Aktionen: block ******/
/*****************************/
class bl1 implements Graphfunctions
{
	// Timestamp zwischenspeichern
	public function execute($parser, $token) 
	{
		$parser->timestamp = $token->value;
	}	
}

class bl2 implements Graphfunctions
{
	// Wer fhrt die Aktion aus zwischenspeichern
	public function execute($parser, $token) 
	{
		$parser->who = $token->value;
	}	
}

class bl3 implements Graphfunctions
{
	// Gebude wurde errichtet
	public function execute($parser, $token) 
	{
		$c = count($parser->buildingList);
		$parser->buildingList[$c] = Array();
		$parser->buildingList[$c]['date'] = $parser->timestamp;
		$parser->buildingList[$c]['nick'] = $parser->who;
		$parser->buildingList[$c]['building'] = $token->value;
	}	
}

class bl4 implements Graphfunctions
{
	// Aktion: Baumeister Entnahme
	public function execute($parser, $token) 
	{
		$c = count($parser->whList);
		$parser->whList[$c]['date'] = $parser->timestamp;
		$parser->whList[$c]['name'] = $token->value;
		$parser->whList[$c]['action'] = 'Entnahme';
		$parser->whList[$c]['guild'] = ''; // Platzhalter anlegen
		$parser->whList[$c]['items'] = Array();
        $parser->whList[$c]['item_guild'] = Array();
	}	
}

/*****************************/
/****** Aktionen: action ******/
/*****************************/
class a1 implements Graphfunctions
{
	// Aktion: Entnahme/Einlagerung speichern
	public function execute($parser, $token) 
	{
		$c = count($parser->whList);
		$parser->whList[$c]['date'] = $parser->timestamp;
		$parser->whList[$c]['name'] = $parser->who;
		$parser->whList[$c]['action'] = $token->value;
		$parser->whList[$c]['guild'] = ''; // Platzhalter anlegen
		$parser->whList[$c]['items'] = Array();
	}	
}

class a2 implements Graphfunctions
{
	// Gilde speichern
	public function execute($parser, $token) 
	{
		$c = count($parser->whList);
		$parser->whList[$c-1]['guild'] = $token->value;
	}	
}

class a3 implements Graphfunctions
{
	// Umbuchungen
	public function execute($parser, $token) 
	{
		$c = count($parser->transferList);
		$parser->transferList[$c]['name'] = $parser->who;
		$parser->transferList[$c]['transfercity'] = (int)$parser->amountCity;
		$parser->transferList[$c]['date'] = $parser->timestamp;
		$parser->transferList[$c]['type'] = 'Umbuchung';
		$parser->transferList[$c]['guild'] = '';
		$parser->amountCity = '';
	}	
}

class a4 implements Graphfunctions
{
    // Aktion: Marktstand Kauf durch Kunden, hier fehlt "Entnahme" im Protokoll
    public function execute($parser, $token) 
    {
        $c = count($parser->whList);
        $parser->whList[$c]['date'] = $parser->timestamp;
        $parser->whList[$c]['name'] = $parser->who;
        $parser->whList[$c]['action'] = "Entnahme";
        $parser->whList[$c]['guild'] = ''; // Platzhalter anlegen
        $parser->whList[$c]['items'] = Array();
    }	
}

/*****************************/
/****** Aktionen: steuer *****/
/*****************************/

class s1 implements Graphfunctions
{
	// Steuern
	public function execute($parser, $token) 
	{
		$c = count($parser->transferList);
		$parser->transferList[$c]['name'] = $parser->who;
		$parser->transferList[$c]['transfercity'] = (int)$parser->amountCity;
		$parser->transferList[$c]['date'] = $parser->timestamp;
		$parser->transferList[$c]['type'] = 'Steuer';
		$parser->transferList[$c]['guild'] = $parser->guild;
		$parser->amountCity = '';
		$parser->guild = '';
	}	
}

class s2 implements Graphfunctions
{
	// Umbuchungen
	public function execute($parser, $token) 
	{
		$parser->guild = $token->value;
	}	
}

/****************************/
/****** Aktionen: ware ******/
/****************************/
class w1 implements Graphfunctions
{
	// Anzahl zwischenspeichern (Item stapelbar)
	public function execute($parser, $token) 
	{
		$parser->amount = (int)$token->value;
                $parser->increment = 0;
                $parser->stability = 0;
                $parser->sellPrice = 0;
	}	
}

class w2 implements Graphfunctions
{
	// Name zwischenspeichern (Item stapelbar)
	public function execute($parser, $token) 
	{
		if(strlen(strstr($token->value,' der ')) > 0 || strlen(strstr($token->value,' des ')) > 0) {
			$pos = strpos($token->value, ' der ') ?: strpos($token->value, ' des ');
			$item = substr($token->value,0, $pos);
		} else {
			$item = $token->value;
		}
		$parser->name = $item;
	}	
}

class w3 implements Graphfunctions
{
    // stapelbare Items
    public function execute($parser, $token) 
    {
        $c = count($parser->whList) - 1; // zuletzt hinzugefgter Eintrag 
        $tmpName = $parser->name . '('.$parser->stability.')' . $parser->increment; // unique item name

        // schauen, ob item schon in Liste ist
        if(array_key_exists($tmpName, $parser->whList[$c]['items']))
            $parser->whList[$c]['items'][$tmpName]['amount'] += $parser->amount;
        else
        {
            $parser->whList[$c]['items'][$tmpName] = Array();
            $parser->whList[$c]['items'][$tmpName]['amount'] = $parser->amount;
            $parser->whList[$c]['items'][$tmpName]['stability'] = $parser->stability;
            $parser->whList[$c]['items'][$tmpName]['item'] = $parser->name;
            $parser->whList[$c]['items'][$tmpName]['increment'] = $parser->increment;
            $parser->whList[$c]['items'][$tmpName]['sellPrice'] = $parser->sellPrice;
        }
    }	
}

class w4 implements Graphfunctions
{
    // Plne (stapelbar) bzw Stbe z.B (Feuer)
    public function execute($parser, $token) 
    {
        $parser->stability = 0;
        $parser->name.= ' ('.$token->value.')';
    }	
}

class w5 implements Graphfunctions
{
    // Name zwischenspeichern (Item mit Haltbarkeit)
    public function execute($parser, $token) 
    {
        //Verzauberungen abschneiden
		if(strlen(strstr($token->value,' der ')) > 0 || strlen(strstr($token->value,' des ')) > 0) {
			$pos = strpos($token->value, ' der ') ?: strpos($token->value, ' des ');
			$item = substr($token->value,0, $pos);
		} else {
			$item = $token->value;
		}

        $parser->name = $item;
        $parser->amount = 1;
        $parser->increment = 0;
        $parser->stability = 0;
        $parser->sellPrice = 0;
    }	
}

class w6 implements Graphfunctions
{
	// Items mit Haltbarkeit
	public function execute($parser, $token) 
	{
            $parser->stability = (int)$token->value;
	}	
}

class W7 implements Graphfunctions
{
    // 2H Waffen, 2H zu Namen wieder hinzufgen
    public function execute($parser, $token) 
    {
        $parser->name .= ' [2H]';
    }	
}

class W8 implements Graphfunctions
{
    // +X Waffen/Mun
    public function execute($parser, $token) 
    {
        $parser->increment = (int)$token->value;        
    }	
}

class W9 implements Graphfunctions
{
    // Marktstand Goldbetrag der verkauften Ware 
    public function execute($parser, $token) 
    {
        $parser->sellPrice = $token->value;   
    }	
}

/**********************************/
/****** Aktionen: baumeister ******/
/**********************************/
class bm1 implements Graphfunctions
{
	// Timestamp zwischenspeichern
	public function execute($parser, $token) 
	{
		$parser->amount = $token->value;
	}	
}

class bm2 implements Graphfunctions
{
	// Baumeister Items als normale Lagerentnahmen handhaben
	public function execute($parser, $token) 
	{
		// Gesamtanzahl an Strukturpunkten und Goldbetrag ignorieren
		if(strstr($token->value, 'Strukturpunkte') !== false || strstr($token->value, 'Gold') !== false)
			return;
		$item = substr($token->value, 0, strpos($token->value,' entnommen'));
		
		$c = count($parser->whList) - 1; // zuletzt hinzugefgter Eintrag
		$v = count($parser->whList[$c]['item_guild']);
		if(!is_array($parser->whList[$c]['items'][$item]))
			$parser->whList[$c]['items'][$item] = Array();
		
		// schauen, ob item schon in Liste ist
		if(array_key_exists($item, $parser->whList[$c]['items']))
				$parser->whList[$c]['items'][$item]['amount'] += $parser->amount;
		else
			$parser->whList[$c]['items'][$item]['amount'] = $parser->amount;
		$parser->whList[$c]['items'][$item]['stability'] = 0;
		$parser->whList[$c]['items'][$item]['item'] = $item;
		$parser->whList[$c]['item_guild'][$v]['item'] = $item;
		$parser->whList[$c]['item_guild'][$v]['amount'] = $parser->amount;
		$parser->whList[$c]['item_guild'][$v]['stability'] = 0;
	}	
}

class bm3 implements Graphfunctions
{
	// Gilde speichern
	public function execute($parser, $token) 
	{
		$c = count($parser->whList);
		$v = count($parser->whList[$c-1]['item_guild']);
		// Gilde wird hier pro Item gespeichert und nicht pro Gesamteintrag
		//$parser->whList[$c-1]['guild'] = $token->value;
		$parser->whList[$c-1]['item_guild'][$v-1]['guild'] = $token->value;
	}	
}

/*****************************/
/****** Aktionen: kasse ******/
/*****************************/
class k1 implements Graphfunctions
{
	// Minus Zeichen wird gelesen
	public function execute($parser, $token) 
	{
		$parser->amountCity = '-';
	}	
}

class k2 implements Graphfunctions
{
	// Betrag aus Gildenkasse
	public function execute($parser, $token) 
	{
		if($parser->amountCity == '-') 
			$parser->amountCity .= $token->value;
		else
			$parser->amountCity = $token->value;
	}	
}

/*****************************/
/*** Aktionen: Standgebhr ***/
/*****************************/
class g1 implements Graphfunctions
{
    public function execute($parser, $token) 
    {
        $c = count($parser->marketList);
        $parser->marketList[$c]['name'] = "Tgliche Standkosten";
        $parser->marketList[$c]['date'] = $parser->timestamp;
        $parser->marketList[$c]['type'] = 'Gebhr';
        $parser->marketList[$c]['amount'] = $token->value;

    }	
}

/*****************************/
/*** Aktionen: Wachdienst ***/
/*****************************/
class h1 implements Graphfunctions
{
    // Nutzer speichern und array initialisieren
	public function execute($parser, $token)
	{
        $c = count($parser->guardList);
        $parser->guardList[$c]['name'] = $token->value;
        $parser->guardList[$c]['date'] = $parser->timestamp;
        $parser->guardList[$c]['type'] = '';
        $parser->guardList[$c]['items'] = [];
	}
}

class h2 implements Graphfunctions
{
    // aktion speichern (z.B. Diebstahl)
    public function execute($parser, $token)
    {
        $c = count($parser->guardList);
        $parser->guardList[$c-1]['type'] = $token->value;
    }
}

class h3 implements Graphfunctions
{
    // Anzahl Ware speichern
    public function execute($parser, $token)
    {
        $parser->amount = (int)$token->value;
    }
}

class h4 implements Graphfunctions
{
    // Ware speichern
    public function execute($parser, $token)
    {
        $c = count($parser->guardList) -1 ;
        $i = count($parser->guardList[$c]['items']);
        $parser->guardList[$c]['items'][$i]['amount'] = $parser->amount;
        $parser->guardList[$c]['items'][$i]['item'] = $token->value;
    }
}
