<?php
require_once 'classes/whprotocoll/whprot.lex.php';
require_once 'classes/whprotocoll/WHBogen.class.php';
require_once 'classes/whprotocoll/WHBogenType.class.php';
require_once 'classes/whprotocoll/Status.class.php';
require_once 'classes/whprotocoll/Graphfunctions.php';
/**
 * Description of WHParser
 *
 * @author Maverick
 */
class WHParser
{
	private $bogen = [];
	private $token;
	private $lex;
	private $stream;

	public $whList = [];
	public $buildingList = [];
	public $transferList = [];
	public $timestamp;	// Zwischenspeicher
	public $who;		// Zwischenspeicher
	public $amount;		// Zwischenspeicher
	public $name;		// Zwischenspeicher
	public $amountCity; // Zwischenspeicher
	public $guild;		// Zwischenspeicher
	public $stability;      // Zwischenspeicher
	public $increment;      // Zwischenspeicher fr +x Waffen/Mun
	public $sellPrice;      // Zwischenspeicher fr Verkaufserls am Marktstand
	public $marketList = [];
	public $guardList = [];


	public function __construct($post)
	{
		// block
		$this->bogen[0] = [];		/*  Type		Val				Token			gIdx Next	Alt Func					*/
		$this->bogen[0][] = 	/* 0*/ new WHBogen(WHBogenType::Morph, '',				WHToken::TIMESTAMP,	-1,  1,  	-1, 	new bl1()); /*(0)----TS---->(1)*/
		$this->bogen[0][] = 	/* 1*/ new WHBogen(WHBogenType::Sym, 'Gebudeverfall', 	WHToken::STRING,	-1,  2,  	3,	null);      /*(1)-Gebudeverfall->(2)*/
		$this->bogen[0][] = 	/* 2*/ new WHBogen(WHBogenType::Graph, '',				-1,			5,  2,  	10,	null);      /*(2)--verfall->(2)*/
		$this->bogen[0][] = 	/* 3*/ new WHBogen(WHBogenType::Sym, 'Baumeister',		WHToken::STRING,	-1,  4,  	11,	new bl4()); /*(3)-Baumeister->(4)*/
		$this->bogen[0][] = 	/* 4*/ new WHBogen(WHBogenType::Graph, '',				-1,			6,  4,  	10,	null);      /*(4)--baumeister->(4)*/
		$this->bogen[0][] = 	/* 5*/ new WHBogen(WHBogenType::Morph, '',				WHToken::STRING,	-1,  6,  	-1, 	new bl2()); /*(5)--String-->(6)*/
		$this->bogen[0][] = 	/* 6*/ new WHBogen(WHBogenType::Morph, '',				WHToken::STRING,	-1,  10,  	7,	new bl3()); /*(6)--String-->(E) Gebude*/
		$this->bogen[0][] = 	/* 7*/ new WHBogen(WHBogenType::Graph, '',				-1,			1,  8,  	10,	null);      /*(7)--aktion-->(7)*/
		$this->bogen[0][] = 	/* 8*/ new WHBogen(WHBogenType::Graph, '',				-1,			2,  9,  	15,	null);      /*(8)---ware--->(9)*/
		$this->bogen[0][] = 	/* 9*/ new WHBogen(WHBogenType::Nil,   '',				-1,			-1,  8,		-1,	null);      /*(9)-----------(8)*/
		$this->bogen[0][] = 	/*10*/ new WHBogen(WHBogenType::End,   '',				-1,					-1,  -1,  	-1, 	null);      /*(E)--------(ENDE)*/
		$this->bogen[0][] = 	/*11*/ new WHBogen(WHBogenType::Sym, 'Tgliche Standkosten',WHToken::STRING,	-1,  12,  	13,	null); /*(11)-standkosten->(12)*/
		$this->bogen[0][] = 	/*12*/ new WHBogen(WHBogenType::Graph, '',				-1,			8,  10,  	10,	null);      /*(12)--standkosten->(E)*/
		$this->bogen[0][] = 	/*13*/ new WHBogen(WHBogenType::Sym, 'Wachdienst',WHToken::STRING,	-1,  14,  	5,	null); /*(13)-Wachdienst->(14)*/
		$this->bogen[0][] = 	/*14*/ new WHBogen(WHBogenType::Graph, '',				-1,			1,  10,  	10,	null);      /*(14)--wachdienst->(E)*/
		$this->bogen[0][] = 	/*15*/ new WHBogen(WHBogenType::Nil,   '',				-1,			-1,  7,		-1,	null);      /*(9)-----------(8)*/

		// aktion
		$this->bogen[1] = Array();		/*	Type		Val				Token			gIdx Next	Alt Func					*/
		$this->bogen[1][] = 	/* 0*/ new WHBogen(WHBogenType::Sym,   'Entnahme',       WHToken::ACTION,	-1,  5,  	1,new a1());	/*(0)-Entnhame->(5)*/
		$this->bogen[1][] = 	/* 1*/ new WHBogen(WHBogenType::Sym,   'Einlagerung',    WHToken::ACTION,	-1,  5,  	2,new a1());	/*(1)-Einlagerung->(5)*/
		$this->bogen[1][] = 	/* 2*/ new WHBogen(WHBogenType::Sym,   'Umbuchung',      WHToken::ACTION,	-1,  8,  	3,null);	/*(2)-Umbuchung->(8)*/
		$this->bogen[1][] = 	/* 3*/ new WHBogen(WHBogenType::Sym,   'Gebhrennderung',WHToken::ACTION,	-1, 10,  	4,null);	/*(3)-Gebhrennderung->(10)*/
		$this->bogen[1][] = 	/* 4*/ new WHBogen(WHBogenType::Graph, '',				-1,			7,  4,  	13,null);	/*(4)--steuer-->(4)*/
		$this->bogen[1][] = 	/* 5*/ new WHBogen(WHBogenType::Sym,   '[',				WHToken::SYMBOL,	-1,  6,  	9,null);	/*(5)---- [---->(6)*/
		$this->bogen[1][] = 	/* 6*/ new WHBogen(WHBogenType::Morph, '',				WHToken::STRING,	-1,  7,  	-1,new a2());	/*(6)--String-->(7)*/
		$this->bogen[1][] = 	/* 7*/ new WHBogen(WHBogenType::Sym,   ']',				WHToken::SYMBOL,	-1,  12,  	-1,null);	/*(7)---- ]---->(E)*/
		$this->bogen[1][] = 	/* 8*/ new WHBogen(WHBogenType::Graph, '',				-1,			4,  12,  	-1,new a3());	/*(8)---kasse--->(E)*/
		$this->bogen[1][] = 	/* 9*/ new WHBogen(WHBogenType::Nil,   '',				-1,			-1,  12,  	-1,null);	/*(9)--------(ENDE)*/
		$this->bogen[1][] = 	/*10*/ new WHBogen(WHBogenType::Morph, '',				WHToken::STRING,	-1,  11,  	12,null);	/*(10)--String-->(11)*/
		$this->bogen[1][] = 	/*11*/ new WHBogen(WHBogenType::Morph, '',				WHToken::NUMBER,	-1,  10,  	10,null);	/*(11)---Numb--->(10)*/
		$this->bogen[1][] = 	/*12*/ new WHBogen(WHBogenType::End,   '',				-1,			-1,  -1,  	-1,null);	/*(E)--------(ENDE)*/
		$this->bogen[1][] = 	/*13*/ new WHBogen(WHBogenType::Nil,   '',				-1,			-1, 14,  	-1,new a4());	/*(9)--------(ENDE)*/
		$this->bogen[1][] = 	/*14*/ new WHBogen(WHBogenType::Graph, '',				-1,			2, 2,  	15,null);	/*(9)--------(ENDE)*/
		$this->bogen[1][] = 	/*15*/ new WHBogen(WHBogenType::Sym,   'Entdeckte Charaktere',WHToken::ACTION,2, 16,  	-1,null);	/*(9)--------(ENDE)*/
		$this->bogen[1][] = 	/*16*/ new WHBogen(WHBogenType::Graph,   '',				-1,			9, 16,  	12,null);	/*(9)--------(ENDE)*/

		// ware
		$this->bogen[2] = Array();                /*                Type   Val                          Token                        gIdx Next        Alt Func                                        */
		$this->bogen[2][] =         /* 0*/ new WHBogen(WHBogenType::Morph, '',                                WHToken::NUMBER,        -1,  1,          5, new w1());    /*(0)---Numb--->(1)*/
		$this->bogen[2][] =         /* 1*/ new WHBogen(WHBogenType::Morph, '',                                WHToken::STRING,        -1,  19,          -1,new w2());    /*(1)--String-->(2) Item*/
		$this->bogen[2][] =         /* 2*/ new WHBogen(WHBogenType::Sym, '(',                                WHToken::SYMBOL,        -1,  3,          17, null);        /*(2)--- ( ---->(3)*/
		$this->bogen[2][] =         /* 3*/ new WHBogen(WHBogenType::Morph, '',                            WHToken::STRING,        -1,  4,          23,  new w4());    /*(3)---Plan oder Stbe (Feuer)--->(4)*/
		$this->bogen[2][] =         /* 4*/ new WHBogen(WHBogenType::Sym, ')',                                WHToken::SYMBOL,        -1,  10,          -1,null);        /*(4)--- ) ---->(E)*/
		$this->bogen[2][] =         /* 5*/ new WHBogen(WHBogenType::Morph, '',                                WHToken::STRING,        -1,  6,          -1,new w5());    /*(5)--String-->(6) Item Haltbar*/
		$this->bogen[2][] =         /* 6*/ new WHBogen(WHBogenType::Sym, '[',                                WHToken::SYMBOL,        -1,  7,          10, null);        /*(2)--- ( ---->(3)*/
		$this->bogen[2][] =         /* 7*/ new WHBogen(WHBogenType::Morph, '',                                WHToken::NUMBER,        -1,  8,          -1,null);        /*(3)---Plan--->(4) 2H*/
		$this->bogen[2][] =         /* 8*/ new WHBogen(WHBogenType::Sym, 'H',                                WHToken::STRING,        -1,  9,          -1, null);        /*(3)---Plan--->(4) 2H*/
		$this->bogen[2][] =         /* 9*/ new WHBogen(WHBogenType::Sym, ']',                                WHToken::SYMBOL,        -1,  10,          -1,new w7());    /*(4)--- ) ---->(E)*/
		$this->bogen[2][] =         /*10*/ new WHBogen(WHBogenType::Sym, '(',                                WHToken::SYMBOL,        -1,  11,          25,null);        /*(6)--- ( ---->(7)*/
		$this->bogen[2][] =         /*11*/ new WHBogen(WHBogenType::Morph, '',                                WHToken::NUMBER,        -1,  12,         -1,new w6());    /*(7)---Numb--->(8)*/
		$this->bogen[2][] =         /*12*/ new WHBogen(WHBogenType::Sym, ')',                                WHToken::SYMBOL,        -1,  15,          -1,null);        /*(8)--- ) ---->(15)*/
		$this->bogen[2][] =         /*13*/ new WHBogen(WHBogenType::Nil,   '',                                -1,                    -1,  25,          -1,new w3());    /*(13)--------(ENDE)*/
		$this->bogen[2][] =         /*14*/ new WHBogen(WHBogenType::End, '',                                -1,                      -1,  -1,          -1,null);        /*(E)--------(ENDE)*/
		$this->bogen[2][] =         /*15*/ new WHBogen(WHBogenType::Sym, '+',                                WHToken::SYMBOL,        -1,  16,          25,null);        /*(15)---- + ---->(16)*/
		$this->bogen[2][] =         /*16*/ new WHBogen(WHBogenType::Morph, '',                                WHToken::NUMBER,        -1,  25,         -1,new w8());    /*(16)---Numb--->(E)*/
		$this->bogen[2][] =         /*17*/ new WHBogen(WHBogenType::Sym, '+',                                WHToken::SYMBOL,        -1,  18,          25,null);        /*(17)---- + ---->(18)*/
		$this->bogen[2][] =         /*18*/ new WHBogen(WHBogenType::Morph, '',                                WHToken::NUMBER,        -1,  25,         -1,new w8());    /*(18)---Numb--->(E)*/
		$this->bogen[2][] =         /*19*/ new WHBogen(WHBogenType::Sym, '[',                                WHToken::SYMBOL,        -1,  20,          2, null);        /*(2)--- ( ---->(3)*/
		$this->bogen[2][] =         /*20*/ new WHBogen(WHBogenType::Morph, '',                                WHToken::NUMBER,        -1, 21,          -1,null);        /*(3)---Plan--->(4) 2H*/
		$this->bogen[2][] =         /*21*/ new WHBogen(WHBogenType::Sym, 'H',                                WHToken::STRING,        -1,  22,          -1, null);        /*(3)---Plan--->(4) 2H*/
		$this->bogen[2][] =         /*22*/ new WHBogen(WHBogenType::Sym, ']',                                WHToken::SYMBOL,        -1,  10,          -1,new w7());    /*(4)--- ) ---->(E)*/
		$this->bogen[2][] =         /*23*/ new WHBogen(WHBogenType::Morph, '',                                WHToken::NUMBER,        -1,  12,         -1,new w6());    /*(7)---Numb--->(8)*/
		$this->bogen[2][] =         /*24*/ new WHBogen(WHBogenType::Nil,   '',                                -1,                    -1,  14,          -1,new w3());    /*(13)--------(ENDE)*/
		$this->bogen[2][] =         /*25*/ new WHBogen(WHBogenType::Sym, 'fr',                               WHToken::STRING,        -1,  26,         24,null);        /*(25)---fr--->(26)*/
		$this->bogen[2][] =         /*26*/ new WHBogen(WHBogenType::Morph, '',                                WHToken::NUMBER,        -1,  27,         -1,new w9());    /*(26)---Numb--->(27)*/
		$this->bogen[2][] =         /*27*/ new WHBogen(WHBogenType::Sym, 'Gold',                              WHToken::STRING,        -1,  24,         -1,null);        /*(27)---Gold--->(E)*/

		// start
		$this->bogen[3] = Array();		/*					Type		Val					Token			gIdx Next	Alt Func					*/
		$this->bogen[3][] = 	/* 0*/ new WHBogen(WHBogenType::Graph, '',				-1,					0,  1,  	2, 	null);	/*(0)----block---->(1)*/
		$this->bogen[3][] = 	/* 1*/ new WHBogen(WHBogenType::Nil,   '',				-1,					-1,  0,  	2,		null);	/*(1)-----------(0)*/
		$this->bogen[3][] = 	/* 2*/ new WHBogen(WHBogenType::End,   '',				-1,					-1,  -1,  	-1, 	null);	/*(E)--------(ENDE)*/

		// kasse
		$this->bogen[4] = Array();		/*					Type		Val					Token			gIdx Next	Alt Func					*/
		$this->bogen[4][] = 	/* 0*/ new WHBogen(WHBogenType::Sym, 'Gildenkasse',		WHToken::STRING,	-1,  1,  	-1,		null);	/*(0)-Gildenkasse->(1)*/
		$this->bogen[4][] = 	/* 1*/ new WHBogen(WHBogenType::Sym, '-',				WHToken::STRING,	-1,  3,  	2,		null);	/*(1)---- - --->(3)*/
		$this->bogen[4][] = 	/* 2*/ new WHBogen(WHBogenType::Sym, '+',				WHToken::SYMBOL,	-1,  3,  	-1,		null);	/*(2)-----+---->(3)*/
		$this->bogen[4][] = 	/* 3*/ new WHBogen(WHBogenType::Morph, '',				WHToken::NUMBER,	-1,  4,  	-1, 	null);	/*(3)---Numb--->(4)*/
		$this->bogen[4][] = 	/* 4*/ new WHBogen(WHBogenType::Sym, 'Gold',			WHToken::STRING,	-1,  5,  	-1,		null);	/*(4)---Gold--->(5)*/
		$this->bogen[4][] = 	/* 5*/ new WHBogen(WHBogenType::Sym, 'Stadtkasse',		WHToken::STRING,	-1,  6,  	-1, 	null);	/*(5)-Stadtkasse->(6)*/
		$this->bogen[4][] = 	/* 6*/ new WHBogen(WHBogenType::Sym, '-',				WHToken::STRING,	-1,  8,  	7,		new k1());	/*(6)---- - --->(8)*/
		$this->bogen[4][] = 	/* 7*/ new WHBogen(WHBogenType::Sym, '+',				WHToken::SYMBOL,	-1,  8,  	-1,		null);	/*(7)---- + --->(8)*/
		$this->bogen[4][] = 	/* 8*/ new WHBogen(WHBogenType::Morph, '',				WHToken::NUMBER,	-1,  9,  	-1, 	new k2());	/*(8)---Numb--->(9)*/
		$this->bogen[4][] = 	/* 9*/ new WHBogen(WHBogenType::Sym, 'Gold',			WHToken::STRING,	-1,  10,  	-1,		null);	/*(9)---Gold--->(E)*/
		$this->bogen[4][] = 	/*10*/ new WHBogen(WHBogenType::End, '',				-1,					-1,  -1,  	-1, 	null);	/*(E)--------(ENDE)*/

		// verfall
		$this->bogen[5] = Array();		/*					Type		Val					Token			gIdx Next	Alt Func					*/
		$this->bogen[5][] = 	/* 0*/ new WHBogen(WHBogenType::Morph, '',				WHToken::STRING,	-1,  1,  	-1, 	null);	/*(0)--String-->(1)*/
		$this->bogen[5][] = 	/* 1*/ new WHBogen(WHBogenType::Morph, '',				WHToken::NUMBER,	-1,  2,  	-1,		null);	/*(1)---Numb--->(2)*/
		$this->bogen[5][] = 	/* 2*/ new WHBogen(WHBogenType::Sym, 'Strukturpunkte',	WHToken::STRING,	-1,  3,  	-1,		null);	/*(2)-Strukturpunkte->(E)*/
		$this->bogen[5][] = 	/* 3*/ new WHBogen(WHBogenType::End, '',				-1,					-1,  -1,  	-1, 	null);	/*(E)--------(ENDE)*/

		// baumeister
		$this->bogen[6] = Array();		/*					Type		Val					Token			gIdx Next	Alt Func					*/
		$this->bogen[6][] = 	/* 0*/ new WHBogen(WHBogenType::Morph, '',				WHToken::STRING,	-1,  1,  	2,		null);	/*(0)--String-->(1)*/
		$this->bogen[6][] = 	/* 1*/ new WHBogen(WHBogenType::Morph, '',				WHToken::NUMBER,	-1,  7,  	-1,		null);	/*(1)---Numb--->(E)*/
		$this->bogen[6][] = 	/* 2*/ new WHBogen(WHBogenType::Morph, '',				WHToken::NUMBER,	-1,  3,  	-1,		new bm1());	/*(2)---Numb--->(3)*/
		$this->bogen[6][] = 	/* 3*/ new WHBogen(WHBogenType::Morph, '',				WHToken::STRING,	-1,  4,  	-1,		new bm2());	/*(3)--String-->(E)*/
		$this->bogen[6][] = 	/* 4*/ new WHBogen(WHBogenType::Sym,   '[',				WHToken::SYMBOL,	-1,  5,  	7,		null);	/*(4)---- [---->(5)*/
		$this->bogen[6][] = 	/* 5*/ new WHBogen(WHBogenType::Morph, '',				WHToken::STRING,	-1,  6,  	-1, 	new bm3());	/*(5)--String-->(6)*/
		$this->bogen[6][] = 	/* 6*/ new WHBogen(WHBogenType::Sym,   ']',				WHToken::SYMBOL,	-1,  7,  	-1, 	null);	/*(6)---- ]---->(E)*/
		$this->bogen[6][] = 	/* 7*/ new WHBogen(WHBogenType::End, '',				-1,					-1,  -1,  	-1, 	null);	/*(E)--------(ENDE)*/

		// steuer
		$this->bogen[7][] = 	/* 0*/ new WHBogen(WHBogenType::Sym,   'Gildensteuer',                  WHToken::ACTION,	-1,  1,  	-1,		null);	/*(0)-Gildensteuer->(8)*/
		$this->bogen[7][] = 	/* 1*/ new WHBogen(WHBogenType::Sym,   '[',				WHToken::SYMBOL,	-1,  2,  	-1,		null);	/*(1)---- [---->(10)*/
		$this->bogen[7][] = 	/* 2*/ new WHBogen(WHBogenType::Morph, '',				WHToken::STRING,	-1,  3,  	-1, 	new s2());	/*(2)--String-->(11)*/
		$this->bogen[7][] = 	/* 3*/ new WHBogen(WHBogenType::Sym,   ']',				WHToken::SYMBOL,	-1,  4,  	-1, 	null);	/*(3)---- ]---->(12)*/
		$this->bogen[7][] = 	/* 4*/ new WHBogen(WHBogenType::Graph, '',				-1,					4,   5,  	-1,		new s1());	/*(4)---kasse--->(E)*/
		$this->bogen[7][] = 	/* 5*/ new WHBogen(WHBogenType::End, '',				-1,					-1,  -1,  	-1, 	null);	/*(E)--------(ENDE)*/

		// Standgebhr
		$this->bogen[8] = Array();/*                Type		Val				Token			gIdx Next	Alt Func					*/
		$this->bogen[8][] = 	/* 0*/ new WHBogen(WHBogenType::Morph,   '',                            WHToken::NUMBER,	-1,  1,  	-1, new g1());	/*(0)-Gildensteuer->(8)*/
		$this->bogen[8][] = 	/* 1*/ new WHBogen(WHBogenType::Sym,   'Gold',				WHToken::SYMBOL,	-1,  2,  	-1, null);	/*(1)---- [---->(10)*/
		$this->bogen[8][] = 	/* 2*/ new WHBogen(WHBogenType::End, '',				-1,			-1,  -1,  	-1, null);	/*(E)--------(ENDE)*/

		// Wachdienst
		$this->bogen[9] = [];/*                		Type					Val								Token			gIdx Next	Alt Func					*/
		$this->bogen[9][] = 	/* 0*/ new WHBogen(WHBogenType::Morph,	'',						WHToken::STRING,	-1,  1,  	-1, new h1());	/*(1)----<user>---->(2)*/
		$this->bogen[9][] =		/* 1*/ new WHBogen(WHBogenType::Sym,   '(',						WHToken::SYMBOL,	-1,  2,  	4,	null);	/*(2)---- (---->(3)*/
		$this->bogen[9][] = 	/* 2*/ new WHBogen(WHBogenType::Morph, '',						WHToken::STRING,	-1,  3,  	-1, new h2());	/*(3)--Diebstahl-->(4)*/
		$this->bogen[9][] = 	/* 3*/ new WHBogen(WHBogenType::Sym,   ')',						WHToken::SYMBOL,	-1,  4,  	-1, null);	/*(4)---- )---->(4)*/
		$this->bogen[9][] = 	/* 4*/ new WHBogen(WHBogenType::Morph, '',						WHToken::NUMBER,	-1,  5,  	7, new h3());	/*(5)--Anzahl-->(6)*/
		$this->bogen[9][] = 	/* 5*/ new WHBogen(WHBogenType::Morph, '',						WHToken::STRING,	-1,  4,  	7, new h4());	/*(6)--Ware-->(5)*/
		$this->bogen[9][] = 	/* 6*/ new WHBogen(WHBogenType::Nil,   '',						-1,				-1,  1,  	-1,	null);	/*(7)-----------(1)*/
		$this->bogen[9][] = 	/* 7*/ new WHBogen(WHBogenType::End,	'',						-1,			-1,  -1,  	-1, null);	/*(E)--------(ENDE)*/


		// stream initialisieren
		$this->stream = fopen('php://memory','r+');
		fwrite($this->stream, $post);
		rewind($this->stream);

		$this->lex = new WHProtLexer($this->stream);

		$this->token = new WHSymbol();
	}

	public function __destruct()
	{
		@fclose($this->stream);
	}

	public function pars($idx)
	{
		$bog = $this->bogen[$idx][0]; // aktueller Bogen
		$success = Status::FAIL;
		$tokenEaten = 0;

		if($this->token->type == WHToken::Empt)
		{
			// token lesen
			$this->token = $this->lex->nextToken();
			// Ende des Streames
			if(!$this->token) {

				return Status::OK;
			}
		}


		while(true)
		{
			switch($bog->type)
			{
				case WHBogenType::Morph : $success = ($this->token->type == $bog->token ? Status::OK : Status::FAIL); /*echo 'Morph: '.$this->token->value.' Status: '.$success.'<br>';*/ break;
				case WHBogenType::Nil :   $success = Status::OK; /*echo 'Nil:'.$bog->next.'<br>';*/ break;
				case WHBogenType::Sym :   $success = ($this->token->value == $bog->value ? Status::OK : Status::FAIL); /*echo 'Sym: '.$this->token->value.' Status: '.$success.'<br>';*/ break;
				case WHBogenType::Graph : /*echo '>>> Graph: '.$bog->gIdx.'<br>';*/ $success = $this->pars($bog->gIdx); /*echo '<<< Ende Graph: '.$bog->gIdx.'<br>';*/ break;
				case WHBogenType::End : /*echo 'OK '.$idx.'<br>';*/ return Status::OK;
			}

			if($success == Status::OK && $bog->func != null)
			{
				$bog->func->execute($this, $this->token);
			}

			if($success == Status::ERROR)	return Status::ERROR;


			if($success == Status::FAIL)
			{
				// Alternativbogen probieren
				if($bog->alt !== -1) {
					//echo 'bog alt:'.$bog->alt.': ';
					$bog = $this->bogen[$idx][$bog->alt];
				}

				else if($tokenEaten)
				{
					/*echo 'fehler<br>';
					print_r($this->token);echo '<br>';
					print_r($bog);echo '<br>';
					echo 'fehler<br>';*/
					return Status::ERROR;
				}
				else
				{
					return Status::FAIL; // Backtracking
				}
			}
			else // Morphem formal akzeptiert
			{
				if($bog->type == WHBogenType::Morph || $bog->type == WHBogenType::Sym)
				{
					// token lesen
					$this->token = $this->lex->nextToken();
					// Ende des Streames
					//if(!$this->token) return Status::OK;
					$tokenEaten++;
				}
				//echo 'bog next:'.$bog->next.': ';
				$bog = $this->bogen[$idx][$bog->next];
			}
		}
	}
}
