<?php
require_once ('classes/Security.php');

Security::setSessionAndCookieAttributes(dirname($_SERVER['PHP_SELF']));

session_start();

include_once ('include/db.php');
include_once ('classes/functions.php');
require_once('classes/user.class.php');
require_once('classes/menue.class.php');

$err = "";
$msg = "";
$site = "";
$sites = Array('start', 'warehouse', 'payment', 'login', 'logout', 'management',
	'settings', 'capabilities', 'hunting', 'info_hero', 'members');

if(!isset($_GET['site']) || $_GET['site'] != 'login')
  include_once('include/auth.php');
  
if(isset($_GET['site']) && in_array($_GET['site'], $sites))
  $site = makeEntityString($_GET['site']);
else
{
  if(!$_SESSION['login'])
  	$site = 'login';
}

$user = new User();
if($site == "login")
{
	if($_POST)
	{  
            $security = new Security();
            $auth = $security->verifyLogin($_POST['username'], $_POST['password'], (isset($_POST['login'])?1:0));
            if($auth)	
            {
                $user->loadUser($_SESSION['uid']);
                $tmpm = new Menue($user);
                $tmpm1 = $tmpm->getMenue(1);
                $ms = count($tmpm1);
                if($ms > 1)
                    $site = $tmpm1[0]['short'];
                redirectTo("?site=".$site);
            }
            else $err = "Benutzername und Passwort stimmen nicht &uuml;berein.";
	}
} else if($site == 'logout')
{
	$security = new Security();
        $security->doLogout();
	redirectTo('?site=login');
} else if($site == "")
{
	$tmpm = new Menue($user);
	$tmpm1 = $tmpm->getMenue(1);
	$ms = count($tmpm1);
	if($ms > 1)
		$site = $tmpm1[0]['short'];
}

echo '<?xml version="1.0" encoding="ISO-8859-1" ?>';

echo '
<!DOCTYPE html>
<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="de" lang="de">
';
?>
<head>
<title>EG-Verwaltungstool by Egrem</title>
<script type="text/javascript" src="js/jquery-3.4.1.min.js"></script>
    <?php if(defined('MESSAGES_JS')){ ?>
<script type="text/javascript" src="js/<?php echo MESSAGES_JS; ?>"></script>
    <?php } ?>
<link rel="stylesheet" type="text/css" href="css/style_1.7.3.css" />
<meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1">
</head>
<body>
<?php
if(isset($_SESSION['login']) && $_SESSION['login'])
{
	$_SESSION['site'] = $site;
	echo '<p>';
	
	$menue1 = new Menue($user);
	$m1 = $menue1->getMenue(1);
	$ms = count($m1);
	$i = 0;
	foreach($m1 as $m)
	{
            echo '<a '.($m['short']==$site?'class="under" ':'').'href="?site='.$m['short'].'">'.$m['site'].'</a>';
            if($m['short'] == 'start') {
                echo '<span id="message-count" title="Neue Mitteilungen!" data-badge="0"></span>';
            }
            if($i != $ms-1) {
                echo ' | ';                    
            } 
            $i++;
	}
	
	echo '</p>';
}

if(file_exists('sites/'.$site.'.php'))
	include 'sites/'.$site.'.php';
else 
	echo '<p>&nbsp;</p><p>&nbsp;</p><p>&nbsp;</p><p class="err">Zugang verweigert!</p>'; 

if(defined('JQUERY_UI_OVERRIDES_CSS')) {
    echo '<link rel="stylesheet" type="text/css" href="css/humanity/'.JQUERY_UI_OVERRIDES_CSS.'" />';
}
?>
    <script>
        $(function() {
            loadCountNewMessages();
        });   
    </script>
</body>
</html>