create procedure `getMinMax`(IN id INT, OUT ammin bigint, OUT wmin double, OUT ammax bigint, OUT wmax double)
BEGIN
  DECLARE ende, icount, market, realval, factor, minviv, maxviv, minvitv, maxvitv, minv, maxv, amount INT;
  DECLARE stab SMALLINT;
  DECLARE weig float;
  DECLARE items CURSOR FOR 
  	(SELECT SUM(wi.icount) as icount, i.marketvalue, i.realvalue, wi.stability, i.weight, iv.minval as ivmin, iv.maxval as ivmax, 
	itv.minval as itvmin, itv.maxval as itvmax 
  	FROM egtool_warehouse_items wi, egtool_items i, egtool_item_values iv, egtool_item_types_values itv 
  	WHERE i.iid=wi.iid and wi.wid=id and wi.stability IN(100,0) and i.itid=itv.itid and i.iid=iv.iid and iv.wid=id and itv.wid=id
        GROUP BY i.iid);
  DECLARE  CONTINUE HANDLER FOR NOT FOUND SET  ende = 1;
  OPEN items;
  SELECT 0 INTO ammin;
  SELECT 0 INTO wmin;
  SELECT 0 INTO ammax;
  SELECT 0 INTO wmax;
  SELECT 0 INTO amount;
  read_loop: LOOP
    FETCH items INTO icount, market, realval, stab, weig, minviv, maxviv, minvitv, maxvitv;  
    IF ende THEN
        LEAVE read_loop;
    END IF;
    
    IF minviv IS NOT NULL THEN
    	SELECT minviv INTO minv;
    else
    	SELECT minvitv INTO minv;
    END IF;
    IF maxviv IS NOT NULL THEN
    	SELECT maxviv INTO maxv;
    else
    	SELECT maxvitv INTO maxv;
    END IF;
    
    IF icount<minv THEN	
    	SELECT minv-icount INTO amount;
    	
    	IF realval > 0 then
     		SELECT realval INTO factor;
    	else 
      		SELECT market INTO factor;
    	END IF;
    	IF stab = 0 THEN
      		SELECT ammin+(amount*factor) INTO ammin;
    	else 
      		SELECT ammin+((amount*factor)*(stab/100)) INTO ammin;
    	END IF;
    	SELECT wmin+(weig*amount) INTO wmin;
    else
    IF icount>maxv THEN	
    	SELECT icount-maxv INTO amount;
    	
    	IF realval > 0 then
     		SELECT realval INTO factor;
    	else 
      		SELECT market INTO factor;
    	END IF;
    	IF stab = 0 THEN
      		SELECT ammax+(amount*factor) INTO ammax;
    	else 
      		SELECT ammax+((amount*factor)*(stab/100)) INTO ammax;
    	END IF;							
    	SELECT wmax+(weig*amount) INTO wmax;
    END IF;
    END IF;
  END LOOP;
  
  close items;
END