CREATE PROCEDURE `getWarehouseTypePrice`(IN id int, tid int, OUT amount bigint, OUT weight double)
BEGIN
  DECLARE ende, icount, market, realval, factor, tid2 INT;
  DECLARE stab SMALLINT;
  DECLARE weig float;
  DECLARE items CURSOR FOR 
  	(SELECT wi.icount, i.marketvalue, i.realvalue, wi.stability, i.weight FROM egtool_warehouse_items wi, egtool_items i WHERE i.itid=tid and i.iid=wi.iid and wi.wid=id);
  DECLARE  CONTINUE HANDLER FOR NOT FOUND SET  ende = 1;
  OPEN items;
  SELECT 0 INTO amount;
  SELECT 0 INTO weight;
  read_loop: LOOP
    FETCH items INTO icount, market, realval, stab, weig;
    IF ende THEN
        LEAVE read_loop;
    END IF;
    IF realval > 0 then
     SELECT realval INTO factor;
    else 
      SELECT market INTO factor;
    END IF;
    IF stab = 0 THEN
      SELECT amount+(icount*factor) INTO amount;
    else 
      SELECT amount+((icount*factor)*(stab/100)) INTO amount;
    END IF;
    SELECT weight+(weig*icount) INTO weight;
  END LOOP;
  
  close items;
END