<?php
if(!file_exists('../include/db.php'))
{
	$currentCookieParams = session_get_cookie_params(); 
	session_set_cookie_params(
	    $currentCookieParams["lifetime"],
	    dirname($_SERVER['PHP_SELF']),
	    $currentCookieParams["domain"],
	    $currentCookieParams["secure"],
	    $currentCookieParams["httponly"]
	); 
	session_name('sid'); 
	session_start();
	ini_set("default_charset", "iso-8859-1");
	define ('DB_PREFIX', 'egtool_');
	
	require '../classes/functions.php';
	require '../classes/user.class.php';
	require '../classes/group.class.php';
	require '../classes/guild.class.php';
	require '../classes/warehouse.class.php';
        require '../classes/enums/EGWorld.enum.php';
        require '../classes/enums/WHType.enum.php';
        require_once '../classes/Security.php';
        require_once __DIR__.'/../classes/config.class.php';
	
	
	/* PHP-Versions check */
	$phpv = phpversion();
	
	if($phpv)
	{
		$phpv1 = (int)substr($phpv, 0, 1);
		if($phpv1 >= 7)
			$phpVersionOk = true;
		else 	
			$phpVersionOk = false;
	}
	else
	{
		$phpv = "";
		$phpVersionOk = true;
	}
		
	$err = "";
	$msg = "";
	
	echo '<?xml version="1.0" encoding="ISO-8859-1" ?>';
	
	echo '
	<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.1//EN"
	       "http://www.w3.org/TR/xhtml11/DTD/xhtml11.dtd">
	<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="de" lang="de">
	';
	?>
	<head>
	<title>EG-Verwaltungstool by Egrem</title>
	<link rel="stylesheet" type="text/css" href="../css/style_1.7.3.css" />
        <link rel="stylesheet" type="text/css" href="../css/strengthify.min.css" />
        <script type="text/javascript" src="../js/jquery-3.4.1.min.js"></script>
        <script type="text/javascript" src="../js/jquery.strengthify.min.js"></script>
        <script type="text/javascript" src="../js/pwstrength_1.0.0.js"></script>
	
	</head>
	<body>
	<h1>Installationsscript</h1>
	<p class="bold">
	<?php 
	
	if(isset($_POST['action']) && $_POST['action'] == 'check' && $phpVersionOk)
	{
		$dbpass = $_POST['dbpass'];
		$host = $_POST['dbhost'];
		$dbname = $_POST['dbname'];
		$dbuser = $_POST['dbuser'];		
		
		$user = $_POST['user'];
		$pass = $_POST['pass'];
		$guild = $_POST['guild'];
		$short = $_POST['short'];
		$warehouse = $_POST['warehouse'];
                $world = $_POST['world'];

		$dbConn = @mysqli_connect($host, $dbuser, $dbpass, $dbname);
                Config::setDBConn($dbConn);
		$err = @mysqli_error(Config::getDBConn());
		if(mysqli_connect_errno())
		{
			$err .= "Benutzername, Passwort oder DB Name des Datenbankservers ist falsch!<br />";
		}
//		else 
//		{
//			$db = @mysqli_select_db($dbname);
//			if(!$db)
//			{
//				$err = "Konnte die Datenbank nicht ausw&auml;hlen!<br />".mysqli_error(Config::getDBConn());
//			}
//		}
		if($_POST['user'] == "" || $_POST['pass'] == "" || $_POST['guild'] == "" || $_POST['short'] == "" || $_POST['warehouse'] == "")
			$err .= '<br />Bitte deinen Namen, Passwort, Gilde, K&uuml;rzel und Name des Lagers angeben.';	
                if(strlen($_POST['pass']) < 8)
			$err .= '<br />Dein Passwort muss mindestens 8 Zeichen lang sein.';
	}
	if($err != "") echo '<br /><span class="err">'.$err.'</span>';
	if($err != "" || !$_POST)
	{
	?>
	</p>
	<form action="?" method="post">
	
	<table class="tableLogin" border="0">
		<tr>
			<th colspan="2">Allgemeine Daten angeben</th>
		</tr>
		  <tr>
	        <td class="left">Datenbankserver</td>
	        <td class="left"><input class="inp1" tabindex="1" type="text" name="dbhost" value="<?php echo (isset($_POST['dbhost'])?$host:'localhost'); ?>" /></td>
	      </tr>
	      <tr>
	        <td class="left">Datenbankname</td>
	        <td class="left"><input class="inp1" tabindex="2" type="text" name="dbname" value="<?php echo (isset($_POST['dbname'])?$dbname:''); ?>" /></td>
	      </tr>
	      <tr>
	        <td class="left">Datenbankbenutzername</td>
	        <td class="left"><input class="inp1" tabindex="3" type="text" name="dbuser" value="<?php echo (isset($_POST['dbuser'])?$dbuser:''); ?>" /></td>
	      </tr>
	      <tr>
	        <td class="left">Datenbankpasswort</td>
	        <td class="left"><input class="inp1" tabindex="4" type="password" name="dbpass" /></td>
	      </tr>
	      <tr>
	      	<td colspan="2">&nbsp;</td>
	      </tr>
	      <tr>
	        <td class="left">Dein Benutzername</td>
	        <td class="left"><input class="inp1" tabindex="5" type="text" name="user" value="<?php echo (isset($_POST['user'])?makeEntityString($user):''); ?>" /></td>
	      </tr>
	      <tr>
	        <td class="left">Dein Passwort</td>
	        <td class="left"><input class="inp1 pwstrengthify" tabindex="6" type="password" name="pass" /></td>
	      </tr>
	      <tr>
	        <td class="left">Deine Gilde</td>
	        <td class="left"><input class="inp1" tabindex="7" type="text" name="guild" /></td>
	      </tr>
	      <tr>
	        <td class="left">Gildenk&uuml;rzel</td>
	        <td class="left">[ <input class="inp1" tabindex="8" type="text" name="short" maxlength="10" style="width: 70px;" /> ]
	        	<span class="hint txt3">max 10 Zeichen<br />Diese Angabe muss identisch mit dem K&uuml;rzel in EG sein!</span></td>
	      </tr>
	      <tr>
	        <td class="left">Name des Stadtlagers</td>
	        <td class="left"><input class="inp1" tabindex="9" type="text" name="warehouse" /></td>
	      </tr>
              <tr>
                <td class="left">Welt</td>
                <td class="left"><select name="world">
                    <option value="<?php echo EGWorld::DUNLADAN ?>">Dunladan</option>
                    <option value="<?php echo EGWorld::ENDURIAS ?>">Endurias</option>
                    <option value="<?php echo EGWorld::ZYRTHANIA ?>">Zyrthania</option>
                    <option value="<?php echo EGWorld::IKANDUR ?>">Ikandur</option>
                    <option value="<?php echo EGWorld::KELORAS ?>">Keloras</option>
                    <option value="<?php echo EGWorld::TESTSERVER ?>">Testserver</option>
                </select></td>
              </tr>
	      <tr>
	      	<td colspan="2">&nbsp;</td>
	      </tr>
	       <tr>
	        <td class="left">PHP-Version</td>
	        <td class="left"><?php 
	        		if($phpv=="")
	        			echo "nicht ermittelbar";
	        		else
	        		{
	        			echo '<span class="bold '.($phpVersionOk?'ok':'err').'">'.$phpv.'</span>';
	        		}
	        		?> <span class="hint">(mind. Version 7)</span></td>
	      </tr>
	      <tr>
	      	<th colspan="2"><input type="submit" value="Daten pr&uuml;fen und Installation beginnen" <?php echo (!$phpVersionOk?'disabled="disabled"':'');?>/></th>
	      </tr>
	</table>
	<input type="hidden" name="action" value="check" />
	</form>
	<?php 
	}
	else 
	{
		//install durchfhren
		//mysql version ermitteln
		$qry = "SELECT VERSION()";
		$res = @ mysqli_query(Config::getDBConn(), $qry);
		if(@mysqli_num_rows($res) == 1)
		{
			$res = @mysqli_fetch_array($res);
			$mysqlv = $res[0];
			$mysqlv1 = (int)$mysqlv;
			if($mysqlv1 >= 5)
				$mysqlVersionOk = true;
			else 	
			{
				$mysqlVersionOk = false;
				echo '<span class="bold err">MySQL Version zu niedrig: '.$mysqlv.'</span> <span class="hint">(mind. Version 5)</span>';
				echo '<p><a href="install.php">zur&uuml;ck</a></p>';
			}
		}
		else
		{
			$mysqlv = "";
			$mysqlVersionOk = true;
		}
		
		if($mysqlVersionOk)
		{		
			//anlegen der datenbankverbindungsdatei
			$handle = @fopen("../include/db.php", "w");
			if(!$handle)
			{	
				echo '<span class="err">Die Datei include/db.php konnte nicht erstellt werden.<br />Pr&uuml;fe bitte die Schreibrechte.</span>';
				echo '<p><a href="install.php">zur&uuml;ck</a></p>';
			}
			else
			{
				$dbcont = '<?php
require_once __DIR__.\'/../classes/config.class.php\';
define (\'MYSQL_HOST\', \''.$host.'\');
define (\'MYSQL_BENUTZER\', \''.$dbuser.'\');
define (\'MYSQL_PASS\', \''.$dbpass.'\');
define (\'MYSQL_DB\', \''.$dbname.'\');
define (\'DB_PREFIX\', \'egtool_\');
                                                        
$dbConn = @mysqli_connect(MYSQL_HOST, MYSQL_BENUTZER, MYSQL_PASS, MYSQL_DB);
if(mysqli_connect_errno())
    die(\'Fehler beim Verbinden zum Datenbankserver\');
Config::setDBConn($dbConn);

// Zeitzone setzen
date_default_timezone_set("Europe/Berlin");
mysqli_query(Config::getDBConn(), "SET time_zone = \'".date(\'P\')."\';");
?>';

				@fputs($handle, $dbcont);
				@fclose($handle);
				
				
				$path = "db/";
				$sql_status = array();
				$files = array();
				$errcount = 0;
				
				//jede .sql datei einlesen und an die db schicken
				$dirhandle = @opendir($path);
				if($dirhandle)
				{
					$i = 0;
					//Ordner auslesen
					while($file = @readdir($dirhandle))
					{
						if(is_file($path.$file) && strlen(strstr($file, ".sql")) > 0)
						{
							array_push($files, $file);
						}
					}
					closedir($dirhandle);
					
					//alphabetisch sortieren
					sort($files, SORT_STRING);
					
					//alle Dateien durchgehen
					foreach($files as $file)
					{
						$handle = @fopen($path.$file, "rt");
						if($handle)
						{
							//der Inhalt der Datei
							$str = @fread($handle, filesize($path.$file));
							
							$str = str_replace("\n", " ", $str);
							$str = str_replace("\r", "", $str);
							$str = str_replace("\t", " ", $str);
							
							//In DB schreiben
							$qry = @ mysqli_query(Config::getDBConn(), $str);
							if(!$qry)
							{
								$sql_status[$i]['file'] = $file;
								$sql_status[$i]['status'] = '<span class="err">Fehler: '.mysqli_error(Config::getDBConn()).'</span>';
								$errcount++;
							}
							else
							{
								$sql_status[$i]['file'] = $file;
								$sql_status[$i]['status'] = '<span class="ok">OK</span>';
							}
							@fclose($handle);
							$i++;
						}
						else 
							echo '<span class="err">Konnte die Datei: '.$path.$file.' nicht &ouml;ffnen</span><br />';
					}
				}
				else 
					echo '<span class="err">Das Verzeichnis '.$path.' existiert nicht mehr!</span>';
				
				
				$userobj = new User();
				$groupobj = new Group($userobj);
				
				//Jetzt den Nutzer anlegen und zur Admingruppe hinzufgen
				$uid = $userobj->addUser(1, $user, '', $pass, '', '', 1, 1, '', 0, 0, 0);
				if($uid > 0 && $groupobj->addUserToGroup(1, $uid))
				{
					$sql_status[$i]['file'] = "Nutzer anlegen";
					$sql_status[$i]['status'] = '<span class="ok">OK</span>';
					$i++;
					
					//Gilde anlegen, Nutzer zur Gilde hinzufgen und Recht hinzufgen, dass Nutzer Gilde bearbeiten darf
					$guildobj = new Guild($userobj);
					if($guildobj->addGuild($guild, "#000000", $short, 0, $world) && $guildobj->addUserToGuild(1, $uid) && $groupobj->addGuildRightToGroup(1, $uid, 1, 1))
					{
						$sql_status[$i]['file'] = "Gilde anlegen";
						$sql_status[$i]['status'] = '<span class="ok">OK</span>';
						$i++;
					}
					else
					{
						$sql_status[$i]['file'] = "Gilde anlegen";
						$sql_status[$i]['status'] = '<span class="err">Fehler: '.mysqli_error(Config::getDBConn()).'</span>';
						$errcount++;
						$i++;
					}
					
					//Lager anlegen und Recht, das Lager zu bearbeiten
					$whobj = new Warehouse($user);
					if($whobj->addWh($warehouse, 1, 0, $world, WHType::STADTLAGER) && $groupobj->addWhToGroup(1, 1, 1, 1))
					{
						$sql_status[$i]['file'] = "Lager anlegen";
						$sql_status[$i]['status'] = '<span class="ok">OK</span>';
						$i++;
					}
					else
					{
						$sql_status[$i]['file'] = "Lager anlegen";
						$sql_status[$i]['status'] = '<span class="err">Fehler: '.mysqli_error(Config::getDBConn()).'</span>';
						$errcount++;
						$i++;
					}
					
				}	
				else
				{
					$sql_status[$i]['file'] = "Nutzer anlegen";
					$sql_status[$i]['status'] = '<span class="err">Fehler: '.mysqli_error(Config::getDBConn()).'</span>';
					$errcount++;
					$i++;
				}
					
				if($errcount == 0)
				{
					echo '<span class="ok">Die Installation war erfolgreich.<br />Bitte l&ouml;sche jetzt das Verzeichnis<br />install/</span>';
					echo '<p><a href="../index.php">zum Tool</a></p>';
				}
				else
				{
					echo '<span class="err">Die Installation war nicht erfolgreich! Es trat mindestens ein Fehler auf.</span>';
				}
				echo '				
				<table class="tableGroup2" border="0">
					<tr>
						<th colspan="2">Status der Datenbankscripts</th>
					</tr>';
					foreach($sql_status as $line)
					{
						echo '
						<tr>
					      <td class="left txt2">'.$line['file'].'</td>
					      <td class="left txt2">'.$line['status'].'</td>
					    </tr>';
					}
				echo '					      
				</table>';
				
				
			}			
		}
	}
	echo '
            <script>
                $(document).ready(function() {
                   bindStrenghtify("../");
               }); 
           </script>
	</body>
	</html>';
}
else
	echo 'Installation bereits abgeschlossen! Die Datenbankdatei existiert bereits.';
?>