<?php
if(file_exists('../include/db.php'))
{
	$currentCookieParams = session_get_cookie_params(); 
	session_set_cookie_params(
	    $currentCookieParams["lifetime"],
	    dirname($_SERVER['PHP_SELF']),
	    $currentCookieParams["domain"],
	    $currentCookieParams["secure"],
	    true
	); 
	session_name('sid'); 
	session_start();
	ini_set("default_charset", "iso-8859-1");
	require_once('../include/db.php');
	require_once '../classes/functions.php';
	require_once '../classes/config.class.php';
	
	$err = "";
	$msg = "";
	
	$neededversion = "1.11.0";
    $newVersion = "1.12.0";
	$config = new Config();
	$curversion = $config->getToolVersion();
	if($curversion != $neededversion)
		$err .= "Dieses Script setzt die Toolversion ".$neededversion." voraus, <br />du nutzt aber ".$curversion.".";
		
	
	
	echo '<?xml version="1.0" encoding="ISO-8859-1" ?>';
	
	echo '
	<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.1//EN"
	       "http://www.w3.org/TR/xhtml11/DTD/xhtml11.dtd">
	<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="de" lang="de">
	';
	?>
	<head>
	<title>EG-Verwaltungstool by Egrem</title>
	<link rel="stylesheet" type="text/css" href="../css/style_1.7.3.css" />
	
	</head>
	<body>
	<h1>Updatescript <?php echo $neededversion ?> -> <?php echo $newVersion ?></h1>
	<p class="bold">
	<?php 
	if($err != "") echo '<br /><span class="err">'.$err.'</span>';
	if($err == "" && !$_POST)
	{
	?>
	</p>
	<form action="?" method="post">
	
	<table class="tableLogin" border="0">
		<tr>
			<th colspan="2">Aktualisierung der Datenbank</th>
		</tr>
		  <tr>
	        <td class="center" colspan="2">Dieses Script aktualisiert deine Datenbank von Version <?php echo $neededversion ?> auf <?php echo $newVersion ?></td>
	      </tr>
	      <tr>
	      	<th colspan="2"><input type="submit" value="Vorgang starten" /></th>
	      </tr>
	</table>
	<input type="hidden" name="action" value="check" />
	</form>
	<?php 
	}
	else if(isset($_POST['action']) && $_POST['action'] == 'check' && $err == "")
	{			
		$sql_status = array();
		$errcount = 0;
		$i = 0;
                            
        /***********  Neue Items ***********/
		$dbChange = Array();	
        $dbChange[] = "DROP TABLE IF EXISTS `".DB_PREFIX."items_world`;";
        $dbChange[] = "CREATE TABLE `".DB_PREFIX."items_world` (
                          `iid` int(10) UNSIGNED NOT NULL,
                          `world` tinyint(3) UNSIGNED NOT NULL
                        ) ENGINE=MyISAM DEFAULT CHARSET=utf8mb4;";
        $dbChange[] = "ALTER TABLE `".DB_PREFIX."items_world` 
                        ADD UNIQUE KEY `u_iid_world` (`iid`,`world`),
                        ADD KEY `iid_world` (`iid`,`world`);";

        $dbChange[] = "DROP TABLE IF EXISTS `".DB_PREFIX."item_types_world`;";
        $dbChange[] = "CREATE TABLE `".DB_PREFIX."item_types_world` (
                          `itid` int(10) UNSIGNED NOT NULL,
                          `world` tinyint(3) UNSIGNED NOT NULL
                        ) ENGINE=MyISAM DEFAULT CHARSET=utf8mb4;";
        $dbChange[] = "ALTER TABLE `".DB_PREFIX."item_types_world` 
                        ADD UNIQUE KEY `u_itid_world` (`itid`,`world`),
                        ADD KEY `itid_world` (`itid`,`world`);";


        $dbChangeErr = "";
		foreach($dbChange as $row)
		{
            if(! mysqli_query(Config::getDBConn(), $row))
            $dbChangeErr .= "<p>".$row."<br />Fehler: ".mysqli_error(Config::getDBConn())."</p>";
		}
        unset($dbChange);

        $worlds = [3,4,5,6,99]; // all old worlds

        // add all item IDs into new table and associate them with existing world IDs
        foreach($worlds as $world) {
            $dbChange[] = "INSERT INTO `".DB_PREFIX."items_world` (`iid`,`world`)
                                SELECT iid, ".$world." FROM ".DB_PREFIX."items i WHERE i.iid<765;";
            $dbChange[] = "INSERT INTO `".DB_PREFIX."item_types_world` (`itid`,`world`)
                                SELECT itid, ".$world." FROM ".DB_PREFIX."item_types it WHERE it.itid<29;";
        }

        foreach($dbChange as $row)
        {
            if(! mysqli_query(Config::getDBConn(), $row))
                $dbChangeErr .= "<p>".$row."<br />Fehler: ".mysqli_error(Config::getDBConn())."</p>";
        }
        unset($dbChange);
        $dbChange = Array();
        $dbChange[] = "INSERT INTO `".DB_PREFIX."item_types` (`itid`, `type`, `prod_equals_cap_lvl`, `cid_fight`) VALUES (NULL, 'Stangenwaffen', '0', '23'); ";
        $dbChange[] = "ALTER TABLE `".DB_PREFIX."item_types` ADD `sort` TINYINT UNSIGNED NULL AFTER `cid_fight`; ";
        $dbChange[] = "INSERT INTO `".DB_PREFIX."item_types` (`itid`, `type`, `prod_equals_cap_lvl`, `cid_fight`, `sort`) VALUES (NULL, 'Mittlere Schilde', '0', '26', NULL); ";


        $dbChange[] = "UPDATE `".DB_PREFIX."item_types` SET `sort` = '1' WHERE `".DB_PREFIX."item_types`.`itid` = 1;";
        $dbChange[] = "UPDATE `".DB_PREFIX."item_types` SET `sort` = '2' WHERE `".DB_PREFIX."item_types`.`itid` = 2;";
        $dbChange[] = "UPDATE `".DB_PREFIX."item_types` SET `sort` = '3' WHERE `".DB_PREFIX."item_types`.`itid` = 3;";
        $dbChange[] = "UPDATE `".DB_PREFIX."item_types` SET `sort` = '4' WHERE `".DB_PREFIX."item_types`.`itid` = 4;";
        $dbChange[] = "UPDATE `".DB_PREFIX."item_types` SET `sort` = '5' WHERE `".DB_PREFIX."item_types`.`itid` = 5;";
        $dbChange[] = "UPDATE `".DB_PREFIX."item_types` SET `sort` = '6' WHERE `".DB_PREFIX."item_types`.`itid` = 6;";
        $dbChange[] = "UPDATE `".DB_PREFIX."item_types` SET `sort` = '7' WHERE `".DB_PREFIX."item_types`.`itid` = 7;";
        $dbChange[] = "UPDATE `".DB_PREFIX."item_types` SET `sort` = '9' WHERE `".DB_PREFIX."item_types`.`itid` = 8;";
        $dbChange[] = "UPDATE `".DB_PREFIX."item_types` SET `sort` = '10' WHERE `".DB_PREFIX."item_types`.`itid` = 9;";
        $dbChange[] = "UPDATE `".DB_PREFIX."item_types` SET `sort` = '11' WHERE `".DB_PREFIX."item_types`.`itid` = 10;";
        $dbChange[] = "UPDATE `".DB_PREFIX."item_types` SET `sort` = '12' WHERE `".DB_PREFIX."item_types`.`itid` = 11;";
        $dbChange[] = "UPDATE `".DB_PREFIX."item_types` SET `sort` = '13' WHERE `".DB_PREFIX."item_types`.`itid` = 12;";
        $dbChange[] = "UPDATE `".DB_PREFIX."item_types` SET `sort` = '14' WHERE `".DB_PREFIX."item_types`.`itid` = 13;";
        $dbChange[] = "UPDATE `".DB_PREFIX."item_types` SET `sort` = '15' WHERE `".DB_PREFIX."item_types`.`itid` = 14;";
        $dbChange[] = "UPDATE `".DB_PREFIX."item_types` SET `sort` = '16' WHERE `".DB_PREFIX."item_types`.`itid` = 15;";
        $dbChange[] = "UPDATE `".DB_PREFIX."item_types` SET `sort` = '17' WHERE `".DB_PREFIX."item_types`.`itid` = 16;";
        $dbChange[] = "UPDATE `".DB_PREFIX."item_types` SET `sort` = '18' WHERE `".DB_PREFIX."item_types`.`itid` = 17;";
        $dbChange[] = "UPDATE `".DB_PREFIX."item_types` SET `sort` = '19' WHERE `".DB_PREFIX."item_types`.`itid` = 18;";
        $dbChange[] = "UPDATE `".DB_PREFIX."item_types` SET `sort` = '20' WHERE `".DB_PREFIX."item_types`.`itid` = 19;";
        $dbChange[] = "UPDATE `".DB_PREFIX."item_types` SET `sort` = '21' WHERE `".DB_PREFIX."item_types`.`itid` = 20;";
        $dbChange[] = "UPDATE `".DB_PREFIX."item_types` SET `sort` = '22' WHERE `".DB_PREFIX."item_types`.`itid` = 21;";
        $dbChange[] = "UPDATE `".DB_PREFIX."item_types` SET `sort` = '24' WHERE `".DB_PREFIX."item_types`.`itid` = 22;";
        $dbChange[] = "UPDATE `".DB_PREFIX."item_types` SET `sort` = '25' WHERE `".DB_PREFIX."item_types`.`itid` = 23;";
        $dbChange[] = "UPDATE `".DB_PREFIX."item_types` SET `sort` = '26' WHERE `".DB_PREFIX."item_types`.`itid` = 24;";
        $dbChange[] = "UPDATE `".DB_PREFIX."item_types` SET `sort` = '27' WHERE `".DB_PREFIX."item_types`.`itid` = 25;";
        $dbChange[] = "UPDATE `".DB_PREFIX."item_types` SET `sort` = '28' WHERE `".DB_PREFIX."item_types`.`itid` = 26;";
        $dbChange[] = "UPDATE `".DB_PREFIX."item_types` SET `sort` = '29' WHERE `".DB_PREFIX."item_types`.`itid` = 27;";
        $dbChange[] = "UPDATE `".DB_PREFIX."item_types` SET `sort` = '30' WHERE `".DB_PREFIX."item_types`.`itid` = 28;";
        $dbChange[] = "UPDATE `".DB_PREFIX."item_types` SET `sort` = '8' WHERE `".DB_PREFIX."item_types`.`itid` = 29;";
        $dbChange[] = "UPDATE `".DB_PREFIX."item_types` SET `sort` = '23' WHERE `".DB_PREFIX."item_types`.`itid` = 30;";

        $dbChange[] = "UPDATE `".DB_PREFIX."buildings_components` SET `iid` = '511' WHERE `".DB_PREFIX."buildings_components`.`bid` = 3 AND `".DB_PREFIX."buildings_components`.`iid` = 503; ";

        foreach($dbChange as $row)
        {
            if(! mysqli_query(Config::getDBConn(), $row))
                $dbChangeErr .= "<p>".$row."<br />Fehler: ".mysqli_error(Config::getDBConn())."</p>";
        }
        unset($dbChange);
        $dbChange = Array();

        // add all new items from sql file
        $path = "update_db_1.12.0/new_items_keloras.sql";
        if(is_file($path)) {
            $handle = @fopen($path, "rt");
            if ($handle) {
                //der Inhalt der Datei
                $str = @fread($handle, filesize($path));

                $str = str_replace("\n", " ", $str);
                $str = str_replace("\r", "", $str);
                $str = str_replace("\t", " ", $str);

                //In DB schreiben
                $qry = @mysqli_query(Config::getDBConn(), $str);
                if(!$qry) {
                    $dbChangeErr .= "<p>".$row."<br />Fehler: ".mysqli_error(Config::getDBConn())."</p>";
                }
            }
        }

        // now add all items and types that are new for keloras (removed magieessenzen 17, new: Stangenwaffen 29, Mittlere Schilde 30
        $inArrNew = "1,2,3,4,5,6,7,8,29,9,10,11,12,13,14,18,19,20,21,30,22";
        $inArrOld = "15,16,23,24,25,26,27,28";

        $dbChange[] = "INSERT INTO `".DB_PREFIX."items_world` (`iid`,`world`)
                            SELECT iid, 7 FROM ".DB_PREFIX."items i WHERE i.itid IN (".$inArrOld.");";
        $dbChange[] = "INSERT INTO `".DB_PREFIX."items_world` (`iid`,`world`)
                            SELECT iid, 7 FROM ".DB_PREFIX."items i WHERE i.itid IN (".$inArrNew.") and i.iid>764;";
        $dbChange[] = "INSERT INTO `".DB_PREFIX."item_types_world` (`itid`,`world`)
                            SELECT itid, 7 FROM ".DB_PREFIX."item_types it WHERE it.itid IN (".$inArrNew.", ".$inArrOld.");";

        foreach($dbChange as $row)
        {
            if(! mysqli_query(Config::getDBConn(), $row))
                $dbChangeErr .= "<p>".$row."<br />Fehler: ".mysqli_error(Config::getDBConn())."</p>";
        }

        if($dbChangeErr == "")
		{
            $sql_status[$i]['file'] = "Neue Items";
            $sql_status[$i]['status'] = '<span class="ok">OK</span>';
		}
		else
		{
            $sql_status[$i]['file'] = "Neue Items";
            $sql_status[$i]['status'] = $dbChangeErr;
            $errcount++;
		}
		$i++;
		unset($dbChange);
		/***********  Ende Neue Items ***********/

        /***********  Start Fähigkeiten ***********/
        $structure = Array();
        $structure[] = "INSERT INTO `".DB_PREFIX."capabilities` (`cid`, `capability`, `type`) VALUES (NULL, 'Lederr&uuml;stungen', '1')";
        $structure[] = "ALTER TABLE `".DB_PREFIX."capabilities`  ADD `name_alias` VARCHAR(40) NULL AFTER `type`;";
        $structure[] = "UPDATE `".DB_PREFIX."capabilities` SET `name_alias` = 'Sattlern (Lederr&uuml;stungen)' WHERE `".DB_PREFIX."capabilities`.`cid` = 11;";
        $structure[] = "UPDATE `".DB_PREFIX."capabilities` SET `name_alias` = 'Stoffr&uuml;stungen' WHERE `".DB_PREFIX."capabilities`.`cid` = 26;";
        $structure[] = "UPDATE `".DB_PREFIX."capabilities` SET `name_alias` = 'Metallr&uuml;stungen' WHERE `".DB_PREFIX."capabilities`.`cid` = 27; ";
        $structure[] = "UPDATE `".DB_PREFIX."capabilities` SET `name_alias` = 'Schneidern (Stoffr&uuml;stungen)' WHERE `egtool_capabilities`.`cid` = 16; ";

        $strucerr = "";
        foreach($structure as $row)
        {
            if(! mysqli_query(Config::getDBConn(), $row))
                $strucerr .= "<p>".$row."<br />Fehler: ".mysqli_error(Config::getDBConn())."</p>";
        }
        if($strucerr == "")
        {
            $sql_status[$i]['file'] = "F&auml;higkeiten aktualisiert";
            $sql_status[$i]['status'] = '<span class="ok">OK</span>';
        }
        else
        {
            $sql_status[$i]['file'] = "F&auml;higkeiten aktualisiert";
            $sql_status[$i]['status'] = $strucerr;
            $errcount++;
        }
        $i++;
        /***********  Ende Fähigkeiten ***********/

        /***********  Start Version ***********/
		$structure = Array();	
		$structure[] = "UPDATE ".DB_PREFIX."config set value='".$newVersion."' WHERE set_key='version'";
		
		$strucerr = "";
		foreach($structure as $row)
		{
			if(! mysqli_query(Config::getDBConn(), $row))
				$strucerr .= "<p>".$row."<br />Fehler: ".mysqli_error(Config::getDBConn())."</p>";
		}
		if($strucerr == "")
		{
			$sql_status[$i]['file'] = "Version aktualisiert";
			$sql_status[$i]['status'] = '<span class="ok">OK</span>';					
		}
		else
		{
			$sql_status[$i]['file'] = "Version aktualisiert";
			$sql_status[$i]['status'] = $strucerr;		
			$errcount++;	
		}
		$i++;
		/***********  Ende Version ***********/

		if($errcount == 0)
		{
			echo '<span class="ok">Das Update war erfolgreich.<br />Bitte l&ouml;sche jetzt das Verzeichnis<br />install/</span>';
			echo '<p><a href="../index.php">zum Tool</a></p>';
		}
		else
		{
			echo '<span class="err">Das Update war nicht erfolgreich! Es trat mindestens ein Fehler auf.</span>';
		}
		echo '				
		<table class="tableGroup2" border="0">
			<tr>
				<th colspan="2">Status der Datenbankscripts</th>
			</tr>';
			foreach($sql_status as $line)
			{
				echo '
				<tr>
			      <td class="left txt2">'.$line['file'].'</td>
			      <td class="left txt2">'.$line['status'].'</td>
			    </tr>';
			}
		echo '					      
		</table>';			
	}
	echo '
	</body>
	</html>';
}
else
	echo 'Das Tool muss bereits installiert sein!';
?>