<?php
if(file_exists('../include/db.php'))
{
	$currentCookieParams = session_get_cookie_params(); 
	session_set_cookie_params(
	    $currentCookieParams["lifetime"],
	    dirname($_SERVER['PHP_SELF']),
	    $currentCookieParams["domain"],
	    $currentCookieParams["secure"],
	    $currentCookieParams["httponly"]
	); 
	session_name('sid'); 
	session_start();
	
	require_once('../include/db.php');
	require '../classes/functions.php';
	require '../classes/config.class.php';
	
	$err = "";
	$msg = "";
	
	$neededversion = "1.6.4";
	$config = new Config();
	$curversion = $config->getToolVersion();
	if($curversion != $neededversion)
		$err .= "Dieses Script setzt die Toolversion ".$neededversion." voraus, <br />du nutzt aber ".$curversion.".";
		
	
	
	echo '<?xml version="1.0" encoding="ISO-8859-1" ?>';
	
	echo '
	<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.1//EN"
	       "http://www.w3.org/TR/xhtml11/DTD/xhtml11.dtd">
	<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="de" lang="de">
	';
	?>
	<head>
	<title>EG-Verwaltungstool by Egrem</title>
	<link rel="stylesheet" type="text/css" href="../css/style_1.7.3.css" />
	
	</head>
	<body>
	<h1>Updatescript 1.6.4 -> 1.6.5</h1>
	<p class="bold">
	<?php 
	if($err != "") echo '<br /><span class="err">'.$err.'</span>';
	if($err == "" && !$_POST)
	{
	?>
	</p>
	<form action="?" method="post">
	
	<table class="tableLogin" border="0">
		<tr>
			<th colspan="2">Aktualisierung der Datenbank</th>
		</tr>
		  <tr>
	        <td class="center" colspan="2">Dieses Script aktualisiert deine Datenbank von Version 1.6.4 auf 1.6.5</td>
	      </tr>
	      <tr>
	      	<th colspan="2"><input type="submit" value="Vorgang starten" /></th>
	      </tr>
	</table>
	<input type="hidden" name="action" value="check" />
	</form>
	<?php 
	}
	else if(isset($_POST['action']) && $_POST['action'] == 'check' && $err == "")
	{			
		$sql_status = array();
		$errcount = 0;
		$i = 0;
		
		/***********  Start Stadtkasse ***********/
		$cittransfer = Array();	
		$cittransfer[] = "CREATE TABLE IF NOT EXISTS `".DB_PREFIX."city_transfer` (
							`ctid` int(10) unsigned NOT NULL AUTO_INCREMENT,
							`date` datetime NOT NULL,
							`nick` varchar(30) NOT NULL,
							`type` varchar(10) NOT NULL,
							`amount_in` int(11) NOT NULL,
							`amount_out` int(11) NOT NULL,
							`guid` int(10) unsigned NOT NULL,
							`wid` int(10) unsigned NOT NULL,
							PRIMARY KEY (`ctid`),
							KEY `transfer_lookup` (`wid`,`nick`,`date`,`type`,`guid`,`amount_in`),
							KEY `i_wid` (`wid`)
						  ) ENGINE=MyISAM DEFAULT CHARSET=latin1 ;";
		
		$cittransfererr = "";
		foreach($cittransfer as $row)
		{
			if(! mysqli_query(Config::getDBConn(), $row))
				$cittransfererr .= "<p>".$row."<br />Fehler: ".mysqli_error(Config::getDBConn())."</p>";
		}
		if($cittransfererr == "")
		{
			$sql_status[$i]['file'] = "Stadtkasse hinzugef�gt";
			$sql_status[$i]['status'] = '<span class="ok">OK</span>';					
		}
		else
		{
			$sql_status[$i]['file'] = "Stadtkasse hinzugef�gt";
			$sql_status[$i]['status'] = $cittransfererr;		
			$errcount++;	
		}
		$i++;
		unset($cittransfer);
		/***********  Ende Stadtkasse ***********/
		
		/***********  Start Seiten ***********/
		$protocoll = Array();	
		$protocoll[] = "UPDATE ".DB_PREFIX."sites SET sort = '5' WHERE sid=40;";
		$protocoll[] = "INSERT INTO ".DB_PREFIX."sites (sid,site,short,sort,type,parent)
						VALUES (NULL , 'Stadtkasse', 'citytransfer', 4, 2, 1);";
		
		$protocollerr = "";
		foreach($protocoll as $row)
		{
			if(! mysqli_query(Config::getDBConn(), $row))
				$protocollerr .= "<p>".$row."<br />Fehler: ".mysqli_error(Config::getDBConn())."</p>";
		}
		if($protocollerr == "")
		{
			$sql_status[$i]['file'] = "Seiten angepasst";
			$sql_status[$i]['status'] = '<span class="ok">OK</span>';					
		}
		else
		{
			$sql_status[$i]['file'] = "Seiten angepasst";
			$sql_status[$i]['status'] = $protocollerr;		
			$errcount++;	
		}
		$i++;
		unset($protocoll);
		/***********  Ende Seiten ***********/
		
		/***********  Start Rechte ***********/
		$protocoll = Array();	
		$protocoll[] = "INSERT INTO ".DB_PREFIX."group_rights (gid,sid)
						VALUES ('1', '48');";
		
		$protocollerr = "";
		foreach($protocoll as $row)
		{
			if(! mysqli_query(Config::getDBConn(), $row))
				$protocollerr .= "<p>".$row."<br />Fehler: ".mysqli_error(Config::getDBConn())."</p>";
		}
		if($protocollerr == "")
		{
			$sql_status[$i]['file'] = "Rechte angepasst";
			$sql_status[$i]['status'] = '<span class="ok">OK</span>';					
		}
		else
		{
			$sql_status[$i]['file'] = "Rechte angepasst";
			$sql_status[$i]['status'] = $protocollerr;		
			$errcount++;	
		}
		$i++;
		unset($protocoll);
		/***********  Ende Rechte ***********/
		
		/***********  Start Version ***********/
		$structure = Array();	
		$structure[] = "UPDATE ".DB_PREFIX."config set value='1.6.5' WHERE set_key='version'";
		
		$strucerr = "";
		foreach($structure as $row)
		{
			if(! mysqli_query(Config::getDBConn(), $row))
				$strucerr .= "<p>".$row."<br />Fehler: ".mysqli_error(Config::getDBConn())."</p>";
		}
		if($strucerr == "")
		{
			$sql_status[$i]['file'] = "Version aktualisiert";
			$sql_status[$i]['status'] = '<span class="ok">OK</span>';					
		}
		else
		{
			$sql_status[$i]['file'] = "Version aktualisiert";
			$sql_status[$i]['status'] = $strucerr;		
			$errcount++;	
		}
		$i++;
		/***********  Ende Version ***********/

		if($errcount == 0)
		{
			echo '<span class="ok">Das Update war erfolgreich.<br />Bitte l&ouml;sche jetzt das Verzeichnis<br />install/</span>';
			echo '<p><a href="../index.php">zum Tool</a></p>';
		}
		else
		{
			echo '<span class="err">Das Update war nicht erfolgreich! Es trat mindestens ein Fehler auf.</span>';
		}
		echo '				
		<table class="tableGroup2" border="0">
			<tr>
				<th colspan="2">Status der Datenbankscripts</th>
			</tr>';
			foreach($sql_status as $line)
			{
				echo '
				<tr>
			      <td class="left txt2">'.$line['file'].'</td>
			      <td class="left txt2">'.$line['status'].'</td>
			    </tr>';
			}
		echo '					      
		</table>';			
	}
	echo '
	</body>
	</html>';
}
else
	echo 'Das Tool muss bereits installiert sein!';
?>