<?php
if(file_exists('../include/db.php'))
{
	$currentCookieParams = session_get_cookie_params(); 
	session_set_cookie_params(
	    $currentCookieParams["lifetime"],
	    dirname($_SERVER['PHP_SELF']),
	    $currentCookieParams["domain"],
	    $currentCookieParams["secure"],
	    $currentCookieParams["httponly"]
	); 
	session_name('sid'); 
	session_start();
	
	require_once('../include/db.php');
	require '../classes/functions.php';
	require '../classes/config.class.php';
	
	$err = "";
	$msg = "";
	
	$neededversion = "1.6.7";
	$config = new Config();
	$curversion = $config->getToolVersion();
	if($curversion != $neededversion)
		$err .= "Dieses Script setzt die Toolversion ".$neededversion." voraus, <br />du nutzt aber ".$curversion.".";
		
	
	
	echo '<?xml version="1.0" encoding="ISO-8859-1" ?>';
	
	echo '
	<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.1//EN"
	       "http://www.w3.org/TR/xhtml11/DTD/xhtml11.dtd">
	<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="de" lang="de">
	';
	?>
	<head>
	<title>EG-Verwaltungstool by Egrem</title>
	<link rel="stylesheet" type="text/css" href="../css/style_1.7.3.css" />
	
	</head>
	<body>
	<h1>Updatescript 1.6.7 -> 1.7.0</h1>
	<p class="bold">
	<?php 
	if($err != "") echo '<br /><span class="err">'.$err.'</span>';
	if($err == "" && !$_POST)
	{
	?>
	</p>
	<form action="?" method="post">
	
	<table class="tableLogin" border="0">
		<tr>
			<th colspan="2">Aktualisierung der Datenbank</th>
		</tr>
		  <tr>
	        <td class="center" colspan="2">Dieses Script aktualisiert deine Datenbank von Version 1.6.7 auf 1.7.0</td>
	      </tr>
	      <tr>
	      	<th colspan="2"><input type="submit" value="Vorgang starten" /></th>
	      </tr>
	</table>
	<input type="hidden" name="action" value="check" />
	</form>
	<?php 
	}
	else if(isset($_POST['action']) && $_POST['action'] == 'check' && $err == "")
	{			
		$sql_status = array();
		$errcount = 0;
		$i = 0;
		
                /***********  Start Users ***********/
		$dbChange = Array();	
		$dbChange[] = "ALTER TABLE ".DB_PREFIX."users ADD avatar VARCHAR(250) DEFAULT NULL AFTER nick;";
                $dbChange[] = "ALTER TABLE ".DB_PREFIX."users ADD gender_id TINYINT(1) DEFAULT NULL AFTER uid;";
                $dbChange[] = "CREATE TABLE IF NOT EXISTS ".DB_PREFIX."users_gender (
                                id int(11) NOT NULL AUTO_INCREMENT,
                                name varchar(50) NOT NULL,
                                PRIMARY KEY (id)
                              ) ENGINE=MyISAM  DEFAULT CHARSET=latin1;";
                $dbChange[] = "INSERT INTO ".DB_PREFIX."users_gender (id, name) VALUES
                                (1, 'm�nnlich'),
                                (2, 'weiblich');";
		
		$dbChangeErr = "";
		foreach($dbChange as $row)
		{
                    if(! mysqli_query(Config::getDBConn(), $row))
                        $dbChangeErr .= "<p>".$row."<br />Fehler: ".mysqli_error(Config::getDBConn())."</p>";
		}
		if($dbChangeErr == "")
		{
                    $sql_status[$i]['file'] = "Charakterdarstellung angepasst";
                    $sql_status[$i]['status'] = '<span class="ok">OK</span>';					
		}
		else
		{
                    $sql_status[$i]['file'] = "Charakterdarstellung angepasst";
                    $sql_status[$i]['status'] = $dbChangeErr;		
                    $errcount++;	
		}
		$i++;
		unset($dbChange);
		/***********  Ende Users ***********/
                
                /***********  Mitgliederliste ***********/
		$dbChange = Array();	
		$dbChange[] = "INSERT INTO ".DB_PREFIX."sites VALUES (NULL, 'Mitglieder', 'members', 4, 1, 0);";
                $dbChange[] = "UPDATE ".DB_PREFIX."sites SET sort = '5' WHERE egtool_sites.sid = 13;";
                $dbChange[] = "UPDATE ".DB_PREFIX."sites SET sort = '6' WHERE egtool_sites.sid = 31;";
                $dbChange[] = "UPDATE ".DB_PREFIX."sites SET sort = '7' WHERE egtool_sites.sid = 5;";
                $dbChange[] = "UPDATE ".DB_PREFIX."sites SET sort = '8' WHERE egtool_sites.sid = 4;";
                $dbChange[] = "UPDATE ".DB_PREFIX."sites SET sort = '9' WHERE egtool_sites.sid = 3;";
                $dbChange[] = "INSERT INTO ".DB_PREFIX."group_rights (gid, sid) VALUES (1, 49);";
		
		$dbChangeErr = "";
		foreach($dbChange as $row)
		{
                    if(! mysqli_query(Config::getDBConn(), $row))
                        $dbChangeErr .= "<p>".$row."<br />Fehler: ".mysqli_error(Config::getDBConn())."</p>";
		}
		if($dbChangeErr == "")
		{
                    $sql_status[$i]['file'] = "Mitgliederliste hinzugef�gt";
                    $sql_status[$i]['status'] = '<span class="ok">OK</span>';					
		}
		else
		{
                    $sql_status[$i]['file'] = "Mitgliederliste";
                    $sql_status[$i]['status'] = $dbChangeErr;		
                    $errcount++;	
		}
		$i++;
		unset($dbChange);
		/***********  Ende Mitgliederliste ***********/
                
                /***********  Gildenk�rzel ***********/
		$dbChange = Array();	
		$dbChange[] = "ALTER TABLE ".DB_PREFIX."guilds CHANGE short short VARCHAR (30) NOT NULL;";
		
		$dbChangeErr = "";
		foreach($dbChange as $row)
		{
                    if(! mysqli_query(Config::getDBConn(), $row))
                        $dbChangeErr .= "<p>".$row."<br />Fehler: ".mysqli_error(Config::getDBConn())."</p>";
		}
		if($dbChangeErr == "")
		{
                    $sql_status[$i]['file'] = "Gildenk�rzel angepasst";
                    $sql_status[$i]['status'] = '<span class="ok">OK</span>';					
		}
		else
		{
                    $sql_status[$i]['file'] = "Gildenk�rzel angepasst";
                    $sql_status[$i]['status'] = $dbChangeErr;		
                    $errcount++;	
		}
		$i++;
		unset($dbChange);
		/***********  Ende Gildenk�rzel ***********/
                
                /***********  Start +x Waren ***********/
		$dbChange = Array();	
		$dbChange[] = "ALTER TABLE ".DB_PREFIX."warehouse_protocoll_entry ADD increment TINYINT UNSIGNED NOT NULL DEFAULT '0' ;";
                $dbChange[] = "ALTER TABLE ".DB_PREFIX."warehouse_items ADD increment TINYINT UNSIGNED NOT NULL DEFAULT '0' ;";
		
		$dbChangeErr = "";
		foreach($dbChange as $row)
		{
                    if(! mysqli_query(Config::getDBConn(), $row))
                        $dbChangeErr .= "<p>".$row."<br />Fehler: ".mysqli_error(Config::getDBConn())."</p>";
		}
		if($dbChangeErr == "")
		{
                    $sql_status[$i]['file'] = "Lager f�r +X Waren vorbereitet";
                    $sql_status[$i]['status'] = '<span class="ok">OK</span>';					
		}
		else
		{
                    $sql_status[$i]['file'] = "Lager f�r +X Waren vorbereitet";
                    $sql_status[$i]['status'] = $dbChangeErr;		
                    $errcount++;	
		}
		$i++;
		unset($dbChange);
		/***********  Ende +x Waren ***********/
                
                /***********  Start Prozeduren ***********/
		$dbChange = Array();	
		$dbChange[] = "drop procedure getMinMax;";
                $dbChange[] = "drop procedure getMinMaxType;";
                $dbChange[] = "create procedure getMinMax(IN id INT, OUT ammin bigint, OUT wmin double, OUT ammax bigint, OUT wmax double)
                                BEGIN
                                  DECLARE ende, icount, market, realval, factor, minviv, maxviv, minvitv, maxvitv, minv, maxv, amount INT;
                                  DECLARE stab SMALLINT;
                                  DECLARE weig float;
                                  DECLARE items CURSOR FOR 
                                        (SELECT SUM(wi.icount) as icount, i.marketvalue, i.realvalue, wi.stability, i.weight, iv.minval as ivmin, iv.maxval as ivmax, 
                                        itv.minval as itvmin, itv.maxval as itvmax 
                                        FROM egtool_warehouse_items wi, egtool_items i, egtool_item_values iv, egtool_item_types_values itv 
                                        WHERE i.iid=wi.iid and wi.wid=id and wi.stability IN(100,0) and i.itid=itv.itid and i.iid=iv.iid and iv.wid=id and itv.wid=id
                                        GROUP BY i.iid);
                                  DECLARE  CONTINUE HANDLER FOR NOT FOUND SET  ende = 1;
                                  OPEN items;
                                  SELECT 0 INTO ammin;
                                  SELECT 0 INTO wmin;
                                  SELECT 0 INTO ammax;
                                  SELECT 0 INTO wmax;
                                  SELECT 0 INTO amount;
                                  read_loop: LOOP
                                    FETCH items INTO icount, market, realval, stab, weig, minviv, maxviv, minvitv, maxvitv;  
                                    IF ende THEN
                                        LEAVE read_loop;
                                    END IF;

                                    IF minviv IS NOT NULL THEN
                                        SELECT minviv INTO minv;
                                    else
                                        SELECT minvitv INTO minv;
                                    END IF;
                                    IF maxviv IS NOT NULL THEN
                                        SELECT maxviv INTO maxv;
                                    else
                                        SELECT maxvitv INTO maxv;
                                    END IF;

                                    IF icount<minv THEN	
                                        SELECT minv-icount INTO amount;

                                        IF realval > 0 then
                                                SELECT realval INTO factor;
                                        else 
                                                SELECT market INTO factor;
                                        END IF;
                                        IF stab = 0 THEN
                                                SELECT ammin+(amount*factor) INTO ammin;
                                        else 
                                                SELECT ammin+((amount*factor)*(stab/100)) INTO ammin;
                                        END IF;
                                        SELECT wmin+(weig*amount) INTO wmin;
                                    else
                                    IF icount>maxv THEN	
                                        SELECT icount-maxv INTO amount;

                                        IF realval > 0 then
                                                SELECT realval INTO factor;
                                        else 
                                                SELECT market INTO factor;
                                        END IF;
                                        IF stab = 0 THEN
                                                SELECT ammax+(amount*factor) INTO ammax;
                                        else 
                                                SELECT ammax+((amount*factor)*(stab/100)) INTO ammax;
                                        END IF;							
                                        SELECT wmax+(weig*amount) INTO wmax;
                                    END IF;
                                    END IF;
                                  END LOOP;

                                  close items;
                                END";
                $dbChange[] = "create procedure getMinMaxType(IN id INT, tid INT, OUT ammin bigint, OUT wmin double, OUT ammax bigint, OUT wmax double)
                                BEGIN
                                  DECLARE ende, icount, market, realval, factor, minviv, maxviv, minvitv, maxvitv, minv, maxv, amount INT;
                                  DECLARE stab SMALLINT;
                                  DECLARE weig float;
                                  DECLARE items CURSOR FOR 
                                        (SELECT SUM(wi.icount) as icount, i.marketvalue, i.realvalue, wi.stability, i.weight, iv.minval as ivmin, iv.maxval as ivmax, 
                                        itv.minval as itvmin, itv.maxval as itvmax 
                                        FROM egtool_warehouse_items wi, egtool_items i, egtool_item_values iv, egtool_item_types_values itv 
                                        WHERE i.itid=tid and i.iid=wi.iid and wi.wid=id and wi.stability IN(100,0) and i.itid=itv.itid and i.iid=iv.iid and iv.wid=id and itv.wid=id
                                        GROUP BY i.iid);
                                  DECLARE  CONTINUE HANDLER FOR NOT FOUND SET  ende = 1;
                                  OPEN items;
                                  SELECT 0 INTO ammin;
                                  SELECT 0 INTO wmin;
                                  SELECT 0 INTO ammax;
                                  SELECT 0 INTO wmax;
                                  SELECT 0 INTO amount;
                                  read_loop: LOOP
                                    FETCH items INTO icount, market, realval, stab, weig, minviv, maxviv, minvitv, maxvitv;  
                                    IF ende THEN
                                        LEAVE read_loop;
                                    END IF;

                                    IF minviv IS NOT NULL THEN
                                        SELECT minviv INTO minv;
                                    else
                                        SELECT minvitv INTO minv;
                                    END IF;
                                    IF maxviv IS NOT NULL THEN
                                        SELECT maxviv INTO maxv;
                                    else
                                        SELECT maxvitv INTO maxv;
                                    END IF;

                                    IF icount<minv THEN	
                                        SELECT minv-icount INTO amount;

                                        IF realval > 0 then
                                                SELECT realval INTO factor;
                                        else 
                                                SELECT market INTO factor;
                                        END IF;
                                        IF stab = 0 THEN
                                                SELECT ammin+(amount*factor) INTO ammin;
                                        else 
                                                SELECT ammin+((amount*factor)*(stab/100)) INTO ammin;
                                        END IF;
                                        SELECT wmin+(weig*amount) INTO wmin;
                                    else
                                    IF icount>maxv THEN	
                                        SELECT icount-maxv INTO amount;

                                        IF realval > 0 then
                                                SELECT realval INTO factor;
                                        else 
                                                SELECT market INTO factor;
                                        END IF;
                                        IF stab = 0 THEN
                                                SELECT ammax+(amount*factor) INTO ammax;
                                        else 
                                                SELECT ammax+((amount*factor)*(stab/100)) INTO ammax;
                                        END IF;							
                                        SELECT wmax+(weig*amount) INTO wmax;
                                    END IF;
                                    END IF;
                                  END LOOP;

                                  close items;
                                END";
		
		$dbChangeErr = "";
		foreach($dbChange as $row)
		{
                    if(! mysqli_query(Config::getDBConn(), $row))
                        $dbChangeErr .= "<p>".$row."<br />Fehler: ".mysqli_error(Config::getDBConn())."</p>";
		}
		if($dbChangeErr == "")
		{
                    $sql_status[$i]['file'] = "Berechnung f�r Warenwert und Lagergewicht angepasst";
                    $sql_status[$i]['status'] = '<span class="ok">OK</span>';					
		}
		else
		{
                    $sql_status[$i]['file'] = "Berechnung f�r Warenwert und Lagergewicht angepasst";
                    $sql_status[$i]['status'] = $dbChangeErr;		
                    //$errcount++;	
		}
		$i++;
		unset($dbChange);
		/***********  Ende Prozeduren ***********/
                
                /***********  Waren ***********/
		$dbChange = Array();	
                $dbChange[] = "UPDATE ".DB_PREFIX."items SET lvl = '4' WHERE egtool_items.iid = 53;";
                $dbChange[] = "UPDATE ".DB_PREFIX."items SET lvl = '3' WHERE egtool_items.iid = 582;";
		
		$dbChangeErr = "";
		foreach($dbChange as $row)
		{
                    if(! mysqli_query(Config::getDBConn(), $row))
                        $dbChangeErr .= "<p>".$row."<br />Fehler: ".mysqli_error(Config::getDBConn())."</p>";
		}
		if($dbChangeErr == "")
		{
                    $sql_status[$i]['file'] = "Waren aktualisiert";
                    $sql_status[$i]['status'] = '<span class="ok">OK</span>';					
		}
		else
		{
                    $sql_status[$i]['file'] = "Waren aktualisiert";
                    $sql_status[$i]['status'] = $dbChangeErr;		
                    $errcount++;	
		}
		$i++;
		unset($dbChange);
		/***********  Ende Waren ***********/
                
		/***********  Start Version ***********/
		$structure = Array();	
		$structure[] = "UPDATE ".DB_PREFIX."config set value='1.7.0' WHERE set_key='version'";
		
		$strucerr = "";
		foreach($structure as $row)
		{
			if(! mysqli_query(Config::getDBConn(), $row))
				$strucerr .= "<p>".$row."<br />Fehler: ".mysqli_error(Config::getDBConn())."</p>";
		}
		if($strucerr == "")
		{
			$sql_status[$i]['file'] = "Version aktualisiert";
			$sql_status[$i]['status'] = '<span class="ok">OK</span>';					
		}
		else
		{
			$sql_status[$i]['file'] = "Version aktualisiert";
			$sql_status[$i]['status'] = $strucerr;		
			$errcount++;	
		}
		$i++;
		/***********  Ende Version ***********/

		if($errcount == 0)
		{
			echo '<span class="ok">Das Update war erfolgreich.<br />Bitte l&ouml;sche jetzt das Verzeichnis<br />install/</span>';
			echo '<p><a href="../index.php">zum Tool</a></p>';
		}
		else
		{
			echo '<span class="err">Das Update war nicht erfolgreich! Es trat mindestens ein Fehler auf.</span>';
		}
		echo '				
		<table class="tableGroup2" border="0">
			<tr>
				<th colspan="2">Status der Datenbankscripts</th>
			</tr>';
			foreach($sql_status as $line)
			{
				echo '
				<tr>
			      <td class="left txt2">'.$line['file'].'</td>
			      <td class="left txt2">'.$line['status'].'</td>
			    </tr>';
			}
		echo '					      
		</table>';			
	}
	echo '
	</body>
	</html>';
}
else
	echo 'Das Tool muss bereits installiert sein!';
?>