<?php
if(file_exists('../include/db.php'))
{
	$currentCookieParams = session_get_cookie_params(); 
	session_set_cookie_params(
	    $currentCookieParams["lifetime"],
	    dirname($_SERVER['PHP_SELF']),
	    $currentCookieParams["domain"],
	    $currentCookieParams["secure"],
	    $currentCookieParams["httponly"]
	); 
	session_name('sid'); 
	session_start();
	
	require_once('../include/db.php');
	require '../classes/functions.php';
	require '../classes/config.class.php';
	
	$err = "";
	$msg = "";
	
	$neededversion = "1.7.0";
	$config = new Config();
	$curversion = $config->getToolVersion();
	if($curversion != $neededversion)
		$err .= "Dieses Script setzt die Toolversion ".$neededversion." voraus, <br />du nutzt aber ".$curversion.".";
		
	
	
	echo '<?xml version="1.0" encoding="ISO-8859-1" ?>';
	
	echo '
	<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.1//EN"
	       "http://www.w3.org/TR/xhtml11/DTD/xhtml11.dtd">
	<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="de" lang="de">
	';
	?>
	<head>
	<title>EG-Verwaltungstool by Egrem</title>
	<link rel="stylesheet" type="text/css" href="../css/style_1.7.3.css" />
	
	</head>
	<body>
	<h1>Updatescript 1.7.0 -> 1.7.1</h1>
	<p class="bold">
	<?php 
	if($err != "") echo '<br /><span class="err">'.$err.'</span>';
	if($err == "" && !$_POST)
	{
	?>
	</p>
	<form action="?" method="post">
	
	<table class="tableLogin" border="0">
		<tr>
			<th colspan="2">Aktualisierung der Datenbank</th>
		</tr>
		  <tr>
	        <td class="center" colspan="2">Dieses Script aktualisiert deine Datenbank von Version 1.7.0 auf 1.7.1</td>
	      </tr>
	      <tr>
	      	<th colspan="2"><input type="submit" value="Vorgang starten" /></th>
	      </tr>
	</table>
	<input type="hidden" name="action" value="check" />
	</form>
	<?php 
	}
	else if(isset($_POST['action']) && $_POST['action'] == 'check' && $err == "")
	{			
		$sql_status = array();
		$errcount = 0;
		$i = 0;
		
                /***********  Start Capabilities ***********/
		$dbChange = Array();	
		$dbChange[] = "UPDATE ".DB_PREFIX."capabilities SET capability = 'Konstruktion' WHERE cid = 5;";           
		
		$dbChangeErr = "";
		foreach($dbChange as $row)
		{
                    if(! mysqli_query(Config::getDBConn(), $row))
                        $dbChangeErr .= "<p>".$row."<br />Fehler: ".mysqli_error(Config::getDBConn())."</p>";
		}
		if($dbChangeErr == "")
		{
                    $sql_status[$i]['file'] = "F�higkeiten angepasst";
                    $sql_status[$i]['status'] = '<span class="ok">OK</span>';					
		}
		else
		{
                    $sql_status[$i]['file'] = "F�higkeiten angepasst";
                    $sql_status[$i]['status'] = $dbChangeErr;		
                    $errcount++;	
		}
		$i++;
		unset($dbChange);
		/***********  Ende Capabilities ***********/
                
                /***********  Smileys ***********/
		$dbChange = Array();	
		$dbChange[] = "CREATE TABLE IF NOT EXISTS ".DB_PREFIX."smileys (
                                id int(10) unsigned NOT NULL AUTO_INCREMENT,
                                image varchar(50) NOT NULL,
                                short_1 varchar(20) NOT NULL,
                                short_2 varchar(20) NOT NULL,
                                sort smallint(6) NOT NULL,
                             PRIMARY KEY (id)
                           ) ENGINE=MyISAM  DEFAULT CHARSET=latin1 AUTO_INCREMENT=10 ;";
                $dbChange[] = "INSERT INTO ".DB_PREFIX."smileys (id, image, short_1, short_2, sort) VALUES
                                (1, 'icon_smile.gif', ':)', ':-)', 1),
                                (2, 'icon_sad.gif', ':(', ':-(', 2),
                                (3, 'icon_wink.gif', ';)', ';-)', 3),
                                (4, 'icon_biggrin.gif', ':d', ':D', 4),
                                (5, 'icon_tasty.gif', ':p', ':P', 5),
                                (6, 'icon_think.gif', ':-k', ':-k', 6),
                                (7, 'icon_neutral.gif', ':|', ':-|', 7),
                                (8, 'icon_smooth.gif', ':^^:', ':^^:', 8),
                                (9, 'icon_sorry.gif', '(:', '(-:', 9);";
		
		$dbChangeErr = "";
		foreach($dbChange as $row)
		{
                    if(! mysqli_query(Config::getDBConn(), $row))
                        $dbChangeErr .= "<p>".$row."<br />Fehler: ".mysqli_error(Config::getDBConn())."</p>";
		}
		if($dbChangeErr == "")
		{
                    $sql_status[$i]['file'] = "Smileys";
                    $sql_status[$i]['status'] = '<span class="ok">OK</span>';					
		}
		else
		{
                    $sql_status[$i]['file'] = "Smileys";
                    $sql_status[$i]['status'] = $dbChangeErr;		
                    $errcount++;	
		}
		$i++;
		unset($dbChange);
		/***********  Ende Smileys ***********/
                
                /***********  Lager ***********/
		$dbChange = Array();	
		$dbChange[] = "ALTER TABLE ".DB_PREFIX."warehouse ADD world SMALLINT UNSIGNED NOT NULL DEFAULT '0';";
		
		$dbChangeErr = "";
		foreach($dbChange as $row)
		{
                    if(! mysqli_query(Config::getDBConn(), $row))
                        $dbChangeErr .= "<p>".$row."<br />Fehler: ".mysqli_error(Config::getDBConn())."</p>";
		}
		if($dbChangeErr == "")
		{
                    $sql_status[$i]['file'] = "Lager aktualisiert<br /> (Bitte die Welt unter Verwaltung->Lager bei allen Lagern nachtragen.)";
                    $sql_status[$i]['status'] = '<span class="ok">OK</span>';					
		}
		else
		{
                    $sql_status[$i]['file'] = "Lager";
                    $sql_status[$i]['status'] = $dbChangeErr;		
                    $errcount++;	
		}
		$i++;
		unset($dbChange);
		/***********  Ende Lager ***********/
                
                /***********  Waren ***********/
		$dbChange = Array();	
		$dbChange[] = "UPDATE ".DB_PREFIX."items SET producable = 1
                                WHERE iid = 495
                                    OR iid = 493
                                    OR iid = 491
                                    OR iid = 497
                                    OR iid = 499
                                    OR iid = 490
                                    OR iid = 492
                                    OR iid = 494";
                $dbChange[] = "UPDATE ".DB_PREFIX."item_types SET prod_equals_cap_lvl = 0 WHERE itid = 18";
		
		$dbChangeErr = "";
		foreach($dbChange as $row)
		{
                    if(! mysqli_query(Config::getDBConn(), $row))
                        $dbChangeErr .= "<p>".$row."<br />Fehler: ".mysqli_error(Config::getDBConn())."</p>";
		}
		if($dbChangeErr == "")
		{
                    $sql_status[$i]['file'] = "Waren aktualisiert";
                    $sql_status[$i]['status'] = '<span class="ok">OK</span>';					
		}
		else
		{
                    $sql_status[$i]['file'] = "Waren aktualisiert";
                    $sql_status[$i]['status'] = $dbChangeErr;		
                    $errcount++;	
		}
		$i++;
		unset($dbChange);
		/***********  Waren ***********/
                
                 /***********  F�higkeiten ***********/
		$dbChange = Array();	
		$dbChange[] = "ALTER TABLE ".DB_PREFIX."guilds ADD auto_cap_active TINYINT(1) NOT NULL DEFAULT '0' ;";
                $dbChange[] = "ALTER TABLE ".DB_PREFIX."item_types_values ADD active_amount INT UNSIGNED NOT NULL DEFAULT '0', ADD inactive_days SMALLINT UNSIGNED NOT NULL DEFAULT '0';";
		$dbChange[] = "INSERT INTO ".DB_PREFIX."config (set_key, value) VALUES ('cron_last_activity_discover', '2015-05-01 13:00');";
		
                $dbChangeErr = "";
		foreach($dbChange as $row)
		{
                    if(! mysqli_query(Config::getDBConn(), $row))
                        $dbChangeErr .= "<p>".$row."<br />Fehler: ".mysqli_error(Config::getDBConn())."</p>";
		}
		if($dbChangeErr == "")
		{
                    $sql_status[$i]['file'] = "Status der F�higkeiten automatisch aktualisieren<br /> (Einstellbar unter Verwaltung -> Gildeneinstellungen, f�r jede Gilde einzeln.)";
                    $sql_status[$i]['status'] = '<span class="ok">OK</span>';					
		}
		else
		{
                    $sql_status[$i]['file'] = "Status der F�higkeiten automatisch aktualisieren";
                    $sql_status[$i]['status'] = $dbChangeErr;		
                    $errcount++;	
		}
		$i++;
		unset($dbChange);
		/***********  F�higkeiten ***********/
                
                /***********  DB ***********/
		$dbChange = Array();	
		$dbChange[] = "ALTER TABLE ".DB_PREFIX."warehouse_items ADD INDEX iid_wid_stab_icount (iid, wid, stability, icount) COMMENT '';";
		
		$dbChangeErr = "";
		foreach($dbChange as $row)
		{
                    if(! mysqli_query(Config::getDBConn(), $row))
                        $dbChangeErr .= "<p>".$row."<br />Fehler: ".mysqli_error(Config::getDBConn())."</p>";
		}
		if($dbChangeErr == "")
		{
                    $sql_status[$i]['file'] = "Ladezeit der Seite Lager->Lager�bersicht optimiert";
                    $sql_status[$i]['status'] = '<span class="ok">OK</span>';					
		}
		else
		{
                    $sql_status[$i]['file'] = "Ladezeit der Seite Lager->Lager�bersicht optimiert";
                    $sql_status[$i]['status'] = $dbChangeErr;		
                    //$errcount++;	
		}
		$i++;
		unset($dbChange);
		/***********  DB ***********/
                                
		/***********  Start Version ***********/
		$structure = Array();	
		$structure[] = "UPDATE ".DB_PREFIX."config set value='1.7.1' WHERE set_key='version'";
		
		$strucerr = "";
		foreach($structure as $row)
		{
			if(! mysqli_query(Config::getDBConn(), $row))
				$strucerr .= "<p>".$row."<br />Fehler: ".mysqli_error(Config::getDBConn())."</p>";
		}
		if($strucerr == "")
		{
			$sql_status[$i]['file'] = "Version aktualisiert";
			$sql_status[$i]['status'] = '<span class="ok">OK</span>';					
		}
		else
		{
			$sql_status[$i]['file'] = "Version aktualisiert";
			$sql_status[$i]['status'] = $strucerr;		
			$errcount++;	
		}
		$i++;
		/***********  Ende Version ***********/

		if($errcount == 0)
		{
			echo '<span class="ok">Das Update war erfolgreich.<br />Bitte l&ouml;sche jetzt das Verzeichnis<br />install/</span>';
			echo '<p><a href="../index.php">zum Tool</a></p>';
		}
		else
		{
			echo '<span class="err">Das Update war nicht erfolgreich! Es trat mindestens ein Fehler auf.</span>';
		}
		echo '				
		<table class="tableGroup2" border="0">
			<tr>
				<th colspan="2">Status der Datenbankscripts</th>
			</tr>';
			foreach($sql_status as $line)
			{
				echo '
				<tr>
			      <td class="left txt2">'.$line['file'].'</td>
			      <td class="left txt2">'.$line['status'].'</td>
			    </tr>';
			}
		echo '					      
		</table>';			
	}
	echo '
	</body>
	</html>';
}
else
	echo 'Das Tool muss bereits installiert sein!';
?>