<?php
if(file_exists('../include/db.php'))
{
	$currentCookieParams = session_get_cookie_params(); 
	session_set_cookie_params(
	    $currentCookieParams["lifetime"],
	    dirname($_SERVER['PHP_SELF']),
	    $currentCookieParams["domain"],
	    $currentCookieParams["secure"],
	    true
	); 
	session_name('sid'); 
	session_start();
	ini_set("default_charset", "iso-8859-1");
	require_once('../include/db.php');
	require_once '../classes/functions.php';
	require_once '../classes/config.class.php';
	
	$err = "";
	$msg = "";
	
	$neededversion = "1.9.2";
        $newVersion = "1.10.0";
	$config = new Config();
	$curversion = $config->getToolVersion();
	if($curversion != $neededversion)
		$err .= "Dieses Script setzt die Toolversion ".$neededversion." voraus, <br />du nutzt aber ".$curversion.".";
		
	
	
	echo '<?xml version="1.0" encoding="ISO-8859-1" ?>';
	
	echo '
	<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.1//EN"
	       "http://www.w3.org/TR/xhtml11/DTD/xhtml11.dtd">
	<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="de" lang="de">
	';
	?>
	<head>
	<title>EG-Verwaltungstool by Egrem</title>
	<link rel="stylesheet" type="text/css" href="../css/style_1.7.3.css" />
	
	</head>
	<body>
	<h1>Updatescript <?php echo $neededversion ?> -> <?php echo $newVersion ?></h1>
	<p class="bold">
	<?php 
	if($err != "") echo '<br /><span class="err">'.$err.'</span>';
	if($err == "" && !$_POST)
	{
	?>
	</p>
	<form action="?" method="post">
	
	<table class="tableLogin" border="0">
		<tr>
			<th colspan="2">Aktualisierung der Datenbank</th>
		</tr>
		  <tr>
	        <td class="center" colspan="2">Dieses Script aktualisiert deine Datenbank von Version <?php echo $neededversion ?> auf <?php echo $newVersion ?></td>
	      </tr>
	      <tr>
	      	<th colspan="2"><input type="submit" value="Vorgang starten" /></th>
	      </tr>
	</table>
	<input type="hidden" name="action" value="check" />
	</form>
	<?php 
	}
	else if(isset($_POST['action']) && $_POST['action'] == 'check' && $err == "")
	{			
		$sql_status = array();
		$errcount = 0;
		$i = 0;
                            
                /***********  Start Items ***********/
		$dbChange = Array();	
                // Schilde
                $dbChange[] = "ALTER TABLE ".DB_PREFIX."items ADD `critical` SMALLINT NULL AFTER `blockabsorb`;";
                $dbChange[] = "INSERT INTO ".DB_PREFIX."items (iid, item, lvl, producable, magical, marketvalue, realvalue, itid, sort, subsort, cid, weight, dmgmin, dmgmax, effect, armor, absorb, handicap, speed, accuracy, blockabsorb, critical) VALUES (NULL, 'Mystischer Bolzen', '0', '1', '1', '0', '0', '16', '0', '0', '15', '0.08', '0', '0', '11', '0', '0', '0', '0', '0', '0', '5');";
                $dbChange[] = "INSERT INTO ".DB_PREFIX."items (iid, item, lvl, producable, magical, marketvalue, realvalue, itid, sort, subsort, cid, weight, dmgmin, dmgmax, effect, armor, absorb, handicap, speed, accuracy, blockabsorb, critical) VALUES (NULL, 'Mystischer Pfeil', '0', '1', '1', '0', '0', '15', '0', '0', '14', '0.03', '0', '0', '11', '0', '0', '0', '0', '0', '0', '5');";
                $dbChange[] = "INSERT INTO ".DB_PREFIX."items (iid, item, lvl, producable, magical, marketvalue, realvalue, itid, sort, subsort, cid, weight, dmgmin, dmgmax, effect, armor, absorb, handicap, speed, accuracy, blockabsorb, critical) VALUES (NULL, 'Mystische Bandagen', '0', '1', '1', '0', '0', '28', '0', '0', '17', '0.2', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '0');";
                $dbChange[] = "INSERT INTO ".DB_PREFIX."items (iid, item, lvl, producable, magical, marketvalue, realvalue, itid, sort, subsort, cid, weight, dmgmin, dmgmax, effect, armor, absorb, handicap, speed, accuracy, blockabsorb, critical) VALUES (NULL, 'Mystische Essenz', '0', '1', '1', '0', '0', '17', '0', '0', '17', '0.03', NULL, NULL, '11', NULL, NULL, NULL, NULL, '5', NULL, '0');";
                
                require_once '../classes/warehouse.class.php';
                $whObj = new Warehouse(null);
                $whs = $whObj->getWHs();
                // add it to "Wareneinstellungen"
                foreach($whs as $wh) {
                    $dbChange[] = "INSERT INTO ".DB_PREFIX."item_values(iid, wid) SELECT iid, ".(int)$wh['wid']." as wid FROM egtool_items where item IN ('Mystischer Bolzen', 'Mystischer Pfeil', 'Mystische Bandagen', 'Mystische Essenz');";
                }
                
		
		$dbChangeErr = "";
		foreach($dbChange as $row)
		{
                    if(! mysqli_query(Config::getDBConn(), $row))
                        $dbChangeErr .= "<p>".$row."<br />Fehler: ".mysqli_error(Config::getDBConn())."</p>";
		}
		if($dbChangeErr == "")
		{
                    $sql_status[$i]['file'] = "Mystische Waren hinzugef�gt.";
                    $sql_status[$i]['status'] = '<span class="ok">OK</span>';
                    // add new items to all existing warehouses
                    foreach($whs as $wh) {
                        $whObj->iniWh($wh['wid']);                        
                    }
		}
		else
		{
                    $sql_status[$i]['file'] = "Mystische Waren";
                    $sql_status[$i]['status'] = $dbChangeErr;		
                    $errcount++;	
		}
		$i++;
		unset($dbChange);
		/***********  Ende Items ***********/
              
                /***********  Start Capabilities ***********/
		$dbChange = Array();	
                // Schilde
                $dbChange[] = "INSERT INTO `".DB_PREFIX."capabilities` (`cid`, `capability`, `type`) VALUES (NULL, 'Sabotage', '1'), (NULL, 'Erkunden', '1');;";                
		
		$dbChangeErr = "";
		foreach($dbChange as $row)
		{
                    if(! mysqli_query(Config::getDBConn(), $row))
                        $dbChangeErr .= "<p>".$row."<br />Fehler: ".mysqli_error(Config::getDBConn())."</p>";
		}
		if($dbChangeErr == "")
		{
                    $sql_status[$i]['file'] = "Sabotage, Erkunden hinzugef�gt.";
                    $sql_status[$i]['status'] = '<span class="ok">OK</span>';					
		}
		else
		{
                    $sql_status[$i]['file'] = "Sabotage, Erkunden";
                    $sql_status[$i]['status'] = $dbChangeErr;		
                    $errcount++;	
		}
		$i++;
		unset($dbChange);
		/***********  Ende Capabilities ***********/
                
                /***********  Start Classes ***********/
		$dbChange = Array();	
                // Schilde
                $dbChange[] = "CREATE TABLE `".DB_PREFIX."attributes_values` (
                                `folks_id` int(10) UNSIGNED NOT NULL,
                                `attributes_id` int(10) UNSIGNED NOT NULL,
                                `base_value_old` smallint(6) NOT NULL,
                                `base_value_new` smallint(6) NOT NULL,
                                PRIMARY KEY (`folks_id`,`attributes_id`)
                              ) ENGINE=MyISAM DEFAULT CHARSET=latin1;";
                $dbChange[] = "CREATE TABLE `".DB_PREFIX."classes` (
                                `id` int(10) UNSIGNED NOT NULL AUTO_INCREMENT,
                                `name` varchar(50) NOT NULL,
                                PRIMARY KEY (`id`)
                              ) ENGINE=MyISAM DEFAULT CHARSET=latin1;";
                $dbChange[] = "CREATE TABLE `".DB_PREFIX."classes_class` (
                                `id` int(10) UNSIGNED NOT NULL AUTO_INCREMENT,
                                `name` varchar(50) NOT NULL,
                                `classes_id` int(10) UNSIGNED NOT NULL,
                                PRIMARY KEY (`id`)
                              ) ENGINE=MyISAM DEFAULT CHARSET=latin1;";
                $dbChange[] = "CREATE TABLE `".DB_PREFIX."classes_class_attributes` (
                                `attributes_id` int(10) UNSIGNED NOT NULL,
                                `classes_class_id` int(10) UNSIGNED NOT NULL,
                                `base_value` smallint(6) NOT NULL,
                                PRIMARY KEY (`attributes_id`,`classes_class_id`)
                              ) ENGINE=MyISAM DEFAULT CHARSET=latin1;";                
                
                $dbChange[] = "INSERT INTO `".DB_PREFIX."attributes_values` (`folks_id`, `attributes_id`, `base_value_old`, `base_value_new`) VALUES
                                (1, 1, 10, 5),
                                (1, 2, 5, 3),
                                (1, 3, 10, 5),
                                (1, 4, 5, 2),
                                (2, 1, 5, 2),
                                (2, 2, 15, 8),
                                (2, 3, 0, 0),
                                (2, 4, 10, 5),
                                (3, 1, 5, 2),
                                (3, 2, 10, 5),
                                (3, 3, 5, 3),
                                (3, 4, 10, 5),
                                (4, 1, 15, 7),
                                (4, 2, 0, 0),
                                (4, 3, 15, 8),
                                (4, 4, 0, 0),
                                (5, 1, 0, 0),
                                (5, 2, 15, 7),
                                (5, 3, 0, 0),
                                (5, 4, 15, 8);";
                $dbChange[] = "INSERT INTO `".DB_PREFIX."classes` (`id`, `name`) VALUES
                                (1, 'Kampf'),
                                (2, 'Magie'),
                                (3, 'List');";
                $dbChange[] = "INSERT INTO `".DB_PREFIX."classes_class` (`id`, `name`, `classes_id`) VALUES
                                (1, 'Barbar', 1),
                                (2, 'S&ouml;ldner', 1),
                                (3, 'Ritter', 1),
                                (4, 'Gardist', 1),
                                (5, 'Bestienj&auml;ger', 1),
                                (6, 'Magier', 2),
                                (7, 'Kleriker', 2),
                                (8, 'Hexer', 2),
                                (9, 'Alchemist', 2),
                                (10, 'Antiquar', 2),
                                (11, 'Waldl&auml;ufer', 3),
                                (12, 'Druide', 3),
                                (13, 'Dieb', 3),
                                (14, 'Streuner', 3),
                                (15, 'Assassine', 3);";
                $dbChange[] = "INSERT INTO `".DB_PREFIX."classes_class_attributes` (`attributes_id`, `classes_class_id`, `base_value`) VALUES
                                (1, 1, 10),
                                (2, 1, 0),
                                (3, 1, 5),
                                (4, 1, 0),
                                (1, 2, 5),
                                (2, 2, 5),
                                (3, 2, 5),
                                (4, 2, 0),
                                (1, 3, 0),
                                (2, 3, 0),
                                (3, 3, 15),
                                (4, 3, 0),
                                (1, 4, 5),
                                (2, 4, 0),
                                (3, 4, 10),
                                (4, 4, 0),
                                (1, 5, 10),
                                (2, 5, 0),
                                (3, 5, 5),
                                (4, 5, 0),
                                (1, 6, 0),
                                (2, 6, 5),
                                (3, 6, 0),
                                (4, 6, 10),
                                (1, 7, 5),
                                (2, 7, 0),
                                (3, 7, 0),
                                (4, 7, 10),
                                (1, 8, 0),
                                (2, 8, 5),
                                (3, 8, 5),
                                (4, 8, 5),
                                (1, 9, 0),
                                (2, 9, 10),
                                (3, 9, 0),
                                (4, 9, 5),
                                (1, 10, 5),
                                (2, 10, 0),
                                (3, 10, 5),
                                (4, 10, 5),
                                (1, 11, 0),
                                (2, 11, 15),
                                (3, 11, 0),
                                (4, 11, 0),
                                (1, 12, 0),
                                (2, 12, 0),
                                (3, 12, 5),
                                (4, 12, 10),
                                (1, 13, 0),
                                (2, 13, 10),
                                (3, 13, 0),
                                (4, 13, 5),
                                (1, 14, 10),
                                (2, 14, 5),
                                (3, 14, 0),
                                (4, 14, 0),
                                (1, 15, 5),
                                (2, 15, 5),
                                (3, 15, 0),
                                (4, 15, 5);";
                
                $dbChange[] = "ALTER TABLE `".DB_PREFIX."users` ADD `classes_class_id` INT UNSIGNED NOT NULL DEFAULT '0' AFTER `apikey`;";
                $dbChange[] = "ALTER TABLE `".DB_PREFIX."folk` DROP `strength`, DROP `skill`, DROP `constitution`, DROP `intelligence`;";
		
		$dbChangeErr = "";
		foreach($dbChange as $row)
		{
                    if(! mysqli_query(Config::getDBConn(), $row))
                        $dbChangeErr .= "<p>".$row."<br />Fehler: ".mysqli_error(Config::getDBConn())."</p>";
		}
		if($dbChangeErr == "")
		{
                    $sql_status[$i]['file'] = "Klassen f�r V�lker hinzugef�gt.";
                    $sql_status[$i]['status'] = '<span class="ok">OK</span>';					
		}
		else
		{
                    $sql_status[$i]['file'] = "Klassen";
                    $sql_status[$i]['status'] = $dbChangeErr;		
                    $errcount++;	
		}
		$i++;
		unset($dbChange);
		/***********  Ende Classes ***********/
                
                /***********  Start Password ***********/
		$dbChange = Array();	
                // Schilde
                $dbChange[] = "ALTER TABLE `".DB_PREFIX."users` CHANGE `pwd` `pwd` VARCHAR(255) CHARACTER SET latin1 COLLATE latin1_swedish_ci NOT NULL;";                
		
		$dbChangeErr = "";
		foreach($dbChange as $row)
		{
                    if(! mysqli_query(Config::getDBConn(), $row))
                        $dbChangeErr .= "<p>".$row."<br />Fehler: ".mysqli_error(Config::getDBConn())."</p>";
		}
		if($dbChangeErr == "")
		{
                    $sql_status[$i]['file'] = "Anpassungen f�r sichere Passwortablage";
                    $sql_status[$i]['status'] = '<span class="ok">OK</span>';					
		}
		else
		{
                    $sql_status[$i]['file'] = "Anpassungen f�r sichere Passwortablage";
                    $sql_status[$i]['status'] = $dbChangeErr;		
                    $errcount++;	
		}
		$i++;
		unset($dbChange);
		/***********  Ende Password ***********/
                
                /***********  Start Prozeduren ***********/
		$dbChange = Array();	
                $dbChange[] = "drop procedure getMinMaxType;";
                $dbChange[] = "create procedure `getMinMaxType`(IN id INT, tid INT, OUT ammin bigint, OUT wmin double, OUT ammax bigint, OUT wmax double)
                                BEGIN
                                  DECLARE ende, icount, market, realval, factor, minviv, maxviv, minvitv, maxvitv, minv, maxv, amount INT;
                                  DECLARE stab SMALLINT;
                                  DECLARE weig float;
                                  DECLARE items CURSOR FOR 
                                        (SELECT SUM(wi.icount) as icount, i.marketvalue, i.realvalue, wi.stability, i.weight, iv.minval as ivmin, iv.maxval as ivmax, 
                                        itv.minval as itvmin, itv.maxval as itvmax 
                                        FROM egtool_warehouse_items wi, egtool_items i, egtool_item_values iv, egtool_item_types_values itv 
                                        WHERE i.itid=tid and i.iid=wi.iid and wi.wid=id and wi.stability IN(100,0) and i.itid=itv.itid and i.iid=iv.iid and iv.wid=id and itv.wid=id
                                        GROUP BY i.iid);
                                  DECLARE  CONTINUE HANDLER FOR NOT FOUND SET  ende = 1;
                                  OPEN items;
                                  SELECT 0 INTO ammin;
                                  SELECT 0 INTO wmin;
                                  SELECT 0 INTO ammax;
                                  SELECT 0 INTO wmax;
                                  SELECT 0 INTO amount;
                                  read_loop: LOOP
                                    FETCH items INTO icount, market, realval, stab, weig, minviv, maxviv, minvitv, maxvitv;  
                                    IF ende THEN
                                        LEAVE read_loop;
                                    END IF;

                                    IF minviv IS NOT NULL THEN
                                        SELECT minviv INTO minv;
                                    else
                                        SELECT minvitv INTO minv;
                                    END IF;
                                    IF maxviv IS NOT NULL THEN
                                        SELECT maxviv INTO maxv;
                                    else
                                        SELECT maxvitv INTO maxv;
                                    END IF;

                                    IF icount<minv THEN	
                                        SELECT minv-icount INTO amount;

                                        IF realval > 0 then
                                                SELECT realval INTO factor;
                                        else 
                                                SELECT market INTO factor;
                                        END IF;
                                        IF stab = 0 THEN
                                                SELECT ammin+(amount*factor) INTO ammin;
                                        else 
                                                SELECT ammin+((amount*factor)*(stab/100)) INTO ammin;
                                        END IF;
                                        SELECT wmin+(weig*amount) INTO wmin;
                                    else
                                    IF icount>maxv THEN	
                                        SELECT icount-maxv INTO amount;

                                        IF realval > 0 then
                                                SELECT realval INTO factor;
                                        else 
                                                SELECT market INTO factor;
                                        END IF;
                                        IF stab = 0 THEN
                                                SELECT ammax+(amount*factor) INTO ammax;
                                        else 
                                                SELECT ammax+((amount*factor)*(stab/100)) INTO ammax;
                                        END IF;							
                                        SELECT wmax+(weig*amount) INTO wmax;
                                    END IF;
                                    END IF;
                                  END LOOP;

                                  close items;
                                END";
		
		$dbChangeErr = "";
		foreach($dbChange as $row)
		{
                    if(! mysqli_query(Config::getDBConn(), $row))
                        $dbChangeErr .= "<p>".$row."<br />Fehler: ".mysqli_error(Config::getDBConn())."</p>";
		}
		if($dbChangeErr == "")
		{
                    $sql_status[$i]['file'] = "Berechnung f�r Warenwert und Lagergewicht angepasst";
                    $sql_status[$i]['status'] = '<span class="ok">OK</span>';					
		}
		else
		{
                    $sql_status[$i]['file'] = "Berechnung f�r Warenwert und Lagergewicht angepasst";
                    $sql_status[$i]['status'] = $dbChangeErr;		
                    //$errcount++;	
		}
		$i++;
		unset($dbChange);
		/***********  Ende Prozeduren ***********/
                
		/***********  Start Version ***********/
		$structure = Array();	
		$structure[] = "UPDATE ".DB_PREFIX."config set value='".$newVersion."' WHERE set_key='version'";
		
		$strucerr = "";
		foreach($structure as $row)
		{
			if(! mysqli_query(Config::getDBConn(), $row))
				$strucerr .= "<p>".$row."<br />Fehler: ".mysqli_error(Config::getDBConn())."</p>";
		}
		if($strucerr == "")
		{
			$sql_status[$i]['file'] = "Version aktualisiert";
			$sql_status[$i]['status'] = '<span class="ok">OK</span>';					
		}
		else
		{
			$sql_status[$i]['file'] = "Version aktualisiert";
			$sql_status[$i]['status'] = $strucerr;		
			$errcount++;	
		}
		$i++;
		/***********  Ende Version ***********/

		if($errcount == 0)
		{
			echo '<span class="ok">Das Update war erfolgreich.<br />Bitte l&ouml;sche jetzt das Verzeichnis<br />install/</span>';
			echo '<p><a href="../index.php">zum Tool</a></p>';
		}
		else
		{
			echo '<span class="err">Das Update war nicht erfolgreich! Es trat mindestens ein Fehler auf.</span>';
		}
		echo '				
		<table class="tableGroup2" border="0">
			<tr>
				<th colspan="2">Status der Datenbankscripts</th>
			</tr>';
			foreach($sql_status as $line)
			{
				echo '
				<tr>
			      <td class="left txt2">'.$line['file'].'</td>
			      <td class="left txt2">'.$line['status'].'</td>
			    </tr>';
			}
		echo '					      
		</table>';			
	}
	echo '
	</body>
	</html>';
}
else
	echo 'Das Tool muss bereits installiert sein!';
?>