<?php

require_once('classes/info_hero.class.php');
require_once('classes/user.class.php');
require_once('classes/item.class.php');
require_once('classes/guild.class.php');
require_once('classes/Folk.php');

// Initialisierung von Leserechten der Gilden von eingeloggten Benutzer
$guild = new Guild($user);
$gus = $guild->getGuildsByReadRight();

// Array mit guid's für Gilden, die der Benutzer ansehen darf
$userGuildsByReadRight = array();

for($i=0;$i<count($gus);$i++) {
    $userGuildsByReadRight[] = $gus[$i]['id'];
}

// Initialisierung von Funktionen
$info_hero = new HeroInfo();
$curUser = new User();
$items = new Item();

// Zuweisung Daten des aufgerufenen Benutzers in Variablen
$hero = $info_hero->getHeroData($_GET['hero_id']);
$hero_eq = $info_hero->getHeroEQ($_GET['hero_id']);
$battleInfo = $info_hero->getBattleInfo($_GET['hero_id']);
$hero_craft = $info_hero->getCrafts($_GET['hero_id']);
$hero_plans = $info_hero->getLearnedPlans($_GET['hero_id']);
$viewer_capabilities = $info_hero->getViewerCapabilities($_SESSION['uid']);

if($hero == false) {
    echo '<p class="err">Dieser Charakter existiert nicht.</p>';
}
elseif(!in_array($hero['guid'], $userGuildsByReadRight)) {
    echo '<p class="err">Keine Zugriffsberechtigung auf dieses Mitglied.</p>';
}
else {

?>

    <link rel="stylesheet" type="text/css" href="css/humanity/<?php echo JQUERY_UI_CSS; ?>" />
    <script type="text/javascript" src="js/<?php echo JQUERY_UI_JS; ?>"></script>
    <script type="text/javascript" src="js/info_hero.js"></script>

    <div id="userPlans" class="overlib ui-draggable" style="display: none;">
        <?php
        if($hero_plans != false) {
            echo '<table class="resultT5">';

            echo '<tbody>';

            echo '<tr>';
            echo '<th class="right" colspan="4">Erlernte Pl&auml;ne';
            echo '&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;
                        <span style="cursor:pointer;" onclick="$(\'#userPlans\').hide();">X</span>
                        &nbsp;&nbsp;';
            echo '</th>';
            echo '</tr>';

            $lastShownPlan = NULL;
            foreach ($hero_plans AS $cid => $plans) {
                foreach($plans AS $plan) {
                    ?>
                    <tr class="plans plan_<?php echo $cid; ?>">
                        <td class="L CB">
                            <?php echo $plan['item']; ?>
                        </td>

                        <td class="R" width="20">
                            <?php echo $plan['lvl']; ?>
                        </td>
                    </tr>
                <?php
                }
            }

            echo '<tr>
                <th colspan="4">&nbsp;</th>
            </tr>';

            echo '</tbody>';

            echo '</table>';
        }
        ?>
    </div>

    <table align="center" border="1" rules="all" width="720px">
        <colgroup>
            <col width="14%"/>
            <col width="40%"/>
            <col width="46%"/>
        </colgroup>
        <tbody>

        <tr>
            <th colspan="3">Darstellung</th>
        </tr>

        <tr>
            <td>
                <img src="
                <?php
                    if(!empty($hero['avatar'])) {
                        echo $hero['avatar'];
                    }
                    else {
                        //echo 'images/avatars/avatar' . $hero['fid'] . '_' . $hero['gender_id'] . '_1.png';
                        echo 'images/avatars/default.png';
                    }
                ?>" class="cpic" alt="Avatar"/>
            </td>
            <td class="LT">
                <?php
                    echo strtotime($hero['lastAction']) >= (time() - (60*5)) ? '<div class="online"></div>' : '<div class="offline"></div>';
                ?>
                <span class="CB"><?php echo $hero['nick'] ?></span> [<span title="<?php echo $hero['guild']; ?>" style="cursor: help; color: <?php echo $hero['guild_color']; ?>;"><?php echo $hero['guild_short']; ?></span>]<br/>
                <span class="CI"><?php echo $hero['folk']; ?>, Level <?php echo $hero['lvl'] ?></span><br/>
                <?php
                    if($hero['class'] !== null) {
                        echo '<span class="CI">'.$hero['class'].'</span><br/>';
                    }
                ?>
                <?php
                    if(!empty($hero['titel'])) {
                        echo '<span class="CI">Gildentitel:</span>&nbsp;' . $hero['titel'] . '<br/>';
                    }

                ?>

                <br />

                <?php

                    if($battleInfo != false) {
                        foreach ($battleInfo AS $key => $value) {
                            echo '<span class="CI">' . $key . ':</span>&nbsp;' . $value . '<br/>';
                        }
                    }

                ?>
            </td>
            <td class="LT">

                <?php
                    if($hero_eq == false) {
                        echo '<span class="italic">Keine Gegenst&auml;nde ausger&uuml;stet.</span>';
                    }
                    else {
                        foreach($hero_eq AS $item) {
                            if($item['magical'] == 1) {
                                echo '<span class="CB">' .  $item['item'];
                            }
                            else {
                                echo '<span>' . $item['item'];
                            }

                            if($item['enchantment'] != NULL) {
                                echo ' ' . $item['enchantment'] . '</span><br />';
                            }
                            else {
                                echo '<br /></span>';
                            }
                        }
                    }
                ?>

            </td>
        </tr>

        <tr>
            <td colspan="4" style="margin: 0; padding: 0;">

                <div id="tabs" class="txt2 left" style="border: 0;">
                    <ul>
                        <li><a href="#description">Beschreibung</a></li>
                        <li><a href="#craft_skills">Handwerksfertigkeiten</a></li>
                        <li><a href="#properties">Eigenschaften</a></li>
                    </ul>
                    <div id="description">
                                <?php
                                if(!empty($hero['description'])) {
                                    echo bbCodeConverter(nl2br($hero['description']));
                                }
                                else {
                                    echo '<span class="italic">Keine Beschreibung verf&uuml;gbar.</span>';
                                }
                                ?>
                    </div>
                    <div id="craft_skills">
                        <?php
                        if($hero_craft == false) {
                                echo '<span class="italic">Keine Berufe erlernt.</span>';
                        }
                        else {
                            ?>

                            <div class="craftFilter">
                                <input class="craftFilter" id="craftActive" type="checkbox" value="1" checked>
                                <label for="craftActive">Aktive Berufe</label>

                                <input class="craftFilter" id="craftInActive" type="checkbox" value="0" checked>
                                <label for="craftInActive">Inaktive Berufe</label>
                            </div>

                            <?php
                            foreach ($hero_craft AS $cid => $craft) {
                                $craftItems = $info_hero->getCraftItems($cid, $craft['lvl']);
                                $magicalItems = $info_hero->getMagicalItems($_GET['hero_id'], $cid);

                                echo '<div class="craftWrapper" style="height: 26px; overflow: hidden; margin-bottom: 10px; border: 1px solid rgb(0, 0, 0);" data-active="' . $craft['active'] . '">';
                                    echo '<table style="width: 100%;" rules="all" border="0">';

                                    echo '<thead>';

                                        echo '<tr>';
                                            echo '<th class="L">' . $craft['capability'] . '</th>';
                                            echo '<th width="20">' . $craft['lvl'] . '</th>';
                                            if(isset($hero_plans[$cid])) {
                                                echo '<th width="56"><button class="heroPlansButton" id="plan_' . $cid . '">Pl&auml;ne</button></th>';
                                            }
                                            else {
                                                echo '<th width="56"></th>';
                                            }
                                            echo '<th width="32">';
                                                if($cid != 18) {
                                                    echo '<button id="' . $cid . '" class="btn btn-default btn-sm expandBox"><span class="ui-icon ui-icon-caret-1-s"></span></button>';
                                                }
                                            echo '</th>';
                                        echo '</tr>';

                                    echo '</thead>';

                                    if($craftItems != false) {
                                        foreach ($craftItems AS $key => $item) {
                                            if(
                                                $magicalItems != false &&
                                                $item['lvl'] >= $magicalItems[0]['lvl']
                                            ) {
                                                echo '<tr>';
                                                    echo '<td class="LT" colspan="4">';
                                                        echo '<span class="bold CB">';
                                                            echo $magicalItems[0]['item'] . '<br />';
                                                        echo '</span>';

                                                        if($item['display_layout'] == 'weapon') {
                                                            if ($magicalItems[0]['speed'] == 2) {
                                                                $speed = 'langsam';
                                                            }
                                                            elseif ($magicalItems[0]['speed'] == 3) {
                                                                $speed = 'normal';
                                                            }
                                                            else {
                                                                $speed = 'schnell';
                                                            }

                                                            echo $magicalItems[0]['damage'] . ' Schaden, ' . $speed . ' <span class="CI">(&Oslash; ' . $magicalItems[0]['average_damage'] . ' Schaden pro Runde)</span><br />';
                                                        }
                                                        elseif($item['display_layout'] == 'magic_staff') {
                                                            echo '+' . $magicalItems[0]['effect'] . '% Wirkung<br />';
                                                        }
                                                        elseif($item['display_layout'] == 'ammunition') {
                                                            echo '+' . $magicalItems[0]['effect'] . '% Wirkung, +' . $magicalItems[0]['accuracy'] . '% Kritische Treffer<br />';
                                                        }
                                                        elseif($item['display_layout'] == 'armor') {
                                                            echo $magicalItems[0]['armor'] . '% R&uuml;stschutz, ' . $magicalItems[0]['absorb'] . ' Absorb, ' . $magicalItems[0]['handicap'] . '% Behinderung<br />';
                                                        }
                                                        elseif($item['display_layout'] == 'shield') {
                                                            echo $magicalItems[0]['armor'] . '% R&uuml;stschutz, ' . $magicalItems[0]['absorb'] . ' Absorb bei Block<br />';
                                                        }
                                                        else {
                                                            echo 'Handwerksmaterial <span class="CI">(Verarbeitung ab Stufe ' . $magicalItems[0]['lvl'] . ')</span><br />';
                                                        }

                                                        echo '<span class="CI">' . $magicalItems[0]['weight'] . ' kg</span>';

                                                        if($item['display_layout'] != 'resource' && $item['display_layout'] != 'ammunition') {
                                                            if(
                                                                isset($viewer_capabilities[$item['cid_fight']]) &&
                                                                $viewer_capabilities[$item['cid_fight']] >= $magicalItems[0]['lvl']
                                                            ) {
                                                                $class = 'CB';
                                                            }
                                                            else {
                                                                $class = 'CR';
                                                            }

                                                            echo ', <span class="' . $class . '">' . $magicalItems[0]['type'] . ', Stufe ' . $magicalItems[0]['lvl'] . '</span>';
                                                        }

                                                    echo '</td>';
                                                echo '</tr>';

                                                array_shift($magicalItems);
                                            }

                                            if(
                                                $item['display_layout'] != 'ammunition' &&
                                                $item['display_layout'] != 'resource' ||
                                                (
                                                    $item['display_layout'] == 'ammunition' ||
                                                    $item['display_layout'] == 'resource' &&
                                                    (
                                                        $item['lvl'] <= $craft['lvl']
                                                    )
                                                )
                                            ) {
                                                echo '<tr>';
                                                    echo '<td class="LT" colspan="4">';
                                                        echo '<span class="bold">';
                                                            echo $item['item'] . '<br />';
                                                        echo '</span>';

                                                        if ($item['display_layout'] == 'weapon') {
                                                            if ($item['speed'] == 2) {
                                                                $speed = 'langsam';
                                                            }
                                                            elseif ($item['speed'] == 3) {
                                                                $speed = 'normal';
                                                            }
                                                            else {
                                                                $speed = 'schnell';
                                                            }

                                                            echo $item['damage'] . ' Schaden, ' . $speed . ' <span class="CI">(&Oslash; ' . $item['average_damage'] . ' Schaden pro Runde)</span><br />';
                                                        }
                                                        elseif ($item['display_layout'] == 'magic_staff') {
                                                            echo '+' . $item['effect'] . '% Wirkung<br />';
                                                        }
                                                        elseif ($item['display_layout'] == 'ammunition') {
                                                            echo '+' . $item['effect'] . '% Wirkung, +' . $item['accuracy'] . '% Kritische Treffer<br />';
                                                        }
                                                        elseif ($item['display_layout'] == 'armor') {
                                                            echo $item['armor'] . '% R&uuml;stschutz, ' . $item['absorb'] . ' Absorb, ' . $item['handicap'] . '% Behinderung<br />';
                                                        }
                                                        elseif ($item['display_layout'] == 'shield') {
                                                            echo $item['armor'] . '% R&uuml;stschutz, ' . $item['absorb'] . ' Absorb bei Block<br />';
                                                        }
                                                        else {
                                                            echo 'Handwerksmaterial <span class="CI">(Verarbeitung ab Stufe ' . $item['lvl'] . ')</span><br />';
                                                        }

                                                        echo '<span class="CI">' . $item['weight'] . ' kg</span>';

                                                        if ($item['display_layout'] != 'resource' && $item['display_layout'] != 'ammunition') {
                                                            if (
                                                                isset($viewer_capabilities[$item['cid_fight']]) &&
                                                                $viewer_capabilities[$item['cid_fight']] >= $item['lvl']
                                                            ) {
                                                                $class = 'CB';
                                                            }
                                                            else {
                                                                $class = 'CR';
                                                            }

                                                            echo ', <span class="' . $class . '">' . $item['type'] . ', Stufe ' . $item['lvl'] . '</span>';
                                                        }
                                                    echo '</td>';
                                                echo '</tr>';
                                            }
                                        }
                                    }

                                    echo '</table>';
                                echo '</div>';
                            }
                        }
                        ?>
                    </div>
                    <div id="properties">
                        <?php

                        $curUser->loadUser($_GET['hero_id']);
                        
                        $usersCaps = $curUser->getUsersCapabilities(1);

                        //Gruppenspezifische Werte laden, bei bedarf
                        $uc = $curUser->getUsersAttributes();
                        $inventar = $curUser->getUsersInventar();
                        $spells = $curUser->getUsersSpell();
                        $userEnch = $curUser->getUsersEnchantments();


                        $lp = $curUser->getLP($uc, $userEnch, $inventar, $items);
                        $handicap = $curUser->getHandicap($uc, $inventar, $items, $userEnch);
                        $armor = $curUser->getArmor($inventar, $items);
                        $absorb = $curUser->getAbsorb($uc, $inventar, $items, $userEnch, $usersCaps, $curUser);
                        $avoid = $curUser->getAvoid($uc, $handicap, $items, $inventar, $userEnch);
                        $accuracy = $curUser->getAccuracy($uc, $inventar, $items, 'nk', $userEnch);
                        $critical = $curUser->getCritical($uc, $handicap, $items, $inventar, $userEnch);

                        echo '
                        <div style="width:100%; margin:0 auto;">
                            <div style="float:left; margin-right:5px; width:49%;">
                                <table class="resultT4" border="0" style="width:100%; border: none;">
                                <tr>
                                    <td colspan="2" class="txt3 nob3 bold" style="padding:0;">Werte im Nahkampf</td>
                                </tr>
                                <tr>
                                    <td class="nob6 bold txt4 left padhead">Allgemeine Werte</td>
                                    <td class="nob5 txt4 padtxt">&nbsp;</td>
                                </tr>
                                <tr>
                                    <td class="nob6 txt4 padtxt left" style="width:50%;">';
                        $block = $curUser->getBlock($uc, $inventar, $items, $userEnch);
                        $blockout = '';
                        if ($block[1] > 0) $blockout = 'Schildblock<br />';
                        echo '
                                    Lebenspunkte<br />
                                    R&uuml;stschutz<br />
                                    Absorb<br />
                                    Ausweichen<br />
                                    ' . $blockout . '
                                    Behinderung<br />
                                    </td>
                                    <td class="nob5 txt4 padtxt left">';
                        if ($block[1] > 0) $blockout = number_format($block[0], 2, '.', '') . ' % (' . $block[1] . '% Schaden)<br />';
                        echo '
                                    ' . $lp . '<br />
                                    ' . number_format($armor, 1, '.', '') . ' %<br />
                                    ' . number_format($absorb, 1, '.', '') . '<br />
                                    ' . number_format($avoid, 2, '.', '') . ' %<br />
                                    ' . $blockout . '
                                    ' . number_format($handicap, 0, '.', '') . ' %<br />
                                    </td>
                                </tr>';
                        for ($i = 0; $i < 2; $i++) {
                            $nkitem = $curUser->getItemForType($inventar, 6 + $i); //6 und 7 f?r nk1, nk2

                            if ($nkitem['iid'] != 0 && in_array($nkitem['itid'], $items->getItidWeapons())) {
                                $item = $items->getItem($nkitem['iid']);
                                $tmpSpeed = $curUser->getSpeed($item, $items, $inventar, 'nk', $userEnch);
                                $speed = ($tmpSpeed == 2 ? 'langsam' : ($tmpSpeed == 3 ? 'normal' : 'schnell'));
                                $speed .= " (" . $item['speed'] . " Angriffe)";

                                $dmg = $curUser->getDmgForWeapon($uc, $item, $items, $inventar, $userEnch, $nkitem, $usersCaps, $curUser);
                                $out = $dmg[0] . ' - ' . $dmg[1];

                                echo '
                                            <tr>
                                                <td class="nob6 bold txt4 left padhead"><br />' . $item['item'] . '</td>
                                                <td class="nob5 txt4 padtxt">&nbsp;</td>
                                            </tr>
                                            <tr>
                                                <td class="nob6 txt4 padtxt left">
                                                Schaden<br />
                                                Geschwindigkeit<br />
                                                Treffsicherheit<br />
                                                Kritische Treffer
                                                </td>
                                            <td class="nob5 txt4 padtxt left">
                                            ' . $out . '<br />
                                            ' . $speed . '<br />
                                            ' . number_format($accuracy, 2, '.', '') . ' %<br />
                                            ' . number_format($critical, 2, '.', '') . ' %
                                            </td>';
                            }
                        }
                        echo '
                                </table>
                            </div>
                            <div style="float:right; width:49%;">
                                <table class="resultT4" border="0" style="width:100%; border:none;">
                                <tr>
                                    <td colspan="2" class="txt3 nob3 bold" style="padding:0;">Werte im Fernkampf</td>
                                </tr>
                                <tr>
                                    <td class="nob6 bold txt4 left padhead">Allgemeine Werte</td>
                                    <td class="nob5 txt4 padtxt">&nbsp;</td>
                                </tr>
                                <tr>
                                    <td class="nob6 txt4 padtxt left" style="width:50%;">';

                        echo '
                                    Lebenspunkte<br />
                                    R&uuml;stschutz<br />
                                    Absorb<br />
                                    Ausweichen<br />
                                    Behinderung<br />
                                    </td>
                                    <td class="nob5 txt4 padtxt left">';

                        echo '
                                    ' . $lp . '<br />
                                    ' . number_format($armor, 1, '.', '') . ' %<br />
                                    ' . number_format($absorb, 1, '.', '') . '<br />
                                    ' . number_format($avoid, 2, '.', '') . ' %<br />
                                    ' . number_format($handicap, 0, '.', '') . ' %<br />
                                    </td>
                                </tr>';
                        $accuracy = $curUser->getAccuracy($uc, $inventar, $items, 'fk', $userEnch);
                        $critical = $curUser->getCritical($uc, $handicap, $items, $inventar, $userEnch, 'fk');
                        $fkitem = $curUser->getItemForType($inventar, 8);
                        //wenn Zauberstab
                        if (in_array($fkitem['itid'], $items->getItidSpellWeapons()))
                            $loop = 3;
                        else
                            $loop = 1; //ander fk waffe
                        for ($i = 0; $i < $loop; $i++) {
                            // nk + fk
                            if ($fkitem['iid'] > 0) {
                                if ($loop == 3) {
                                    $spell = $curUser->getItemForType($spells, 1 + $i);
                                    $dmg = $curUser->getDmgForSpell($uc, $spell, $items, $inventar, $handicap, $userEnch, $usersCaps, $curUser);
                                    if ($spell['spid'] == 0) break;
                                    $name = $spell['name'];
                                } else {
                                    $spell = $items->getItem($fkitem['iid']);
                                    $dmg = $curUser->getDmgForFk($uc, $spell, $items, $inventar, $handicap, $userEnch, $fkitem, $usersCaps, $curUser);
                                    $name = $spell['item'];
                                }
                                $speed = ($spell['speed'] == 1 ? 'sehr langsam' : ($spell['speed'] == 2 ? 'langsam' : ($spell['speed'] == 3 ? 'normal' : 'schnell')));
                                $speed .= " (" . $spell['speed'] . ($spell['speed'] > 1 ? ' Angriffe' : ' Angriff') . ')';


                                $out = $dmg[0] . ' - ' . $dmg[1];

                                echo '
                                            <tr>
                                                <td class="nob6 bold txt4 left padhead"><br />' . $name . '</td>
                                                <td class="nob5 txt4 padtxt">&nbsp;</td>
                                            </tr>
                                            <tr>
                                                <td class="nob6 txt4 padtxt left">
                                                ' . (isset($spell['type2']) && ($spell['type2'] == 3 || $spell['type2'] == 4) ? 'Lebenspunkte' : 'Schaden') . '<br />
                                                ' . (isset($spell['reach']) && $spell['reach'] > 1 ? 'Wirkungsbereich<br />' : '') . '
                                                Geschwindigkeit<br />
                                                Treffsicherheit<br />
                                                Kritische Treffer
                                                </td>
                                            <td class="nob5 txt4 padtxt left">
                                            ' . $out . '<br />
                                            ' . (isset($spell['reach']) && $spell['reach'] > 1 ? $spell['reach'] . ' Felder<br />' : '') . '
                                            ' . $speed . '<br />
                                            ' . number_format($accuracy, 2, '.', '') . ' %<br />
                                            ' . number_format($critical, 2, '.', '') . ' %
                                            </td>';
                            }
                        }
                        echo '
                                </table>
                            </div>
                        </div><div style="clear:both;"></div>
                        ';
                        ?>

                    </div>
                </div>

            </td>
        </tr>
        </tbody>
    </table>

<?php

}

?>