<?php
use Repository\MarketUtilization;

if($menue2->checkPermission($do))
{ 
    require_once('classes/warehouse.class.php');
    require_once('classes/guild.class.php');
    require_once 'classes/enums/WHType.enum.php';
    require_once('Repository/MarketUtilization.php');
    
    $menue3 = new Menue($user);
    $m3 = $menue3->getMenue(3, $menue2->getIdForSite($do));
    
    $dos2 = Array('overview', 'buyer');
    $do2 = "";
    if(isset($_GET['do2']) && in_array($_GET['do2'], $dos2)) { 
        $do2 = $_GET['do2'];        
    } else if(array_key_exists (0, $m3)){ 
        $do2 = $m3[0]['short'];        
    }
    
    $wh = new Warehouse($user);
    $market = new MarketUtilization();
    
    $whsRead = $wh->getWHsByReadRight();
    $whs = [];
    foreach ($whsRead as $row) {
        if ($row['type'] == WHType::MARKTSTAND) {
            $whs[] = $row;
        }                
    }
        
    // Lagerauswahl
    if( isset($_REQUEST['wh']) && ($_REQUEST['wh'] === "0" || $wh->canAccess($whs, $_REQUEST['wh'])) ) {
        $whId = (int)$_REQUEST['wh'];      
    } else if(array_key_exists(0, $whs)) {
        $whId = $whs[0]['wid'];        
    } else {
        $whId = 0;
    }

    // wenn alle ausgewhlt wurde, fge alle mit Schreibrechten zur Auswahl
    if($whId === 0) {
        $whIds = [];
        foreach($whs as $w) {
            array_push($whIds, $w['wid']);
        }            
    } else {
        $whIds[] = $whId;        
    }
    
    // submenu
    $ms = count($m3);
    $i = 0;
    echo '<p>';
    foreach($m3 as $m)
    {
        echo '<a '.($m['short']==$do2?'class="under" ':'').'href="?site='.$site.'&amp;do='.$do.'&amp;do2='.$m['short'].'">'.$m['site'].'</a>';
        if($i != $ms-1)
                echo ' | '; $i++;
    }
    echo '</p>';

    if($menue3->checkPermission($do2))
    { 
        $m = $wh->getMonths();
        $months = getMonthList($m);
        $years = $wh->getYears();
        $total = false;
        $yearly = false;
        $itid = 0;
        $pageLinkHref = '?site=' . $site . '&amp;do=' . $do . '&amp;do2=' . $do2 . '&amp;wh=' . $whId;

        $shows = Array('monthly', 'total', 'yearly');
        
        // monatliche oder gesamtansicht
        if ( isset($_GET['show']) && in_array($_GET['show'], $shows)) {
            $show = $_GET['show'];
        } else {
            $show = $shows[0];  //beim ersten Aufruf der Seite
        }
        
        // wenn Gesamt checkbox
        if (isset($_REQUEST['total']) || $show == "total") {
            $total = true;
        }
        
        // wenn jhrliche checkbox
        if (isset($_REQUEST['yearly']) || $show == "yearly") {
            $yearly = true;
        }

        if(!$total && !$yearly && isset($_REQUEST['month']))    // monatliche Anzeige
        {
            $year = (int)$_REQUEST['year'];
            $month = (int)$_REQUEST['month'];
            $daymin = max(array(1,(int)$_REQUEST['daymin']));
            $daymax = min(array(31,(int)$_REQUEST['daymax']));
            $pageLinkHref .= "&amp;year=".$year."&amp;month=".$month."&amp;daymin=".$daymin."&amp;daymax=".$daymax;
        } else if($yearly && isset($_REQUEST['year'])) {        // jhrliche Anzeige
            $year = (int)$_REQUEST['year'];
            $month = 0;
            $daymin = 1;
            $daymax = 31;
            $pageLinkHref .= "&amp;year=".$year."&amp;yearly=on";
        } else if( $total ) {                                   // alle Jahre
            $year = 0;
            $month = 0;
            $daymin = 1;
            $daymax = 31;
            $pageLinkHref .= "&amp;total=on";
        } else {//beim ersten Aufruf der Seite
        
            $year = (in_array(date("Y"), $years) ? date("Y") : $years[0]);
            $month = (in_array(date("n"), $m) ? date("n") : $m[0]);
            $daymin = 1;
            $daymax = 31;
            $pageLinkHref .= "&amp;year=".$year."&amp;month=".$month."&amp;daymin=".$daymin."&amp;daymax=".$daymax;
        }

        if($daymin>$daymax) {
            $daymin = $daymax;  
        }
        
        
        echo '<link rel="stylesheet" type="text/css" href="css/humanity/'.JQUERY_UI_CSS.'" />
              <script type="text/javascript" src="js/'.JQUERY_UI_JS.'"></script>';

        echo '<div id="itemusers"></div>';
        echo '<form action="?site='.$site.'&amp;do='.$do.'&amp;do2=monthly" method="get">
            <table border="0" class="tableGroup2" cellspacing="0" cellpadding="0" style="border:none;">
            <tr style="border:none;">
                    <td style="border:none;" >
                    Lager: 
                    <select name="wh">
                            <option value="0">--alle--</option>';
                                    foreach($whs as $single)
                                    {  
                                        switch($single['type']) {
                                            case WHType::STADTLAGER : $whtype = 'Stadtlager'; break;
                                            case WHType::GILDENLAGER : $whtype = 'Gildenlager, '.$single['short']; break;
                                            case WHType::MARKTSTAND : $whtype = 'Marktstand, '.$single['short']; break;
                                        }
                                        echo '<option value="'.$single['wid'].'"'; if($whId==$single['wid']) echo ' selected="selected"'; echo'>
                                                '.$single['name'].' ('.$whtype.')</option>';
                                    }
                                echo '</select></td>
            </tr>
            <tr style="border:none;">
                    <td style="border:none;" >Gesamt <input type="checkbox" name="total"'.($total?' checked="checked"':'').' id="total" />
                            jhrlich <input type="checkbox" name="yearly"'.($yearly?' checked="checked"':'').' id="yearly" />
                            <select name="month" id="month">';
                            foreach($months as $month2)
                            {  echo '<option value="'.$month2[1].'"'; if($month==$month2[1]) echo ' selected="selected"'; echo'>'.$month2[0].'</option>'; }
                            echo '
                            </select>
                            <select name="year" id="year">';
                            foreach($years as $year2)
                            {  echo '<option value="'.$year2.'"'; if($year==$year2) echo ' selected="selected"'; echo'>'.$year2.'</option>'; }
                            echo '
                            </select>
                    </td>
            </tr>
            <tr style="border:none;">
                    <td style="border:none;"><div style="float:left; width:40px;margin-right:20px;">Zeitraum:</div><div id="slider-range" class="slider2"></div><div class="range hint center">'.$daymin.'. - '.$daymax.'.</div></td>
            </tr>
            </table>


             <p><input type="submit" value="Anzeigen" /></p>
             <input type="hidden" name="site" value="'.$site.'" />
             <input type="hidden" name="do" value="'.$do.'" />
             <input type="hidden" name="do2" value="'.$do2.'" />
             <input type="hidden" name="show" value="'.$show.'" />
             <input type="hidden" id="daymin" name="daymin" value="'.$daymin.'" />
             <input type="hidden" id="daymax" name="daymax" value="'.$daymax.'" />';
        
        // wenn eine einzelne Warengruppe angeklickt wurde                    
        if ( isset($_GET['it']) ) {
            $itid = (int) $_GET['it'];
            echo '<input type="hidden" id="it" name="it" value="' . $itid . '" />';
        }
        echo ' 
            </form>
        ';
        
        if($do2 === 'overview') {
            include 'marketutilization/overview.php';            
        } else if($do2 === 'buyer') {
            include 'marketutilization/buyer.php'; 
        }
        
    } else {
        echo '<p>&nbsp;</p><p>&nbsp;</p><p>&nbsp;</p><p class="err">Zugang verweigert!</p>'; 
    }
?>
    <script type="text/javascript">
        $(document).ready(function()
        {
            $( "#slider-range" ).slider({
                range: true,
                min: 1,
                max: 31,
                values: [ <?php echo $daymin.', '.$daymax; ?> ],
                slide: function( event, ui ) 
                {
                    $( "#daymin" ).val( ui.values[ 0 ] );
                    $( "#daymax" ).val( ui.values[ 1 ] );
                    $( ".range" ).text( ui.values[ 0 ] + ". - " + ui.values[ 1 ] +"." );
                }
            });

            if($("#total").is(":checked"))
                disableYearMonth();
            if($("#yearly").is(":checked"))
                disableMonth();

            $("#total").click(function()
            {
                if($(this).is(":checked"))
                    disableYearMonth();
                else
                    enableYearMonth();
            });	

            $("#yearly").click(function()
            {
                if($(this).is(":checked"))
                    disableMonth();
                else
                    enableYearMonth();
            });
        });

        function disableYearMonth()
        {
            $("#month").attr("disabled","true");
            $("#year").attr("disabled","true");
            $("#yearly").attr("disabled","true");
            $( "#slider-range" ).slider( "option", "disabled", true );
        }

        function enableYearMonth()
        {
            $("#month").removeAttr("disabled");
            $("#year").removeAttr("disabled");
            $("#yearly").removeAttr("disabled");
            $("#total").removeAttr("disabled");
            $( "#slider-range" ).slider( "option", "disabled", false );
        }

        function disableMonth()
        {
            $("#month").attr("disabled","true");
            $("#total").attr("disabled","true");
            $( "#slider-range" ).slider( "option", "disabled", true );
        }
    </script>
    <script type="text/javascript" src="js/<?php echo AJAX_JS; ?>"></script>
    <script type="text/javascript" src="js/<?php echo JQUERY_UI_JS; ?>"></script>
<?php
} else {
    echo '<p>&nbsp;</p><p>&nbsp;</p><p>&nbsp;</p><p class="err">Zugang verweigert!</p>'; 
}
