<?php

require_once('classes/members.class.php');
require_once('classes/info_hero.class.php');
require_once('classes/guild.class.php');

$members = new members();
$info_hero = new HeroInfo();

// Prüfung der Leserechte
$guild = new Guild($user);
$gus = $guild->getGuildsByReadRight();

if(isset($_GET['guid']) && isset($_GET['character'])) {
    $guid = mysqli_real_escape_string(Config::getDBConn(), $_GET['guid']);

    if(!empty($_GET['character'])) {
        $character = mysqli_real_escape_string(Config::getDBConn(), $_GET['character']);
    }
    else {
        $character = '0';
    }
}
else {
    $guid = '0';
    $character = '0';
}

$showMembers = $members->getMembers($guid, $character, $gus);

?>

<form method="GET" style="margin-bottom: 15px;">
    <input type="hidden" name="site" value="members">

    <table class="tableLogin" border="0" style="margin-bottom: 5px;">
        <tbody>

        <tr>
            <th colspan="2">Gildenauswahl</th>
        </tr>

        <tr>
            <td class="left">Gilde</td>
            <td class="left" style="padding-right: 10px;">
                <select name="guid" style="width: 100%;">
                    <option value="0">--alle--</option>

                    <?php
                    if($gus):
                        foreach($gus AS $gData):
                            $selected = $gData['id'] == $guid ? ' selected' : '';
                    ?>

                            <option value="<?php echo $gData['id'];?>" style="color: <?php echo $gData['color']; ?>;" <?php echo $selected; ?>><?php echo $gData['name']; ?></option>

                    <?php
                        endforeach;
                    endif;
                    ?>

                </select>
            </td>
        </tr>

        <tr>
            <td class="left">Charaktersuche</td>
            <td class="left" style="padding-right: 10px;">
                <input style="width: 100%;" type="text" name="character" placeholder="Charaktername" value="<?php echo $character != '0' ? $character : ''; ?>">
            </td>
        </tr>

        </tbody>
    </table>

    <button type="submit">Anzeigen</button>

</form>


<table align="center" border="1" rules="all" width="720px">
    <tbody>

        <?php
        if($showMembers != false):
            foreach($showMembers AS $uid => $uData):
                $battleInfo = $info_hero->getBattleInfo($uid);
        ?>

            <tr>
                    <td width="50">
                        <a href="?site=info_hero&hero_id=<?php echo $uid; ?>">
                            <img src="
                            <?php
                            if(!empty($uData['avatar'])) {
                                echo $uData['avatar'];
                            }
                            else {
                                //echo 'images/avatars/avatar' . $uData['fid'] . '_' . $uData['gender_id'] . '.jpg';
                                echo 'images/avatars/default.png';
                            }
                            ?>" class="cpic" alt="Avatar"/>
                        </a>
                    </td>
                    <td class="LT">
                        <?php
                            echo strtotime($uData['lastAction']) >= (time() - (60*5)) ? '<div class="online"></div>' : '<div class="offline"></div>';
                        ?>
                        <a href="?site=info_hero&hero_id=<?php echo $uid; ?>"><?php echo $uData['nick'] ?></a>
                        <?php

                        if(
                            !is_null($uData['guild_name']) &&
                            !is_null($uData['guild_short']) &&
                            !is_null($uData['guild_color'])
                        ) {
                            echo '[<span title="' . $uData['guild_name'] . '" style="cursor: help; color: ' . $uData['guild_color'] . '">' . $uData['guild_short'] . '</span>]';
                        }

                        ?>

                        <br/>

                        <span class="CI"><?php echo $uData['folk']; ?>, Level <?php echo $uData['lvl'] ?><?php if($uData['class'] !== null) echo ', '.$uData['class'] ?></span><br/>

                        <br />

                        <?php

                        if($battleInfo != false) {
                            foreach ($battleInfo AS $key => $value) {
                                echo '<span class="CI">' . $key . ':</span>&nbsp;' . $value . '<br/>';
                            }
                        }

                        ?>
                    </td>
            </tr>

        <?php
            endforeach;
        else:
            echo '<i>Noch keine Charaktere vorhanden.</i>';
        endif;
        ?>
    </tbody>
</table>