<?php 
    require_once('classes/warehouse.class.php');
    require_once('classes/guild.class.php');
    require_once 'classes/payment.class.php';
    $payment = new Payment();
    $wh = new Warehouse($user);


    $m = $wh->getMonths();
    $months = getMonthList($m);
    $years = $wh->getYears();

    $m_pay = $payment->getMonths();
    $months_pay = getMonthList($m_pay);
    $years_pay = $payment->getYears();

    $whs = $wh->getWHsByReadRight();
    if(isset($_REQUEST['wh']) && ($wh->canAccess($whs, (int)$_REQUEST['wh']) || $_REQUEST['wh'] == 0))
            $whId = (int)$_REQUEST['wh'];
    else if(array_key_exists(0, $whs))
            $whId = $whs[0]['wid'];

    //gilden
    $guild = new Guild($user);

    $gus = $guild->getGuildsByReadRight();

    if(isset($_REQUEST['gu']))
            $guId = (int)$_REQUEST['gu'];
    else if(array_key_exists(0, $gus))
            $guId = $gus[0]['id'];
    else 
            $guId = 0;

    $tab = (int)($_GET['tab'] ?? 0);
    
    // collect year for payment monthly
    $yearMontly = (int)($_GET['year_monthly'] ?? 0);
    if($yearMontly === 0 && count($years_pay) >= 1) {
        $yearMontly = $years_pay[0];            
    }    
    
    // collect year for combined payment/wh chart
    $yearPayWH = (int)($_GET['year_pay_wh'] ?? 0);
    if($yearPayWH === 0 && count($years) >= 1) {
        $yearPayWH = $years[0];
    } else if($yearPayWH == 0 && count($years_pay) >= 1) {
        $yearPayWH = $years_pay[0];
    }

    // collect other parameters
    $yearf = (int)($_GET['yearfrom'] ?? 0);
    $monthf = (int)($_GET['monthfrom'] ?? 0);
    $yeart = (int)($_GET['yearto'] ?? 0);
    $montht = (int)($_GET['monthto'] ?? 0);

    if(isset($_REQUEST['weekday']) && in_array($_REQUEST['weekday'], array('day','week')))
            $weekday = $_REQUEST['weekday']; 	else	$weekday = "week";
    if(isset($_REQUEST['minmax']) && in_array($_REQUEST['minmax'], array('min','max','all')))
            $minmax = $_REQUEST['minmax']; 		else	$minmax = "all";

    if($yearf == 0 && count($years) >= 1) $yearf = $years[0];
    else if($yearf == 0 && count($years_pay) >= 1) $yearf = $years_pay[0];

    if($monthf == 0 && count($m) >= 1) $monthf = $m[0];
    else if($monthf == 0 && count($m_pay) >= 1) $monthf = $m_pay[0];

    if($yeart == 0 && count($years) >= 1) $yeart = $years[0];
    else if($yeart == 0 && count($years_pay) >= 1) $yeart = $years_pay[0];

    if($montht == 0 && count($m) >= 1) $montht = $m[0];
    else if($montht == 0 && count($m_pay) >= 1) $montht = $m_pay[0];

    $target1 = 'ajaxcalls/chartData.php?action=monthlypayment&year='.$yearMontly.'&gu='.$guId;
    $target2 = 'ajaxcalls/chartData.php?action=weeklypayment&yearf='.$yearf.'&monthf='.$monthf.'&yeart='.$yeart.'&montht='.$montht.'&action2='.$weekday.'&gu='.$guId;
    $target3 = 'ajaxcalls/chartData.php?action=weeklywh&yearf='.$yearf.'&monthf='.$monthf.'&yeart='.$yeart.'&montht='.$montht.'&action2='.$weekday.'&wh='.$whId;
    $target4 = 'ajaxcalls/chartData.php?action=whtype&wh='.$whId.'&minmax='.$minmax;
    $target5 = 'ajaxcalls/chartData.php?action=monthlywhpayment&year='.$yearPayWH.'&gu='.$guId.'&wh='.$whId;

    echo '<link rel="stylesheet" type="text/css" href="css/humanity/'.JQUERY_UI_CSS.'" />
              <script type="text/javascript" src="js/'.JQUERY_UI_JS.'"></script>';

    echo '
    <div style="width:750px; margin: 0 auto;">
        <div id="tabs" class="txt2 left" style="border:none; background:none;">
            <ul>
                <li class="txt4"><a href="#tabs-1">Gildenkasse monatlich</a></li>
                <li class="txt4"><a href="#tabs-2">Gildenkasse w&ouml;chentlich</a></li>
                <li class="txt4"><a href="#tabs-3">Lager w&ouml;chentlich</a></li>
                <li class="txt4"><a href="#tabs-4">Warengruppen</a></li>
                <li class="txt4"><a href="#tabs-5">Kassen-, Lagertransaktionen</a></li>
            </ul>';
        
            echo '
            <div id="tabs-1" class="left txt3">
                <form action="?site='.$site.'&amp;action=monthlypayment" method="get">
                    <p>Gilde: <select id="guild" name="gu">';
                    foreach($gus as $single)
                    {  
                        echo '<option value="'.$single['id'].'"'; if($guId==$single['id']) echo ' selected="selected"'; echo'>
                            '.$single['name'].'</option>';                         
                    }
                    echo '</select> Jahr: 
                            <select name="year_monthly">';
                    foreach($years_pay as $yearp)
                    {  
                        echo '<option value="'.$yearp.'"'; if($yearMontly==$yearp) echo ' selected="selected"'; echo'>'.$yearp.'</option>';                         
                    }
                    echo '</select>
                     <input type="submit" value="anzeigen" />
                     <input type="hidden" name="site" value="'.$site.'" />
                     <input type="hidden" name="action" value="monthly" />
                     <input type="hidden" name="do" value="'.$do.'" />
                     <input type="hidden" name="tab" value="0" />
                    </p>
                </form>
                <canvas id="chart_monthly" width="700" height="320"></canvas>
            </div>

            <div id="tabs-2" class="left txt3">
                <form action="?site='.$site.'&amp;action=weekly" method="get">
                    <p>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;Gilde: <select id="guild" name="gu">';
                    foreach($gus as $single)
                        {  echo '<option value="'.$single['id'].'"'; if($guId==$single['id']) echo ' selected="selected"'; echo'>
                                    '.$single['name'].'</option>'; }
                        echo '</select> <br /> 
                    Zeitraum: <select name="monthfrom">';
                    foreach($months_pay as $month)
                    {  echo '<option value="'.$month[1].'"'; if($monthf==$month[1]) echo ' selected="selected"'; echo'>'.$month[0].'</option>'; }
                    echo '</select>
                    <select name="yearfrom">';
                    foreach($years_pay as $year)
                    {  echo '<option value="'.$year.'"'; if($yearf==$year) echo ' selected="selected"'; echo'>'.$year.'</option>'; }
                    echo '</select>
                    - 
                    <select class="monthto" name="monthto">';
                    foreach($months_pay as $month)
                    {  echo '<option value="'.$month[1].'"'; if($montht==$month[1]) echo ' selected="selected"'; echo'>'.$month[0].'</option>'; }
                    echo '</select>
                    <select class="yearto" name="yearto">';
                    foreach($years_pay as $year)
                    {  echo '<option value="'.$year.'"'; if($yeart==$year) echo ' selected="selected"'; echo'>'.$year.'</option>'; }
                    echo '</select>
                    <input class="radday" type="radio" name="weekday" value="day" '.($weekday=='day'?'checked="checked"':'').'/> Tage <span class="hint">(nur ein Monat)</span>
                    <input class="radweek" type="radio" name="weekday" value="week" '.($weekday=='week'?'checked="checked"':'').'/> KW
                    </p>
                     <p class="center"><input type="submit" value="anzeigen" /></p>
                     <input type="hidden" name="site" value="'.$site.'" />
                     <input type="hidden" name="action" value="monthly" />
                     <input type="hidden" name="do" value="'.$do.'" />
                     <input type="hidden" name="tab" value="1" />                    
                </form>	
                <canvas id="chart_weekly" width="700" height="320"></canvas>						
            </div>

            <div id="tabs-3" class="left txt3">
                <form action="?site='.$site.'&amp;action=weekly" method="get">
                    <p>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;Lager: <select name="wh">
                        <option value="0"'; if($whId==0) echo ' selected="selected"'; echo'>alle</option>';
                        foreach($whs as $single)
                        {  
                            $whtype = ($single['parent'] == 0? 'Stadtlager':'Gildenlager, '.$single['short']);
                            echo '<option value="'.$single['wid'].'"'; if($whId==$single['wid']) echo ' selected="selected"'; echo'>
                                    '.$single['name'].' ('.$whtype.')</option>';                                                 
                        }
                        echo '</select> <br /> 
                    Zeitraum: <select name="monthfrom">';
                    foreach($months as $month)
                    {  echo '<option value="'.$month[1].'"'; if($monthf==$month[1]) echo ' selected="selected"'; echo'>'.$month[0].'</option>'; }
                    echo '</select>
                    <select name="yearfrom">';
                    foreach($years as $year)
                    {  echo '<option value="'.$year.'"'; if($yearf==$year) echo ' selected="selected"'; echo'>'.$year.'</option>'; }
                    echo '</select>
                    - 
                    <select class="monthto" name="monthto">';
                    foreach($months as $month)
                    {  echo '<option value="'.$month[1].'"'; if($montht==$month[1]) echo ' selected="selected"'; echo'>'.$month[0].'</option>'; }
                    echo '</select>
                    <select class="yearto" name="yearto">';
                    foreach($years as $year)
                    {  echo '<option value="'.$year.'"'; if($yeart==$year) echo ' selected="selected"'; echo'>'.$year.'</option>'; }
                    echo '</select>
                    <input class="radday" type="radio" name="weekday" value="day" '.($weekday=='day'?'checked="checked"':'').'/> Tage <span class="hint">(nur ein Monat)</span>
                    <input class="radweek" type="radio" name="weekday" value="week" '.($weekday=='week'?'checked="checked"':'').'/> KW
                     </p>
                    <p class="center"><input type="submit" value="anzeigen" /></p>
                     <input type="hidden" name="site" value="'.$site.'" />
                     <input type="hidden" name="action" value="monthly" />
                     <input type="hidden" name="do" value="'.$do.'" />
                     <input type="hidden" name="tab" value="2" />
                </form>	
                <canvas id="chart_weekly_wh" width="700" height="320"></canvas>						
            </div>

            <div id="tabs-4" class="left txt3">

                    <form action="?site='.$site.'&amp;do='.$do.'&amp;action=changewh" method="get">		 
                    <p>Lager: <select name="wh">';
                    foreach($whs as $single)
                    {  
                        $whtype = ($single['parent'] == 0? 'Stadtlager':'Gildenlager, '.$single['short']);
                        echo '<option value="'.$single['wid'].'"'; if($whId==$single['wid']) echo ' selected="selected"'; echo'>
                                '.$single['name'].' ('.$whtype.')</option>';                                             
                    }
                    echo '</select>
                     <input type="radio" name="minmax" value="all" '.($minmax=='all'?'checked="checked"':'').'/> gesamt
                     <input type="radio" name="minmax" value="min" '.($minmax=='min'?'checked="checked"':'').'/> fehlende Waren
                     <input type="radio" name="minmax" value="max" '.($minmax=='max'?'checked="checked"':'').'/> &uuml;bersch&uuml;ssige Waren
                     </p>
                     <p class="center"><input type="submit" value="anzeigen" /></p>
                     <input type="hidden" name="site" value="'.$site.'" />
                     <input type="hidden" name="action" value="whtype" />
                     <input type="hidden" name="do" value="'.$do.'" />
                     <input type="hidden" name="tab" value="3" />
                    </form>
                    <canvas id="chart_whtype" width="700" height="400"></canvas>		
            </div>';

        echo '
            <div id="tabs-5" class="left txt3">
                <form action="?site='.$site.'&amp;action=monthlypayment" method="get">
                    <p>Lager: <select name="wh">
                        <option value="0"'; if($whId==0) echo ' selected="selected"'; echo'>alle</option>';
                        foreach($whs as $single)
                        {  
                                $whtype = ($single['parent'] == 0? 'Stadtlager':'Gildenlager, '.$single['short']);
                                echo '<option value="'.$single['wid'].'"'; if($whId==$single['wid']) echo ' selected="selected"'; echo'>
                                        '.$single['name'].' ('.$whtype.')</option>';                                 
                        }
                                echo '</select>
                    Gilde: <select id="guild" name="gu">
                            <option value="0">alle</option>';
                    foreach($gus as $single)
                    {  
                        echo '<option value="'.$single['id'].'"'; if($guId==$single['id']) echo ' selected="selected"'; echo'>
                                '.$single['name'].'</option>';                         
                    }
                    echo '</select> 
                    <select name="year_pay_wh">';
                    if(count($years) > 0) $y_tmp = $years; else $y_tmp = $years_pay;
                    foreach($y_tmp as $year)
                    {  
                        echo '<option value="'.$year.'"'; if($yearPayWH==$year) echo ' selected="selected"'; echo'>'.$year.'</option>'; 
                    }                        
                    echo '</select>
                     </p>
                     <p class="center"><input type="submit" value="anzeigen" /></p>
                     <input type="hidden" name="site" value="'.$site.'" />
                     <input type="hidden" name="action" value="monthly" />
                     <input type="hidden" name="do" value="'.$do.'" />
                     <input type="hidden" name="tab" value="4" />
                </form>
                <canvas id="chart_whpaymonthly" width="700" height="320"></canvas>
            </div>
        </div>
    </div>';



    echo '<script type="text/javascript">
            $(document).ready(function()
            {
                    $( "#tabs" ).tabs();
                    $( "#tabs" ).tabs("option", "active" , '.$tab.' );

                    if($(".radday").is(":checked"))
                            disableSecondMonth();
                    $(".radday").click(function()
                    {
                            disableSecondMonth();
                    });

                    $(".radweek").click(function()
                    {
                            enableSecondMonth();
                    });
            });
    </script>'
?>
<script type="text/javascript" src="js/Chart.2.9.3.min.js"></script>
<script type="text/javascript" src="js/chart_1.0.0.js"></script>
<script>
    $(document).ready(function()
    {
        loadChart("<?php echo $target1; ?>", 'chart_monthly');
        loadChart("<?php echo $target2; ?>", 'chart_weekly', 'line');
        loadChart("<?php echo $target3; ?>", 'chart_weekly_wh', 'line');
        loadChart("<?php echo $target4; ?>", 'chart_whtype');
        loadChart("<?php echo $target5; ?>", 'chart_whpaymonthly', 'bar', true);        
    });
</script>